/*************************************************************************
 *
 *  $RCSfile: act_all.hxx,v $
 *
 *  $Revision: 1.1.12.1 $
 *
 *  last change: $Author: mh $ $Date: 2003/01/27 16:59:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef ARY_ACTION_ACTALL_HXX
#define ARY_ACTION_ACTALL_HXX


// USED SERVICES
    // BASE CLASSES
#include <ary/actions.hxx>
    // COMPONENTS
#include <cosv/ploc_dir.hxx>
    // PARAMETERS


namespace ary
{

class RepositoryCenter;

namespace n22
{
class RepositoryCenter;
}

namespace action
{


/**
*/
class InitCppParse : public Command
{
  public:
    virtual             ~InitCppParse();

  private:
    virtual void        do_Run(
                            n22::RepositoryCenter &
                                                io_rReposy );
};



/**
*/
class InitIdlParse : public Command
{
  public:
    virtual             ~InitIdlParse();

  private:
    virtual void        do_Run(
                            RepositoryCenter &      io_rReposy );
};

/**
*/
class ProduceAllSecondaries : public Command
{
  public:
    virtual             ~ProduceAllSecondaries();

  private:
    virtual void        do_Run(
                            RepositoryCenter &      io_rReposy );
};

/**
*/
class Save : public Command
{
  public:
                        Save(
                            const csv::ploc::Directory &
                                                i_rDestination );
    virtual             ~Save();

  private:
    virtual void        do_Run(
                            RepositoryCenter &      io_rReposy );
    // DATA
    csv::ploc::Directory
                        aDestination;
};



/**
*/
class Statistic : public Command
{
  public:
                        Statistic();
    virtual             ~Statistic();

  private:
    virtual void        do_Run(
                            RepositoryCenter &      io_rReposy );
    // DATA
};


} // namespace action
} // namespace ary


#endif
