/*************************************************************************
 *
 *  $RCSfile: l_rwgate.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: np $ $Date: 2002/03/08 14:45:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef ARY_LOC_L_RWGATE_HXX
#define ARY_LOC_L_RWGATE_HXX


#include <ary/ids.hxx>


namespace csv
{
    namespace ploc
    {
        class Path;
        class DirectoryChain;
    }
}

namespace ary
{
namespace loc
{
    class LocationRoot;
    class SourceCodeFile;

class RwGate
{
  public:
	// LIFECYCLE
	virtual             ~RwGate() {}

    // OPERATIONS
    ary::loc::LocationRoot &
                        CheckIn_Root(
                            const csv::ploc::Path &
                                                i_rPath );
    ary::loc::SourceCodeFile &
                        CheckIn_File(
                            const udmstri &     i_sFileName,
                            const csv::ploc::DirectoryChain &
                                                i_rFileSubPath,
                            Lid                 i_nRootDir );
  private:
    virtual ary::loc::LocationRoot &
                        do_CheckIn_Root(
                            const csv::ploc::Path &
                                                i_rPath ) = 0;
    virtual ary::loc::SourceCodeFile &
                        do_CheckIn_File(
                            const udmstri &     i_sFileName,
                            const csv::ploc::DirectoryChain &
                                                i_rFileSubPath,
                            Lid                 i_nRootDir ) = 0;
};


// IMPLEMENTATION
inline ary::loc::LocationRoot &
RwGate::CheckIn_Root( const csv::ploc::Path & i_rPath )
    { return do_CheckIn_Root(i_rPath); }
inline ary::loc::SourceCodeFile &
RwGate::CheckIn_File( const udmstri &                     i_sFileName,
                      const csv::ploc::DirectoryChain &   i_rFileSubPath,
                      Lid                                 i_nRootDir )
    { return do_CheckIn_File( i_sFileName, i_rFileSubPath, i_nRootDir ); }



} // namespace loc
} // namespace ary



#endif

