/*************************************************************************
 *
 *  $RCSfile: speci_ce.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: np $ $Date: 2002/03/08 14:45:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef ARY_SPECI_CE_HXX
#define ARY_SPECI_CE_HXX


// USED SERVICES
	// BASE CLASSES
#include <ary_i/ce2.hxx>
	// COMPONENTS
	// PARAMETERS
#include <csi/l_uidl/service.hxx>
#include <csi/l_uidl/intrface.hxx>
#include <csi/l_uidl/struct.hxx>
#include <csi/l_uidl/except.hxx>
#include <csi/l_uidl/enum.hxx>
#include <csi/l_uidl/typedef.hxx>
#include <csi/l_uidl/property.hxx>
#include <csi/l_uidl/struelem.hxx>
#include <csi/l_uidl/function.hxx>
#include <csi/l_uidl/attrib.hxx>
#include <csi/l_uidl/enumvalu.hxx>
#include <csi/l_uidl/constant.hxx>



namespace ary
{
namespace uidl
{



template <class ENTITY_TYPE>
class SpecificCe : public CodeEntity2
{
  public:
						SpecificCe(
							DYN ENTITY_TYPE &	let_drClient )
												:	pClient(&let_drClient) {}

	const ENTITY_TYPE &	Client() const			{ return *pClient; }
	ENTITY_TYPE &		Client()				{ return *pClient; }

	virtual const udmstri &
						Name() const;

  private:
	Dyn< ENTITY_TYPE >	pClient;
};

template <class ENTITY_TYPE>
const udmstri &
SpecificCe<ENTITY_TYPE>::Name() const
{
	return Client().Name();
}



}   // namespace uidl
}   // namespace ary


#endif



