/*************************************************************************
 *
 *  $RCSfile: ref.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: np $ $Date: 2002/03/08 14:45:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef UDM_REF_HXX
#define UDM_REF_HXX



// USED SERVICES
	// BASE CLASSES
	// COMPONENTS
#include <udm/ref_base.hxx>
	// PARAMETERS


namespace udm
{


template <class TYPE>
class IRef : public Ref_Base
{
  public:
	// LIFECYCLE
						IRef(
							uintt   		  	i_nId = 0 )
												:	Ref_Base(i_nId) {}
						IRef(
							const Ref_Base &   	i_rRef )
												:	Ref_Base(i_rRef.Id()) {}
	// OPERATORS
	IRef & 				operator=(
							uintt   			i_nId )
												{ nId = i_nId; return *this; }
	IRef & 				operator=(
							const Ref_Base &	i_rRef )
												{ nId = i_rRef.Id(); return *this; }
	// INQUIRY
	TYPE &				ref(
							const ReferenceResolver<TYPE> &
												i_rResolver ) const
												{ return * i_rResolver.GetPtr(nId); }
	TYPE *		   		ptr(
							const ReferenceResolver<TYPE> &
												i_rResolver ) const
												{ return i_rResolver.GetPtr(nId); }
};

// IMPLEMENTATION


}   // namespace_end udm

#endif

