/*************************************************************************
 *
 *  $RCSfile: spece.hxx,v $
 *
 *  $Revision: 1.2.2.1 $
 *
 *  last change: $Author: mh $ $Date: 2003/01/27 17:01:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef ARY_SPECE_HXX
#define ARY_SPECE_HXX

// [ed] 6/15/02 We need full class definitions in order to instantiate templates on OS X
#ifdef MACOSX
#include <ary_i/uidl/cenamesp.hxx>
#endif

// USED SERVICES
	// BASE CLASSES
#include <ary_i/uidl/speci_ce.hxx>
	// COMPONENTS
#include <ary_i/codeinf2.hxx>
	// PARAMETERS


namespace csi
{
namespace uidl
{
class Service;
class Interface;
class Struct;
class Exception;
class Enum;
class Typedef;
class Constant;
class Property;
class Function;
class Attribute;
class StructElement;
class EnumValue;
}   // namespace uidl
}   // namespace csi





namespace ary
{
namespace uidl
{

class CeNamespace;

class SCE_Module : public SpecificCe< ary::uidl::CeNamespace >
{
  public:
						SCE_Module(
							ary::uidl::CeNamespace &
												let_drNamespace )
												:	SpecificCe< ary::uidl::CeNamespace >(let_drNamespace) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Service : public SpecificCe< csi::uidl::Service >
{
  public:
						SCE_Service(
							csi::uidl::Service &
												let_drService )
												:	SpecificCe< csi::uidl::Service >(let_drService) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Interface : public SpecificCe< csi::uidl::Interface >
{
  public:
						SCE_Interface(
							csi::uidl::Interface &
												let_drInterface )
												:	SpecificCe< csi::uidl::Interface >(let_drInterface) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Struct : public SpecificCe< csi::uidl::Struct >
{
  public:
						SCE_Struct(
							csi::uidl::Struct & let_drStruct )
												:	SpecificCe< csi::uidl::Struct >(let_drStruct) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Exception : public SpecificCe< csi::uidl::Exception >
{
  public:
						SCE_Exception(
							csi::uidl::Exception & let_drException )
												:	SpecificCe< csi::uidl::Exception >(let_drException) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Enum : public SpecificCe< csi::uidl::Enum >
{
  public:
						SCE_Enum(
							csi::uidl::Enum & let_drEnum )
												:	SpecificCe< csi::uidl::Enum >(let_drEnum) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Typedef : public SpecificCe< csi::uidl::Typedef >
{
  public:
						SCE_Typedef(
							csi::uidl::Typedef & let_drTypedef )
												:	SpecificCe< csi::uidl::Typedef >(let_drTypedef) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_ConstantsGroup : public SpecificCe< csi::uidl::ConstantsGroup >
{
  public:
						SCE_ConstantsGroup(
							csi::uidl::ConstantsGroup & let_drGroup )
												:	SpecificCe< csi::uidl::ConstantsGroup >(let_drGroup) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Constant : public SpecificCe< csi::uidl::Constant >
{
  public:
						SCE_Constant(
							csi::uidl::Constant & let_drConstant )
												:	SpecificCe< csi::uidl::Constant >(let_drConstant) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};



class SCE_Property : public SpecificCe< csi::uidl::Property >
{
  public:
						SCE_Property(
							csi::uidl::Property & let_drProperty )
												:	SpecificCe< csi::uidl::Property >(let_drProperty) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Function : public SpecificCe< csi::uidl::Function >
{
  public:
						SCE_Function(
							csi::uidl::Function & let_drFunction )
												:	SpecificCe< csi::uidl::Function >(let_drFunction) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_Attribute : public SpecificCe< csi::uidl::Attribute >
{
  public:
						SCE_Attribute(
							csi::uidl::Attribute & let_drAttribute )
												:	SpecificCe< csi::uidl::Attribute >(let_drAttribute) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_StructElement : public SpecificCe< csi::uidl::StructElement >
{
  public:
						SCE_StructElement(
							csi::uidl::StructElement & let_drElement )
												:	SpecificCe< csi::uidl::StructElement >(let_drElement) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

class SCE_EnumValue : public SpecificCe< csi::uidl::EnumValue >
{
  public:
						SCE_EnumValue(
							csi::uidl::EnumValue & let_drEnumValue )
												:	SpecificCe< csi::uidl::EnumValue >(let_drEnumValue) {}
	virtual void	   	DisplayAt(
							csi::uidl::Display &
												o_rDisplay ) const;
};

}   // namespace uidl
}   // namespace ary

#endif



