/*************************************************************************
 *
 *  $RCSfile: reflect.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: np $ $Date: 2002/03/08 14:45:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef OODB_REFLECT_HXX
#define OODB_REFLECT_HXX

// USED SERVICES
	// BASE CLASSES
	// COMPONENTS
#include <template/array.hxx>
	// PARAMETERS
class MemberVisitor;
class Reflected;
class SerialDevice;
class MemberAccessor;
class MemberIterator;


/**
**/
class StdReflection
{
  public:
	// 	LIFECYCLE
						StdReflection(
							intt			i_nSize );
	virtual void	  	AddAccessor(	/// @#AddAccessor
							DYN MemberAccessor &
											let_drAccessor);
						~StdReflection();

	//	OPERATORS

	//	OPERATIONS
	virtual void		PerformVisit(
							MemberVisitor & 	io_rVisitor,
							Reflected &         i_rX ) const;

	virtual void	   	SerialWrite(
							SerialDevice & 		o_rDest,
							const Reflected & 	i_rSrc ) const;
	virtual void	 	SerialRead(
							SerialDevice &		io_rSrc,
							Reflected & 		o_rDest ) const;

	//	INQUIRY
	const MemberAccessor *
						AccessorTo(
							intt			i_nMemberId) const;
	MemberIterator		Members() const;

  private:
	//	SERVICE FUNCTIONS
	MemberAccessor *	FirstValidAccessor() const;

	//	DATA
	CosvArray<DYN MemberAccessor*>
						aAccessors;           	/// @ATTENTION [1..anzahl]  Because 0 is an invalid MemberId and the array indices are the MemberIds ths array starts with 1!
	MemberAccessor *	pFirstValidAccessor;
};




/** @#AddAccessor
	Accessors must be added in ascending order of member ids.
	But unused numbers in the sequence are allowed.
**/




#endif


