/*************************************************************************
 *
 *  $RCS: $
 *
 *  $Revision: 1.1.6.1 $
 *
 *  last change: $Author: mh $ $Date: 2002/05/31 13:21:40 $
 *
 *  The Contents of this  are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this  are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the License); You may not use this 
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an AS IS basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef CONNECTIVITY_TKEYVALUE_HXX
#define CONNECTIVITY_TKEYVALUE_HXX

#ifndef _CONNECTIVITY_FILE_VALUE_HXX_
#include "connectivity/FValue.hxx"
#endif

namespace connectivity
{
	class OKeyValue
	{
	private:
		::std::vector<ORowSetValueDecoratorRef> m_aKeys;
		sal_Int32 m_nValue;		

	public:
		OKeyValue() { }
		OKeyValue(sal_Int32 nVal) : m_nValue(nVal) {}
		~OKeyValue(){}

		inline static void * SAL_CALL operator new( size_t nSize ) SAL_THROW( () )
			{ return ::rtl_allocateMemory( nSize ); }
		inline static void * SAL_CALL operator new( size_t nSize,const void* _pHint ) SAL_THROW( () )
			{ return (void *)_pHint; }
		inline static void SAL_CALL operator delete( void * pMem ) SAL_THROW( () )
			{ ::rtl_freeMemory( pMem ); }
		inline static void SAL_CALL operator delete( void * pMem,const void* _pHint ) SAL_THROW( () )
			{  }

		inline void pushKey(const ORowSetValueDecoratorRef& _aValueRef)
		{ 
			m_aKeys.push_back(_aValueRef); 
		}
		inline void setValue(sal_Int32 nVal) { m_nValue = nVal; }

		::rtl::OUString	getKeyString(::std::vector<ORowSetValueDecoratorRef>::size_type i) const 
		{ 
			OSL_ENSURE(m_aKeys.size() > i,"Wrong index for KEyValue"); 
			return m_aKeys[i]->getValue(); 
		}
		double			getKeyDouble(::std::vector<ORowSetValueDecoratorRef>::size_type i) const 
		{ 
			OSL_ENSURE(m_aKeys.size() > i,"Wrong index for KEyValue"); 
			return m_aKeys[i]->getValue(); 
		}

		inline sal_Int32 getValue() const { return m_nValue; }
	};
}

#endif // CONNECTIVITY_TKEYVALUE_HXX

