/*************************************************************************
 *
 *  $RCSfile: ppatch.cxx,v $
 *
 *  $Revision: 1.3.2.2 $
 *
 *  last change: $Author: mh $ $Date: 2002/10/31 20:47:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OSL_THREAD_H_
#include <osl/thread.h>
#endif

#include "maindlg.hxx"
#include "environ.hxx"

#include "sihelp.hxx"
#include "OfficeRunningCheck.hxx"

#include "ppatch.hxx"
#include "ppatch.hrc"

#include "strings.hrc"
PagePatchSetup::PagePatchSetup( SvAgentDlg* pParent, const ResId& rResId ) :
	SvAgentPage		( pParent, rResId ),
	aFTInfo1		( this, ResId(FT_INFO1, rResId.GetResMgr()) ),
	aFTInfo2		( this, ResId(FT_INFO2, rResId.GetResMgr()) ),
	m_aOfficeRunning( this, rResId.GetResMgr() )
{
	String aText( ResId(STR_TITLE, rResId.GetResMgr()) );
	// #99630# StarOffice 6.0 Product Patch 1
	if (GETDLG()->GetEnv()->GetInstallMode() == IM_PATCH)
	{
		String suProductPatch(UniString::CreateFromAscii("%1 "));
		suProductPatch += String( ResId(STR_PRODUCTPATCH, rResId.GetResMgr()) );

		aText.SearchAndReplace( UniString::CreateFromAscii("%1"), suProductPatch );
	}

	aText.SearchAndReplace( UniString::CreateFromAscii("%1"),
			UniString::CreateFromAscii(GETDLG()->GetEnv()->GetProductName().GetBuffer()) );
	pParent->SetTitleStr( aText );


    // String aProductPatchNameVar( UniString::CreateFromAscii( "%PRODUCTPATCHNAME" ) );
    // String aProductPatchName( ResId( STR_PRODUCTPATCH, rResId.GetResMgr() ) );
	FreeResource();

	Font aBold( aFTInfo1.GetFont() );
	aBold.SetWeight( WEIGHT_BOLD );
	aFTInfo1.SetFont( aBold );

	aText = aFTInfo1.GetText();
	aText.SearchAndReplace( UniString::CreateFromAscii("%1"), GETDLG()->GetNextText() );
	aFTInfo1.SetText( aText );

	aText = aFTInfo2.GetText();
	aText.SearchAndReplace( UniString::CreateFromAscii("%1"), GETDLG()->GetNextText() );
	aText.SearchAndReplace( UniString::CreateFromAscii("%2"), GETDLG()->GetCancelText() );
	aFTInfo2.SetText( aText );
}

PagePatchSetup::~PagePatchSetup()
{
}

SvAgentPage* PagePatchSetup::Create( SvAgentDlg* pParent, const ResId& rResId )
{
	return new PagePatchSetup( pParent, rResId );
}

BOOL PagePatchSetup::AllowNext()
{
	BOOL bIsRunning = m_aOfficeRunning.isRunning( GETDLG()->GetEnv() );
	return !bIsRunning;
}
