#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.21.2.4 $
#
#   last change: $Author: mh $ $Date: 2002/10/31 21:30:36 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

ENABLE_EXCEPTIONS=TRUE
PRJNAME=sfx2
TARGET=sfx
.INCLUDE :  $(PRJ)$/util$/makefile.pmk
#sfx.hid generieren
GEN_HID=TRUE

# --- Settings -----------------------------------------------------

.INCLUDE :  settings.mk

# --- Allgemein ----------------------------------------------------

LIB1TARGET= $(SLB)$/$(TARGET).lib
LIB1FILES=  $(SLB)$/appl.lib		\
            $(SLB)$/explorer.lib	\
            $(SLB)$/doc.lib			\
            $(SLB)$/view.lib		\
            $(SLB)$/control.lib		\
            $(SLB)$/notify.lib		\
            $(SLB)$/menu.lib		\
            $(SLB)$/inet.lib		\
            $(SLB)$/accel.lib		\
            $(SLB)$/toolbox.lib		\
            $(SLB)$/statbar.lib		\
            $(SLB)$/dialog.lib		\
            $(SLB)$/bastyp.lib		\
            $(SLB)$/config.lib

HELPIDFILES=\
			..\inc\sfxsids.hrc	\
			..\source\inc\helpid.hrc

.IF "$(GUI)"!="UNX"
LIB2TARGET= $(LB)$/$(TARGET).lib
LIB2FILES=  $(LB)$/appl.lib       \
            $(LB)$/isfx.lib
.ENDIF

SHL1TARGET= sfx$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= isfx
.IF "$(PROFULLSWITCH)"!=""
.IF "$(OS)$(CPU)"=="SOLARISS"
SHL1VERSIONMAP=libsfx641ss.so.mapfile
.ENDIF
.ENDIF

SHL1STDLIBS+=\
                $(FWELIB) \
		$(BASICLIB) \
		$(VOSLIB) \
		$(SALLIB) \
		$(SALHELPERLIB) \
		$(CHANELLIB) \
		$(SO2LIB) \
		$(INETLIBSH) \
		$(SVTOOLLIB) \
		$(SVLLIB)	\
		$(SVLIB) \
		$(TOOLSLIB) \
		$(HELPLIB) \
		$(SVMEMLIB) \
		$(GOODIESLIB) \
		$(TKLIB) \
		$(SOTLIB) \
		$(RTLLIB) \
		$(CPPULIB) \
		$(CPPUHELPERLIB) \
        $(UNOTOOLSLIB) \
        $(UCBHELPERLIB) \
		$(COMPHELPERLIB) \
		$(XMLOFFLIB) \
		$(XMLSCRIPTLIB)

# [ed] 6/17/02 Add in another library

.IF "$(OS)"=="MACOSX"
SHL1STDLIBS += $(INETLIB)
.ENDIF

.IF "$(SOLAR_JAVA)" != ""
SHL1STDLIBS+=\
		$(SJLIB)
.ENDIF

.IF "$(GUI)"=="WNT"

SHL1STDLIBS+=\
		advapi32.lib \
		shell32.lib \
		gdi32.lib \
		ole32.lib \
		uuid.lib

SHL1STDLIBS+=user9x.lib

.ENDIF


.IF "$(GUI)"!="MAC"
SHL1DEPN += $(shell $(FIND) $(SLO) -type f -name "*.OBJ" -print)
.ENDIF

.IF "$(SOLAR_JAVA)" != ""
SHL1DEPN+= \
			$(L)$/sj.lib
.ENDIF

SHL1LIBS=   $(LIB1TARGET)

SHL1OBJS=   $(SLO)$/sfxdll.obj

SHL1DEF=    $(MISC)$/$(SHL1TARGET).def

DEF1NAME	=$(SHL1TARGET)
DEF1DEPN	=$(MISC)$/$(SHL1TARGET).flt	\
				$(HXX1FILES)	\
				$(HXX2FILES)	\
				$(HXX3FILES)	\
				$(HXX4FILES)	\
				$(HXX5FILES)	\
				$(HXX6FILES)	\
				$(HXX7FILES)	\
				$(HXX8FILES)	\
				$(HXX9FILES)	\
				$(HXX10FILES)
DEFLIB1NAME	=sfx
DEF1DES		=Sfx

.IF "$(GUI)"=="WNT"
DEF1EXPORT6 = component_writeInfo
DEF1EXPORT7 = component_getFactory
.ENDIF

SFXSRSLIST=\
		$(SRS)$/accel.srs \
		$(SRS)$/appl.srs \
		$(SRS)$/doc.srs \
		$(SRS)$/view.srs \
		$(SRS)$/config.srs \
		$(SRS)$/menu.srs \
		$(SRS)$/statbar.srs \
		$(SRS)$/toolbox.srs \
		$(SRS)$/dialog.srs \
		$(SRS)$/bastyp.srs \
		$(SRS)$/explorer.srs

RESLIB1NAME=$(TARGET)
RESLIB1SRSFILES=$(SFXSRSLIST)

# --- Targets ------------------------------------------------------


.INCLUDE :  target.mk

ALLTAR : $(SRS)$/hidother.hid

# --- SFX-Filter-Datei ---

$(MISC)$/$(SHL1TARGET).flt: makefile.mk
    @echo ------------------------------
    @echo Making: $@
    @+$(TYPE) sfxcommon.flt > $@
	@echo CntSearchLocationsTabPage>>$@
	@echo CntSearchDialog>>$@
.IF "$(GUI)"=="WNT"
    @echo WEP>>$@
    @echo ?CreateType@>>$@
.ENDIF
.IF "$(COM)"=="MSC"
    @echo ??_5>>$@
    @echo ??_7>>$@
    @echo ??_8>>$@
    @echo ??_9>>$@
    @echo ??_C>>$@
    @echo ??_E>>$@
    @echo ??_F>>$@
    @echo ??_G>>$@
    @echo ??_H>>$@
    @echo ??_I>>$@
	@echo ?CreateImpl@>>$@
	@echo ?GetGlobalClassName@>>$@
	@echo ?GetSvFactory@>>$@
    @echo ?LinkStub>>$@
    @echo ?nClassId@>>$@
	@echo ?RegisterInterface@>>$@
	@echo ::UsrException>>$@
	@echo ::IllegalArg>>$@
	@echo AVIllegalArg>>$@
	@echo ::Exception>>$@
	@echo NoSuchElementException>>$@
	@echo __CT>>$@
        @echo lcl_translateBasic2Uno>>$@
.ENDIF

# "$(COM)"=="MSC"

$(MISC)$/$(PRJNAME).hid : $(SRS)$/hidother.hid

$(SRS)$/hidother.hid: hidother.src
.IF "$(GUI)$(CPU)"=="WNTI"
.IF "$(BUILD_SOSL)"==""
	@+echo no hids
	@+-mhids hidother.src $(SRS) $(PRJNAME) dummy $(INCLUDE)
.ENDIF
.ELSE
	@echo nix
.ENDIF          # "$(GUI)$(CPU)"=="WNTI"

