/*************************************************************************
 *
 *  $RCSfile: collator_ko_KR_dict.cxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: bustamam $ $Date: 2001/12/15 13:39:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <collator_CJK.hxx>

static sal_uInt16 index[] = {
	0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 1000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0100,   // 4000
	0x0200, 0x0300, 0x0400, 0x0500, 0x0600, 0x0700, 0x0800, 0x0900, 0x0A00, 0x0B00, 0x0C00, 0x0D00, 0x0E00, 0x0F00, 0x1000, 0x1100,   // 5000
	0x1200, 0x1300, 0x1400, 0x1500, 0x1600, 0x1700, 0x1800, 0x1900, 0x1A00, 0x1B00, 0x1C00, 0x1D00, 0x1E00, 0x1F00, 0x2000, 0x2100,   // 6000
	0x2200, 0x2300, 0x2400, 0x2500, 0x2600, 0x2700, 0x2800, 0x2900, 0x2A00, 0x2B00, 0x2C00, 0x2D00, 0x2E00, 0x2F00, 0x3000, 0x3100,   // 7000
	0x3200, 0x3300, 0x3400, 0x3500, 0x3600, 0x3700, 0x3800, 0x3900, 0x3A00, 0x3B00, 0x3C00, 0x3D00, 0x3E00, 0x3F00, 0x4000, 0x4100,   // 8000
	0x4200, 0x4300, 0x4400, 0x4500, 0x4600, 0x4700, 0x4800, 0x4900, 0x4A00, 0x4B00, 0x4C00, 0x4D00, 0x4E00, 0x4F00, 0x5000, 0x5100,   // 9000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x5200, 0x5300, 0x5400, 0x5500,   // A000
	0x5600, 0x5700, 0x5800, 0x5900, 0x5A00, 0x5B00, 0x5C00, 0x5D00, 0x5E00, 0x5F00, 0x6000, 0x6100, 0x6200, 0x6300, 0x6400, 0x6500,   // B000
	0x6600, 0x6700, 0x6800, 0x6900, 0x6A00, 0x6B00, 0x6C00, 0x6D00, 0x6E00, 0x6F00, 0x7000, 0x7100, 0x7200, 0x7300, 0x7400, 0x7500,   // C000
	0x7600, 0x7700, 0x7800, 0x7900, 0x7A00, 0x7B00, 0x7C00, 0x7D00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // E000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x7E00, 0xFFFF, 0x7F00, 0x8000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F000
};

static sal_uInt16 weight[] = {
	0x2842, 0x29D7, 0xFFFF, 0x32BB, 0xFFFF, 0xFFFF, 0xFFFF, 0x1303, 0x28BB, 0x1C85, 0x1C96, 0x3AB6, 0xFFFF, 0x1871, 0xFFFF, 0xFFFF,   // 4E00 - 4E0F
	0xFFFF, 0x31A4, 0xFFFF, 0xFFFF, 0x2F3D, 0x197F, 0x1DB1, 0xFFFF, 0x033D, 0x177E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FF2, 0xFFFF,   // 4E10 - 4E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2BAD, 0xFFFF, 0xFFFF,   // 4E20 - 4E2F
	0xFFFF, 0xFFFF, 0x026B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CC4, 0x0A38, 0xFFFF, 0x2B5A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4E30 - 4E3F
	0xFFFF, 0xFFFF, 0x24E0, 0x07B1, 0xFFFF, 0x033E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C70, 0xFFFF, 0x1C24, 0x3C51, 0x3AA9,   // 4E40 - 4E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02DF, 0xFFFF, 0x1FF3, 0x27A3, 0xFFFF, 0xFFFF, 0xFFFF, 0x033F, 0x012E, 0x236C,   // 4E50 - 4E5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x004A, 0xFFFF, 0x0BA5, 0xFFFF, 0xFFFF,   // 4E60 - 4E6F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2722, 0xFFFF, 0xFFFF, 0x17DC, 0x1C78, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x011E, 0xFFFF,   // 4E70 - 4E7F
	0xFFFF, 0xFFFF, 0x0F9A, 0xFFFF, 0xFFFF, 0xFFFF, 0x118A, 0xFFFF, 0x242F, 0xFFFF, 0xFFFF, 0x1C25, 0x27F4, 0xFFFF, 0x2640, 0xFFFF,   // 4E80 - 4E8F
	0x2680, 0x266D, 0x3C52, 0xFFFF, 0x2514, 0x29D8, 0xFFFF, 0xFFFF, 0x0488, 0xFFFF, 0xFFFF, 0x1C26, 0xFFFF, 0xFFFF, 0x22DD, 0xFFFF,   // 4E90 - 4E9F
	0xFFFF, 0x132E, 0x3B01, 0xFFFF, 0x0308, 0x3B19, 0x2448, 0xFFFF, 0x3C11, 0xFFFF, 0xFFFF, 0x3B63, 0x01A2, 0x29D9, 0x1009, 0xFFFF,   // 4EA0 - 4EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A39, 0xFFFF, 0xFFFF, 0xFFFF, 0x2826, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4EB0 - 4EBF
	0x2081, 0x2827, 0xFFFF, 0xFFFF, 0x325B, 0xFFFF, 0xFFFF, 0x0340, 0xFFFF, 0xFFFF, 0x046E, 0x009A, 0xFFFF, 0x2868, 0xFFFF, 0xFFFF,   // 4EC0 - 4ECF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2873, 0x1C27, 0x352B, 0x28BC, 0x1872, 0x1D4E, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BB4, 0xFFFF, 0x301E,   // 4ED0 - 4EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0A8A, 0x10B7, 0x27F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4EE0 - 4EEF
	0x232C, 0xFFFF, 0x2BAE, 0xFFFF, 0xFFFF, 0xFFFF, 0x011F, 0x009B, 0xFFFF, 0xFFFF, 0xFFFF, 0x2853, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4EF0 - 4EFF
	0xFFFF, 0x04AF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B02, 0x27F6, 0x047D, 0xFFFF, 0x2515, 0x04B0, 0x17C3,   // 4F00 - 4F0F
	0x1714, 0x3E1B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4F10 - 4F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16A7,   // 4F20 - 4F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x163A, 0xFFFF, 0x10B8, 0xFFFF, 0x204E, 0xFFFF, 0x1C28, 0xFFFF, 0x1C29, 0x0002, 0xFFFF, 0xFFFF,   // 4F30 - 4F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2989, 0xFFFF, 0xFFFF, 0x0A3A, 0x2950, 0x3900, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26ED, 0x2951, 0x2B5B,   // 4F40 - 4F4F
	0x2AE4, 0x2641, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AB7, 0xFFFF, 0xFFFF, 0xFFFF, 0x2430, 0x2843, 0x18B9, 0x288E, 0xFFFF, 0xFFFF, 0xFFFF,   // 4F50 - 4F5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3812, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2396,   // 4F60 - 4F6F
	0x16A8, 0xFFFF, 0xFFFF, 0x0003, 0xFFFF, 0xFFFF, 0x04F8, 0xFFFF, 0xFFFF, 0xFFFF, 0x298A, 0xFFFF, 0xFFFF, 0xFFFF, 0x2844, 0x1C2A,   // 4F70 - 4F7F
	0xFFFF, 0x204F, 0xFFFF, 0x002E, 0x2CC2, 0xFFFF, 0x0FD1, 0xFFFF, 0x3297, 0xFFFF, 0x02AC, 0x10D0, 0xFFFF, 0x201F, 0xFFFF, 0x2B5C,   // 4F80 - 4F8F
	0xFFFF, 0x2723, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1245, 0xFFFF, 0x2F3E, 0xFFFF, 0xFFFF, 0x025A, 0xFFFF, 0x27C5, 0xFFFF, 0xFFFF,   // 4F90 - 4F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x143D, 0x3D84,   // 4FA0 - 4FAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32C6, 0x1071, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38B2,   // 4FB0 - 4FBF
	0xFFFF, 0xFFFF, 0x01D6, 0x30E9, 0x22DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2516, 0x2B88, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A80, 0xFFFF,   // 4FC0 - 4FCF
	0xFFFF, 0x2621, 0xFFFF, 0x01A3, 0x3BDA, 0xFFFF, 0xFFFF, 0x1E34, 0xFFFF, 0xFFFF, 0x12A9, 0xFFFF, 0xFFFF, 0x17B2, 0xFFFF, 0x1C2B,   // 4FD0 - 4FDF
	0x3C01, 0x2050, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EDE, 0x1873,   // 4FE0 - 4FEF
	0xFFFF, 0x0341, 0xFFFF, 0x1693, 0xFFFF, 0x3992, 0xFFFF, 0xFFFF, 0x17EA, 0xFFFF, 0x23FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4FF0 - 4FFF
	0xFFFF, 0xFFFF, 0x177F, 0xFFFF, 0xFFFF, 0xFFFF, 0x100A, 0xFFFF, 0xFFFF, 0x2F86, 0xFFFF, 0x009C, 0xFFFF, 0x1692, 0xFFFF, 0xFFFF,   // 5000 - 500F
	0xFFFF, 0x1515, 0x0B61, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B42, 0xFFFF, 0xFFFF, 0x3D85, 0x27C6, 0xFFFF, 0x300C, 0xFFFF, 0x01A4, 0x2F3F,   // 5010 - 501F
	0xFFFF, 0x2F87, 0xFFFF, 0x166F, 0x3298, 0xFFFF, 0x03A9, 0x2ACC, 0x0109, 0xFFFF, 0x24E1, 0x1246, 0x353A, 0x259F, 0xFFFF, 0xFFFF,   // 5020 - 502F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x236D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5030 - 503F
	0xFFFF, 0xFFFF, 0xFFFF, 0x23EA, 0xFFFF, 0xFFFF, 0xFFFF, 0x0004, 0x0150, 0x26EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38B3,   // 5040 - 504F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B1A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B5D, 0xFFFF, 0x29DA, 0xFFFF, 0xFFFF, 0xFFFF,   // 5050 - 505F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0120, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5060 - 506F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x325A, 0x29DB, 0x2642, 0xFFFF, 0x36F1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5070 - 507F
	0x02E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1874, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1670, 0xFFFF, 0xFFFF,   // 5080 - 508F
	0xFFFF, 0x012F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C68, 0x1980, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5090 - 509F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3151, 0x2622, 0xFFFF, 0xFFFF,   // 50A0 - 50AF
	0xFFFF, 0xFFFF, 0x2517, 0x298B, 0xFFFF, 0x2FA3, 0xFFFF, 0x1C97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01A5, 0xFFFF,   // 50B0 - 50BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0452, 0xFFFF, 0xFFFF, 0xFFFF, 0x3047, 0x1D4F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C98,   // 50C0 - 50CF
	0xFFFF, 0x0309, 0xFFFF, 0xFFFF, 0xFFFF, 0x17C4, 0x3E71, 0xFFFF, 0xFFFF, 0xFFFF, 0x118B, 0xFFFF, 0xFFFF, 0xFFFF, 0x26EF, 0xFFFF,   // 50D0 - 50DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x25E2, 0xFFFF, 0x1FF4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F77, 0xFFFF, 0xFFFF,   // 50E0 - 50EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0005, 0xFFFF, 0x1754, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C2C,   // 50F0 - 50FF
	0x27C7, 0x2B89, 0xFFFF, 0xFFFF, 0x23E2, 0xFFFF, 0x01A6, 0xFFFF, 0xFFFF, 0x013A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5100 - 510F
	0xFFFF, 0xFFFF, 0x2724, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C99,   // 5110 - 511F
	0xFFFF, 0x1166, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2643, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5120 - 512F
	0xFFFF, 0xFFFF, 0x2952, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1072, 0xFFFF, 0xFFFF, 0x075E, 0xFFFF, 0x23FF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5130 - 513F
	0x2545, 0x2766, 0xFFFF, 0x269B, 0x3C12, 0x31CA, 0x2A81, 0x3E38, 0x1D50, 0x02AD, 0xFFFF, 0x0448, 0x357D, 0x13EC, 0x3654, 0xFFFF,   // 5140 - 514F
	0xFFFF, 0xFFFF, 0x22DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C3C, 0xFFFF, 0xFFFF, 0xFFFF,   // 5150 - 515F
	0xFFFF, 0xFFFF, 0x0489, 0xFFFF, 0xFFFF, 0x285F, 0xFFFF, 0x07B3, 0x298C, 0x100B, 0x2725, 0x37FB, 0x025B, 0x123F, 0x3C2C, 0xFFFF,   // 5160 - 516F
	0xFFFF, 0x025C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1780, 0x04B1, 0x0342, 0x298D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0197, 0xFFFF, 0xFFFF, 0xFFFF,   // 5170 - 517F
	0x04B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2416, 0xFFFF, 0xFFFF, 0xFFFF, 0x2FB0, 0xFFFF, 0xFFFF, 0x28E7, 0xFFFF, 0xFFFF,   // 5180 - 518F
	0xFFFF, 0xFFFF, 0x143E, 0xFFFF, 0xFFFF, 0x13ED, 0xFFFF, 0x2623, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5190 - 519F
	0x0287, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x140A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13E7, 0xFFFF, 0x0BB5, 0xFFFF, 0xFFFF, 0xFFFF,   // 51A0 - 51AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x236E, 0x0FEA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x109E, 0xFFFF, 0xFFFF,   // 51B0 - 51BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3007, 0xFFFF, 0x2B8A, 0xFFFF, 0xFFFF, 0x100C, 0xFFFF, 0x2A82, 0x1280, 0x0BB6, 0xFFFF, 0xFFFF,   // 51C0 - 51CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x127A, 0x27BA, 0x3E72, 0xFFFF,   // 51D0 - 51DF
	0xFFFF, 0x1720, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 51E0 - 51EF
	0x3CEB, 0x009D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E39, 0xFFFF, 0x3035, 0x25E3, 0x31BA, 0xFFFF, 0xFFFF, 0x3AE9, 0xFFFF, 0xFFFF,   // 51F0 - 51FF
	0x0B62, 0xFFFF, 0xFFFF, 0x2828, 0xFFFF, 0xFFFF, 0x18A1, 0x29B6, 0x24E3, 0xFFFF, 0x002F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1516, 0xFFFF,   // 5200 - 520F
	0xFFFF, 0x3C13, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x109F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30CD, 0xFFFF, 0xFFFF,   // 5210 - 521F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x37EE, 0x176D, 0xFFFF, 0xFFFF, 0xFFFF, 0x12AA, 0x1C69, 0xFFFF, 0xFFFF, 0xFFFF, 0x029B, 0xFFFF,   // 5220 - 522F
	0x0B63, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A15, 0x1E83, 0x03AA, 0x2F6A, 0x2874, 0x0020, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5230 - 523F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3070, 0xFFFF, 0xFFFF, 0xFFFF, 0x32B0, 0xFFFF, 0xFFFF, 0x1C61, 0x0449, 0x0FA6, 0x298E, 0xFFFF, 0xFFFF,   // 5240 - 524F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x300E, 0xFFFF, 0x1875, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x007B, 0xFFFF, 0x1624, 0xFFFF, 0xFFFF,   // 5250 - 525F
	0xFFFF, 0x1D87, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2869, 0x298F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1876,   // 5260 - 526F
	0xFFFF, 0xFFFF, 0x3ADF, 0xFFFF, 0xFFFF, 0x2F88, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3993, 0xFFFF, 0x30CE,   // 5270 - 527F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3D3B, 0xFFFF, 0xFFFF, 0xFFFF, 0x044A, 0x1755, 0x1230, 0xFFFF, 0xFFFF, 0xFFFF, 0x013B, 0xFFFF, 0xFFFF,   // 5280 - 528F
	0xFFFF, 0x2A16, 0x013C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1084, 0xFFFF, 0xFFFF, 0xFFFF, 0x025D,   // 5290 - 529F
	0x0006, 0xFFFF, 0xFFFF, 0x10A0, 0x0453, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A83, 0x0886, 0x0142, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 52A0 - 52AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B2C, 0xFFFF,   // 52B0 - 52BF
	0xFFFF, 0x01A7, 0xFFFF, 0x1657, 0xFFFF, 0x32B1, 0xFFFF, 0x2624, 0xFFFF, 0x13EE, 0xFFFF, 0xFFFF, 0xFFFF, 0x01A8, 0xFFFF, 0xFFFF,   // 52C0 - 52CF
	0xFFFF, 0xFFFF, 0x1269, 0xFFFF, 0xFFFF, 0x0BB7, 0x2661, 0xFFFF, 0x005C, 0x14F9, 0xFFFF, 0x3D95, 0xFFFF, 0x1FF5, 0x10F1, 0x143F,   // 52D0 - 52DF
	0xFFFF, 0xFFFF, 0x1DB2, 0x296D, 0x0454, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 52E0 - 52EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3D96, 0xFFFF, 0x1073, 0xFFFF, 0xFFFF, 0x03AB, 0xFFFF, 0x288F, 0x0427, 0xFFFF, 0xFFFF, 0x0343, 0x1525,   // 52F0 - 52FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3901, 0xFFFF, 0xFFFF, 0x3E3A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3902, 0xFFFF, 0x3903,   // 5300 - 530F
	0x17C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1981, 0x3CAC, 0x189D, 0xFFFF, 0x2020, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5310 - 531F
	0x28BD, 0x02AE, 0xFFFF, 0x0071, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1982, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D26,   // 5320 - 532F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3A96, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A15,   // 5330 - 533F
	0x0344, 0x2082, 0xFFFF, 0x301F, 0x2860, 0xFFFF, 0xFFFF, 0x1FF6, 0x2518, 0x3DD8, 0x163B, 0xFFFF, 0xFFFF, 0x1304, 0xFFFF, 0xFFFF,   // 5340 - 534F
	0xFFFF, 0x1983, 0x2ABC, 0x353B, 0x3C02, 0xFFFF, 0xFFFF, 0x0790, 0xFFFF, 0xFFFF, 0x1625, 0xFFFF, 0x17C6, 0xFFFF, 0x1763, 0xFFFF,   // 5350 - 535F
	0x29C6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02C0, 0xFFFF, 0x1D72, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14D1,   // 5360 - 536F
	0x2829, 0x26F0, 0xFFFF, 0xFFFF, 0x0021, 0x0F9B, 0xFFFF, 0x03AC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C29, 0xFFFF, 0x01A9,   // 5370 - 537F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2346, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5380 - 538F
	0xFFFF, 0xFFFF, 0xFFFF, 0x233A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12AB, 0xFFFF, 0x3D86, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x269C,   // 5390 - 539F
	0x325C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x03B7, 0x3AB8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2499, 0xFFFF, 0xFFFF,   // 53A0 - 53AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x010A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 53B0 - 53BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2F78, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2644, 0x2F40, 0x047E, 0x2645, 0xFFFF, 0x163C, 0xFFFF, 0xFFFF,   // 53C0 - 53CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F1C, 0xFFFF, 0x3213, 0x1EDF, 0xFFFF, 0xFFFF, 0xFFFF, 0x163D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 53D0 - 53DF
	0xFFFF, 0x24E4, 0x3107, 0x0345, 0x020A, 0x0346, 0xFFFF, 0xFFFF, 0xFFFF, 0x020B, 0x2C71, 0x0414, 0x1E0E, 0x37FC, 0xFFFF, 0x0007,   // 53E0 - 53EF
	0x357E, 0x2CC3, 0x1C2D, 0x2646, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C2E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 53F0 - 53FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3E51, 0x0022, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AF6, 0x04F9, 0x296E, 0xFFFF, 0x0BB8, 0x140B, 0x3D87, 0x12AC,   // 5400 - 540F
	0x3655, 0x3B64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x037D, 0xFFFF, 0x12C7, 0xFFFF, 0x27AC,   // 5410 - 541F
	0x38DA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1877, 0xFFFF, 0xFFFF, 0x18A2, 0xFFFF, 0x3AEA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5420 - 542F
	0xFFFF, 0xFFFF, 0xFFFF, 0x251A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E61, 0x3214, 0xFFFF, 0x1517, 0x3D88, 0xFFFF, 0x2519, 0xFFFF,   // 5430 - 543F
	0xFFFF, 0xFFFF, 0x1074, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29DC, 0xFFFF, 0x020C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5440 - 544F
	0xFFFF, 0x354D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5450 - 545F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B61, 0xFFFF, 0x2B60, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5460 - 546F
	0xFFFF, 0x020D, 0xFFFF, 0x15E4, 0xFFFF, 0x0008, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2051, 0x3C53, 0x140C, 0xFFFF, 0xFFFF,   // 5470 - 547F
	0x2953, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3904, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CAD, 0xFFFF, 0x0347, 0xFFFF,   // 5480 - 548F
	0x1878, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5490 - 549F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x352C, 0xFFFF, 0xFFFF, 0xFFFF, 0x2875, 0xFFFF, 0xFFFF, 0x2C72, 0x030A, 0xFFFF, 0xFFFF, 0xFFFF,   // 54A0 - 54AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3B1B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x282B, 0xFFFF, 0xFFFF,   // 54B0 - 54BF
	0x233B, 0x39CC, 0xFFFF, 0xFFFF, 0x3C9B, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AF7, 0x28E8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 54C0 - 54CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 54D0 - 54DF
	0xFFFF, 0x269D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0009, 0xFFFF, 0xFFFF, 0x30CF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0232, 0x3D5B, 0xFFFF,   // 54E0 - 54EF
	0xFFFF, 0xFFFF, 0x3036, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3905, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 54F0 - 54FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3813, 0xFFFF, 0x1C2F, 0x2C9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12AD, 0xFFFF,   // 5500 - 550F
	0x0A78, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x131A, 0xFFFF, 0xFFFF, 0xFFFF,   // 5510 - 551F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2727,   // 5520 - 552F
	0xFFFF, 0x2F89, 0xFFFF, 0xFFFF, 0xFFFF, 0x231B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x352D, 0xFFFF,   // 5530 - 553F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x353C, 0xFFFF, 0x1C9A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1518,   // 5540 - 554F
	0xFFFF, 0xFFFF, 0xFFFF, 0x01D7, 0xFFFF, 0xFFFF, 0x0A5D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22E0, 0xFFFF,   // 5550 - 555F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3AEC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5560 - 556F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A17, 0xFFFF, 0xFFFF, 0xFFFF,   // 5570 - 557F
	0x00AF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D51, 0xFFFF, 0x3037, 0x0F83, 0xFFFF, 0x3D89, 0x3AED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5580 - 558F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3020, 0x3DD9, 0x3CC5, 0xFFFF, 0x3E73, 0x004B, 0xFFFF, 0xFFFF,   // 5590 - 559F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3DBC, 0xFFFF, 0x2728, 0x1C9B, 0x0742, 0x030B, 0xFFFF, 0x0A3B, 0xFFFF,   // 55A0 - 55AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 55B0 - 55BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D8A, 0xFFFF, 0x1CC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 55C0 - 55CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C9C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x251B, 0xFFFF, 0x04B3, 0xFFFF, 0xFFFF, 0x2F41,   // 55D0 - 55DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1C30, 0x3299, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 55E0 - 55EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE0, 0x2B62, 0xFFFF,   // 55F0 - 55FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x354E, 0xFFFF, 0xFFFF, 0x000A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5600 - 560F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0348, 0xFFFF, 0xFFFF, 0x1C9C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5610 - 561F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E0F,   // 5620 - 562F
	0xFFFF, 0xFFFF, 0x2A84, 0xFFFF, 0x3215, 0xFFFF, 0x2021, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5630 - 563F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5640 - 564F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3B8F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5650 - 565F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04B4, 0xFFFF, 0xFFFF, 0x3E74, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5660 - 566F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5670 - 567F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D5C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5680 - 568F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5690 - 569F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2458, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19AE, 0xFFFF, 0x3B65, 0xFFFF,   // 56A0 - 56AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2400, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2890, 0xFFFF, 0xFFFF, 0xFFFF,   // 56B0 - 56BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A3, 0xFFFF, 0xFFFF, 0x3E75, 0xFFFF, 0xFFFF,   // 56C0 - 56CF
	0xFFFF, 0x30EA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE1, 0x1C31, 0xFFFF, 0xFFFF, 0x3D27, 0xFFFF,   // 56D0 - 56DF
	0x282C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 56E0 - 56EF
	0x023C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10B9, 0x020E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 56F0 - 56FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3906, 0x23D7, 0xFFFF, 0xFFFF, 0xFFFF, 0x03AD, 0xFFFF, 0xFFFF, 0x0374, 0xFFFF, 0x26F1, 0xFFFF, 0xFFFF,   // 5700 - 570F
	0xFFFF, 0xFFFF, 0x269F, 0x269E, 0xFFFF, 0xFFFF, 0x0B64, 0xFFFF, 0x0A3C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3656,   // 5710 - 571F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0415, 0xFFFF, 0xFFFF,   // 5720 - 572F
	0x2C73, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5730 - 573F
	0x2C74, 0xFFFF, 0x37EF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0428, 0xFFFF, 0xFFFF, 0x1671, 0xFFFF, 0xFFFF, 0x0A5E, 0x005D, 0xFFFF,   // 5740 - 574F
	0x2AE5, 0x00C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5750 - 575F
	0xFFFF, 0x37DA, 0xFFFF, 0xFFFF, 0x023D, 0xFFFF, 0x354F, 0xFFFF, 0xFFFF, 0xFFFF, 0x38CE, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A8C, 0xFFFF,   // 5760 - 576F
	0x01AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0349, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x353D, 0xFFFF, 0xFFFF, 0xFFFF,   // 5770 - 577F
	0xFFFF, 0xFFFF, 0x1EE2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A8B, 0xFFFF, 0xFFFF, 0x3C14, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5780 - 578F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3B1C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5790 - 579F
	0x2798, 0xFFFF, 0x034A, 0x26A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 57A0 - 57AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 57B0 - 57BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x233C, 0xFFFF, 0xFFFF, 0xFFFF, 0x2625, 0x2B8B, 0xFFFF, 0xFFFF, 0x1341, 0xFFFF, 0xFFFF, 0x1D98, 0xFFFF,   // 57C0 - 57CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x244A,   // 57D0 - 57DF
	0x1879, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 57E0 - 57EF
	0x2FA4, 0xFFFF, 0xFFFF, 0xFFFF, 0x203C, 0xFFFF, 0xFFFF, 0x2CDD, 0xFFFF, 0x1695, 0x04B6, 0xFFFF, 0x04B7, 0xFFFF, 0xFFFF, 0xFFFF,   // 57F0 - 57FF
	0x0387, 0xFFFF, 0x0A79, 0xFFFF, 0xFFFF, 0x017A, 0x36B3, 0xFFFF, 0x007C, 0x275C, 0x22F0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5800 - 580F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3052, 0xFFFF,   // 5810 - 581F
	0xFFFF, 0x17B3, 0xFFFF, 0xFFFF, 0x2A18, 0xFFFF, 0xFFFF, 0x2459, 0xFFFF, 0xFFFF, 0x005E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x25E4,   // 5820 - 582F
	0x23EB, 0x17B4, 0xFFFF, 0xFFFF, 0x28BE, 0x0B65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01D8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5830 - 583F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02E1, 0x24B3, 0xFFFF, 0xFFFF, 0xFFFF, 0x009E,   // 5840 - 584F
	0xFFFF, 0x1E10, 0xFFFF, 0xFFFF, 0x356A, 0xFFFF, 0xFFFF, 0x0B66, 0x0A7A, 0xFFFF, 0x3108, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CBC, 0xFFFF,   // 5850 - 585F
	0xFFFF, 0x2990, 0x251C, 0xFFFF, 0x3D97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5860 - 586F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C9D, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F79, 0xFFFF, 0xFFFF, 0x2991, 0xFFFF, 0x1F1D, 0xFFFF,   // 5870 - 587F
	0xFFFF, 0xFFFF, 0xFFFF, 0x01AB, 0xFFFF, 0x1D1D, 0xFFFF, 0xFFFF, 0xFFFF, 0x2626, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5880 - 588F
	0xFFFF, 0xFFFF, 0xFFFF, 0x14D2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x318C, 0xFFFF, 0x2C42, 0x3B90,   // 5890 - 589F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1510, 0x0B97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x352E, 0xFFFF,   // 58A0 - 58AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x18A4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x251D, 0x28BF, 0xFFFF, 0xFFFF, 0x0030, 0xFFFF,   // 58B0 - 58BF
	0xFFFF, 0x1756, 0xFFFF, 0xFFFF, 0xFFFF, 0x2553, 0xFFFF, 0x0A3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D98, 0xFFFF,   // 58C0 - 58CF
	0xFFFF, 0x3AC5, 0xFFFF, 0x2324, 0xFFFF, 0x3C54, 0xFFFF, 0xFFFF, 0x11B3, 0x02AF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02E2, 0x1120,   // 58D0 - 58DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2399, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C32, 0x2854, 0xFFFF, 0xFFFF, 0x28C0,   // 58E0 - 58EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2845, 0x3C55, 0x1D1E, 0xFFFF, 0x1EE3, 0xFFFF, 0xFFFF,   // 58F0 - 58FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AB9,   // 5900 - 590F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04B8, 0x1D3C, 0x25BF, 0xFFFF, 0xFFFF, 0x1F1E, 0x0A32, 0xFFFF, 0x236F, 0xFFFF, 0xFFFF, 0xFFFF,   // 5910 - 591F
	0xFFFF, 0xFFFF, 0x1473, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A8D, 0xFFFF, 0x3021, 0x357F, 0x187A, 0xFFFF, 0x25E5, 0x232D, 0xFFFF,   // 5920 - 592F
	0xFFFF, 0x206A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C03, 0xFFFF,   // 5930 - 593F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2401, 0xFFFF, 0xFFFF, 0x04B9, 0x07B4, 0x17EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0416, 0x2B63,   // 5940 - 594F
	0x3CC6, 0x01D9, 0xFFFF, 0xFFFF, 0x18A5, 0x3BD3, 0xFFFF, 0x36F2, 0xFFFF, 0xFFFF, 0x3B1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5950 - 595F
	0x2992, 0xFFFF, 0x1C33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x251E, 0xFFFF, 0xFFFF, 0x355B, 0x2767, 0x28C1, 0x1D3D, 0x18A6, 0xFFFF,   // 5960 - 596F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0844, 0x0888, 0xFFFF, 0xFFFF, 0xFFFF, 0x0031, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C56, 0xFFFF, 0xFFFF,   // 5970 - 597F
	0xFFFF, 0xFFFF, 0x2434, 0x1984, 0x132F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2855, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5980 - 598F
	0xFFFF, 0xFFFF, 0xFFFF, 0x04BA, 0xFFFF, 0xFFFF, 0x25E6, 0x046F, 0xFFFF, 0x14D3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5990 - 599F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x352F, 0xFFFF, 0xFFFF, 0x1672, 0xFFFF, 0xFFFF, 0xFFFF, 0x36F3, 0xFFFF, 0xFFFF, 0xFFFF,   // 59A0 - 59AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1342, 0xFFFF, 0x3008, 0xFFFF, 0xFFFF, 0x3053, 0xFFFF,   // 59B0 - 59BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x29DD, 0xFFFF, 0xFFFF, 0x1440, 0xFFFF, 0xFFFF, 0x2876, 0xFFFF, 0x2022, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 59C0 - 59CF
	0x2954, 0x020F, 0xFFFF, 0x1D99, 0x26F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2856, 0x25E7, 0xFFFF, 0x007D, 0x2B5E, 0xFFFF, 0xFFFF,   // 59D0 - 59DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0032, 0xFFFF, 0x27FA, 0xFFFF, 0x2CC4, 0xFFFF, 0x3E76, 0xFFFF, 0x3B03, 0xFFFF,   // 59E0 - 59EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x245A, 0xFFFF, 0xFFFF, 0x282D, 0xFFFF, 0xFFFF, 0xFFFF, 0x2877,   // 59F0 - 59FF
	0xFFFF, 0x26F3, 0xFFFF, 0x25A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A00 - 5A0F
	0xFFFF, 0x1C34, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A4, 0xFFFF, 0xFFFF, 0x251F, 0x0761, 0xFFFF, 0xFFFF, 0x245B,   // 5A10 - 5A1F
	0x2052, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22E1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1305, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A20 - 5A2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3216, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F8A, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A30 - 5A3F
	0xFFFF, 0x11B4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x37DB, 0xFFFF, 0xFFFF, 0x256F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A40 - 5A4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C81, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A50 - 5A5F
	0xFFFF, 0xFFFF, 0x1985, 0xFFFF, 0xFFFF, 0xFFFF, 0x187B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A60 - 5A6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A70 - 5A7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A80 - 5A8F
	0xFFFF, 0xFFFF, 0x1343, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15E5, 0x26A1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A90 - 5A9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2023, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AA0 - 5AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AB0 - 5ABF
	0xFFFF, 0x000B, 0x1EE4, 0xFFFF, 0x26A2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CC5, 0xFFFF, 0xFFFF, 0x3BFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AC0 - 5ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AD0 - 5ADF
	0xFFFF, 0x296F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B04, 0xFFFF, 0xFFFF, 0x0945, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AE0 - 5AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AF0 - 5AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CAE, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E77, 0xFFFF, 0x1D52, 0x030C, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B00 - 5B0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38DB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B10 - 5B1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19AF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B20 - 5B2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B30 - 5B3F
	0x1C9D, 0xFFFF, 0xFFFF, 0x239A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B40 - 5B4F
	0x2878, 0x3BF3, 0xFFFF, 0xFFFF, 0x025E, 0x286A, 0xFFFF, 0x2879, 0x2AB6, 0xFFFF, 0x187C, 0xFFFF, 0x287A, 0x3D5D, 0xFFFF, 0x1369,   // 5B50 - 5B5F
	0xFFFF, 0xFFFF, 0xFFFF, 0x01DA, 0x0210, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B1E, 0xFFFF, 0x1E40, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B60 - 5B6F
	0x1F1F, 0x289E, 0xFFFF, 0xFFFF, 0xFFFF, 0x187D, 0xFFFF, 0xFFFF, 0x3AC6, 0xFFFF, 0x2729, 0xFFFF, 0x23F4, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B70 - 5B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A9B, 0xFFFF, 0x2647, 0x1EE5, 0x2301, 0xFFFF, 0x1E58, 0x2570, 0xFFFF, 0xFFFF, 0x02FD,   // 5B80 - 5B8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x17C7, 0xFFFF, 0x3571, 0x3D51, 0x2ACD, 0x0288, 0x2B64, 0x29DE, 0x2571, 0x27C8, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B90 - 5B9F
	0xFFFF, 0xFFFF, 0x00B0, 0x1D53, 0x206B, 0x272A, 0x3CC7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D9A, 0xFFFF, 0x0398, 0xFFFF,   // 5BA0 - 5BAF
	0x28EA, 0xFFFF, 0xFFFF, 0x3B1F, 0x245C, 0x1E11, 0x000C, 0xFFFF, 0x2053, 0x2627, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F20,   // 5BB0 - 5BBF
	0x2FA5, 0xFFFF, 0x2970, 0x26A3, 0x04BB, 0x282E, 0x160C, 0x034B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x187E, 0xFFFF, 0xFFFF, 0xFFFF,   // 5BC0 - 5BCF
	0x1344, 0xFFFF, 0x3ACD, 0x2648, 0x203D, 0xFFFF, 0xFFFF, 0x0862, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12FA, 0x2F6B,   // 5BD0 - 5BDF
	0xFFFF, 0x0272, 0x32C7, 0xFFFF, 0x2520, 0x25E8, 0x206C, 0x0861, 0x2FA6, 0x2076, 0xFFFF, 0x1C35, 0x0289, 0xFFFF, 0x118C, 0x2B8C,   // 5BE0 - 5BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3109, 0x17B5, 0xFFFF, 0x30F2, 0xFFFF, 0x1C36, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5BF0 - 5BFF
	0xFFFF, 0x17EC, 0xFFFF, 0xFFFF, 0x1C37, 0xFFFF, 0xFFFF, 0x28C2, 0x2993, 0x26F4, 0x2AB7, 0x2077, 0xFFFF, 0x0A8E, 0x0B67, 0x1E12,   // 5C00 - 5C0F
	0xFFFF, 0x1E13, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3048, 0xFFFF, 0xFFFF, 0x1C9E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C10 - 5C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2649, 0xFFFF, 0xFFFF, 0xFFFF, 0x1673, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C20 - 5C2F
	0xFFFF, 0x3217, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2024, 0x2768, 0x300F, 0x0211, 0x0A12, 0xFFFF, 0x15E6, 0x091C,   // 5C30 - 5C3F
	0x0375, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x010B, 0x01DB, 0xFFFF, 0x0388, 0xFFFF, 0xFFFF, 0x2533, 0xFFFF, 0x2026, 0x2025, 0xFFFF,   // 5C40 - 5C4F
	0xFFFF, 0x1D73, 0xFFFF, 0xFFFF, 0xFFFF, 0x2994, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1781, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C50 - 5C5F
	0x0B68, 0xFFFF, 0x11B5, 0xFFFF, 0x3273, 0x12AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E35, 0xFFFF, 0xFFFF, 0x0C4B,   // 5C60 - 5C6F
	0xFFFF, 0x1C6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E52, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C70 - 5C7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C80 - 5C8F
	0x04BC, 0x28AF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C90 - 5C9F
	0xFFFF, 0x007E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x231C, 0xFFFF, 0x1EE6, 0x0072, 0xFFFF, 0xFFFF, 0xFFFF,   // 5CA0 - 5CAF
	0xFFFF, 0x0A8F, 0xFFFF, 0x22F1, 0xFFFF, 0x3C57, 0xFFFF, 0x15FB, 0x2302, 0xFFFF, 0x10BB, 0xFFFF, 0xFFFF, 0xFFFF, 0x29C7, 0xFFFF,   // 5CB0 - 5CBF
	0x1EE7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5CC0 - 5CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x329A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5CD0 - 5CDF
	0x1C9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22E2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17ED,   // 5CE0 - 5CEF
	0x17EE, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BDB, 0xFFFF, 0x0B69, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B8D, 0xFFFF, 0x3C04, 0xFFFF, 0xFFFF,   // 5CF0 - 5CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD2, 0x04BD, 0xFFFF,   // 5D00 - 5D0F
	0xFFFF, 0x023E, 0xFFFF, 0xFFFF, 0x3152, 0xFFFF, 0x233D, 0x007F, 0xFFFF, 0x1247, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D10 - 5D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5C, 0xFFFF, 0x18CA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D20 - 5D2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D30 - 5D3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15E7, 0x005F, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D40 - 5D4F
	0x0FB0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D50 - 5D5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5D, 0xFFFF, 0xFFFF, 0x25C0, 0xFFFF, 0xFFFF, 0x2F42,   // 5D60 - 5D6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D70 - 5D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x034C, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D80 - 5D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CEF, 0xFFFF, 0xFFFF,   // 5D90 - 5D9F
	0x030D, 0xFFFF, 0x25EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2405, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5DA0 - 5DAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24B6, 0xFFFF, 0x10BC, 0xFFFF, 0x1D1F, 0x22F2, 0xFFFF, 0xFFFF,   // 5DB0 - 5DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x25C1, 0xFFFF, 0xFFFF,   // 5DC0 - 5DCF
	0xFFFF, 0xFFFF, 0x1306, 0xFFFF, 0xFFFF, 0xFFFF, 0x231D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3022, 0x2B65, 0xFFFF,   // 5DD0 - 5DDF
	0xFFFF, 0x1F2B, 0x1E14, 0xFFFF, 0xFFFF, 0x025F, 0x2AE6, 0x030E, 0x010C, 0xFFFF, 0xFFFF, 0x14FA, 0xFFFF, 0xFFFF, 0x2F43, 0xFFFF,   // 5DE0 - 5DEF
	0xFFFF, 0x04BE, 0x27FC, 0x1C38, 0x37DC, 0xFFFF, 0xFFFF, 0x3B05, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E41, 0x0121, 0xFFFF,   // 5DF0 - 5DFF
	0xFFFF, 0xFFFF, 0x2027, 0x3907, 0xFFFF, 0xFFFF, 0x1721, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E78, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E00 - 5E0F
	0xFFFF, 0x3572, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3054, 0xFFFF, 0xFFFF, 0x2CC6, 0xFFFF, 0x16A9, 0xFFFF, 0x2A19, 0xFFFF, 0xFFFF,   // 5E10 - 5E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C39, 0xFFFF, 0x1D3E, 0xFFFF, 0xFFFF,   // 5E20 - 5E2F
	0xFFFF, 0xFFFF, 0xFFFF, 0x28C3, 0xFFFF, 0xFFFF, 0x0A90, 0xFFFF, 0x1CA0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1441, 0xFFFF, 0x3D8B,   // 5E30 - 5E3F
	0x29DF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22F3, 0x391D, 0xFFFF, 0x1674, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CEC, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E40 - 5E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12FB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x329B,   // 5E50 - 5E5F
	0xFFFF, 0x1706, 0x0A7B, 0x38DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E60 - 5E6F
	0xFFFF, 0xFFFF, 0x0033, 0x38CF, 0x0849, 0xFFFF, 0xFFFF, 0x1782, 0x3B43, 0x0034, 0xFFFF, 0x3CC8, 0x272B, 0x272C, 0x04BF, 0xFFFF,   // 5E70 - 5E7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28C4, 0xFFFF, 0xFFFF, 0x1986, 0xFFFF, 0xFFFF, 0x1CA1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D20,   // 5E80 - 5E8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2955, 0xFFFF, 0x29C8, 0xFFFF, 0xFFFF, 0x01AC, 0xFFFF, 0x187F, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E90 - 5E9F
	0x1CA2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B6B, 0x2AE7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0212, 0xFFFF, 0x29E0, 0xFFFF, 0xFFFF,   // 5EA0 - 5EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x231E, 0x1D21, 0x0080, 0x2628, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x272D, 0xFFFF,   // 5EB0 - 5EBF
	0xFFFF, 0xFFFF, 0x1CA3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3ABA, 0x10AC, 0x0FC2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5EC0 - 5ECF
	0x034D, 0xFFFF, 0xFFFF, 0x027F, 0xFFFF, 0xFFFF, 0x118D, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B66, 0x2995, 0xFFFF, 0xFFFF, 0xFFFF, 0x14D4,   // 5ED0 - 5EDF
	0x2F8B, 0xFFFF, 0x38DD, 0x02B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1075, 0xFFFF, 0xFFFF, 0xFFFF,   // 5EE0 - 5EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3060, 0xFFFF, 0xFFFF, 0x245E, 0x29E1, 0xFFFF, 0xFFFF, 0x0122, 0x3D28, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5EF0 - 5EFF
	0xFFFF, 0x1764, 0xFFFF, 0xFFFF, 0x1121, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x203E,   // 5F00 - 5F0F
	0xFFFF, 0x2028, 0xFFFF, 0x0399, 0x2A85, 0x282F, 0xFFFF, 0x18BA, 0x3C9C, 0xFFFF, 0xFFFF, 0x27FD, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A1A,   // 5F10 - 5F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BDC, 0x3C58, 0xFFFF, 0x0889, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F20 - 5F2F
	0xFFFF, 0x2378, 0xFFFF, 0xFFFF, 0xFFFF, 0x28C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0081, 0xFFFF, 0x3A97, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F30 - 5F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3550, 0xFFFF, 0x0082, 0xFFFF, 0x15E8, 0xFFFF, 0x1307, 0xFFFF,   // 5F40 - 5F4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A3E, 0x3C2D, 0xFFFF, 0x3DF7, 0xFFFF, 0x27FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F50 - 5F5F
	0xFFFF, 0xFFFF, 0x3C15, 0xFFFF, 0xFFFF, 0xFFFF, 0x23EC, 0x2662, 0xFFFF, 0x2FA7, 0x3994, 0x2A86, 0x19B0, 0x3832, 0xFFFF, 0xFFFF,   // 5F60 - 5F6F
	0x2F8C, 0x24B7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1675, 0xFFFF, 0x244B, 0xFFFF, 0xFFFF, 0x3A87, 0xFFFF, 0xFFFF, 0x18BB,   // 5F70 - 5F7F
	0x2593, 0x29E2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A91, 0xFFFF, 0x1F2C, 0xFFFF, 0xFFFF, 0x3D29, 0x124F, 0x3D8C, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F80 - 5F8F
	0x1D22, 0x01AD, 0x0B6C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CDA, 0x1696, 0x1C3A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2ACE, 0xFFFF,   // 5F90 - 5F9F
	0x0FD3, 0x23D8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CED, 0x17C8, 0x1F2D, 0xFFFF, 0xFFFF, 0xFFFF, 0x15E9, 0xFFFF,   // 5FA0 - 5FAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CE7, 0xFFFF, 0x0AF0, 0xFFFF, 0x3038, 0xFFFF, 0xFFFF, 0xFFFF, 0x3DF8, 0xFFFF, 0xFFFF,   // 5FB0 - 5FBF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2078, 0xFFFF, 0x3A98, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C0, 0x2830, 0xFFFF, 0xFFFF,   // 5FC0 - 5FCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30F3, 0x2C75, 0x1330, 0x1331, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5FD0 - 5FDF
	0x31CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x33F6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5FE0 - 5FEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0858, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C8B, 0xFFFF, 0x18A7,   // 5FF0 - 5FFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x232E,   // 6000 - 600F
	0xFFFF, 0xFFFF, 0x088A, 0xFFFF, 0xFFFF, 0xFFFF, 0x3908, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10BD, 0x1C3B, 0xFFFF, 0xFFFF,   // 6010 - 601F
	0x3580, 0x27FF, 0xFFFF, 0xFFFF, 0xFFFF, 0x047F, 0xFFFF, 0x1D9B, 0x26A4, 0xFFFF, 0x02E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0143,   // 6020 - 602F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6030 - 603F
	0xFFFF, 0x2857, 0x1F2E, 0x2029, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CEE, 0xFFFF, 0xFFFF,   // 6040 - 604F
	0x0260, 0xFFFF, 0x3B06, 0xFFFF, 0xFFFF, 0x1D23, 0xFFFF, 0xFFFF, 0xFFFF, 0x239B, 0xFFFF, 0xFFFF, 0xFFFF, 0x029C, 0xFFFF, 0xFFFF,   // 6050 - 605F
	0xFFFF, 0xFFFF, 0x3D2A, 0x287B, 0x3E28, 0x329C, 0xFFFF, 0xFFFF, 0x3ACE, 0x2799, 0x0023, 0xFFFF, 0x0859, 0x0261, 0xFFFF, 0x203F,   // 6060 - 606F
	0x3E62, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6070 - 607F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x248A, 0xFFFF, 0xFFFF, 0xFFFF, 0x206D, 0xFFFF, 0xFFFF, 0x2A1B, 0x3ACF, 0xFFFF, 0xFFFF,   // 6080 - 608F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D2B, 0xFFFF, 0x3814, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E59, 0x2996, 0xFFFF, 0xFFFF, 0xFFFF, 0x2521,   // 6090 - 609F
	0x272E, 0xFFFF, 0xFFFF, 0x3CC9, 0x310A, 0xFFFF, 0xFFFF, 0x12AF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60A0 - 60AF
	0x2ACF, 0xFFFF, 0x1987, 0x0AF1, 0x31F3, 0xFFFF, 0x15FC, 0xFFFF, 0x01DC, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B6D, 0x3009, 0xFFFF, 0xFFFF,   // 60B0 - 60BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29E3, 0xFFFF, 0x0B98, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60C0 - 60CF
	0xFFFF, 0x3C7B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C8C, 0xFFFF, 0x1D3F, 0xFFFF, 0xFFFF, 0x272F,   // 60D0 - 60DF
	0x3C2E, 0x22F4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60E0 - 60EF
	0x3530, 0x08FA, 0xFFFF, 0x1CA4, 0xFFFF, 0xFFFF, 0x3CEF, 0xFFFF, 0xFFFF, 0x2370, 0x1D9C, 0x325D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60F0 - 60FF
	0xFFFF, 0x1EE9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0123, 0xFFFF, 0x2730, 0x2731, 0xFFFF, 0xFFFF, 0xFFFF, 0x15FD, 0x383E, 0x27C9,   // 6100 - 610F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x264A, 0x233E, 0xFFFF, 0xFFFF, 0xFFFF, 0x0060,   // 6110 - 611F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6120 - 612F
	0x3CF0, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F8D, 0xFFFF, 0xFFFF, 0x009F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2054, 0xFFFF, 0x00A0, 0x26A5,   // 6130 - 613F
	0xFFFF, 0xFFFF, 0x2629, 0xFFFF, 0x1250, 0xFFFF, 0xFFFF, 0x279A, 0x287C, 0xFFFF, 0x0198, 0x3581, 0x3CF1, 0xFFFF, 0xFFFF, 0xFFFF,   // 6140 - 614F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3995, 0xFFFF, 0x1442, 0xFFFF, 0xFFFF, 0x2F7A, 0x2F7B, 0xFFFF, 0xFFFF, 0xFFFF, 0x3784, 0xFFFF, 0x366D,   // 6150 - 615F
	0xFFFF, 0xFFFF, 0x1308, 0x028A, 0x0024, 0xFFFF, 0xFFFF, 0x3C2F, 0x00A1, 0xFFFF, 0xFFFF, 0x2AD0, 0xFFFF, 0xFFFF, 0x1076, 0xFFFF,   // 6160 - 616F
	0x26F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01AE, 0x0083, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3010, 0x2607, 0xFFFF,   // 6170 - 617F
	0xFFFF, 0x310B, 0x264B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1988, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C43, 0xFFFF,   // 6180 - 618F
	0x108E, 0x19CD, 0xFFFF, 0xFFFF, 0x30D0, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E7A, 0x3E79, 0x3551, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6190 - 619F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A8, 0xFFFF, 0xFFFF, 0x0BB9, 0xFFFF, 0x0151, 0xFFFF, 0x15FE, 0x01AF, 0xFFFF, 0x14FB, 0xFFFF,   // 61A0 - 61AF
	0xFFFF, 0xFFFF, 0x3B97, 0xFFFF, 0xFFFF, 0xFFFF, 0x23E3, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A5F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0061, 0xFFFF,   // 61B0 - 61BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0455, 0xFFFF, 0xFFFF, 0xFFFF, 0x0035, 0x3B20, 0x27BB, 0x2523, 0x14FC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 61C0 - 61CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 61D0 - 61DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0762, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 61E0 - 61EF
	0xFFFF, 0xFFFF, 0x2CE8, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F84, 0x3D2C, 0x3BDD, 0xFFFF, 0x2F7C, 0xFFFF, 0x034E, 0xFFFF, 0xFFFF, 0x27CA,   // 61F0 - 61FF
	0x108F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A7C, 0x0273, 0xFFFF, 0x14FD, 0xFFFF, 0x1F4A, 0x1EEA, 0x2788, 0xFFFF,   // 6200 - 620F
	0x1D9D, 0x22E3, 0x01DD, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C7C, 0xFFFF, 0xFFFF, 0xFFFF, 0x3011, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x044B,   // 6210 - 621F
	0xFFFF, 0x0062, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29B7, 0xFFFF, 0xFFFF, 0xFFFF, 0x1240, 0xFFFF,   // 6220 - 622F
	0x2997, 0x3E7B, 0xFFFF, 0xFFFF, 0x0A92, 0xFFFF, 0x3C59, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1077, 0x1676,   // 6230 - 623F
	0x1E15, 0x38B4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D54, 0x3C5A, 0x1989, 0xFFFF, 0x1EEB, 0xFFFF, 0x28EB, 0xFFFF, 0xFFFF,   // 6240 - 624F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3531, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x353F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6250 - 625F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A9, 0xFFFF,   // 6260 - 626F
	0xFFFF, 0x0480, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1881, 0xFFFF, 0xFFFF, 0x198A, 0xFFFF, 0xFFFF, 0x2347, 0xFFFF, 0xFFFF, 0x1FF7,   // 6270 - 627F
	0x04C1, 0xFFFF, 0xFFFF, 0xFFFF, 0x30D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0189, 0x37DD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6280 - 628F
	0xFFFF, 0x23E4, 0x1D24, 0xFFFF, 0xFFFF, 0x36F4, 0xFFFF, 0x3B07, 0x29B8, 0xFFFF, 0xFFFF, 0x3909, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6290 - 629F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3A88, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 62A0 - 62AF
	0xFFFF, 0x390A, 0xFFFF, 0xFFFF, 0xFFFF, 0x2956, 0xFFFF, 0xFFFF, 0xFFFF, 0x131B, 0xFFFF, 0xFFFF, 0x2325, 0x318D, 0xFFFF, 0xFFFF,   // 62B0 - 62BF
	0xFFFF, 0xFFFF, 0x18BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14FE, 0x085A, 0x0FBB, 0xFFFF, 0xFFFF, 0x163E, 0x1626, 0xFFFF, 0x0764,   // 62C0 - 62CF
	0x02E5, 0xFFFF, 0x010D, 0x3012, 0x1658, 0xFFFF, 0x3532, 0x25EC, 0x034F, 0x2ABD, 0xFFFF, 0x30D2, 0x1697, 0xFFFF, 0xFFFF, 0xFFFF,   // 62D0 - 62DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x029D, 0x2040, 0x04FA, 0x2C45,   // 62E0 - 62EF
	0xFFFF, 0x0262, 0xFFFF, 0x03AE, 0xFFFF, 0xFFFF, 0xFFFF, 0x0213, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FEA, 0x0765,   // 62F0 - 62FF
	0xFFFF, 0x2C76, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C77, 0xFFFF, 0x2303, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6300 - 630F
	0xFFFF, 0x0B6E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6310 - 631F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AE8, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C9E,   // 6320 - 632F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29E4, 0x2462, 0xFFFF, 0x1309, 0x3C05, 0xFFFF,   // 6330 - 633F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F4D, 0xFFFF, 0xFFFF, 0x37FD, 0xFFFF, 0xFFFF, 0x0786,   // 6340 - 634F
	0x2461, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x390B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6350 - 635F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17EF, 0x1C3C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x010E, 0xFFFF,   // 6360 - 636F
	0xFFFF, 0xFFFF, 0x03AF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3055, 0xFFFF, 0xFFFF, 0x0787, 0x085B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D25,   // 6370 - 637F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1E16, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EEC, 0x0B6F, 0xFFFF, 0xFFFF, 0x28C6, 0xFFFF, 0xFFFF, 0xFFFF,   // 6380 - 638F
	0xFFFF, 0xFFFF, 0x1698, 0xFFFF, 0xFFFF, 0xFFFF, 0x2348, 0xFFFF, 0x0389, 0xFFFF, 0xFFFF, 0x02C1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6390 - 639F
	0x0FF3, 0x2FA8, 0x3565, 0xFFFF, 0xFFFF, 0x29D0, 0xFFFF, 0x0263, 0x318E, 0x2402, 0x2A87, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63A0 - 63AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63B0 - 63BF
	0x0036, 0xFFFF, 0xFFFF, 0xFFFF, 0x2732, 0xFFFF, 0x0417, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14D5,   // 63C0 - 63CF
	0x2A1C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27B3, 0xFFFF, 0xFFFF, 0xFFFF, 0x239C, 0x3CCA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63D0 - 63DF
	0xFFFF, 0x22F6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0152, 0x3DF9, 0xFFFF,   // 63E0 - 63EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26A6, 0xFFFF, 0x2371, 0x1C8E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63F0 - 63FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E42, 0xFFFF, 0x1627,   // 6400 - 640F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E17, 0xFFFF, 0x25ED, 0x0B70, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EED, 0xFFFF, 0xFFFF, 0xFFFF,   // 6410 - 641F
	0xFFFF, 0xFFFF, 0x2C9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x163F, 0x356B, 0xFFFF, 0xFFFF,   // 6420 - 642F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E1C, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F4E, 0xFFFF,   // 6430 - 643F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6440 - 644F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2971, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6450 - 645F
	0x310C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C78,   // 6460 - 646F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1443, 0x1444, 0x29D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6470 - 647F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10F3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6480 - 648F
	0xFFFF, 0x35A3, 0x1C79, 0x25EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x084A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A7D, 0xFFFF,   // 6490 - 649F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3039, 0x1659, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14FF, 0xFFFF, 0x37DE, 0x3120, 0xFFFF,   // 64A0 - 64AF
	0x2F57, 0xFFFF, 0x1628, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A50, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 64B0 - 64BF
	0xFFFF, 0x2554, 0xFFFF, 0xFFFF, 0x10F4, 0x3023, 0xFFFF, 0x358D, 0xFFFF, 0xFFFF, 0x0170, 0xFFFF, 0xFFFF, 0x2A88, 0x01B0, 0xFFFF,   // 64C0 - 64CF
	0xFFFF, 0xFFFF, 0x0470, 0xFFFF, 0x0A60, 0xFFFF, 0xFFFF, 0xFFFF, 0x1757, 0xFFFF, 0x010F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 64D0 - 64DF
	0xFFFF, 0x0A93, 0x3541, 0xFFFF, 0xFFFF, 0x0FB1, 0x2F6C, 0x0110, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27CB, 0xFFFF, 0xFFFF, 0xFFFF,   // 64E0 - 64EF
	0xFFFF, 0xFFFF, 0x3013, 0xFFFF, 0x3CBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x37DF, 0xFFFF, 0xFFFF, 0xFFFF, 0x25EF, 0xFFFF,   // 64F0 - 64FF
	0x1640, 0xFFFF, 0xFFFF, 0xFFFF, 0x35E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6500 - 650F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x239D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D90, 0xFFFF, 0xFFFF,   // 6510 - 651F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1090, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x030F, 0x3CBD, 0x0FB2, 0xFFFF, 0xFFFF, 0x2C79,   // 6520 - 652F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EEE, 0x0214, 0x2733, 0x00A2, 0xFFFF, 0x0264, 0xFFFF, 0xFFFF, 0x1677, 0x29E5,   // 6530 - 653F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0215, 0xFFFF, 0xFFFF, 0x3D5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D26, 0x0310, 0x15FF,   // 6540 - 654F
	0xFFFF, 0x0350, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2524, 0x3815, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F8E, 0xFFFF,   // 6550 - 655F
	0xFFFF, 0xFFFF, 0x0063, 0x1C6B, 0xFFFF, 0xFFFF, 0x0B99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01B1, 0x239E, 0xFFFF, 0xFFFF,   // 6560 - 656F
	0xFFFF, 0xFFFF, 0x0216, 0xFFFF, 0x29E6, 0x2972, 0xFFFF, 0x1882, 0x1EEF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D55, 0xFFFF,   // 6570 - 657F
	0xFFFF, 0xFFFF, 0x10AD, 0x38DF, 0xFFFF, 0x3D5F, 0xFFFF, 0x1519, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19B1, 0xFFFF, 0xFFFF, 0xFFFF,   // 6580 - 658F
	0x198B, 0x1641, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C3D, 0xFFFF, 0x118E, 0xFFFF, 0x0233, 0x1C3D, 0xFFFF, 0xFFFF, 0x2CD9,   // 6590 - 659F
	0xFFFF, 0x230F, 0xFFFF, 0xFFFF, 0x0456, 0x3014, 0xFFFF, 0x1883, 0xFFFF, 0xFFFF, 0xFFFF, 0x2891, 0x2F7D, 0xFFFF, 0xFFFF, 0x1C3E,   // 65A0 - 65AF
	0x2055, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A3F, 0xFFFF, 0x1678, 0xFFFF, 0xFFFF, 0x23D9, 0x202A, 0xFFFF, 0xFFFF,   // 65B0 - 65BF
	0xFFFF, 0x1679, 0xFFFF, 0xFFFF, 0xFFFF, 0x1078, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D56, 0x29E7, 0xFFFF, 0xFFFF, 0x2AAF,   // 65C0 - 65CF
	0xFFFF, 0xFFFF, 0x1231, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 65D0 - 65DF
	0x1500, 0xFFFF, 0xFFFF, 0x04C3, 0xFFFF, 0x2846, 0x0A40, 0xFFFF, 0x2C7A, 0x2A89, 0xFFFF, 0xFFFF, 0x1F2F, 0x2663, 0xFFFF, 0xFFFF,   // 65E0 - 65EF
	0xFFFF, 0x3AD0, 0xFFFF, 0xFFFF, 0x264C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2594, 0x1600, 0x1601, 0x0B9A, 0xFFFF, 0x2525,   // 65F0 - 65FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x023F, 0x1FF8, 0xFFFF, 0x167A, 0x3C5B, 0xFFFF, 0x2F8F, 0xFFFF, 0x140D, 0x3C82,   // 6600 - 660F
	0x18AA, 0x0471, 0xFFFF, 0x244C, 0x1D40, 0x3E49, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1783, 0x1D9E,   // 6610 - 661F
	0x24B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31B3, 0xFFFF, 0x1345, 0x2892, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E18, 0xFFFF, 0x202B,   // 6620 - 662F
	0x3ABB, 0x2664, 0xFFFF, 0xFFFF, 0x14D6, 0xFFFF, 0x2F90, 0xFFFF, 0xFFFF, 0xFFFF, 0x1784, 0x232F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6630 - 663F
	0xFFFF, 0x2A8A, 0x202C, 0x3CF2, 0x3CF3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CA0, 0xFFFF, 0x2CA1, 0xFFFF, 0xFFFF, 0xFFFF, 0x2304,   // 6640 - 664F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B8E, 0xFFFF, 0x3BDE, 0xFFFF, 0x2B67, 0x3E7C, 0x1D9F,   // 6650 - 665F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2526, 0x3CCC, 0x3D2D, 0x3C5C, 0x2056, 0x130A, 0xFFFF, 0x3542, 0xFFFF, 0xFFFF, 0x17B6, 0x01B2,   // 6660 - 666F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1D41, 0x3061, 0xFFFF, 0x29E8, 0x03F3, 0x29E9, 0xFFFF, 0x2C7B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6670 - 667F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3DBD, 0xFFFF, 0xFFFF, 0x000D, 0x3D9E, 0x3DFA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24BA, 0xFFFF,   // 6680 - 668F
	0x26F6, 0x1D27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x077B, 0x231F, 0x239F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x140E, 0xFFFF, 0xFFFF,   // 6690 - 669F
	0x0217, 0xFFFF, 0x2F91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28B0, 0xFFFF, 0xFFFF, 0x1445, 0xFFFF,   // 66A0 - 66AF
	0xFFFF, 0xFFFF, 0x28C7, 0x3C30, 0x391E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D88, 0xFFFF, 0x01B3, 0xFFFF, 0xFFFF, 0x0B9B, 0xFFFF,   // 66B0 - 66BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24A9, 0xFFFF, 0x1085, 0x0A61, 0xFFFF, 0x3D60, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 66C0 - 66CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x233F, 0xFFFF, 0xFFFF, 0x1D28, 0xFFFF, 0xFFFF, 0x25F1, 0x391F, 0xFFFF, 0xFFFF,   // 66D0 - 66DF
	0x02B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E7D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 66E0 - 66EF
	0x2585, 0xFFFF, 0x0234, 0x24E5, 0x01B4, 0xFFFF, 0xFFFF, 0x004C, 0x1D29, 0x2A8C, 0x2A8B, 0xFFFF, 0x130B, 0xFFFF, 0x2C44, 0x3071,   // 66F0 - 66FF
	0x3153, 0xFFFF, 0xFFFF, 0x3D2E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26BA, 0x2734, 0xFFFF, 0x18CB, 0xFFFF, 0x17C9, 0xFFFF, 0xFFFF,   // 6700 - 670F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C63, 0x2CDA, 0xFFFF, 0x0FC3, 0xFFFF, 0xFFFF, 0xFFFF, 0x1332, 0xFFFF, 0x2A8D, 0x04C4, 0x04C5,   // 6710 - 671F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1474, 0x1122, 0x1456, 0xFFFF, 0x15EA, 0x131C, 0x17D7, 0x2F6D, 0x31BB, 0xFFFF,   // 6720 - 672F
	0xFFFF, 0x2B68, 0xFFFF, 0xFFFF, 0x1629, 0xFFFF, 0x3533, 0xFFFF, 0xFFFF, 0xFFFF, 0x03D0, 0xFFFF, 0xFFFF, 0x3D8D, 0xFFFF, 0xFFFF,   // 6730 - 673F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0037, 0xFFFF, 0xFFFF, 0x1C87, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B0, 0x3B44,   // 6740 - 674F
	0x28EC, 0x30F4, 0xFFFF, 0x3996, 0xFFFF, 0xFFFF, 0x28C8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C3E, 0xFFFF, 0x04C6, 0x1E36,   // 6750 - 675F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B08, 0xFFFF, 0x1699,   // 6760 - 676F
	0x0130, 0x0BBA, 0xFFFF, 0x14D7, 0xFFFF, 0x2957, 0xFFFF, 0x37E0, 0xFFFF, 0xFFFF, 0xFFFF, 0x09B3, 0xFFFF, 0xFFFF, 0x1E5A, 0x37F0,   // 6770 - 677F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x198C, 0xFFFF, 0x2595, 0xFFFF, 0x167B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0792,   // 6780 - 678F
	0x1D42, 0xFFFF, 0xFFFF, 0x0C3F, 0xFFFF, 0x32C8, 0xFFFF, 0x12DC, 0xFFFF, 0xFFFF, 0x1346, 0xFFFF, 0x0274, 0x2C7C, 0xFFFF, 0xFFFF,   // 6790 - 679F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0218,   // 67A0 - 67AF
	0x38D0, 0xFFFF, 0xFFFF, 0x2C7D, 0xFFFF, 0xFFFF, 0x000E, 0x000F, 0x0351, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x202D, 0xFFFF,   // 67B0 - 67BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1785, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16AA,   // 67C0 - 67CF
	0x1446, 0x0064, 0x32BC, 0x249D, 0x2736, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2737, 0xFFFF, 0xFFFF, 0x3543, 0xFFFF, 0xFFFF,   // 67D0 - 67DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0352, 0xFFFF, 0xFFFF, 0x0038, 0xFFFF, 0xFFFF, 0x0010,   // 67E0 - 67EF
	0x07B5, 0x2B69, 0xFFFF, 0x1232, 0x202E, 0x2FB1, 0x1C3F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C40, 0xFFFF, 0xFFFF, 0x29EA, 0xFFFF,   // 67F0 - 67FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6800 - 680F
	0xFFFF, 0xFFFF, 0x1F30, 0x2998, 0xFFFF, 0xFFFF, 0x1D2A, 0x1251, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6810 - 681F
	0xFFFF, 0x0311, 0x16AB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2665,   // 6820 - 682F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B2D, 0x0457, 0xFFFF, 0xFFFF, 0x0171, 0x28ED, 0xFFFF, 0xFFFF,   // 6830 - 683F
	0x0131, 0x3B09, 0x01DE, 0x0B71, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2305, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CC7, 0xFFFF,   // 6840 - 684F
	0x0BBB, 0x1CA5, 0xFFFF, 0x3CCD, 0x04FB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6850 - 685F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CA2, 0xFFFF, 0xFFFF,   // 6860 - 686F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x366E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0039,   // 6870 - 687F
	0xFFFF, 0x100D, 0xFFFF, 0xFFFF, 0xFFFF, 0x1347, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0235,   // 6880 - 688F
	0xFFFF, 0xFFFF, 0xFFFF, 0x28EE, 0x329D, 0xFFFF, 0xFFFF, 0x01B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A8E, 0xFFFF, 0x3D61,   // 6890 - 689F
	0xFFFF, 0x2572, 0x30D3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2527, 0x12B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C41, 0xFFFF, 0x2A1D,   // 68A0 - 68AF
	0x01DF, 0x0240, 0xFFFF, 0x1E19, 0xFFFF, 0x1722, 0x15EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 68B0 - 68BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C8, 0x1786, 0xFFFF, 0xFFFF, 0xFFFF, 0x13EF, 0xFFFF, 0x04C7, 0xFFFF, 0x0241, 0xFFFF, 0xFFFF,   // 68C0 - 68CF
	0xFFFF, 0xFFFF, 0x17F0, 0xFFFF, 0xFFFF, 0x2AD1, 0xFFFF, 0x2A8F, 0x044C, 0xFFFF, 0x18CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BBC,   // 68D0 - 68DF
	0x0A7E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x289F, 0x01E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C88, 0xFFFF,   // 68E0 - 68EF
	0xFFFF, 0xFFFF, 0x1D2B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B72, 0x028B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 68F0 - 68FF
	0x2573, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2041, 0x318F, 0xFFFF,   // 6900 - 690F
	0xFFFF, 0xFFFF, 0x30D4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6910 - 691F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x140F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6920 - 692F
	0x2372, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2464, 0xFFFF, 0x31B4,   // 6930 - 693F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23A1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6940 - 694F
	0xFFFF, 0xFFFF, 0xFFFF, 0x39D3, 0x1D74, 0x3534, 0xFFFF, 0x0124, 0xFFFF, 0x1501, 0x30D5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1281, 0xFFFF,   // 6950 - 695F
	0x0793, 0x2739, 0x273A, 0x15EC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29EB, 0xFFFF, 0xFFFF, 0x2C3B, 0xFFFF, 0x2406, 0x2958, 0x1F31,   // 6960 - 696F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x044D, 0xFFFF, 0x3B21, 0x3190, 0x24BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6970 - 697F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6980 - 698F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x262A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CA3, 0x167C, 0xFFFF, 0xFFFF, 0xFFFF,   // 6990 - 699F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CF4, 0xFFFF, 0x198D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24BC, 0xFFFF,   // 69A0 - 69AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1233, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x356C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 69B0 - 69BF
	0xFFFF, 0x0219, 0xFFFF, 0x1642, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0353, 0x36B4, 0x2F92, 0xFFFF, 0xFFFF,   // 69C0 - 69CF
	0x02E6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 69D0 - 69DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0280, 0xFFFF, 0x00A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 69E0 - 69EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0418, 0xFFFF, 0x2A90, 0xFFFF, 0x0458,   // 69F0 - 69FF
	0xFFFF, 0xFFFF, 0x22F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1707, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A00 - 6A0F
	0xFFFF, 0x100E, 0xFFFF, 0x11B6, 0xFFFF, 0xFFFF, 0xFFFF, 0x2959, 0xFFFF, 0x3997, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3191, 0x28C9,   // 6A10 - 6A1F
	0xFFFF, 0x1447, 0xFFFF, 0x23A2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A20 - 6A2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30D6, 0xFFFF, 0xFFFF, 0x162A, 0x1EF0, 0x3CAF, 0xFFFF, 0xFFFF, 0x2B8F, 0xFFFF, 0xFFFF,   // 6A30 - 6A3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0065, 0xFFFF, 0xFFFF, 0xFFFF, 0x25F3, 0xFFFF, 0xFFFF, 0x0312, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A40 - 6A4F
	0xFFFF, 0xFFFF, 0x266F, 0x1F32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0432, 0x0CF0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C9,   // 6A50 - 6A5F
	0xFFFF, 0x1CA6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D52, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A60 - 6A6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A70 - 6A7F
	0x0A41, 0xFFFF, 0xFFFF, 0xFFFF, 0x0172, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29EC, 0xFFFF, 0xFFFF, 0xFFFF, 0x23E5, 0x0472, 0xFFFF,   // 6A80 - 6A8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1758, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D2F, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A90 - 6A9F
	0xFFFF, 0xFFFF, 0x013D, 0x28CA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AA0 - 6AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0x19B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AEE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AB0 - 6ABF
	0xFFFF, 0xFFFF, 0x0B73, 0x03D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AC0 - 6ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0x10F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1079, 0x2C31, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AD0 - 6ADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AE0 - 6AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B98, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2361, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AF0 - 6AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F9C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x03B0, 0xFFFF, 0x28CB, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B00 - 6B0F
	0xFFFF, 0xFFFF, 0x0F9D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FB3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B10 - 6B1F
	0x3E5D, 0x2F44, 0xFFFF, 0x3E4A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B20 - 6B2F
	0xFFFF, 0xFFFF, 0x2608, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04CA, 0xFFFF, 0xFFFF, 0x3E5E, 0x028C, 0xFFFF,   // 6B30 - 6B3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E5F, 0x3B9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0011, 0xFFFF, 0x3552, 0xFFFF,   // 6B40 - 6B4F
	0x0354, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2437,   // 6B50 - 6B5F
	0xFFFF, 0x3CCB, 0x2C7E, 0x29ED, 0x2F45, 0x17B7, 0x1502, 0xFFFF, 0xFFFF, 0xFFFF, 0x25A1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B60 - 6B6F
	0xFFFF, 0xFFFF, 0x1DB3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1086, 0x03F4, 0xFFFF, 0xFFFF, 0x1C42, 0xFFFF, 0xFFFF, 0xFFFF, 0x1464,   // 6B70 - 6B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2330, 0x2CA4, 0xFFFF, 0x3582, 0xFFFF, 0xFFFF, 0x1F33, 0x1EF1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B80 - 6B8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2042, 0xFFFF, 0x28A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2670, 0xFFFF,   // 6B90 - 6B9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10AE, 0x19B3,   // 6BA0 - 6BAF
	0xFFFF, 0xFFFF, 0x1D89, 0xFFFF, 0xFFFF, 0x0A42, 0xFFFF, 0x279B, 0xFFFF, 0xFFFF, 0x1C7A, 0xFFFF, 0x0025, 0xFFFF, 0xFFFF, 0x2999,   // 6BB0 - 6BBF
	0xFFFF, 0x3DDA, 0xFFFF, 0xFFFF, 0xFFFF, 0x27CD, 0x0355, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1503, 0xFFFF, 0x1448, 0xFFFF, 0x1348,   // 6BC0 - 6BCF
	0xFFFF, 0xFFFF, 0x0B8A, 0x275E, 0x198E, 0xFFFF, 0x198F, 0x1990, 0x1991, 0xFFFF, 0xFFFF, 0x1449, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6BD0 - 6BDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C5D, 0x0356, 0xFFFF, 0xFFFF, 0xFFFF,   // 6BE0 - 6BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6BF0 - 6BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x299A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22C0,   // 6C00 - 6C0F
	0xFFFF, 0x1602, 0xFFFF, 0x136A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C10 - 6C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0x04CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C20 - 6C2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EF2, 0xFFFF, 0xFFFF, 0x19CE, 0x24BD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1723, 0xFFFF,   // 6C30 - 6C3F
	0x29EE, 0x2C3C, 0x0357, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1724, 0xFFFF,   // 6C40 - 6C4F
	0x1D43, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C6C, 0xFFFF, 0x3AD1, 0xFFFF, 0xFFFF, 0x2528, 0xFFFF, 0xFFFF, 0x2438, 0x3C9D, 0x0084,   // 6C50 - 6C5F
	0x2C7F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x024A, 0xFFFF, 0x2596, 0xFFFF, 0xFFFF, 0x24E6, 0xFFFF, 0xFFFF,   // 6C60 - 6C6F
	0x3583, 0xFFFF, 0x0481, 0xFFFF, 0xFFFF, 0xFFFF, 0x151A, 0xFFFF, 0xFFFF, 0xFFFF, 0x018A, 0xFFFF, 0xFFFF, 0x04CC, 0x18AB, 0xFFFF,   // 6C70 - 6C7F
	0xFFFF, 0x2079, 0x04CD, 0x2534, 0xFFFF, 0x26A7, 0x3B0A, 0x2465, 0x32C9, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B9C, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C80 - 6C8F
	0x1457, 0xFFFF, 0x1465, 0x0A6F, 0x13F0, 0x1526, 0x31CC, 0xFFFF, 0xFFFF, 0x1C43, 0x2C80, 0x3816, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C90 - 6C9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x131D, 0xFFFF, 0xFFFF, 0x295A, 0xFFFF,   // 6CA0 - 6CAF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3ABC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1992, 0x273B, 0xFFFF, 0x329E, 0x1E1A, 0x021A, 0x3049, 0x2466,   // 6CB0 - 6CBF
	0xFFFF, 0x3CF5, 0x3C16, 0xFFFF, 0x1D75, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3024, 0x162B, 0xFFFF, 0x3A99, 0xFFFF, 0xFFFF, 0xFFFF,   // 6CC0 - 6CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3C9E, 0xFFFF, 0x172A, 0xFFFF, 0x1C44, 0xFFFF, 0xFFFF, 0xFFFF, 0x1725, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6CD0 - 6CDF
	0xFFFF, 0x390D, 0x37E1, 0x27B4, 0xFFFF, 0x0A13, 0xFFFF, 0xFFFF, 0x2B6B, 0xFFFF, 0xFFFF, 0x3BDF, 0xFFFF, 0xFFFF, 0x1643, 0x1603,   // 6CE0 - 6CEF
	0x3584, 0xFFFF, 0xFFFF, 0x24BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6CF0 - 6CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23A3, 0x10A1, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D00 - 6D0F
	0xFFFF, 0x17B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DB4, 0xFFFF, 0x1EF3, 0xFFFF, 0x0F8E, 0xFFFF, 0xFFFF, 0x0BBD, 0xFFFF,   // 6D10 - 6D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CA5, 0xFFFF, 0x273C, 0xFFFF, 0x1D76, 0x3C9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D20 - 6D2F
	0xFFFF, 0xFFFF, 0x2B6C, 0xFFFF, 0xFFFF, 0x1F34, 0x3E3B, 0xFFFF, 0x02B2, 0x26A8, 0xFFFF, 0x3CD9, 0xFFFF, 0x3E63, 0x37E2, 0xFFFF,   // 6D30 - 6D3F
	0xFFFF, 0x1234, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D40 - 6D4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29B9, 0x2B90, 0xFFFF, 0x19B4, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D50 - 6D5F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2574, 0xFFFF, 0xFFFF, 0x390E, 0xFFFF, 0xFFFF, 0x3C5E, 0x0FC4, 0xFFFF, 0x12B2, 0xFFFF, 0x1884, 0xFFFF,   // 6D60 - 6D6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2609, 0xFFFF, 0xFFFF, 0x3B22, 0x32CA, 0x3C06, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3817,   // 6D70 - 6D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x248B, 0xFFFF, 0x01B6, 0x1E1B, 0x1D91, 0xFFFF, 0xFFFF, 0x262B, 0x3D62, 0x2467, 0xFFFF,   // 6D80 - 6D8F
	0xFFFF, 0x1E37, 0xFFFF, 0x2468, 0xFFFF, 0x3072, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D90 - 6D9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2340,   // 6DA0 - 6DAF
	0xFFFF, 0xFFFF, 0x2349, 0xFFFF, 0xFFFF, 0x3AEF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6DB0 - 6DBF
	0x29EF, 0xFFFF, 0xFFFF, 0x03B1, 0x329F, 0x1D44, 0x3D63, 0x04CE, 0xFFFF, 0xFFFF, 0xFFFF, 0x12DD, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C5F,   // 6DC0 - 6DCF
	0xFFFF, 0x1F21, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B74, 0x2AD2, 0x11B7, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E5B, 0xFFFF,   // 6DD0 - 6DDF
	0xFFFF, 0x0A62, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29F0, 0xFFFF, 0x1248, 0x27AD, 0xFFFF, 0xFFFF, 0x3D30, 0xFFFF,   // 6DE0 - 6DEF
	0xFFFF, 0x207B, 0xFFFF, 0x1F35, 0xFFFF, 0x2469, 0xFFFF, 0x3C83, 0x3062, 0x2403, 0x3025, 0x304A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6DF0 - 6DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6E00 - 6E0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C89, 0xFFFF, 0x3CCE, 0x295B, 0x0066, 0xFFFF, 0xFFFF, 0xFFFF, 0x29F1,   // 6E10 - 6E1F
	0x0111, 0x0B75, 0xFFFF, 0x1C45, 0x165A, 0x22F8, 0x2563, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D77, 0x325E, 0x26F7, 0xFFFF, 0x3B0B,   // 6E20 - 6E2F
	0xFFFF, 0xFFFF, 0x1D57, 0xFFFF, 0x004D, 0xFFFF, 0x24BF, 0xFFFF, 0x273E, 0xFFFF, 0x14D8, 0xFFFF, 0x15ED, 0x28EF, 0x3C84, 0xFFFF,   // 6E30 - 6E3F
	0xFFFF, 0xFFFF, 0xFFFF, 0x169A, 0x15EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B6D, 0xFFFF, 0xFFFF, 0x0A43, 0xFFFF, 0xFFFF,   // 6E40 - 6E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C60, 0xFFFF, 0x1CA7, 0xFFFF, 0xFFFF, 0x0A63, 0x2043, 0xFFFF, 0x29F2, 0x3CF6,   // 6E50 - 6E5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x262C, 0xFFFF, 0xFFFF, 0xFFFF, 0x3192, 0xFFFF, 0xFFFF, 0x2831, 0x3573,   // 6E60 - 6E6F
	0xFFFF, 0xFFFF, 0x26A9, 0x0794, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6E70 - 6E7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6E80 - 6E8F
	0x26AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1235, 0x0358, 0xFFFF, 0x1410,   // 6E90 - 6E9F
	0xFFFF, 0xFFFF, 0x2847, 0xFFFF, 0xFFFF, 0x1885, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01E1, 0x253B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E1C,   // 6EA0 - 6EAF
	0xFFFF, 0x2CA6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x262D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A16, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6EB0 - 6EBF
	0xFFFF, 0xFFFF, 0x167D, 0xFFFF, 0x2F93, 0x13FB, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CF7, 0xFFFF, 0x287D, 0x3015, 0xFFFF, 0x3C17, 0xFFFF,   // 6EC0 - 6ECF
	0xFFFF, 0x3CDA, 0xFFFF, 0x28F0, 0x0B76, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6ED0 - 6EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3073,   // 6EE0 - 6EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2973, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C61, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0242, 0x130C,   // 6EF0 - 6EFF
	0xFFFF, 0x23DA, 0x3998, 0xFFFF, 0xFFFF, 0xFFFF, 0x32BD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11B8,   // 6F00 - 6F0F
	0xFFFF, 0x00A4, 0xFFFF, 0xFFFF, 0x246A, 0x2A91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F10 - 6F1F
	0x12FC, 0xFFFF, 0x3AD2, 0x1091, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x130D, 0x2C81, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F20 - 6F2F
	0xFFFF, 0x1EF4, 0x2F94, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29C9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28CC,   // 6F30 - 6F3F
	0xFFFF, 0x24C0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F40 - 6F4F
	0xFFFF, 0x165B, 0xFFFF, 0xFFFF, 0x018B, 0xFFFF, 0xFFFF, 0x2CDE, 0x1644, 0xFFFF, 0x1F22, 0x28B1, 0xFFFF, 0xFFFF, 0x10F6, 0x1D45,   // 6F50 - 6F5F
	0xFFFF, 0xFFFF, 0x3CF8, 0xFFFF, 0x276B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A64, 0x2A92, 0xFFFF,   // 6F60 - 6F6F
	0x03D2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28A1, 0xFFFF, 0x0BBE, 0x17BA, 0x12C8, 0xFFFF,   // 6F70 - 6F7F
	0xFFFF, 0x1C8F, 0xFFFF, 0xFFFF, 0x2CE9, 0xFFFF, 0xFFFF, 0xFFFF, 0x303A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B6E, 0x3833, 0xFFFF,   // 6F80 - 6F8F
	0x2671, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C62, 0xFFFF, 0xFFFF, 0x003A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F90 - 6F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3AD3, 0x358E, 0xFFFF, 0xFFFF, 0x10D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D31, 0x2F58,   // 6FA0 - 6FAF
	0xFFFF, 0x299B, 0xFFFF, 0x2529, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A51, 0xFFFF,   // 6FB0 - 6FBF
	0x0173, 0x3544, 0x10AF, 0x08B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24E7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6FC0 - 6FCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24C1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A1E,   // 6FD0 - 6FDF
	0x3C63, 0x2740, 0xFFFF, 0xFFFF, 0x0B77, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C64, 0xFFFF, 0x0FB4, 0x2B92, 0xFFFF, 0xFFFF, 0x3545,   // 6FE0 - 6FEF
	0xFFFF, 0x19B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x107A, 0xFFFF,   // 6FF0 - 6FFF
	0xFFFF, 0x23A4, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C18, 0x0B8B, 0xFFFF, 0xFFFF, 0x1C46, 0xFFFF, 0x207C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1236,   // 7000 - 700F
	0xFFFF, 0x3920, 0xFFFF, 0xFFFF, 0xFFFF, 0x19B6, 0xFFFF, 0xFFFF, 0x10F7, 0xFFFF, 0x3AD4, 0x24C2, 0x2789, 0x1087, 0x29F3, 0x1E1D,   // 7010 - 701F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3B23, 0xFFFF, 0xFFFF, 0xFFFF, 0x1123, 0x1167, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24C3,   // 7020 - 702F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x281D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F9E, 0xFFFF,   // 7030 - 703F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x028D, 0xFFFF, 0xFFFF, 0xFFFF,   // 7040 - 704F
	0x3C19, 0x1E85, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3553, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C65, 0xFFFF, 0xFFFF,   // 7050 - 705F
	0xFFFF, 0xFFFF, 0xFFFF, 0x130E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CB0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7060 - 706F
	0x3D32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0359, 0xFFFF, 0xFFFF, 0xFFFF, 0x2893, 0x28F1, 0xFFFF, 0xFFFF,   // 7070 - 707F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01B7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3218, 0xFFFF, 0xFFFF, 0xFFFF, 0x249F, 0xFFFF,   // 7080 - 708F
	0xFFFF, 0xFFFF, 0x30D7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E4B, 0x287E, 0x02B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7090 - 709F
	0xFFFF, 0x29F4, 0xFFFF, 0xFFFF, 0x1E1E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BE0, 0x0112, 0x3554, 0xFFFF, 0x3C1A,   // 70A0 - 70AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1787, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B6F, 0x2894, 0x29CA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 70B0 - 70BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10A2, 0xFFFF, 0xFFFF, 0x3E1D, 0xFFFF, 0xFFFF, 0xFFFF, 0x252A,   // 70C0 - 70CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CA0, 0x0F8F, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C46, 0xFFFF, 0x246C,   // 70D0 - 70DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 70E0 - 70EF
	0xFFFF, 0x01B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3834, 0xFFFF, 0xFFFF, 0xFFFF, 0x17F1, 0xFFFF, 0xFFFF,   // 70F0 - 70FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23ED, 0xFFFF, 0xFFFF, 0x2B93, 0xFFFF, 0xFFFF, 0xFFFF,   // 7100 - 710F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x169B, 0x18AC, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B9D, 0xFFFF,   // 7110 - 711F
	0xFFFF, 0x1504, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30D8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7120 - 712F
	0x24A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x246D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7130 - 713F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3DFB, 0xFFFF, 0x1092, 0x3DBE, 0xFFFF, 0x3CF9, 0xFFFF, 0x299C, 0xFFFF,   // 7140 - 714F
	0x24C4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x077D, 0xFFFF, 0xFFFF, 0x246E, 0xFFFF, 0xFFFF, 0x2666, 0xFFFF, 0x1C7B, 0xFFFF,   // 7150 - 715F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1349, 0x3CCF, 0x3D8E, 0x2A93, 0xFFFF, 0x1708, 0xFFFF, 0xFFFF, 0x23A5, 0xFFFF, 0x287F, 0xFFFF,   // 7160 - 716F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D58, 0xFFFF, 0xFFFF,   // 7170 - 717F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2044, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2672, 0x268E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D9A,   // 7180 - 718F
	0xFFFF, 0xFFFF, 0x3C1B, 0xFFFF, 0x262E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E7E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F23,   // 7190 - 719F
	0xFFFF, 0xFFFF, 0x17F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x252B, 0xFFFF, 0xFFFF, 0xFFFF,   // 71A0 - 71AF
	0xFFFF, 0x248D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E7F, 0x3E80, 0xFFFF, 0xFFFF, 0xFFFF, 0x32A0, 0xFFFF,   // 71B0 - 71BF
	0xFFFF, 0x24AB, 0xFFFF, 0x2470, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF1, 0x0B9E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x118F, 0xFFFF,   // 71C0 - 71CF
	0x12C9, 0xFFFF, 0x1E1F, 0xFFFF, 0x1709, 0x2471, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24C5,   // 71D0 - 71DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A94, 0x2F59, 0x1EF5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30EB, 0x1D92, 0xFFFF,   // 71E0 - 71EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D9B, 0x2057, 0xFFFF, 0x0B78, 0x25F5,   // 71F0 - 71FF
	0x3BD4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3921, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7200 - 720F
	0x10F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7210 - 721F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A95, 0xFFFF, 0x37E3, 0x290D, 0xFFFF, 0xFFFF,   // 7220 - 722F
	0x26AB, 0xFFFF, 0x26F8, 0xFFFF, 0xFFFF, 0x2895, 0x1886, 0xFFFF, 0xFFFF, 0xFFFF, 0x2373, 0x3D64, 0xFFFF, 0x1CA8, 0x2804, 0xFFFF,   // 7230 - 723F
	0x1CA9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28CD, 0x38B5, 0x37F1, 0xFFFF, 0xFFFF, 0xFFFF, 0x3818, 0xFFFF, 0xFFFF, 0xFFFF,   // 7240 - 724F
	0xFFFF, 0xFFFF, 0x3056, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B8C, 0x22E4, 0xFFFF, 0x264D, 0xFFFF, 0x19B7, 0xFFFF, 0x144A,   // 7250 - 725F
	0xFFFF, 0x144B, 0x1168, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1458, 0xFFFF, 0x1527, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7260 - 726F
	0xFFFF, 0xFFFF, 0x1CD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3785, 0xFFFF, 0xFFFF, 0xFFFF, 0x017B, 0xFFFF, 0xFFFF,   // 7270 - 727F
	0x1D2C, 0x12B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7280 - 728F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7290 - 729F
	0xFFFF, 0xFFFF, 0x0B8D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E81, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x017C, 0xFFFF, 0xFFFF, 0x1726,   // 72A0 - 72AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 72B0 - 72BF
	0x1CAA, 0xFFFF, 0x02B4, 0xFFFF, 0x2974, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2326, 0xFFFF,   // 72C0 - 72CF
	0x3C66, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x035A, 0xFFFF, 0x295C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 72D0 - 72DF
	0xFFFF, 0x0313, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EF6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 72E0 - 72EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B4, 0x3C07, 0xFFFF, 0xFFFF, 0x0FC5, 0x3819, 0xFFFF, 0xFFFF,   // 72F0 - 72FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24E8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7300 - 730F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F95, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x136B, 0x202F, 0x2ABE, 0xFFFF, 0xFFFF,   // 7310 - 731F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x25C2, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA0, 0x295D, 0x14D9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7320 - 732F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2741, 0x2742, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CDB, 0x26AC,   // 7330 - 733F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2535, 0x1C47, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7340 - 734F
	0x28CF, 0xFFFF, 0x252C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x03B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7350 - 735F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B8E, 0xFFFF, 0x3D33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7360 - 736F
	0x24C6, 0xFFFF, 0x3D3C, 0xFFFF, 0xFFFF, 0x10B2, 0xFFFF, 0xFFFF, 0x1EF7, 0xFFFF, 0x0A52, 0x3B99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7370 - 737F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BE1, 0xFFFF, 0x2880, 0x1E4A, 0xFFFF, 0x2536, 0xFFFF, 0x2597, 0xFFFF, 0xFFFF, 0x29F5, 0xFFFF,   // 7380 - 738F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3026, 0xFFFF, 0x035B, 0x264E, 0x04CF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1604,   // 7390 - 739F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x276C, 0xFFFF, 0x2575, 0xFFFF, 0xFFFF, 0xFFFF, 0x19B8, 0xFFFF, 0xFFFF,   // 73A0 - 73AF
	0xFFFF, 0xFFFF, 0x10BE, 0x0A94, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BE2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 73B0 - 73BF
	0x162C, 0xFFFF, 0x0012, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1605, 0x1C6D, 0xFFFF, 0x3A9A, 0x2CA7, 0xFFFF, 0x0026,   // 73C0 - 73CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02B5, 0xFFFF, 0xFFFF, 0x0265, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D8F, 0x0F90, 0xFFFF,   // 73D0 - 73DF
	0x2B70, 0xFFFF, 0xFFFF, 0x1F36, 0x17BB, 0x2805, 0x3B66, 0xFFFF, 0xFFFF, 0x3C1C, 0x0419, 0xFFFF, 0xFFFF, 0x1645, 0xFFFF, 0xFFFF,   // 73E0 - 73EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1505, 0xFFFF, 0x1DA1, 0xFFFF, 0xFFFF, 0xFFFF, 0x29F6, 0x3BE3, 0xFFFF,   // 73F0 - 73FF
	0xFFFF, 0x1D59, 0xFFFF, 0x035C, 0xFFFF, 0x0FC6, 0x12B5, 0x1EF8, 0xFFFF, 0x1237, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7400 - 740F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2576, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7410 - 741F
	0x299D, 0x1F24, 0x3546, 0xFFFF, 0xFFFF, 0x3C67, 0x04D0, 0xFFFF, 0x0243, 0xFFFF, 0x04D1, 0x17F3, 0x2577, 0xFFFF, 0x2AD3, 0x028E,   // 7420 - 742F
	0x24A1, 0xFFFF, 0xFFFF, 0x12DE, 0x0473, 0x1994, 0x37E4, 0xFFFF, 0x3547, 0xFFFF, 0x172B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C85,   // 7430 - 743F
	0x264F, 0x144C, 0xFFFF, 0x31B5, 0x1D5A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7440 - 744F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3ABD, 0xFFFF, 0x26AD, 0xFFFF, 0x088E, 0x3C68, 0x24C8, 0x2744, 0xFFFF, 0x1D2D, 0x1FDD,   // 7450 - 745F
	0x1238, 0xFFFF, 0x262F, 0xFFFF, 0x25F6, 0x253C, 0xFFFF, 0xFFFF, 0x2CA8, 0x3C1D, 0x12F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC7,   // 7460 - 746F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0459, 0xFFFF,   // 7470 - 747F
	0xFFFF, 0xFFFF, 0x04D2, 0x12B6, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D5B, 0xFFFF, 0x1093, 0xFFFF, 0x28D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7480 - 748F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12CA, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CFA, 0xFFFF, 0x162D, 0x01B9,   // 7490 - 749F
	0xFFFF, 0x2CA9, 0xFFFF, 0x04D3, 0xFFFF, 0x01BA, 0xFFFF, 0x1759, 0x2F5A, 0xFFFF, 0x2A96, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 74A0 - 74AF
	0x3CD0, 0xFFFF, 0x1EF9, 0xFFFF, 0xFFFF, 0x243A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F25, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CBD, 0xFFFF, 0x1D5C,   // 74B0 - 74BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CC8, 0xFFFF, 0xFFFF, 0xFFFF, 0x01BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1124,   // 74C0 - 74CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24CA, 0xFFFF, 0xFFFF, 0xFFFF, 0x028F, 0xFFFF, 0x2F5B, 0xFFFF, 0x0275, 0xFFFF, 0xFFFF, 0xFFFF,   // 74D0 - 74DF
	0x3C69, 0xFFFF, 0x3999, 0x37F2, 0xFFFF, 0xFFFF, 0x2564, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2555, 0xFFFF,   // 74E0 - 74EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2881, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 74F0 - 74FF
	0xFFFF, 0x1788, 0xFFFF, 0xFFFF, 0x017D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7500 - 750F
	0xFFFF, 0x2C47, 0xFFFF, 0xFFFF, 0xFFFF, 0x2556, 0xFFFF, 0xFFFF, 0x0067, 0xFFFF, 0x207D, 0x304B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CDA,   // 7510 - 751F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1C6E, 0xFFFF, 0x1CDB, 0x1E20, 0xFFFF, 0x2630, 0xFFFF, 0xFFFF, 0x17BC, 0x2631, 0xFFFF, 0xFFFF, 0xFFFF,   // 7520 - 752F
	0x299E, 0x2745, 0x0073, 0x2058, 0xFFFF, 0xFFFF, 0xFFFF, 0x0796, 0x299F, 0xFFFF, 0x29F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7530 - 753F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0429, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01E2, 0xFFFF, 0xFFFF, 0x25C3,   // 7540 - 754F
	0xFFFF, 0x29A0, 0xFFFF, 0x0A70, 0x1646, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1239, 0xFFFF, 0x2CAA, 0x31A5, 0x1506, 0xFFFF, 0xFFFF,   // 7550 - 755F
	0xFFFF, 0xFFFF, 0x3A9B, 0xFFFF, 0xFFFF, 0x0FF4, 0x3E1E, 0xFFFF, 0xFFFF, 0xFFFF, 0x170A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B94,   // 7560 - 756F
	0x2807, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CB1, 0x0A7F, 0xFFFF, 0x04D4, 0xFFFF, 0x0085, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04D5,   // 7570 - 757F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0086, 0x2B71, 0xFFFF, 0xFFFF, 0x3057, 0x3A9C, 0xFFFF, 0xFFFF, 0x1E22, 0x1E21,   // 7580 - 758F
	0xFFFF, 0x27CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C6F, 0xFFFF, 0xFFFF,   // 7590 - 759F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00A5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x244F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 75A0 - 75AF
	0xFFFF, 0x390F, 0x3A89, 0x0068, 0xFFFF, 0x2882, 0xFFFF, 0xFFFF, 0x0A53, 0x2CAB, 0xFFFF, 0xFFFF, 0x0BBF, 0x295E, 0x2CC9, 0xFFFF,   // 75B0 - 75BF
	0xFFFF, 0xFFFF, 0x0013, 0xFFFF, 0xFFFF, 0x1789, 0xFFFF, 0x2C48, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2808, 0xFFFF, 0xFFFF,   // 75C0 - 75CF
	0xFFFF, 0xFFFF, 0x23A6, 0xFFFF, 0x32A1, 0x3E4C, 0xFFFF, 0xFFFF, 0x0C40, 0x01BC, 0xFFFF, 0x3670, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 75D0 - 75DF
	0xFFFF, 0xFFFF, 0x12B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 75E0 - 75EF
	0x0A66, 0xFFFF, 0x12F3, 0xFFFF, 0x32A2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1995, 0xFFFF, 0x021B, 0xFFFF, 0xFFFF, 0xFFFF,   // 75F0 - 75FF
	0x23DB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23A7, 0xFFFF, 0xFFFF,   // 7600 - 760F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E23, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x253D,   // 7610 - 761F
	0x3016, 0x2F96, 0x1647, 0xFFFF, 0x123A, 0xFFFF, 0x1EFA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7620 - 762F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7630 - 763F
	0xFFFF, 0xFFFF, 0x1190, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2320, 0xFFFF, 0x003B, 0xFFFF,   // 7640 - 764F
	0xFFFF, 0xFFFF, 0x2747, 0xFFFF, 0xFFFF, 0xFFFF, 0x175A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7650 - 765F
	0xFFFF, 0x32A3, 0xFFFF, 0xFFFF, 0x29BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F86, 0xFFFF, 0xFFFF, 0x1D5D, 0xFFFF, 0xFFFF, 0xFFFF,   // 7660 - 766F
	0x2557, 0xFFFF, 0x29A1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01E3, 0xFFFF, 0xFFFF, 0x0CF2, 0x165C, 0x16AC, 0x16AD, 0xFFFF,   // 7670 - 767F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2976, 0xFFFF, 0x00A6, 0x3CFB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0314, 0xFFFF,   // 7680 - 768F
	0x021C, 0xFFFF, 0xFFFF, 0x3C6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7690 - 769F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3A8A, 0xFFFF,   // 76A0 - 76AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3193, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1411,   // 76B0 - 76BF
	0xFFFF, 0xFFFF, 0x2650, 0x169C, 0xFFFF, 0xFFFF, 0x18AD, 0xFFFF, 0x24CB, 0xFFFF, 0x281E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 76C0 - 76CF
	0xFFFF, 0xFFFF, 0x3AF8, 0xFFFF, 0xFFFF, 0xFFFF, 0x00A7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA2, 0x0B79, 0xFFFF, 0x28A2, 0x136D,   // 76D0 - 76DF
	0xFFFF, 0x2CAC, 0xFFFF, 0x0069, 0x1648, 0xFFFF, 0xFFFF, 0x10F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1459, 0xFFFF,   // 76E0 - 76EF
	0xFFFF, 0xFFFF, 0x136C, 0xFFFF, 0x2C93, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CAB, 0xFFFF, 0xFFFF, 0xFFFF, 0x1649, 0xFFFF, 0x1F37, 0xFFFF,   // 76F0 - 76FF
	0xFFFF, 0x1DA3, 0xFFFF, 0xFFFF, 0x13F1, 0xFFFF, 0xFFFF, 0xFFFF, 0x3566, 0x15EF, 0xFFFF, 0x003C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7700 - 770F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CAD, 0xFFFF,   // 7710 - 771F
	0x13F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BE4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7720 - 772F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x03B2, 0x144D, 0xFFFF, 0x2A97, 0xFFFF, 0x2306, 0xFFFF, 0xFFFF, 0xFFFF,   // 7730 - 773F
	0x2F4F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BE5, 0xFFFF, 0xFFFF,   // 7740 - 774F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7750 - 775F
	0xFFFF, 0x1EFB, 0xFFFF, 0x0B8F, 0xFFFF, 0xFFFF, 0x145A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3058, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7760 - 776F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B7A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x021D, 0x24E9,   // 7770 - 777F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CAE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7780 - 778F
	0xFFFF, 0x1412, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x130F, 0xFFFF,   // 7790 - 779F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x176E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F38, 0x1191, 0xFFFF, 0xFFFF,   // 77A0 - 77AF
	0x006A, 0xFFFF, 0xFFFF, 0x0BC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x304C, 0x013E, 0xFFFF, 0xFFFF, 0x035D,   // 77B0 - 77BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 77C0 - 77CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30EC, 0xFFFF, 0xFFFF, 0xFFFF, 0x144E, 0x048A, 0xFFFF, 0xFFFF, 0xFFFF,   // 77D0 - 77DF
	0xFFFF, 0xFFFF, 0x2030, 0x27CF, 0xFFFF, 0x2C82, 0xFFFF, 0xFFFF, 0xFFFF, 0x035E, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A44, 0x25A2, 0x0315,   // 77E0 - 77EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1D46, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 77F0 - 77FF
	0xFFFF, 0xFFFF, 0x1C48, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7800 - 780F
	0xFFFF, 0xFFFF, 0x1996, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7810 - 781F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C83, 0x2FA9, 0x32CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12E2, 0xFFFF, 0xFFFF, 0xFFFF,   // 7820 - 782F
	0xFFFF, 0xFFFF, 0x3910, 0xFFFF, 0x37E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7830 - 783F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x041A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2473,   // 7840 - 784F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30D9, 0xFFFF, 0xFFFF,   // 7850 - 785F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x123B, 0x01BD, 0xFFFF, 0xFFFF, 0x2474,   // 7860 - 786F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18CD, 0xFFFF, 0xFFFF, 0xFFFF,   // 7870 - 787F
	0xFFFF, 0x04D6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1104, 0x2341, 0x1E86, 0xFFFF,   // 7880 - 788F
	0xFFFF, 0x1997, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2578, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7890 - 789F
	0xFFFF, 0xFFFF, 0xFFFF, 0x004E, 0xFFFF, 0xFFFF, 0xFFFF, 0x175B, 0xFFFF, 0x1D47, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 78A0 - 78AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CBE, 0x3CBF, 0x12F4, 0xFFFF, 0xFFFF, 0xFFFF,   // 78B0 - 78BF
	0xFFFF, 0x2883, 0xFFFF, 0xFFFF, 0xFFFF, 0x167E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1169, 0x2F46, 0xFFFF, 0xFFFF, 0x01E4, 0xFFFF,   // 78C0 - 78CF
	0x164A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 78D0 - 78DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F5, 0xFFFF, 0xFFFF, 0xFFFF, 0x01BE, 0xFFFF, 0xFFFF, 0x04D7,   // 78E0 - 78EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x003D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x164B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 78F0 - 78FF
	0xFFFF, 0x30DA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30DB, 0xFFFF,   // 7900 - 790F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x243B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7910 - 791F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x107B, 0x1088, 0x164C, 0xFFFF, 0xFFFF, 0xFFFF,   // 7920 - 792F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2031, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C49, 0xFFFF,   // 7930 - 793F
	0x1C4A, 0x04D8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04D9, 0x04DA, 0x2C84, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7940 - 794F
	0x2651, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A98, 0x2C85, 0xFFFF, 0xFFFF, 0x2A99, 0x0113, 0x3C6B, 0x31A6, 0x2059, 0xFFFF,   // 7950 - 795F
	0x1C4B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CAC, 0xFFFF, 0xFFFF, 0x399A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A1F, 0xFFFF, 0xFFFF,   // 7960 - 796F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04DB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1105,   // 7970 - 797F
	0xFFFF, 0x0474, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CB2, 0x29FA, 0x17CA,   // 7980 - 798F
	0xFFFF, 0x2652, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7990 - 799F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23DC, 0x3E82, 0xFFFF, 0xFFFF, 0x1D5E, 0xFFFF, 0xFFFF, 0xFFFF, 0x10D2, 0xFFFF,   // 79A0 - 79AF
	0xFFFF, 0x0B7B, 0xFFFF, 0x23A8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2653, 0xFFFF, 0xFFFF, 0xFFFF, 0x0475, 0x3CB3, 0x0B90,   // 79B0 - 79BF
	0x1EFC, 0x1C4C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x178A, 0x084B, 0x3194, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 79C0 - 79CF
	0xFFFF, 0x0276, 0x30DC, 0xFFFF, 0xFFFF, 0x1998, 0xFFFF, 0xFFFF, 0x1999, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A9A,   // 79D0 - 79DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32D5, 0xFFFF, 0x2CAF, 0x2331, 0xFFFF, 0x2CCA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 79E0 - 79EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x280A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 79F0 - 79FF
	0x3E83, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DB5, 0xFFFF, 0xFFFF, 0x003E, 0xFFFF, 0xFFFF, 0x29FB, 0xFFFF, 0x30DD, 0xFFFF, 0xFFFF,   // 7A00 - 7A0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x285A, 0xFFFF, 0xFFFF, 0x381A, 0xFFFF, 0x2C94, 0x32A4, 0xFFFF, 0x1282, 0xFFFF, 0xFFFF, 0x39CD,   // 7A10 - 7A1F
	0x2A9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AD4, 0xFFFF,   // 7A20 - 7A2F
	0xFFFF, 0x32D6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2667, 0x2C95, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B7C, 0x0014, 0x01E5, 0xFFFF, 0x021E,   // 7A30 - 7A3F
	0x0236, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x145B, 0xFFFF, 0xFFFF, 0x32A5, 0xFFFF, 0xFFFF, 0xFFFF, 0x2977, 0x24CC, 0xFFFF,   // 7A40 - 7A4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7A50 - 7A5F
	0xFFFF, 0x1CC2, 0x24EA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x253E, 0xFFFF, 0x3CC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7A60 - 7A6F
	0x23A9, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BF4, 0xFFFF, 0x035F, 0xFFFF, 0xFFFF, 0x039A, 0x0266, 0xFFFF, 0xFFFF, 0x29FC, 0xFFFF, 0x3027,   // 7A70 - 7A7F
	0xFFFF, 0x0BA6, 0xFFFF, 0xFFFF, 0x2F50, 0xFFFF, 0xFFFF, 0xFFFF, 0x25F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7A80 - 7A8F
	0xFFFF, 0xFFFF, 0x2CCB, 0x2F97, 0xFFFF, 0x2A9C, 0xFFFF, 0xFFFF, 0x037E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x038A,   // 7A90 - 7A9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2565, 0x2566, 0xFFFF, 0xFFFF, 0xFFFF, 0x039B, 0x25F9,   // 7AA0 - 7AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x041B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7AB0 - 7ABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F5C, 0x041C, 0xFFFF, 0x0C41, 0xFFFF, 0xFFFF, 0x29BB, 0x12E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7AC0 - 7ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14DA, 0xFFFF, 0x2F7E, 0xFFFF, 0xFFFF, 0xFFFF, 0x178B, 0xFFFF, 0x01BF,   // 7AD0 - 7ADF
	0x28D1, 0xFFFF, 0xFFFF, 0x2B95, 0xFFFF, 0x0BC1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EFE, 0xFFFF, 0xFFFF, 0x004F, 0xFFFF, 0x0A45,   // 7AE0 - 7AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01C0, 0xFFFF, 0xFFFF, 0x2B83, 0x31A7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x003F,   // 7AF0 - 7AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C8D,   // 7B00 - 7B0F
	0xFFFF, 0x1E24, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CDD, 0xFFFF, 0x2978, 0xFFFF, 0xFFFF, 0x3585, 0xFFFF,   // 7B10 - 7B1F
	0x12E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1887, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A20, 0x10BF, 0xFFFF, 0xFFFF,   // 7B20 - 7B2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DB6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7B30 - 7B3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3A9D, 0xFFFF, 0xFFFF, 0x0CF3, 0xFFFF, 0x045A, 0x29A2, 0x1F39, 0xFFFF, 0x1715,   // 7B40 - 7B4F
	0x02B6, 0x31A8, 0x3671, 0xFFFF, 0x0A71, 0xFFFF, 0x2FB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7B50 - 7B5F
	0x042A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA4, 0xFFFF, 0x1D2E, 0xFFFF,   // 7B60 - 7B6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2476, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x252D, 0xFFFF, 0xFFFF,   // 7B70 - 7B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00A8, 0xFFFF, 0xFFFF, 0xFFFF, 0x29A3, 0xFFFF, 0xFFFF, 0xFFFF, 0x290E,   // 7B80 - 7B8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x162E, 0x04DC, 0xFFFF, 0x1C70, 0xFFFF, 0xFFFF, 0x2F47, 0xFFFF, 0xFFFF, 0x0199, 0xFFFF, 0xFFFF,   // 7B90 - 7B9F
	0xFFFF, 0x0290, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29A4, 0xFFFF, 0xFFFF,   // 7BA0 - 7BAF
	0xFFFF, 0x1CAD, 0xFFFF, 0xFFFF, 0x28B2, 0xFFFF, 0xFFFF, 0xFFFF, 0x295F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BB0 - 7BBF
	0x29BC, 0x3CFC, 0xFFFF, 0xFFFF, 0x1727, 0xFFFF, 0x29A5, 0x38B6, 0xFFFF, 0x31A9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BC0 - 7BCF
	0xFFFF, 0xFFFF, 0x2045, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BD0 - 7BDF
	0x1E25, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C4D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BE0 - 7BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BF0 - 7BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AB0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C00 - 7C0F
	0xFFFF, 0xFFFF, 0x2F5D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A46, 0xFFFF,   // 7C10 - 7C1F
	0xFFFF, 0x0040, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CFD, 0xFFFF, 0xFFFF, 0x28B3, 0x1E26, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C20 - 7C2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x304D, 0x10B0, 0x1888,   // 7C30 - 7C3F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0FB5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B72, 0x2979, 0xFFFF, 0xFFFF,   // 7C40 - 7C4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C50 - 7C5F
	0x1125, 0xFFFF, 0xFFFF, 0xFFFF, 0x304E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B9, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C60 - 7C6F
	0xFFFF, 0xFFFF, 0xFFFF, 0x15F0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C70 - 7C7F
	0xFFFF, 0xFFFF, 0xFFFF, 0x199A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C80 - 7C8F
	0xFFFF, 0xFFFF, 0x12E5, 0xFFFF, 0xFFFF, 0x162F, 0xFFFF, 0x2A9D, 0x29CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E38,   // 7C90 - 7C9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B84, 0xFFFF, 0x28D2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x100F, 0xFFFF,   // 7CA0 - 7CAF
	0xFFFF, 0x1010, 0x2F5F, 0x00C7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29FD, 0xFFFF,   // 7CB0 - 7CBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C6C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7CC0 - 7CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18AF, 0x2A9E,   // 7CD0 - 7CDF
	0x0087, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1011, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7CE0 - 7CEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01E6, 0xFFFF, 0xFFFF, 0x041D, 0xFFFF,   // 7CF0 - 7CFF
	0x04DD, 0xFFFF, 0x2B73, 0xFFFF, 0x237B, 0x3CA1, 0x2654, 0x3E53, 0x3CD1, 0xFFFF, 0x151B, 0x151C, 0xFFFF, 0x079B, 0xFFFF, 0xFFFF,   // 7D00 - 7D0F
	0x09B4, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F3A, 0xFFFF, 0xFFFF, 0x1C4E, 0x02FE, 0x2C86, 0x0482, 0x18B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D10 - 7D1F
	0x1E27, 0x167F, 0x1CC3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2884, 0x2B74, 0xFFFF, 0x2F6E, 0x11BA,   // 7D20 - 7D2F
	0x1DB7, 0xFFFF, 0xFFFF, 0x205A, 0xFFFF, 0x2960, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E28, 0x006B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D30 - 7D3F
	0xFFFF, 0xFFFF, 0x2AD5, 0x3BE6, 0x2A9F, 0x01C1, 0x164D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D40 - 7D4F
	0x018C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0316, 0xFFFF,   // 7D50 - 7D5F
	0xFFFF, 0x0F91, 0x3BE7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0483, 0xFFFF, 0x278A, 0xFFFF, 0x2834, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D2F, 0xFFFF,   // 7D60 - 7D6F
	0xFFFF, 0x3672, 0x1C4F, 0x0088, 0xFFFF, 0xFFFF, 0x29BD, 0xFFFF, 0xFFFF, 0x017E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0360,   // 7D70 - 7D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29FE, 0x1F00,   // 7D80 - 7D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x01C2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AD6, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D90 - 7D9F
	0x1106, 0xFFFF, 0x2B75, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F01, 0x274A, 0xFFFF, 0xFFFF,   // 7DA0 - 7DAF
	0xFFFF, 0x0089, 0x1333, 0xFFFF, 0x303B, 0x2FAA, 0xFFFF, 0xFFFF, 0x1249, 0xFFFF, 0x04DE, 0x3555, 0xFFFF, 0x2896, 0x1283, 0x13F3,   // 7DB0 - 7DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32A6, 0xFFFF, 0xFFFF, 0x04F3, 0x199B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7DC0 - 7DCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D30, 0xFFFF, 0x3AF0, 0xFFFF, 0x1D5F, 0xFFFF, 0xFFFF, 0x2CDF, 0x0A47, 0xFFFF,   // 7DD0 - 7DDF
	0x3074, 0x1606, 0xFFFF, 0x2477, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38B7, 0x2579, 0xFFFF, 0xFFFF, 0x13F4, 0xFFFF, 0xFFFF, 0x26FA,   // 7DE0 - 7DEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1094, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32A7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7DF0 - 7DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CB0, 0x234A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E00 - 7E0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x253F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1630, 0xFFFF, 0x2CB1, 0x3C6D, 0x260A,   // 7E10 - 7E1F
	0xFFFF, 0x28F2, 0xFFFF, 0x3BE8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17F4, 0xFFFF, 0xFFFF, 0x31AA, 0x2479,   // 7E20 - 7E2F
	0xFFFF, 0x2AD7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x310D, 0x297A, 0xFFFF,   // 7E30 - 7E3F
	0xFFFF, 0x170C, 0xFFFF, 0x18CE, 0xFFFF, 0xFFFF, 0x1507, 0x25FA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E40 - 7E4F
	0xFFFF, 0xFFFF, 0x2C49, 0xFFFF, 0x2C96, 0x1D60, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x25FB, 0xFFFF,   // 7E50 - 7E5F
	0xFFFF, 0x1F02, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FF9, 0x3D34, 0x01E7, 0xFFFF, 0x017F, 0xFFFF, 0xFFFF,   // 7E60 - 7E6F
	0x2AA0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2450, 0xFFFF, 0xFFFF, 0x01E8, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E70 - 7E7F
	0xFFFF, 0xFFFF, 0x2F5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E39, 0xFFFF, 0xFFFF, 0x29A6,   // 7E80 - 7E8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x24CD, 0xFFFF, 0xFFFF, 0x1D8A, 0xFFFF, 0x2F60, 0xFFFF, 0xFFFF, 0x0B92, 0x0FB6, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E90 - 7E9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EA0 - 7EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EB0 - 7EBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EC0 - 7ECF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7ED0 - 7EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EE0 - 7EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EF0 - 7EFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F00 - 7F0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F10 - 7F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F20 - 7F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1889, 0xFFFF, 0x3B0C, 0xFFFF, 0x018D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F30 - 7F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2362, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F40 - 7F4F
	0x0291, 0xFFFF, 0xFFFF, 0xFFFF, 0x1334, 0x3AD5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F50 - 7F5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B21, 0x02C2, 0xFFFF, 0xFFFF, 0x32A8, 0xFFFF,   // 7F60 - 7F6F
	0x1716, 0xFFFF, 0x1D31, 0xFFFF, 0xFFFF, 0x134A, 0xFFFF, 0x37E6, 0xFFFF, 0x12BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F70 - 7F7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F87, 0xFFFF, 0xFFFF, 0x04DF, 0xFFFF, 0x23AB, 0xFFFF, 0x008A, 0xFFFF, 0x15F1, 0xFFFF,   // 7F80 - 7F8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x021F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10C0, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F03, 0xFFFF,   // 7F90 - 7F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x037F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D61, 0x27D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7FA0 - 7FAF
	0xFFFF, 0xFFFF, 0x3E84, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12BB, 0x00C8, 0xFFFF, 0xFFFF, 0xFFFF, 0x2655, 0xFFFF, 0xFFFF,   // 7FB0 - 7FBF
	0xFFFF, 0x2558, 0xFFFF, 0xFFFF, 0xFFFF, 0x2032, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x281F, 0xFFFF, 0x2820, 0xFFFF, 0x10C1, 0xFFFF,   // 7FC0 - 7FCF
	0xFFFF, 0xFFFF, 0x1FEB, 0xFFFF, 0x1CAE, 0x3E64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x297B,   // 7FD0 - 7FDF
	0x3219, 0x199C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38B8, 0xFFFF, 0x257A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7FE0 - 7FEF
	0x3AD6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0317, 0xFFFF, 0xFFFF, 0x2821, 0xFFFF, 0xFFFF, 0xFFFF,   // 7FF0 - 7FFF
	0x25FC, 0x10FA, 0xFFFF, 0x0220, 0xFFFF, 0x2885, 0x04E0, 0xFFFF, 0xFFFF, 0x0361, 0xFFFF, 0xFFFF, 0x280C, 0xFFFF, 0xFFFF, 0xFFFF,   // 8000 - 800F
	0x07B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01C3, 0xFFFF, 0x144F, 0x2673, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8010 - 801F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04E1, 0xFFFF, 0xFFFF,   // 8020 - 802F
	0xFFFF, 0xFFFF, 0xFFFF, 0x280D, 0xFFFF, 0xFFFF, 0x2374, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3567, 0xFFFF, 0x01C4,   // 8030 - 803F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0A67, 0xFFFF, 0xFFFF, 0x10C2, 0xFFFF, 0xFFFF, 0xFFFF, 0x1192, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8040 - 804F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA5, 0xFFFF, 0x19CF, 0xFFFF, 0x321A, 0xFFFF, 0xFFFF, 0xFFFF, 0x151D, 0xFFFF,   // 8050 - 805F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1095,   // 8060 - 806F
	0x310E, 0xFFFF, 0x1DA6, 0x2632, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3063, 0x1126, 0x277A,   // 8070 - 807F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x280E, 0x1F26, 0x1C50, 0x2AA1, 0xFFFF, 0x275F, 0xFFFF, 0x126A, 0x04E2, 0xFFFF, 0xFFFF, 0xFFFF,   // 8080 - 808F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B0D, 0xFFFF, 0x0041, 0xFFFF, 0xFFFF,   // 8090 - 809F
	0xFFFF, 0x0221, 0x2C87, 0xFFFF, 0xFFFF, 0x199D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0180, 0x1680, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x048B,   // 80A0 - 80AF
	0xFFFF, 0x02FF, 0x2760, 0xFFFF, 0x3D65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 80B0 - 80BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x26FB, 0x2B5F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x169D, 0xFFFF, 0x3586, 0xFFFF,   // 80C0 - 80CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x169E, 0x0074, 0xFFFF, 0xFFFF, 0x3911, 0xFFFF,   // 80D0 - 80DF
	0xFFFF, 0x3C6E, 0xFFFF, 0xFFFF, 0x276D, 0x1D32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 80E0 - 80EF
	0xFFFF, 0x02B7, 0xFFFF, 0xFFFF, 0x0BC2, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E3C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09EC, 0xFFFF, 0xFFFF,   // 80F0 - 80FF
	0xFFFF, 0xFFFF, 0x2C88, 0xFFFF, 0xFFFF, 0x3C08, 0x321B, 0x3C09, 0x1350, 0xFFFF, 0x3017, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8100 - 810F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x257B, 0xFFFF, 0x0027, 0x01C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8110 - 811F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F3B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F04, 0xFFFF, 0x355C, 0xFFFF, 0xFFFF, 0xFFFF, 0x3912,   // 8120 - 812F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F98, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x199E, 0xFFFF,   // 8130 - 813F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x234B, 0xFFFF, 0xFFFF, 0x205B, 0xFFFF,   // 8140 - 814F
	0x188A, 0x188B, 0xFFFF, 0xFFFF, 0x008B, 0x257C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8150 - 815F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA7, 0x08FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AD8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8160 - 816F
	0x25FD, 0x0125, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28D3, 0x17CB, 0x1D62, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x36B5,   // 8170 - 817F
	0x1681, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0174, 0xFFFF, 0x1631, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0222,   // 8180 - 818F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x188C, 0xFFFF, 0x12FD, 0x1FDE, 0xFFFF, 0xFFFF,   // 8190 - 819F
	0x0318, 0xFFFF, 0xFFFF, 0x2CCC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3835, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 81A0 - 81AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1D63, 0xFFFF, 0x31F4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27BC, 0xFFFF, 0xFFFF, 0x0A68, 0x3D35, 0x08B9,   // 81B0 - 81BF
	0x0C4C, 0xFFFF, 0x199F, 0xFFFF, 0xFFFF, 0xFFFF, 0x23E6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A21, 0xFFFF, 0xFFFF,   // 81C0 - 81CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28D4,   // 81D0 - 81DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x205C, 0xFFFF, 0x2567, 0xFFFF, 0x28D5, 0x12DF, 0xFFFF, 0x2886, 0xFFFF, 0xFFFF, 0x321C, 0xFFFF, 0xFFFF,   // 81E0 - 81EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2C89, 0x32A9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A95, 0x2CB2, 0x0362, 0xFFFF, 0x274B, 0xFFFF,   // 81F0 - 81FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0363, 0xFFFF, 0x243D, 0x3E69, 0xFFFF, 0x0364, 0xFFFF, 0x1D78, 0x1C51, 0xFFFF, 0xFFFF,   // 8200 - 820F
	0xFFFF, 0xFFFF, 0x1D33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3028, 0x1F3C, 0xFFFF, 0x1508, 0x2B76,   // 8210 - 821F
	0xFFFF, 0x008C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B0E, 0x1682, 0x164E, 0xFFFF, 0xFFFF, 0xFFFF,   // 8220 - 822F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3535, 0x1632, 0x3BE9, 0xFFFF, 0x1D64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8230 - 823F
	0x188D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x243E, 0xFFFF, 0x29FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8240 - 824F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8250 - 825F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27D1, 0xFFFF, 0x3AF1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0042, 0x1012,   // 8260 - 826F
	0xFFFF, 0x0043, 0x1CC4, 0xFFFF, 0xFFFF, 0xFFFF, 0x24A2, 0xFFFF, 0x30DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2342, 0xFFFF,   // 8270 - 827F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2656, 0xFFFF, 0x2897, 0x039C, 0xFFFF,   // 8280 - 828F
	0xFFFF, 0xFFFF, 0x1335, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x188E, 0x0C4D, 0xFFFF, 0xFFFF, 0x2C8A, 0xFFFF, 0x1C8A,   // 8290 - 829F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00A9, 0x3C6F, 0xFFFF, 0xFFFF, 0x0476, 0xFFFF, 0xFFFF, 0x18B1, 0x37E7, 0x24EB, 0x207E,   // 82A0 - 82AF
	0xFFFF, 0x3CB4, 0xFFFF, 0x1683, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C8B, 0x2674, 0x045B, 0xFFFF, 0x3195, 0x1450, 0x22E5, 0xFFFF, 0x286B,   // 82B0 - 82BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 82C0 - 82CF
	0xFFFF, 0x26AE, 0x24A3, 0xFFFF, 0x3587, 0x30E0, 0xFFFF, 0x14DB, 0xFFFF, 0xFFFF, 0xFFFF, 0x0015, 0xFFFF, 0xFFFF, 0x3913, 0x0365,   // 82D0 - 82DF
	0xFFFF, 0x280F, 0xFFFF, 0xFFFF, 0xFFFF, 0x237C, 0x0223, 0x2961, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 82E0 - 82EF
	0xFFFF, 0x24D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0224, 0x3A9E, 0xFFFF,   // 82F0 - 82FF
	0xFFFF, 0x2B9F, 0x1509, 0x1728, 0x0016, 0x1451, 0xFFFF, 0xFFFF, 0xFFFF, 0x131E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8300 - 830F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1413, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8310 - 831F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2887, 0xFFFF, 0xFFFF, 0x1336, 0xFFFF, 0xFFFF, 0xFFFF, 0x17CC,   // 8320 - 832F
	0xFFFF, 0x1F05, 0xFFFF, 0xFFFF, 0x3D36, 0x2835, 0x0A33, 0xFFFF, 0x2633, 0x243F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8330 - 833F
	0x1F3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B45, 0xFFFF, 0x30E1, 0x3C1E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x285C,   // 8340 - 834F
	0xFFFF, 0x2810, 0x3CFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8350 - 835F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8360 - 836F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0C42, 0xFFFF, 0xFFFF, 0xFFFF, 0x3ABE, 0xFFFF, 0xFFFF, 0xFFFF, 0x297C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8370 - 837F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12BC, 0x28D6, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C52, 0xFFFF,   // 8380 - 838F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01C6, 0xFFFF, 0x205D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x257D, 0xFFFF,   // 8390 - 839F
	0xFFFF, 0xFFFF, 0x3C0A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x188F, 0x22E6, 0x12FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 83A0 - 83AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1337, 0xFFFF, 0xFFFF,   // 83B0 - 83BF
	0xFFFF, 0x3064, 0xFFFF, 0xFFFF, 0xFFFF, 0x0292, 0xFFFF, 0xFFFF, 0xFFFF, 0x1107, 0x0376, 0xFFFF, 0x042B, 0xFFFF, 0xFFFF, 0xFFFF,   // 83C0 - 83CF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0277, 0xFFFF, 0xFFFF, 0x2F9A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2FAB, 0xFFFF, 0xFFFF, 0xFFFF,   // 83D0 - 83DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17BD, 0xFFFF, 0x045C, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CB5,   // 83E0 - 83EF
	0x0225, 0x1284, 0x19A0, 0xFFFF, 0x2321, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2962, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F27, 0xFFFF, 0xFFFF,   // 83F0 - 83FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x31F5, 0x0B7D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD4, 0xFFFF, 0x136E, 0x38D1, 0x26FC, 0xFFFF,   // 8400 - 840F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8410 - 841F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3196, 0xFFFF, 0xFFFF, 0x1310, 0xFFFF, 0xFFFF, 0xFFFF,   // 8420 - 842F
	0xFFFF, 0x3DBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x274C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F92, 0xFFFF, 0xFFFF,   // 8430 - 843F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24AC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8440 - 844F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2963, 0xFFFF, 0xFFFF, 0xFFFF, 0x0050, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8450 - 845F
	0xFFFF, 0x3914, 0xFFFF, 0x0BC3, 0xFFFF, 0xFFFF, 0x26FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C70, 0x28D7, 0xFFFF, 0xFFFF, 0x237D,   // 8460 - 846F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x041E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8470 - 847F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8480 - 848F
	0x1F06, 0xFFFF, 0xFFFF, 0xFFFF, 0x2033, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1475, 0xFFFF, 0xFFFF, 0x1C71, 0xFFFF, 0xFFFF, 0xFFFF,   // 8490 - 849F
	0xFFFF, 0x1684, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 84A0 - 84AF
	0xFFFF, 0xFFFF, 0x3915, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C4A, 0xFFFF, 0xFFFF, 0x237E, 0x2F9B, 0xFFFF, 0xFFFF, 0x3C71,   // 84B0 - 84BF
	0x1E43, 0xFFFF, 0x1414, 0xFFFF, 0x31AB, 0xFFFF, 0x1D48, 0xFFFF, 0xFFFF, 0x2634, 0xFFFF, 0x00AA, 0xFFFF, 0x2034, 0xFFFF, 0xFFFF,   // 84C0 - 84CF
	0xFFFF, 0x1C53, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F07, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 84D0 - 84DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17F5, 0xFFFF, 0x1096, 0xFFFF,   // 84E0 - 84EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F3E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1193, 0xFFFF, 0xFFFF, 0xFFFF,   // 84F0 - 84FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8500 - 850F
	0xFFFF, 0x13FC, 0xFFFF, 0x1311, 0x17CD, 0xFFFF, 0xFFFF, 0x2888, 0x1C8B, 0xFFFF, 0x267E, 0xFFFF, 0xFFFF, 0xFFFF, 0x11BC, 0xFFFF,   // 8510 - 851F
	0xFFFF, 0x2FAC, 0xFFFF, 0x28D8, 0xFFFF, 0x310F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E29, 0x27AE, 0xFFFF, 0x2CB3,   // 8520 - 852F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38E1, 0xFFFF, 0x26FE,   // 8530 - 853F
	0xFFFF, 0x0A69, 0xFFFF, 0x170D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30E2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0319, 0xFFFF,   // 8540 - 854F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2675, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C31, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8550 - 855F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F3F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x03B9, 0x3575, 0x150A, 0xFFFF, 0xFFFF, 0x1E2A, 0xFFFF, 0xFFFF,   // 8560 - 856F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8570 - 857F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1633, 0xFFFF, 0xFFFF, 0x15F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27D2,   // 8580 - 858F
	0xFFFF, 0x008D, 0xFFFF, 0xFFFF, 0x28D9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D79, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8590 - 859F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3029, 0xFFFF, 0x3DB0, 0x1C7C, 0x205E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D34,   // 85A0 - 85AF
	0x3D9C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A22, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 85B0 - 85BF
	0xFFFF, 0x0226, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2889, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FB7, 0x205F, 0x28DA,   // 85C0 - 85CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2657, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x107C, 0x24EC, 0xFFFF, 0xFFFF,   // 85D0 - 85DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF4, 0x237F, 0xFFFF, 0xFFFF, 0xFFFF, 0x170E, 0x1F08, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 85E0 - 85EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2964, 0xFFFF, 0xFFFF, 0x12CB, 0x2AA2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0281,   // 85F0 - 85FF
	0xFFFF, 0xFFFF, 0x24ED, 0xFFFF, 0xFFFF, 0xFFFF, 0x10FB, 0x1E2B, 0xFFFF, 0xFFFF, 0x2540, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8600 - 860F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23F5, 0x175C, 0xFFFF, 0xFFFF, 0x1D65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8610 - 861F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FA0, 0xFFFF, 0xFFFF,   // 8620 - 862F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F88,   // 8630 - 863F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C72, 0xFFFF,   // 8640 - 864F
	0x3AC7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0126, 0x300A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B91, 0x10FC, 0xFFFF, 0x2658, 0x3C73,   // 8650 - 865F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E1F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8660 - 866F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CA2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8670 - 867F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x151E, 0xFFFF, 0x1685, 0xFFFF, 0xFFFF, 0xFFFF,   // 8680 - 868F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2837, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8690 - 869F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0267, 0x2AA3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 86A0 - 86AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 86B0 - 86BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C54, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A48, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 86C0 - 86CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D37, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2568, 0xFFFF, 0x2B77, 0xFFFF, 0xFFFF, 0xFFFF, 0x031A,   // 86D0 - 86DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AF9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CCD, 0xFFFF, 0xFFFF,   // 86E0 - 86EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22E7, 0xFFFF,   // 86F0 - 86FF
	0x30ED, 0xFFFF, 0x17F6, 0x2060, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x252E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8700 - 870F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C8C, 0xFFFF, 0x19A1, 0xFFFF, 0x160D, 0xFFFF, 0xFFFF, 0xFFFF,   // 8710 - 871F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8720 - 872F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8730 - 873F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0052, 0xFFFF,   // 8740 - 874F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2046, 0xFFFF, 0x3CFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26FF,   // 8750 - 875F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3ABF, 0xFFFF, 0x1FDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8760 - 876F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C74, 0xFFFF, 0x29D2, 0xFFFF, 0x2569, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8770 - 877F
	0xFFFF, 0xFFFF, 0x0FC8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x278B, 0xFFFF, 0xFFFF,   // 8780 - 878F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1415,   // 8790 - 879F
	0xFFFF, 0xFFFF, 0x3C1F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87A0 - 87AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0A81, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F89, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87B0 - 87BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87C0 - 87CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87D0 - 87DF
	0x164F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D66, 0xFFFF, 0xFFFF, 0x25FF,   // 87E0 - 87EF
	0xFFFF, 0xFFFF, 0x31CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B24, 0xFFFF, 0x27D3, 0xFFFF, 0xFFFF, 0x1D8B, 0xFFFF,   // 87F0 - 87FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FFA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8800 - 880F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FBD,   // 8810 - 881F
	0xFFFF, 0xFFFF, 0x2B96, 0x107D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8820 - 882F
	0xFFFF, 0x0227, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28B4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1312, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8830 - 883F
	0x3BF5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2BAF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B46, 0x247B, 0xFFFF, 0xFFFF,   // 8840 - 884F
	0xFFFF, 0xFFFF, 0x3BEA, 0x1F4B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0017, 0xFFFF, 0x22E8, 0xFFFF, 0x2700, 0xFFFF, 0x31CE, 0xFFFF, 0xFFFF,   // 8850 - 885F
	0xFFFF, 0x3C20, 0x0366, 0x27D4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x399B, 0xFFFF, 0xFFFF, 0x1C8C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8860 - 886F
	0x1EA4, 0xFFFF, 0x079E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31CF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0477, 0x0478,   // 8870 - 887F
	0xFFFF, 0x26AF, 0x1420, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0018, 0xFFFF, 0xFFFF, 0x0A96, 0xFFFF, 0x3916, 0xFFFF, 0xFFFF,   // 8880 - 888F
	0xFFFF, 0xFFFF, 0x0A49, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F09, 0x2CB4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0244, 0xFFFF,   // 8890 - 889F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3A8B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 88A0 - 88AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0228, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 88B0 - 88BF
	0xFFFF, 0x28F3, 0x10A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12BD,   // 88C0 - 88CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24EF, 0x274D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0380, 0xFFFF, 0xFFFF, 0x17BE, 0x28DB, 0xFFFF, 0x1C55,   // 88D0 - 88DF
	0xFFFF, 0x12BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 88E0 - 88EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1CAF, 0x169F, 0x16A0, 0xFFFF, 0xFFFF, 0x0F8A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A23, 0xFFFF, 0xFFFF,   // 88F0 - 88FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8900 - 890F
	0x0051, 0xFFFF, 0x3917, 0x17BF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2701, 0x16A1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8910 - 891F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x260B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x36B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8920 - 892F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FEC, 0xFFFF, 0x11BD, 0xFFFF, 0xFFFF, 0x1D7A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8930 - 893F
	0xFFFF, 0x008E, 0xFFFF, 0xFFFF, 0x23AD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8940 - 894F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0479,   // 8950 - 895F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FB8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x131F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8960 - 896F
	0xFFFF, 0xFFFF, 0x1FED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D35,   // 8970 - 897F
	0xFFFF, 0x2600, 0xFFFF, 0x0A6A, 0xFFFF, 0xFFFF, 0x17CF, 0x381B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0181, 0xFFFF, 0xFFFF, 0xFFFF, 0x041F,   // 8980 - 898F
	0xFFFF, 0xFFFF, 0xFFFF, 0x13E8, 0xFFFF, 0xFFFF, 0x2035, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8990 - 899F
	0xFFFF, 0x0175, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B7E, 0x32B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89A0 - 89AF
	0xFFFF, 0xFFFF, 0x045D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0028, 0xFFFF, 0xFFFF, 0x0FB9, 0xFFFF, 0xFFFF,   // 89B0 - 89BF
	0x0293, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89C0 - 89CF
	0xFFFF, 0xFFFF, 0x0029, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89D0 - 89DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3B25, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89E0 - 89EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CB0, 0xFFFF, 0xFFFF, 0xFFFF, 0x30EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89F0 - 89FF
	0x23EE, 0xFFFF, 0x2A00, 0x1890, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01E9, 0xFFFF, 0x2061, 0xFFFF, 0x3CA3, 0xFFFF, 0x3657, 0xFFFF,   // 8A00 - 8A0F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3D9D, 0xFFFF, 0xFFFF, 0x3E54, 0x3548, 0x04E3, 0xFFFF, 0xFFFF, 0x256A, 0xFFFF, 0x22E9, 0xFFFF, 0x1E5C,   // 8A10 - 8A1F
	0xFFFF, 0xFFFF, 0xFFFF, 0x018E, 0xFFFF, 0x094A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1686, 0xFFFF, 0xFFFF, 0x1D7B, 0xFFFF, 0xFFFF,   // 8A20 - 8A2F
	0xFFFF, 0x3B92, 0xFFFF, 0xFFFF, 0x1E2C, 0xFFFF, 0x0019, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CB5, 0x2B78, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8A30 - 8A3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8A40 - 8A4F
	0x1C56, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AA4, 0x38D2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2965, 0xFFFF, 0xFFFF, 0x1C57, 0xFFFF,   // 8A50 - 8A5F
	0x24D1, 0xFFFF, 0x1F40, 0x24F0, 0xFFFF, 0xFFFF, 0x2036, 0xFFFF, 0xFFFF, 0x2037, 0xFFFF, 0xFFFF, 0xFFFF, 0x03D3, 0x29A7, 0xFFFF,   // 8A60 - 8A6F
	0x3EA9, 0x3CB6, 0x3B26, 0x1CB1, 0xFFFF, 0x1D67, 0xFFFF, 0xFFFF, 0xFFFF, 0x304F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8A70 - 8A7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B79, 0xFFFF, 0x0278, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C8D, 0x2838, 0xFFFF, 0xFFFF,   // 8A80 - 8A8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1D36, 0xFFFF, 0x3556, 0xFFFF, 0xFFFF, 0x274E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23DD, 0xFFFF,   // 8A90 - 8A9F
	0x1DA8, 0x01EA, 0xFFFF, 0x150B, 0x252F, 0x0229, 0x1E5D, 0xFFFF, 0x3D38, 0xFFFF, 0x1D7C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8AA0 - 8AAF
	0x1F0A, 0xFFFF, 0x0279, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A3, 0xFFFF, 0xFFFF, 0x27D5, 0xFFFF, 0x279C, 0x2AA5,   // 8AB0 - 8ABF
	0xFFFF, 0xFFFF, 0x3050, 0xFFFF, 0x1F41, 0xFFFF, 0xFFFF, 0x0A6B, 0xFFFF, 0xFFFF, 0xFFFF, 0x3065, 0xFFFF, 0x290F, 0xFFFF, 0x3197,   // 8AC0 - 8ACF
	0xFFFF, 0xFFFF, 0x1013, 0xFFFF, 0xFFFF, 0xFFFF, 0x110E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x274F, 0x3059, 0xFFFF, 0xFFFF, 0xFFFF,   // 8AD0 - 8ADF
	0xFFFF, 0x2038, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3075, 0x3B27, 0xFFFF, 0xFFFF, 0x2A01, 0x0044, 0xFFFF, 0x2750, 0x288A, 0xFFFF,   // 8AE0 - 8AEF
	0xFFFF, 0x3DFC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x207F, 0x39D4, 0x2A24, 0xFFFF, 0x23EF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0773, 0xFFFF,   // 8AF0 - 8AFF
	0x1452, 0x2310, 0x2702, 0xFFFF, 0x0CF5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15F3, 0xFFFF,   // 8B00 - 8B0F
	0x160E, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AC8, 0xFFFF, 0x1E3A, 0x1687, 0xFFFF, 0x019A, 0x2822, 0x008F, 0xFFFF, 0x1C58, 0xFFFF, 0xFFFF,   // 8B10 - 8B1F
	0x2601, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1453, 0xFFFF, 0xFFFF, 0x297D, 0x123C, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B20 - 8B2F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0367, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x045E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B30 - 8B3F
	0xFFFF, 0x3CB7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C4B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E29, 0x04E4,   // 8B40 - 8B4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2047, 0xFFFF, 0x0A6C, 0xFFFF, 0x17C0, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B50 - 8B5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01C7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A4, 0xFFFF, 0xFFFF, 0x2451,   // 8B60 - 8B6F
	0x27D6, 0xFFFF, 0xFFFF, 0xFFFF, 0x0182, 0xFFFF, 0xFFFF, 0x3C75, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24F1, 0xFFFF, 0xFFFF,   // 8B70 - 8B7F
	0x0B93, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1765, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B80 - 8B8F
	0x1F0B, 0xFFFF, 0x2F7F, 0x23AF, 0xFFFF, 0xFFFF, 0x2F80, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F61, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B90 - 8B9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BA0 - 8BAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BB0 - 8BBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BC0 - 8BCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BD0 - 8BDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BE0 - 8BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BF0 - 8BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C00 - 8C0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C10 - 8C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C20 - 8C2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0237, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01EB,   // 8C30 - 8C3F
	0xFFFF, 0x3CDC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C44, 0xFFFF, 0x04E5, 0xFFFF, 0x39D5, 0xFFFF, 0x257E, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C40 - 8C4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2039, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C50 - 8C5F
	0xFFFF, 0x1CB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C76, 0x24F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C60 - 8C6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x399C, 0x203A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C70 - 8C7F
	0xFFFF, 0xFFFF, 0x30E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1351, 0xFFFF, 0x1454, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C80 - 8C8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x381C, 0x2A02, 0xFFFF,   // 8C90 - 8C9F
	0x1891, 0x28F4, 0x0268, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19B9, 0x3CB8, 0x37F3, 0x3568, 0x0294, 0x2FB3, 0xFFFF, 0xFFFF, 0x2966,   // 8CA0 - 8CAF
	0x1DB9, 0xFFFF, 0xFFFF, 0x2814, 0x03F5, 0xFFFF, 0x38C8, 0x134B, 0x0A97, 0xFFFF, 0xFFFF, 0x19A5, 0x305A, 0x2813, 0xFFFF, 0x150C,   // 8CB0 - 8CBF
	0x3AC0, 0x18B2, 0x116A, 0x285D, 0x3D39, 0xFFFF, 0xFFFF, 0x288B, 0x001A, 0xFFFF, 0x297E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8CC0 - 8CCF
	0xFFFF, 0x2CB6, 0xFFFF, 0x19BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x116B, 0xFFFF, 0x1C59, 0xFFFF, 0x1CB3, 0xFFFF,   // 8CD0 - 8CDF
	0x16A2, 0xFFFF, 0x3BEC, 0x134C, 0x302A, 0xFFFF, 0x1892, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CCE, 0xFFFF, 0xFFFF, 0x0B7F, 0xFFFF, 0xFFFF,   // 8CE0 - 8CEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x116C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1893, 0x0368, 0x1CBE, 0xFFFF, 0xFFFF,   // 8CF0 - 8CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C8F, 0x31F6, 0xFFFF, 0x276E, 0x2C4C, 0xFFFF, 0x2F62, 0xFFFF, 0xFFFF, 0x1D8C, 0xFFFF, 0xFFFF,   // 8D00 - 8D0F
	0xFFFF, 0xFFFF, 0xFFFF, 0x28DC, 0xFFFF, 0xFFFF, 0x1E3B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D10 - 8D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D20 - 8D2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D30 - 8D3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D40 - 8D4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D50 - 8D5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x297F, 0xFFFF, 0x1C5A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BD5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D60 - 8D6F
	0x2B7A, 0xFFFF, 0xFFFF, 0x0420, 0x1894, 0xFFFF, 0xFFFF, 0x04E6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D70 - 8D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x30E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D80 - 8D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AA6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D90 - 8D9F
	0xFFFF, 0xFFFF, 0xFFFF, 0x321D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3198, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8DA0 - 8DAF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2AB1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1895, 0xFFFF, 0xFFFF, 0xFFFF, 0x2C90, 0xFFFF,   // 8DB0 - 8DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3588, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x165D, 0x2CCF, 0xFFFF, 0xFFFF, 0x001B,   // 8DC0 - 8DCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x37E8, 0xFFFF, 0x0114, 0xFFFF, 0xFFFF,   // 8DD0 - 8DDF
	0xFFFF, 0x2980, 0xFFFF, 0x1D68, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x027A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10FD,   // 8DE0 - 8DEF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0B80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8DF0 - 8DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2635, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A72,   // 8E00 - 8E0F
	0x302B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0115, 0xFFFF,   // 8E10 - 8E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E20 - 8E2F
	0x2751, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2ADA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E30 - 8E3F
	0xFFFF, 0xFFFF, 0x2752, 0xFFFF, 0x2A25, 0xFFFF, 0xFFFF, 0x0127, 0x0B81, 0x2F49, 0x3C32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E40 - 8E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31AC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2981,   // 8E50 - 8E5F
	0x3018, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E60 - 8E6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31AD, 0xFFFF, 0x03BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E70 - 8E7F
	0xFFFF, 0x2AA7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2967, 0xFFFF, 0xFFFF, 0x2B7B, 0xFFFF, 0xFFFF, 0x2380, 0xFFFF, 0xFFFF,   // 8E80 - 8E8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E90 - 8E9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12CC, 0x2062, 0x039D, 0xFFFF, 0xFFFF, 0xFFFF,   // 8EA0 - 8EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8EB0 - 8EBF
	0x0369, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F4A, 0x2311, 0x03D4, 0x0381, 0xFFFF, 0xFFFF,   // 8EC0 - 8ECF
	0xFFFF, 0xFFFF, 0x3B9A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x247C,   // 8ED0 - 8EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CB7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8EE0 - 8EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31AE, 0xFFFF, 0xFFFF, 0x001C, 0xFFFF, 0xFFFF, 0x2048, 0xFFFF,   // 8EF0 - 8EFF
	0xFFFF, 0xFFFF, 0xFFFF, 0x031B, 0xFFFF, 0x10FE, 0xFFFF, 0xFFFF, 0xFFFF, 0x28F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F00 - 8F0F
	0xFFFF, 0xFFFF, 0x305B, 0x1313, 0x17C1, 0x01C8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1014, 0x32AB, 0x3DFD, 0x1338, 0x303C,   // 8F10 - 8F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1097, 0x178C, 0xFFFF, 0x16A3, 0x124A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CE0,   // 8F20 - 8F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2B7C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F0C, 0x17D0, 0xFFFF, 0x17D1, 0xFFFF, 0xFFFF, 0x29A8, 0x2440,   // 8F30 - 8F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AE0, 0x26B0, 0xFFFF, 0xFFFF, 0xFFFF, 0x29A9, 0xFFFF, 0xFFFF, 0xFFFF, 0x303D, 0x031C, 0xFFFF,   // 8F40 - 8F4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2441, 0xFFFF, 0x0300,   // 8F50 - 8F5F
	0xFFFF, 0xFFFF, 0x1089, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F60 - 8F6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F70 - 8F7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F80 - 8F8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2063, 0x022B, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F90 - 8F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0FA7, 0xFFFF, 0xFFFF, 0x37F4, 0xFFFF, 0x1766, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C5B, 0xFFFF, 0x1767,   // 8FA0 - 8FAF
	0x2CB8, 0x260C, 0x08BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8FB0 - 8FBF
	0xFFFF, 0xFFFF, 0x2659, 0xFFFF, 0xFFFF, 0x2065, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24D2, 0xFFFF,   // 8FC0 - 8FCF
	0xFFFF, 0x045F, 0xFFFF, 0xFFFF, 0x1650, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8FD0 - 8FDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x001D, 0xFFFF, 0xFFFF, 0xFFFF, 0x2982, 0x1634, 0xFFFF, 0x2CD0, 0xFFFF, 0xFFFF,   // 8FE0 - 8FEF
	0x1F4C, 0xFFFF, 0x0144, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15F4, 0xFFFF, 0x2983, 0xFFFF, 0xFFFF, 0xFFFF, 0x3199, 0xFFFF, 0xFFFF,   // 8FF0 - 8FFF
	0x36B7, 0x1E5E, 0x029E, 0x0B82, 0xFFFF, 0x3D90, 0x2453, 0xFFFF, 0x3C21, 0xFFFF, 0xFFFF, 0x3918, 0xFFFF, 0x1E2D, 0xFFFF, 0x36F5,   // 9000 - 900F
	0x31AF, 0x036A, 0xFFFF, 0xFFFF, 0x0B83, 0x01C9, 0xFFFF, 0x0C45, 0xFFFF, 0x2968, 0x3673, 0xFFFF, 0xFFFF, 0x1D37, 0x10C3, 0x1E3C,   // 9010 - 901F
	0x2AA8, 0x2B97, 0x17F7, 0x1098, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3076, 0xFFFF,   // 9020 - 902F
	0xFFFF, 0x2B7D, 0x2CB9, 0xFFFF, 0xFFFF, 0x0421, 0xFFFF, 0xFFFF, 0x2848, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AAA, 0xFFFF, 0x2754, 0xFFFF,   // 9030 - 903F
	0xFFFF, 0x0C4E, 0x1F0D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x265A, 0xFFFF, 0xFFFF, 0x2753, 0x2676, 0xFFFF, 0x38B9, 0x027B, 0xFFFF,   // 9040 - 904F
	0x3AC1, 0x3D00, 0xFFFF, 0x0B84, 0x0A54, 0x2703, 0xFFFF, 0xFFFF, 0xFFFF, 0x2602, 0xFFFF, 0xFFFF, 0x1E44, 0x0A73, 0x3077, 0xFFFF,   // 9050 - 905F
	0x26B1, 0x1E2E, 0xFFFF, 0x0183, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2984, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AA9, 0x2F4B, 0x0C4F,   // 9060 - 906F
	0xFFFF, 0xFFFF, 0x2C91, 0xFFFF, 0xFFFF, 0x2B98, 0xFFFF, 0x302C, 0x1D69, 0xFFFF, 0x2755, 0xFFFF, 0x1194, 0x0117, 0xFFFF, 0x3A8C,   // 9070 - 907F
	0x2604, 0x134D, 0x3B28, 0x1F0E, 0x3CD2, 0xFFFF, 0xFFFF, 0x2815, 0x12FF, 0xFFFF, 0x1768, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F8B,   // 9080 - 908F
	0xFFFF, 0x27B5, 0xFFFF, 0xFFFF, 0xFFFF, 0x2559, 0xFFFF, 0xFFFF, 0xFFFF, 0x1339, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9090 - 909F
	0xFFFF, 0xFFFF, 0x3C22, 0x076C, 0xFFFF, 0xFFFF, 0x1688, 0xFFFF, 0x30F5, 0xFFFF, 0x1C5C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x006C,   // 90A0 - 90AF
	0x3589, 0x036B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E2F, 0xFFFF, 0xFFFF, 0x2969, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 90B0 - 90BF
	0xFFFF, 0x2668, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x031D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 90C0 - 90CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC9, 0xFFFF,   // 90D0 - 90DF
	0xFFFF, 0x0382, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1896, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0282, 0xFFFF, 0xFFFF,   // 90E0 - 90EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x265B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B85, 0xFFFF, 0xFFFF,   // 90F0 - 90FF
	0xFFFF, 0xFFFF, 0x22F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9100 - 910F
	0xFFFF, 0xFFFF, 0x319A, 0xFFFF, 0xFFFF, 0x3B67, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9110 - 911F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A03, 0xFFFF, 0xFFFF,   // 9120 - 912F
	0xFFFF, 0xFFFF, 0x0A4A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9130 - 913F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2756, 0x2A04, 0x319B, 0x2898, 0x16A4, 0x2B7E, 0xFFFF,   // 9140 - 914F
	0xFFFF, 0xFFFF, 0x2B7F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9150 - 915F
	0xFFFF, 0xFFFF, 0x30E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1416, 0x0F94, 0xFFFF, 0x1F0F, 0xFFFF, 0xFFFF, 0xFFFF,   // 9160 - 916F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D66, 0xFFFF, 0x3C7D, 0x1C72, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9170 - 917F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F42, 0xFFFF, 0x321E, 0xFFFF, 0x30E6, 0xFFFF, 0x2A26, 0xFFFF, 0xFFFF,   // 9180 - 918F
	0xFFFF, 0xFFFF, 0x1DA9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x319C, 0xFFFF, 0xFFFF, 0xFFFF,   // 9190 - 919F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x27D7, 0x28DD, 0xFFFF, 0x30E7, 0x3C33,   // 91A0 - 91AF
	0xFFFF, 0x165E, 0xFFFF, 0xFFFF, 0x10D3, 0x00D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 91B0 - 91BF
	0x23B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2FAD, 0xFFFF, 0x2757, 0xFFFF, 0x1D49, 0x12BF, 0x2BB0, 0x2376, 0x1015,   // 91C0 - 91CF
	0x12C0, 0x0504, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EA5, 0x2A05, 0xFFFF, 0xFFFF, 0xFFFF, 0x1897, 0x32CD, 0xFFFF, 0xFFFF,   // 91D0 - 91DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2AAA, 0xFFFF, 0xFFFF, 0xFFFF, 0x302D, 0xFFFF, 0xFFFF, 0x265C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 91E0 - 91EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2FAE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 91F0 - 91FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C50, 0xFFFF, 0xFFFF,   // 9200 - 920F
	0x013F, 0x37F5, 0x1C90, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2770, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x042C, 0xFFFF,   // 9210 - 921F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9220 - 922F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10C4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2537, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29AA,   // 9230 - 923F
	0x0075, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0118, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9240 - 924F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x019B, 0xFFFF, 0xFFFF, 0xFFFF, 0x2480, 0xFFFF, 0xFFFF, 0x26BC, 0xFFFF,   // 9250 - 925F
	0xFFFF, 0xFFFF, 0x165F, 0xFFFF, 0x036C, 0x1F4D, 0x2A06, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9260 - 926F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9270 - 927F
	0x279D, 0xFFFF, 0xFFFF, 0x3110, 0xFFFF, 0x0BC4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9280 - 928F
	0xFFFF, 0x1D6A, 0xFFFF, 0x29AB, 0xFFFF, 0xFFFF, 0x1F10, 0xFFFF, 0x1417, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AF2, 0xFFFF, 0xFFFF, 0xFFFF,   // 9290 - 929F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92A0 - 92AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x24F4, 0xFFFF, 0xFFFF, 0x036D, 0x1E30, 0xFFFF, 0x1F11, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92B0 - 92BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A07, 0xFFFF, 0xFFFF, 0x3C0B,   // 92C0 - 92CF
	0xFFFF, 0xFFFF, 0x17F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92D0 - 92DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D38, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3919, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92E0 - 92EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0119, 0xFFFF, 0xFFFF, 0xFFFF, 0x0090, 0xFFFF, 0xFFFF, 0xFFFF,   // 92F0 - 92FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1108, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9300 - 930F
	0x319D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x319E, 0xFFFF, 0x2910, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F43, 0x0A6D,   // 9310 - 931F
	0x2A08, 0x04E7, 0x29AC, 0xFFFF, 0x04E8, 0xFFFF, 0x047B, 0xFFFF, 0x14DC, 0xFFFF, 0xFFFF, 0x1D4A, 0xFFFF, 0xFFFF, 0x022C, 0x2F51,   // 9320 - 932F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9330 - 933F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24D4, 0xFFFF, 0x1099, 0x027C, 0xFFFF, 0x0B86, 0xFFFF, 0xFFFF,   // 9340 - 934F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22FA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A4B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9350 - 935F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2758, 0xFFFF,   // 9360 - 936F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0128, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32CE, 0xFFFF, 0x2ADB, 0xFFFF,   // 9370 - 937F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x019C, 0xFFFF, 0xFFFF, 0xFFFF,   // 9380 - 938F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2636, 0xFFFF, 0x1E87, 0xFFFF, 0xFFFF, 0xFFFF, 0x319F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9390 - 939F
	0xFFFF, 0xFFFF, 0xFFFF, 0x3C23, 0xFFFF, 0xFFFF, 0xFFFF, 0x00AC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C77, 0x2CBA, 0xFFFF, 0xFFFF,   // 93A0 - 93AF
	0x2849, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93B0 - 93BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2AB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93C0 - 93CF
	0xFFFF, 0x2985, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2637, 0xFFFF,   // 93D0 - 93DF
	0xFFFF, 0x01CA, 0xFFFF, 0xFFFF, 0x11BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93E0 - 93EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2CE1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93F0 - 93FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D53, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9400 - 940F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2ADC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9410 - 941F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D6B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29AD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9420 - 942F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x303E, 0xFFFF, 0xFFFF, 0x3549, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9430 - 943F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9440 - 944F
	0xFFFF, 0x006D, 0x006E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9450 - 945F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9460 - 946F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2F63, 0xFFFF, 0x2F52,   // 9470 - 947F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9480 - 948F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9490 - 949F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94A0 - 94AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94B0 - 94BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94C0 - 94CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94D0 - 94DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94E0 - 94EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94F0 - 94FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9500 - 950F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9510 - 951F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9520 - 952F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9530 - 953F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9540 - 954F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9550 - 955F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9560 - 956F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x28DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9570 - 957F
	0x151F, 0xFFFF, 0xFFFF, 0x1D8D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38E2, 0xFFFF, 0x00AD, 0xFFFF, 0xFFFF, 0xFFFF, 0x2771,   // 9580 - 958F
	0xFFFF, 0x3AD7, 0x3AD8, 0x0045, 0x1607, 0xFFFF, 0xFFFF, 0xFFFF, 0x0076, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9590 - 959F
	0xFFFF, 0xFFFF, 0xFFFF, 0x002A, 0x3AFA, 0x1717, 0xFFFF, 0xFFFF, 0x0422, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x107E, 0xFFFF, 0xFFFF,   // 95A0 - 95AF
	0xFFFF, 0x2490, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24A5, 0x2312, 0xFFFF, 0xFFFF, 0xFFFF,   // 95B0 - 95BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2322, 0xFFFF, 0xFFFF, 0x3CDD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 95C0 - 95CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AFB, 0x03BB, 0x3795, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0295, 0xFFFF, 0xFFFF, 0xFFFF,   // 95D0 - 95DF
	0xFFFF, 0x302E, 0x175D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 95E0 - 95EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 95F0 - 95FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9600 - 960F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1898, 0xFFFF, 0xFFFF, 0xFFFF,   // 9610 - 961F
	0xFFFF, 0x302F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x37F6, 0xFFFF, 0xFFFF, 0xFFFF, 0x257F, 0xFFFF,   // 9620 - 962F
	0xFFFF, 0xFFFF, 0x1689, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AAB, 0xFFFF, 0xFFFF, 0xFFFF, 0x22EA,   // 9630 - 963F
	0x3536, 0xFFFF, 0x3A8D, 0xFFFF, 0x1899, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11BF, 0x1352, 0x0091, 0xFFFF, 0xFFFF,   // 9640 - 964F
	0x3AD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38E3, 0x3AFC, 0x1D8E, 0x1FFB, 0x3019,   // 9650 - 965F
	0xFFFF, 0xFFFF, 0x26B3, 0x2CBB, 0x2A27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16A5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9660 - 966F
	0x27AF, 0xFFFF, 0xFFFF, 0x2CBC, 0xFFFF, 0x1285, 0x0B87, 0x3AF3, 0x1241, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23B1, 0xFFFF, 0xFFFF,   // 9670 - 967F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x265D, 0x1260, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A98, 0x1F12, 0xFFFF, 0x3D01, 0x01EC, 0xFFFF,   // 9680 - 968F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0176, 0x2677, 0xFFFF, 0xFFFF, 0x2343, 0x044E, 0xFFFF, 0x2A28, 0x28DF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9690 - 969F
	0xFFFF, 0xFFFF, 0xFFFF, 0x12CD, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F13, 0x1F14, 0xFFFF, 0x3BA8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 96A0 - 96AF
	0xFFFF, 0x279E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10D4, 0xFFFF, 0xFFFF, 0xFFFF, 0x301A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 96B0 - 96BF
	0x2899, 0x2307, 0xFFFF, 0xFFFF, 0x268F, 0x22EB, 0x2CE2, 0x022D, 0xFFFF, 0x32AC, 0xFFFF, 0x2B99, 0x288C, 0x255A, 0x296A, 0xFFFF,   // 96C0 - 96CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AAC, 0x1F15, 0xFFFF, 0xFFFF, 0x20A4, 0xFFFF, 0x31A0, 0x28B6, 0xFFFF, 0xFFFF, 0xFFFF,   // 96D0 - 96DF
	0xFFFF, 0xFFFF, 0x12C1, 0x0780, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x265E, 0x265F, 0x1D7D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1520,   // 96E0 - 96EF
	0x18B3, 0xFFFF, 0x2678, 0xFFFF, 0xFFFF, 0xFFFF, 0x10C5, 0x116D, 0xFFFF, 0x1635, 0xFFFF, 0x29AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 96F0 - 96FF
	0x1F16, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A09, 0x2CBD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9700 - 970F
	0xFFFF, 0x29CC, 0xFFFF, 0x24F6, 0xFFFF, 0xFFFF, 0x12E0, 0xFFFF, 0xFFFF, 0x24D6, 0xFFFF, 0xFFFF, 0x1CB4, 0xFFFF, 0x3AC2, 0xFFFF,   // 9710 - 971F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x150D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9720 - 972F
	0x1C73, 0xFFFF, 0x10FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x175E, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A29, 0xFFFF, 0xFFFF,   // 9730 - 973F
	0xFFFF, 0xFFFF, 0x108A, 0xFFFF, 0x2344, 0xFFFF, 0xFFFF, 0xFFFF, 0x10C6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9740 - 974F
	0xFFFF, 0x3066, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A0A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A0B, 0xFFFF, 0x19A7, 0xFFFF,   // 9750 - 975F
	0xFFFF, 0x15F5, 0x13F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BD6, 0xFFFF, 0xFFFF, 0xFFFF, 0x283A, 0xFFFF, 0xFFFF,   // 9760 - 976F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CB9, 0xFFFF, 0xFFFF, 0x283B, 0xFFFF, 0xFFFF, 0x1320, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9770 - 977F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C34, 0xFFFF, 0x2308, 0xFFFF, 0x0269,   // 9780 - 978F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9790 - 979F
	0x0377, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0053, 0xFFFF, 0xFFFF, 0x0378, 0xFFFF, 0x38BA, 0xFFFF, 0xFFFF,   // 97A0 - 97AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 97B0 - 97BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3030, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2704, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 97C0 - 97CF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3ADA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B88, 0xFFFF, 0xFFFF, 0xFFFF,   // 97D0 - 97DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 97E0 - 97EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x27B0, 0xFFFF, 0xFFFF, 0x1E31, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2679, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B68,   // 97F0 - 97FF
	0x3C78, 0x3BF6, 0x2A0C, 0x01CB, 0xFFFF, 0x3B11, 0x1F44, 0xFFFF, 0x1F17, 0xFFFF, 0x2669, 0xFFFF, 0x1E5F, 0xFFFF, 0xFFFF, 0xFFFF,   // 9800 - 980F
	0x24F7, 0x2580, 0x1651, 0x0BA0, 0xFFFF, 0xFFFF, 0xFFFF, 0x37E9, 0x10C7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9810 - 981F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C46, 0xFFFF, 0xFFFF,   // 9820 - 982F
	0x3C0C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01CC, 0x36B8, 0xFFFF, 0x19BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9830 - 983F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x027D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A2A, 0x234C, 0x22FB, 0xFFFF,   // 9840 - 984F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2309, 0xFFFF, 0xFFFF, 0xFFFF, 0x26B4, 0xFFFF, 0x29AF, 0xFFFF, 0xFFFF, 0xFFFF, 0x123D, 0xFFFF,   // 9850 - 985F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3C79, 0xFFFF, 0x022E, 0xFFFF, 0xFFFF, 0xFFFF, 0x29B0, 0xFFFF, 0xFFFF, 0xFFFF, 0x3BEE,   // 9860 - 986F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9870 - 987F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9880 - 988F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9890 - 989F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x39D6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C91,   // 98A0 - 98AF
	0xFFFF, 0x358A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 98B0 - 98BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x399E, 0xFFFF, 0xFFFF, 0x399D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 98C0 - 98CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A8, 0x170F, 0xFFFF, 0xFFFF, 0x2049,   // 98D0 - 98DF
	0xFFFF, 0x1E45, 0x04E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x32B2, 0x27B1, 0x1652,   // 98E0 - 98EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2818, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C5D, 0x391A, 0x204A, 0xFFFF,   // 98F0 - 98FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x031E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B69, 0x23B3, 0xFFFF, 0x2819, 0xFFFF, 0xFFFF, 0xFFFF,   // 9900 - 990F
	0x2F64, 0xFFFF, 0xFFFF, 0x22EC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2443, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29B1, 0xFFFF,   // 9910 - 991F
	0x178D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0296, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9920 - 992F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9930 - 993F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1314, 0xFFFF, 0xFFFF, 0xFFFF, 0x0460, 0xFFFF, 0x03D5, 0x2F65, 0x1D6C, 0xFFFF, 0xFFFF,   // 9940 - 994F
	0xFFFF, 0x04EA, 0x2605, 0xFFFF, 0x255B, 0xFFFF, 0xFFFF, 0x3B6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9950 - 995F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9960 - 996F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9970 - 997F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9980 - 998F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F18, 0xFFFF, 0xFFFF, 0x3B6B, 0xFFFF, 0xFFFF, 0xFFFF, 0x3A9F, 0xFFFF, 0xFFFF,   // 9990 - 999F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17D2, 0xFFFF, 0xFFFF, 0x3C24, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F6, 0x23DE, 0x39D7, 0xFFFF,   // 99A0 - 99AF
	0xFFFF, 0x3537, 0xFFFF, 0x32AD, 0x1F45, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x284A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 99B0 - 99BF
	0xFFFF, 0x1636, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 99C0 - 99CF
	0x2B81, 0x0895, 0x036E, 0xFFFF, 0xFFFF, 0x001E, 0xFFFF, 0xFFFF, 0xFFFF, 0x189A, 0xFFFF, 0xFFFF, 0xFFFF, 0x3538, 0xFFFF, 0x1C5E,   // 99D0 - 99DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B29, 0xFFFF, 0xFFFF,   // 99E0 - 99EF
	0xFFFF, 0x0F95, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2B9A,   // 99F0 - 99FF
	0xFFFF, 0x19D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x178E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04EB, 0x04EC,   // 9A00 - 9A0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x38BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A10 - 9A1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0129, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A20 - 9A2F
	0x0CF7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31A1, 0x1E32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A30 - 9A3F
	0x1353, 0xFFFF, 0xFFFF, 0x399F, 0xFFFF, 0x036F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3D67, 0xFFFF, 0xFFFF,   // 9A40 - 9A4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x031F, 0xFFFF, 0x3BA9, 0xFFFF, 0xFFFF, 0x01CD, 0x2454, 0xFFFF, 0xFFFF, 0xFFFF, 0x321F,   // 9A50 - 9A5F
	0xFFFF, 0xFFFF, 0x107F, 0xFFFF, 0xFFFF, 0x04ED, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CD3, 0x1080, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A60 - 9A6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A70 - 9A7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A80 - 9A8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A90 - 9A9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x024C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AA0 - 9AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3B2A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AB0 - 9ABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AC0 - 9ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F19, 0x3078, 0xFFFF, 0xFFFF, 0xFFFF, 0x022F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AD0 - 9ADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x24A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1660, 0xFFFF,   // 9AE0 - 9AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AF0 - 9AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B00 - 9B0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F1A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B10 - 9B1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1195, 0xFFFF, 0xFFFF, 0x36F6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B20 - 9B2F
	0xFFFF, 0x267F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x03F6, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B30 - 9B3F
	0xFFFF, 0x02E7, 0x3C86, 0x1661, 0x16AE, 0x134E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2705,   // 9B40 - 9B4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x23DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B50 - 9B5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1100,   // 9B60 - 9B6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B70 - 9B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x29CD, 0xFFFF,   // 9B80 - 9B8F
	0xFFFF, 0x391B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x230A,   // 9B90 - 9B9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0320, 0xFFFF, 0xFFFF, 0x1D6D, 0xFFFF,   // 9BA0 - 9BAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BB0 - 9BBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12C2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BC0 - 9BCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3067, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BD0 - 9BDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0245, 0xFFFF, 0xFFFF, 0xFFFF, 0x01CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BE0 - 9BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BF0 - 9BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x31A2, 0xFFFF, 0xFFFF,   // 9C00 - 9C0F
	0x22FC, 0xFFFF, 0x17D3, 0xFFFF, 0xFFFF, 0x3AC3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C10 - 9C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CD4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C20 - 9C2F
	0xFFFF, 0xFFFF, 0x2530, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1315, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C30 - 9C3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0092, 0xFFFF, 0x176F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C40 - 9C4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C50 - 9C5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C60 - 9C6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C70 - 9C7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C80 - 9C8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C90 - 9C9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CA0 - 9CAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CB0 - 9CBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CC0 - 9CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CD0 - 9CDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2AAD, 0xFFFF, 0x189B, 0xFFFF, 0x0370, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CE0 - 9CEF
	0xFFFF, 0xFFFF, 0xFFFF, 0x17F9, 0x1418, 0xFFFF, 0x2482, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CF0 - 9CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22ED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D00 - 9D0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x26B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D10 - 9D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2332, 0xFFFF, 0x2327, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D20 - 9D2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3CA4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D30 - 9D3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D40 - 9D4F
	0xFFFF, 0x0184, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22EE, 0xFFFF, 0xFFFF,   // 9D50 - 9D5F
	0x0238, 0x150E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18CF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D60 - 9D6F
	0xFFFF, 0xFFFF, 0x289A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D70 - 9D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D80 - 9D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D90 - 9D9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x145C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2363,   // 9DA0 - 9DAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AC9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DB0 - 9DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x01ED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DC0 - 9DCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0371, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DD0 - 9DDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DE0 - 9DEF
	0xFFFF, 0xFFFF, 0x3220, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3E2A, 0x27BD, 0x1101, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DF0 - 9DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E00 - 9E0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2364, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FA1, 0xFFFF,   // 9E10 - 9E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E20 - 9E2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E30 - 9E3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E40 - 9E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E50 - 9E5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E60 - 9E6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1102, 0xFFFF, 0xFFFF, 0xFFFF, 0x3AF4, 0xFFFF, 0xFFFF, 0xFFFF, 0x24A7, 0xFFFF, 0x1109,   // 9E70 - 9E7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E80 - 9E8F
	0xFFFF, 0xFFFF, 0x04EE, 0x110A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1081, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C5F, 0xFFFF, 0x12CF,   // 9E90 - 9E9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1354, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9EA0 - 9EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0379, 0x13F6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F8, 0xFFFF, 0xFFFF, 0x3DFE, 0xFFFF,   // 9EB0 - 9EBF
	0xFFFF, 0xFFFF, 0xFFFF, 0x3D02, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D39, 0x1082, 0xFFFF,   // 9EC0 - 9ECF
	0xFFFF, 0x3E45, 0xFFFF, 0xFFFF, 0x0140, 0xFFFF, 0xFFFF, 0xFFFF, 0x1511, 0xFFFF, 0xFFFF, 0x0A99, 0x31BC, 0xFFFF, 0x29CE, 0xFFFF,   // 9ED0 - 9EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A82, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9EE0 - 9EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15F6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9EF0 - 9EFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2531, 0x1770, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A0D, 0xFFFF,   // 9F00 - 9F0F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0230, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F10 - 9F1F
	0x1D3A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F20 - 9F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F30 - 9F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2A2B, 0x28F6, 0xFFFF, 0xFFFF, 0x28F7, 0xFFFF,   // 9F40 - 9F4F
	0xFFFF, 0xFFFF, 0x32AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x296B,   // 9F50 - 9F5F
	0xFFFF, 0x10C8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D7E, 0xFFFF, 0xFFFF, 0x2F53, 0xFFFF, 0x23E0, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F60 - 9F6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x22FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F70 - 9F7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11AB, 0xFFFF, 0xFFFF,   // 9F80 - 9F8F
	0x168A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x006F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0372, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F90 - 9F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FA0 - 9FAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FB0 - 9FBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FC0 - 9FCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FD0 - 9FDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FE0 - 9FEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FF0 - 9FFF
	0x0001, 0x001F, 0x002B, 0x002C, 0x002D, 0x0046, 0x0047, 0x0048, 0x0049, 0x0054, 0x0055, 0x0056, 0x0057, 0x0058, 0x0059, 0x005A,   // AC00 - AC0F
	0x005B, 0x0070, 0x0077, 0x0078, 0x0079, 0x007A, 0x0093, 0x0094, 0x0095, 0x0096, 0x0097, 0x0098, 0x0099, 0x00AE, 0x00B1, 0x00B2,   // AC10 - AC1F
	0x00B3, 0x00B4, 0x00B5, 0x00B6, 0x00B7, 0x00B8, 0x00B9, 0x00BA, 0x00BB, 0x00BC, 0x00BD, 0x00BE, 0x00BF, 0x00C0, 0x00C1, 0x00C2,   // AC20 - AC2F
	0x00C3, 0x00C4, 0x00C9, 0x00CA, 0x00CB, 0x00CC, 0x00CD, 0x00CE, 0x00CF, 0x00D0, 0x00D2, 0x00D3, 0x00D4, 0x00D5, 0x00D6, 0x00D7,   // AC30 - AC3F
	0x00D8, 0x00D9, 0x00DA, 0x00DB, 0x00DC, 0x00DD, 0x00DE, 0x00DF, 0x00E0, 0x00E1, 0x00E2, 0x00E3, 0x00E4, 0x00E5, 0x00E6, 0x00E7,   // AC40 - AC4F
	0x00E8, 0x00E9, 0x00EA, 0x00EB, 0x00EC, 0x00ED, 0x00EE, 0x00EF, 0x00F0, 0x00F1, 0x00F2, 0x00F3, 0x00F4, 0x00F5, 0x00F6, 0x00F7,   // AC50 - AC5F
	0x00F8, 0x00F9, 0x00FA, 0x00FB, 0x00FC, 0x00FD, 0x00FE, 0x00FF, 0x0100, 0x0101, 0x0102, 0x0103, 0x0104, 0x0105, 0x0106, 0x0107,   // AC60 - AC6F
	0x0108, 0x011A, 0x011B, 0x011C, 0x011D, 0x012A, 0x012B, 0x012C, 0x012D, 0x0132, 0x0133, 0x0134, 0x0135, 0x0136, 0x0137, 0x0138,   // AC70 - AC7F
	0x0139, 0x0141, 0x0145, 0x0146, 0x0147, 0x0148, 0x0149, 0x014A, 0x014B, 0x014C, 0x014D, 0x014E, 0x014F, 0x0153, 0x0154, 0x0155,   // AC80 - AC8F
	0x0156, 0x0157, 0x0158, 0x0159, 0x015A, 0x015B, 0x015C, 0x015D, 0x015E, 0x015F, 0x0160, 0x0161, 0x0162, 0x0163, 0x0164, 0x0165,   // AC90 - AC9F
	0x0166, 0x0167, 0x0168, 0x0169, 0x016A, 0x016B, 0x016C, 0x016D, 0x016E, 0x016F, 0x0177, 0x0178, 0x0179, 0x0185, 0x0186, 0x0187,   // ACA0 - ACAF
	0x0188, 0x018F, 0x0190, 0x0191, 0x0192, 0x0193, 0x0194, 0x0195, 0x0196, 0x019D, 0x019E, 0x019F, 0x01A0, 0x01A1, 0x01CF, 0x01D0,   // ACB0 - ACBF
	0x01D1, 0x01D2, 0x01D3, 0x01D4, 0x01D5, 0x01EE, 0x01EF, 0x01F0, 0x01F1, 0x01F2, 0x01F3, 0x01F4, 0x01F5, 0x01F6, 0x01F7, 0x01F8,   // ACC0 - ACCF
	0x01F9, 0x01FA, 0x01FB, 0x01FC, 0x01FD, 0x01FE, 0x01FF, 0x0200, 0x0201, 0x0202, 0x0203, 0x0204, 0x0205, 0x0206, 0x0207, 0x0208,   // ACD0 - ACDF
	0x0209, 0x0231, 0x0239, 0x023A, 0x023B, 0x0246, 0x0247, 0x0248, 0x0249, 0x024D, 0x024E, 0x024F, 0x0250, 0x0251, 0x0252, 0x0253,   // ACE0 - ACEF
	0x0254, 0x0255, 0x0256, 0x0257, 0x0258, 0x0259, 0x026A, 0x026C, 0x026D, 0x026E, 0x026F, 0x0270, 0x0271, 0x027E, 0x0283, 0x0284,   // ACF0 - ACFF
	0x0285, 0x0297, 0x0298, 0x0299, 0x029A, 0x029F, 0x02A0, 0x02A1, 0x02A2, 0x02A3, 0x02A4, 0x02A5, 0x02A6, 0x02A7, 0x02A8, 0x02A9,   // AD00 - AD0F
	0x02AA, 0x02AB, 0x02B9, 0x02BA, 0x02BB, 0x02BC, 0x02BD, 0x02BE, 0x02BF, 0x02C3, 0x02C4, 0x02C5, 0x02C6, 0x02C7, 0x02C8, 0x02C9,   // AD10 - AD1F
	0x02CA, 0x02CB, 0x02CC, 0x02CD, 0x02CE, 0x02CF, 0x02D0, 0x02D1, 0x02D2, 0x02D3, 0x02D4, 0x02D5, 0x02D6, 0x02D7, 0x02D8, 0x02D9,   // AD20 - AD2F
	0x02DA, 0x02DB, 0x02DC, 0x02DD, 0x02DE, 0x02E8, 0x02E9, 0x02EA, 0x02EB, 0x02EC, 0x02ED, 0x02EE, 0x02EF, 0x02F0, 0x02F1, 0x02F2,   // AD30 - AD3F
	0x02F3, 0x02F4, 0x02F5, 0x02F6, 0x02F7, 0x02F8, 0x02F9, 0x02FA, 0x02FB, 0x02FC, 0x0301, 0x0302, 0x0303, 0x0304, 0x0305, 0x0306,   // AD40 - AD4F
	0x0307, 0x0321, 0x0322, 0x0323, 0x0324, 0x0325, 0x0326, 0x0327, 0x0328, 0x0329, 0x032A, 0x032B, 0x032C, 0x032D, 0x032E, 0x032F,   // AD50 - AD5F
	0x0330, 0x0331, 0x0332, 0x0333, 0x0334, 0x0335, 0x0336, 0x0337, 0x0338, 0x0339, 0x033A, 0x033B, 0x033C, 0x0373, 0x037A, 0x037B,   // AD60 - AD6F
	0x037C, 0x0383, 0x0384, 0x0385, 0x0386, 0x038B, 0x038C, 0x038D, 0x038E, 0x038F, 0x0390, 0x0391, 0x0392, 0x0393, 0x0394, 0x0395,   // AD70 - AD7F
	0x0396, 0x0397, 0x039E, 0x039F, 0x03A0, 0x03A1, 0x03A2, 0x03A3, 0x03A4, 0x03A5, 0x03A6, 0x03A7, 0x03A8, 0x03B3, 0x03B4, 0x03B5,   // AD80 - AD8F
	0x03B6, 0x03BC, 0x03BD, 0x03BE, 0x03BF, 0x03C0, 0x03C1, 0x03C2, 0x03C3, 0x03C4, 0x03C5, 0x03C6, 0x03C7, 0x03C8, 0x03C9, 0x03CA,   // AD90 - AD9F
	0x03CB, 0x03CC, 0x03CD, 0x03CE, 0x03CF, 0x03D6, 0x03D7, 0x03D8, 0x03D9, 0x03DA, 0x03DB, 0x03DC, 0x03DD, 0x03DE, 0x03DF, 0x03E0,   // ADA0 - ADAF
	0x03E1, 0x03E2, 0x03E3, 0x03E4, 0x03E5, 0x03E6, 0x03E7, 0x03E8, 0x03E9, 0x03EA, 0x03EB, 0x03EC, 0x03ED, 0x03EE, 0x03EF, 0x03F0,   // ADB0 - ADBF
	0x03F1, 0x03F8, 0x03F9, 0x03FA, 0x03FB, 0x03FC, 0x03FD, 0x03FE, 0x03FF, 0x0400, 0x0401, 0x0402, 0x0403, 0x0404, 0x0405, 0x0406,   // ADC0 - ADCF
	0x0407, 0x0408, 0x0409, 0x040A, 0x040B, 0x040C, 0x040D, 0x040E, 0x040F, 0x0410, 0x0411, 0x0412, 0x0413, 0x0423, 0x0424, 0x0425,   // ADD0 - ADDF
	0x0426, 0x042E, 0x042F, 0x0430, 0x0431, 0x0433, 0x0434, 0x0435, 0x0436, 0x0437, 0x0438, 0x0439, 0x043A, 0x043B, 0x043C, 0x043D,   // ADE0 - ADEF
	0x043E, 0x043F, 0x0440, 0x0441, 0x0442, 0x0443, 0x0444, 0x0445, 0x0446, 0x0447, 0x044F, 0x0450, 0x0451, 0x0461, 0x0462, 0x0463,   // ADF0 - ADFF
	0x0464, 0x0466, 0x0467, 0x0468, 0x0469, 0x046A, 0x046B, 0x046C, 0x046D, 0x047C, 0x0484, 0x0485, 0x0486, 0x0487, 0x048C, 0x048D,   // AE00 - AE0F
	0x048E, 0x048F, 0x0490, 0x0491, 0x0492, 0x0493, 0x0494, 0x0495, 0x0496, 0x0497, 0x0498, 0x0499, 0x049A, 0x049B, 0x049C, 0x049D,   // AE10 - AE1F
	0x049E, 0x049F, 0x04A0, 0x04A1, 0x04A2, 0x04A3, 0x04A4, 0x04A5, 0x04A6, 0x04A7, 0x04A8, 0x04A9, 0x04AA, 0x04AB, 0x04AC, 0x04AD,   // AE20 - AE2F
	0x04AE, 0x04EF, 0x04F0, 0x04F1, 0x04F2, 0x04F4, 0x04F5, 0x04F6, 0x04F7, 0x04FC, 0x04FD, 0x04FE, 0x04FF, 0x0500, 0x0501, 0x0502,   // AE30 - AE3F
	0x0503, 0x0505, 0x0506, 0x0507, 0x0508, 0x0509, 0x050A, 0x050B, 0x050C, 0x050D, 0x050E, 0x050F, 0x0510, 0x0511, 0x0512, 0x0513,   // AE40 - AE4F
	0x0514, 0x0515, 0x0516, 0x0517, 0x0518, 0x0519, 0x051A, 0x051B, 0x051C, 0x051D, 0x051E, 0x051F, 0x0520, 0x0521, 0x0522, 0x0523,   // AE50 - AE5F
	0x0524, 0x0525, 0x0526, 0x0527, 0x0528, 0x0529, 0x052A, 0x052B, 0x052C, 0x052D, 0x052E, 0x052F, 0x0530, 0x0531, 0x0532, 0x0533,   // AE60 - AE6F
	0x0534, 0x0535, 0x0536, 0x0537, 0x0538, 0x0539, 0x053A, 0x053B, 0x053C, 0x053D, 0x053E, 0x053F, 0x0540, 0x0541, 0x0542, 0x0543,   // AE70 - AE7F
	0x0544, 0x0545, 0x0546, 0x0547, 0x0548, 0x0549, 0x054A, 0x054B, 0x054C, 0x054D, 0x054E, 0x054F, 0x0550, 0x0551, 0x0552, 0x0553,   // AE80 - AE8F
	0x0554, 0x0555, 0x0556, 0x0557, 0x0558, 0x0559, 0x055A, 0x055B, 0x055C, 0x055D, 0x055E, 0x055F, 0x0560, 0x0561, 0x0562, 0x0563,   // AE90 - AE9F
	0x0564, 0x0565, 0x0566, 0x0567, 0x0568, 0x0569, 0x056A, 0x056B, 0x056C, 0x056D, 0x056E, 0x056F, 0x0570, 0x0571, 0x0572, 0x0573,   // AEA0 - AEAF
	0x0574, 0x0575, 0x0576, 0x0577, 0x0578, 0x0579, 0x057A, 0x057B, 0x057C, 0x057D, 0x057E, 0x057F, 0x0580, 0x0581, 0x0582, 0x0583,   // AEB0 - AEBF
	0x0584, 0x0585, 0x0586, 0x0587, 0x0588, 0x0589, 0x058A, 0x058B, 0x058C, 0x058D, 0x058E, 0x058F, 0x0590, 0x0591, 0x0592, 0x0593,   // AEC0 - AECF
	0x0594, 0x0595, 0x0596, 0x0597, 0x0598, 0x0599, 0x059A, 0x059B, 0x059C, 0x059D, 0x059E, 0x059F, 0x05A0, 0x05A1, 0x05A2, 0x05A3,   // AED0 - AEDF
	0x05A4, 0x05A5, 0x05A6, 0x05A7, 0x05A8, 0x05A9, 0x05AA, 0x05AB, 0x05AC, 0x05AD, 0x05AE, 0x05AF, 0x05B0, 0x05B1, 0x05B2, 0x05B3,   // AEE0 - AEEF
	0x05B4, 0x05B5, 0x05B6, 0x05B7, 0x05B8, 0x05B9, 0x05BA, 0x05BB, 0x05BC, 0x05BD, 0x05BE, 0x05BF, 0x05C0, 0x05C1, 0x05C2, 0x05C3,   // AEF0 - AEFF
	0x05C4, 0x05C5, 0x05C6, 0x05C7, 0x05C8, 0x05C9, 0x05CA, 0x05CB, 0x05CC, 0x05CD, 0x05CE, 0x05CF, 0x05D0, 0x05D1, 0x05D2, 0x05D3,   // AF00 - AF0F
	0x05D4, 0x05D5, 0x05D6, 0x05D7, 0x05D8, 0x05D9, 0x05DA, 0x05DB, 0x05DC, 0x05DD, 0x05DE, 0x05DF, 0x05E0, 0x05E1, 0x05E2, 0x05E3,   // AF10 - AF1F
	0x05E4, 0x05E5, 0x05E6, 0x05E7, 0x05E8, 0x05E9, 0x05EA, 0x05EB, 0x05EC, 0x05ED, 0x05EE, 0x05EF, 0x05F0, 0x05F1, 0x05F2, 0x05F3,   // AF20 - AF2F
	0x05F4, 0x05F5, 0x05F6, 0x05F7, 0x05F8, 0x05F9, 0x05FA, 0x05FB, 0x05FC, 0x05FD, 0x05FE, 0x05FF, 0x0600, 0x0601, 0x0602, 0x0603,   // AF30 - AF3F
	0x0604, 0x0605, 0x0606, 0x0607, 0x0608, 0x0609, 0x060A, 0x060B, 0x060C, 0x060D, 0x060E, 0x060F, 0x0610, 0x0611, 0x0612, 0x0613,   // AF40 - AF4F
	0x0614, 0x0615, 0x0616, 0x0617, 0x0618, 0x0619, 0x061A, 0x061B, 0x061C, 0x061D, 0x061E, 0x061F, 0x0620, 0x0621, 0x0622, 0x0623,   // AF50 - AF5F
	0x0624, 0x0625, 0x0626, 0x0627, 0x0628, 0x0629, 0x062A, 0x062B, 0x062C, 0x062D, 0x062E, 0x062F, 0x0630, 0x0631, 0x0632, 0x0633,   // AF60 - AF6F
	0x0634, 0x0635, 0x0636, 0x0637, 0x0638, 0x0639, 0x063A, 0x063B, 0x063C, 0x063D, 0x063E, 0x063F, 0x0640, 0x0641, 0x0642, 0x0643,   // AF70 - AF7F
	0x0644, 0x0645, 0x0646, 0x0647, 0x0648, 0x0649, 0x064A, 0x064B, 0x064C, 0x064D, 0x064E, 0x064F, 0x0650, 0x0651, 0x0652, 0x0653,   // AF80 - AF8F
	0x0654, 0x0655, 0x0656, 0x0657, 0x0658, 0x0659, 0x065A, 0x065B, 0x065C, 0x065D, 0x065E, 0x065F, 0x0660, 0x0661, 0x0662, 0x0663,   // AF90 - AF9F
	0x0664, 0x0665, 0x0666, 0x0667, 0x0668, 0x0669, 0x066A, 0x066B, 0x066C, 0x066D, 0x066E, 0x066F, 0x0670, 0x0671, 0x0672, 0x0673,   // AFA0 - AFAF
	0x0674, 0x0675, 0x0676, 0x0677, 0x0678, 0x0679, 0x067A, 0x067B, 0x067C, 0x067D, 0x067E, 0x067F, 0x0680, 0x0681, 0x0682, 0x0683,   // AFB0 - AFBF
	0x0684, 0x0685, 0x0686, 0x0687, 0x0688, 0x0689, 0x068A, 0x068B, 0x068C, 0x068D, 0x068E, 0x068F, 0x0690, 0x0691, 0x0692, 0x0693,   // AFC0 - AFCF
	0x0694, 0x0695, 0x0696, 0x0697, 0x0698, 0x0699, 0x069A, 0x069B, 0x069C, 0x069D, 0x069E, 0x069F, 0x06A0, 0x06A1, 0x06A2, 0x06A3,   // AFD0 - AFDF
	0x06A4, 0x06A5, 0x06A6, 0x06A7, 0x06A8, 0x06A9, 0x06AA, 0x06AB, 0x06AC, 0x06AD, 0x06AE, 0x06AF, 0x06B0, 0x06B1, 0x06B2, 0x06B3,   // AFE0 - AFEF
	0x06B4, 0x06B5, 0x06B6, 0x06B7, 0x06B8, 0x06B9, 0x06BA, 0x06BB, 0x06BC, 0x06BD, 0x06BE, 0x06BF, 0x06C0, 0x06C1, 0x06C2, 0x06C3,   // AFF0 - AFFF
	0x06C4, 0x06C5, 0x06C6, 0x06C7, 0x06C8, 0x06C9, 0x06CA, 0x06CB, 0x06CC, 0x06CD, 0x06CE, 0x06CF, 0x06D0, 0x06D1, 0x06D2, 0x06D3,   // B000 - B00F
	0x06D4, 0x06D5, 0x06D6, 0x06D7, 0x06D8, 0x06D9, 0x06DA, 0x06DB, 0x06DC, 0x06DD, 0x06DE, 0x06DF, 0x06E0, 0x06E1, 0x06E2, 0x06E3,   // B010 - B01F
	0x06E4, 0x06E5, 0x06E6, 0x06E7, 0x06E8, 0x06E9, 0x06EA, 0x06EB, 0x06EC, 0x06ED, 0x06EE, 0x06EF, 0x06F0, 0x06F1, 0x06F2, 0x06F3,   // B020 - B02F
	0x06F4, 0x06F5, 0x06F6, 0x06F7, 0x06F8, 0x06F9, 0x06FA, 0x06FB, 0x06FC, 0x06FD, 0x06FE, 0x06FF, 0x0700, 0x0701, 0x0702, 0x0703,   // B030 - B03F
	0x0704, 0x0705, 0x0706, 0x0707, 0x0708, 0x0709, 0x070A, 0x070B, 0x070C, 0x070D, 0x070E, 0x070F, 0x0710, 0x0711, 0x0712, 0x0713,   // B040 - B04F
	0x0714, 0x0715, 0x0716, 0x0717, 0x0718, 0x0719, 0x071A, 0x071B, 0x071C, 0x071D, 0x071E, 0x071F, 0x0720, 0x0721, 0x0722, 0x0723,   // B050 - B05F
	0x0724, 0x0725, 0x0726, 0x0727, 0x0728, 0x0729, 0x072A, 0x072B, 0x072C, 0x072D, 0x072E, 0x072F, 0x0730, 0x0731, 0x0732, 0x0733,   // B060 - B06F
	0x0734, 0x0735, 0x0736, 0x0737, 0x0738, 0x0739, 0x073A, 0x073B, 0x073C, 0x073D, 0x073E, 0x073F, 0x0740, 0x0741, 0x0743, 0x0744,   // B070 - B07F
	0x0745, 0x0746, 0x0747, 0x0748, 0x0749, 0x074A, 0x074B, 0x074C, 0x074D, 0x074E, 0x074F, 0x0750, 0x0751, 0x0752, 0x0753, 0x0754,   // B080 - B08F
	0x0755, 0x0756, 0x0757, 0x0758, 0x0759, 0x075A, 0x075B, 0x075C, 0x075D, 0x076D, 0x0776, 0x0777, 0x0778, 0x0782, 0x0783, 0x0784,   // B090 - B09F
	0x0785, 0x0788, 0x0789, 0x078A, 0x078B, 0x078C, 0x078D, 0x078E, 0x078F, 0x0799, 0x079F, 0x07A0, 0x07A1, 0x07A2, 0x07AA, 0x07AB,   // B0A0 - B0AF
	0x07AC, 0x07AD, 0x07AE, 0x07AF, 0x07B0, 0x07B7, 0x07B8, 0x07B9, 0x07BA, 0x07BB, 0x07BC, 0x07BD, 0x07BE, 0x07BF, 0x07C0, 0x07C1,   // B0B0 - B0BF
	0x07C2, 0x07C3, 0x07C4, 0x07C5, 0x07C6, 0x07C7, 0x07C8, 0x07C9, 0x07CA, 0x07CB, 0x07CD, 0x07CE, 0x07CF, 0x07D0, 0x07D1, 0x07D2,   // B0C0 - B0CF
	0x07D3, 0x07D4, 0x07D5, 0x07D6, 0x07D7, 0x07D8, 0x07D9, 0x07DA, 0x07DB, 0x07DC, 0x07DD, 0x07DE, 0x07DF, 0x07E0, 0x07E1, 0x07E2,   // B0D0 - B0DF
	0x07E3, 0x07E4, 0x07E5, 0x07E6, 0x07E7, 0x07E8, 0x07E9, 0x07EA, 0x07EB, 0x07EC, 0x07ED, 0x07EE, 0x07EF, 0x07F0, 0x07F1, 0x07F2,   // B0E0 - B0EF
	0x07F3, 0x07F4, 0x07F5, 0x07F6, 0x07F7, 0x07F8, 0x07F9, 0x07FA, 0x07FB, 0x07FC, 0x07FD, 0x07FE, 0x07FF, 0x0800, 0x0801, 0x0802,   // B0F0 - B0FF
	0x0803, 0x0804, 0x0805, 0x0806, 0x0807, 0x0808, 0x0809, 0x080A, 0x080B, 0x080C, 0x080D, 0x080E, 0x080F, 0x0810, 0x0811, 0x0812,   // B100 - B10F
	0x0813, 0x0814, 0x0815, 0x0816, 0x0817, 0x0818, 0x0819, 0x081A, 0x081B, 0x081C, 0x081D, 0x081E, 0x081F, 0x0820, 0x0821, 0x0822,   // B110 - B11F
	0x0823, 0x0824, 0x0825, 0x0826, 0x0827, 0x0828, 0x0829, 0x082A, 0x082B, 0x082C, 0x082D, 0x082E, 0x082F, 0x0830, 0x0831, 0x0832,   // B120 - B12F
	0x0833, 0x0834, 0x0835, 0x0836, 0x0837, 0x0838, 0x0839, 0x083A, 0x083B, 0x083C, 0x083D, 0x083E, 0x083F, 0x0840, 0x0841, 0x0842,   // B130 - B13F
	0x0843, 0x0845, 0x0846, 0x0847, 0x0848, 0x084C, 0x084D, 0x084E, 0x084F, 0x0850, 0x0851, 0x0852, 0x0853, 0x0854, 0x0855, 0x0856,   // B140 - B14F
	0x0857, 0x085C, 0x085D, 0x085E, 0x085F, 0x0860, 0x0863, 0x0864, 0x0865, 0x0866, 0x0867, 0x0868, 0x0869, 0x086A, 0x086B, 0x086C,   // B150 - B15F
	0x086D, 0x086E, 0x086F, 0x0870, 0x0871, 0x0872, 0x0873, 0x0874, 0x0875, 0x0876, 0x0877, 0x0878, 0x0879, 0x087A, 0x087B, 0x087C,   // B160 - B16F
	0x087D, 0x087E, 0x087F, 0x0880, 0x0881, 0x0882, 0x0883, 0x0884, 0x0885, 0x0898, 0x089F, 0x08A0, 0x08A1, 0x08A3, 0x08A4, 0x08A5,   // B170 - B17F
	0x08A6, 0x08A7, 0x08A8, 0x08A9, 0x08AA, 0x08AB, 0x08AC, 0x08AD, 0x08AE, 0x08AF, 0x08B0, 0x08B1, 0x08B2, 0x08B3, 0x08BB, 0x08BC,   // B180 - B18F
	0x08BD, 0x08BE, 0x08BF, 0x08C0, 0x08C1, 0x08C2, 0x08C3, 0x08C4, 0x08C5, 0x08C6, 0x08C7, 0x08C8, 0x08C9, 0x08CA, 0x08CB, 0x08CC,   // B190 - B19F
	0x08CD, 0x08CE, 0x08CF, 0x08D0, 0x08D1, 0x08D2, 0x08D3, 0x08D4, 0x08D5, 0x08D6, 0x08D7, 0x08D8, 0x08D9, 0x08DA, 0x08DB, 0x08DC,   // B1A0 - B1AF
	0x08DD, 0x08DE, 0x08DF, 0x08E0, 0x08E1, 0x08E2, 0x08E3, 0x08E4, 0x08E5, 0x08E6, 0x08E7, 0x08E8, 0x08E9, 0x08EA, 0x08EB, 0x08EC,   // B1B0 - B1BF
	0x08ED, 0x08EE, 0x08EF, 0x08F0, 0x08F1, 0x08F2, 0x08F3, 0x08F4, 0x08F5, 0x08F6, 0x08F7, 0x08F8, 0x08F9, 0x0900, 0x0901, 0x0902,   // B1C0 - B1CF
	0x0903, 0x0904, 0x0905, 0x0906, 0x0907, 0x0908, 0x0909, 0x090A, 0x090B, 0x090C, 0x090D, 0x090E, 0x090F, 0x0910, 0x0911, 0x0912,   // B1D0 - B1DF
	0x0913, 0x0914, 0x0915, 0x0916, 0x0917, 0x0918, 0x0919, 0x091A, 0x091B, 0x091D, 0x091E, 0x091F, 0x0920, 0x0921, 0x0922, 0x0923,   // B1E0 - B1EF
	0x0924, 0x0925, 0x0926, 0x0927, 0x0928, 0x0929, 0x092A, 0x092B, 0x092C, 0x092D, 0x092E, 0x092F, 0x0930, 0x0931, 0x0932, 0x0933,   // B1F0 - B1FF
	0x0934, 0x0935, 0x0936, 0x0937, 0x0938, 0x0941, 0x0942, 0x0943, 0x0944, 0x0946, 0x0947, 0x0948, 0x0949, 0x094B, 0x094C, 0x094D,   // B200 - B20F
	0x094E, 0x094F, 0x0950, 0x0951, 0x0952, 0x0953, 0x0954, 0x0955, 0x0956, 0x0957, 0x0958, 0x0959, 0x095A, 0x095B, 0x095C, 0x095D,   // B210 - B21F
	0x095E, 0x095F, 0x0960, 0x0961, 0x0962, 0x0963, 0x0964, 0x0965, 0x0966, 0x0967, 0x0968, 0x0969, 0x096A, 0x096B, 0x096C, 0x096D,   // B220 - B22F
	0x096E, 0x096F, 0x0970, 0x0971, 0x0972, 0x0973, 0x0974, 0x0975, 0x0976, 0x0977, 0x0978, 0x0979, 0x097A, 0x097B, 0x097C, 0x097D,   // B230 - B23F
	0x097E, 0x097F, 0x0980, 0x0981, 0x0982, 0x0983, 0x0984, 0x0985, 0x0986, 0x0987, 0x0988, 0x0989, 0x098A, 0x098B, 0x098C, 0x098D,   // B240 - B24F
	0x098E, 0x098F, 0x0990, 0x0991, 0x0992, 0x0993, 0x0994, 0x0995, 0x0996, 0x0997, 0x0998, 0x0999, 0x099A, 0x099B, 0x099C, 0x099D,   // B250 - B25F
	0x099E, 0x099F, 0x09A0, 0x09A1, 0x09A2, 0x09A3, 0x09A4, 0x09A5, 0x09A6, 0x09A7, 0x09A8, 0x09A9, 0x09AA, 0x09AB, 0x09AC, 0x09AD,   // B260 - B26F
	0x09AE, 0x09AF, 0x09B0, 0x09B1, 0x09B2, 0x09B5, 0x09B6, 0x09B7, 0x09B8, 0x09B9, 0x09BA, 0x09BB, 0x09BC, 0x09BD, 0x09BE, 0x09BF,   // B270 - B27F
	0x09C0, 0x09C1, 0x09C2, 0x09C3, 0x09C4, 0x09C5, 0x09C6, 0x09C7, 0x09C8, 0x09C9, 0x09CA, 0x09CB, 0x09CC, 0x09CD, 0x09CE, 0x09CF,   // B280 - B28F
	0x09D0, 0x09D1, 0x09D4, 0x09D5, 0x09D6, 0x09D7, 0x09D8, 0x09D9, 0x09DA, 0x09DB, 0x09DC, 0x09DD, 0x09DE, 0x09DF, 0x09E0, 0x09E1,   // B290 - B29F
	0x09E2, 0x09E4, 0x09E5, 0x09E6, 0x09E7, 0x09E8, 0x09EF, 0x09F0, 0x09F1, 0x09F2, 0x09F3, 0x09F4, 0x09F5, 0x09F6, 0x09F7, 0x09F8,   // B2A0 - B2AF
	0x09F9, 0x09FA, 0x09FB, 0x09FC, 0x09FD, 0x09FE, 0x09FF, 0x0A00, 0x0A01, 0x0A02, 0x0A03, 0x0A04, 0x0A05, 0x0A06, 0x0A07, 0x0A08,   // B2B0 - B2BF
	0x0A09, 0x0A0A, 0x0A0B, 0x0A0C, 0x0A0D, 0x0A0E, 0x0A0F, 0x0A10, 0x0A11, 0x0A14, 0x0A17, 0x0A18, 0x0A19, 0x0A1A, 0x0A1B, 0x0A1C,   // B2C0 - B2CF
	0x0A1D, 0x0A1E, 0x0A1F, 0x0A20, 0x0A21, 0x0A22, 0x0A23, 0x0A24, 0x0A25, 0x0A26, 0x0A27, 0x0A28, 0x0A29, 0x0A2A, 0x0A2B, 0x0A2C,   // B2D0 - B2DF
	0x0A2D, 0x0A2E, 0x0A2F, 0x0A30, 0x0A31, 0x0A34, 0x0A35, 0x0A36, 0x0A37, 0x0A4C, 0x0A4D, 0x0A4E, 0x0A4F, 0x0A55, 0x0A56, 0x0A57,   // B2E0 - B2EF
	0x0A58, 0x0A59, 0x0A5A, 0x0A5B, 0x0A5C, 0x0A6E, 0x0A74, 0x0A75, 0x0A76, 0x0A77, 0x0A83, 0x0A84, 0x0A85, 0x0A86, 0x0A87, 0x0A88,   // B2F0 - B2FF
	0x0A89, 0x0A9A, 0x0A9C, 0x0A9D, 0x0A9E, 0x0A9F, 0x0AA0, 0x0AA1, 0x0AA2, 0x0AA3, 0x0AA4, 0x0AA5, 0x0AA6, 0x0AA7, 0x0AA8, 0x0AA9,   // B300 - B30F
	0x0AAA, 0x0AAB, 0x0AAC, 0x0AAD, 0x0AAE, 0x0AAF, 0x0AB0, 0x0AB1, 0x0AB2, 0x0AB3, 0x0AB4, 0x0AB5, 0x0AB6, 0x0AB7, 0x0AB8, 0x0AB9,   // B310 - B31F
	0x0ABA, 0x0ABB, 0x0ABC, 0x0ABD, 0x0ABE, 0x0ABF, 0x0AC0, 0x0AC1, 0x0AC2, 0x0AC3, 0x0AC4, 0x0AC5, 0x0AC6, 0x0AC7, 0x0AC8, 0x0AC9,   // B320 - B32F
	0x0ACA, 0x0ACB, 0x0ACC, 0x0ACD, 0x0ACE, 0x0ACF, 0x0AD0, 0x0AD1, 0x0AD2, 0x0AD3, 0x0AD4, 0x0AD5, 0x0AD6, 0x0AD7, 0x0AD8, 0x0AD9,   // B330 - B33F
	0x0ADA, 0x0ADB, 0x0ADC, 0x0ADD, 0x0ADE, 0x0ADF, 0x0AE0, 0x0AE1, 0x0AE2, 0x0AE3, 0x0AE4, 0x0AE5, 0x0AE6, 0x0AE7, 0x0AE8, 0x0AE9,   // B340 - B34F
	0x0AEA, 0x0AEB, 0x0AEC, 0x0AED, 0x0AEE, 0x0AEF, 0x0AF2, 0x0AF3, 0x0AF4, 0x0AF5, 0x0AF6, 0x0AF7, 0x0AF8, 0x0AF9, 0x0AFA, 0x0AFB,   // B350 - B35F
	0x0AFC, 0x0AFD, 0x0AFE, 0x0AFF, 0x0B00, 0x0B01, 0x0B02, 0x0B03, 0x0B04, 0x0B05, 0x0B06, 0x0B07, 0x0B08, 0x0B09, 0x0B0A, 0x0B0B,   // B360 - B36F
	0x0B0C, 0x0B0D, 0x0B0E, 0x0B0F, 0x0B10, 0x0B11, 0x0B12, 0x0B13, 0x0B14, 0x0B15, 0x0B16, 0x0B17, 0x0B18, 0x0B19, 0x0B1A, 0x0B1B,   // B370 - B37F
	0x0B1C, 0x0B1D, 0x0B1E, 0x0B1F, 0x0B20, 0x0B21, 0x0B22, 0x0B23, 0x0B24, 0x0B25, 0x0B26, 0x0B27, 0x0B28, 0x0B29, 0x0B2A, 0x0B2B,   // B380 - B38F
	0x0B2C, 0x0B2D, 0x0B2E, 0x0B2F, 0x0B30, 0x0B31, 0x0B32, 0x0B33, 0x0B34, 0x0B35, 0x0B36, 0x0B37, 0x0B38, 0x0B39, 0x0B3A, 0x0B3B,   // B390 - B39F
	0x0B3C, 0x0B3D, 0x0B3E, 0x0B3F, 0x0B40, 0x0B41, 0x0B42, 0x0B43, 0x0B44, 0x0B45, 0x0B46, 0x0B47, 0x0B48, 0x0B49, 0x0B4A, 0x0B4B,   // B3A0 - B3AF
	0x0B4C, 0x0B4D, 0x0B4E, 0x0B4F, 0x0B50, 0x0B51, 0x0B52, 0x0B53, 0x0B54, 0x0B55, 0x0B56, 0x0B57, 0x0B58, 0x0B59, 0x0B5A, 0x0B5B,   // B3B0 - B3BF
	0x0B5C, 0x0B5D, 0x0B5E, 0x0B5F, 0x0B60, 0x0B89, 0x0B94, 0x0B95, 0x0B96, 0x0BA1, 0x0BA2, 0x0BA3, 0x0BA4, 0x0BA7, 0x0BA8, 0x0BA9,   // B3C0 - B3CF
	0x0BAA, 0x0BAB, 0x0BAC, 0x0BAD, 0x0BAE, 0x0BAF, 0x0BB0, 0x0BB1, 0x0BB2, 0x0BB3, 0x0BC5, 0x0BC6, 0x0BC7, 0x0BC8, 0x0BC9, 0x0BCA,   // B3D0 - B3DF
	0x0BCB, 0x0BCC, 0x0BCD, 0x0BCE, 0x0BCF, 0x0BD0, 0x0BD1, 0x0BD2, 0x0BD3, 0x0BD4, 0x0BD5, 0x0BD6, 0x0BD7, 0x0BD8, 0x0BD9, 0x0BDA,   // B3E0 - B3EF
	0x0BDB, 0x0BDC, 0x0BDD, 0x0BDE, 0x0BDF, 0x0BE0, 0x0BE1, 0x0BE2, 0x0BE3, 0x0BE4, 0x0BE5, 0x0BE6, 0x0BE7, 0x0BE8, 0x0BE9, 0x0BEA,   // B3F0 - B3FF
	0x0BEB, 0x0BEC, 0x0BED, 0x0BEE, 0x0BEF, 0x0BF0, 0x0BF1, 0x0BF2, 0x0BF3, 0x0BF4, 0x0BF5, 0x0BF6, 0x0BF7, 0x0BF8, 0x0BF9, 0x0BFA,   // B400 - B40F
	0x0BFB, 0x0BFC, 0x0BFD, 0x0BFE, 0x0BFF, 0x0C00, 0x0C01, 0x0C02, 0x0C03, 0x0C04, 0x0C05, 0x0C06, 0x0C07, 0x0C08, 0x0C09, 0x0C0A,   // B410 - B41F
	0x0C0B, 0x0C0C, 0x0C0D, 0x0C0E, 0x0C0F, 0x0C10, 0x0C11, 0x0C12, 0x0C13, 0x0C14, 0x0C15, 0x0C16, 0x0C17, 0x0C18, 0x0C19, 0x0C1A,   // B420 - B42F
	0x0C1B, 0x0C1C, 0x0C1D, 0x0C1E, 0x0C1F, 0x0C20, 0x0C21, 0x0C22, 0x0C23, 0x0C24, 0x0C25, 0x0C26, 0x0C27, 0x0C28, 0x0C29, 0x0C2A,   // B430 - B43F
	0x0C2B, 0x0C2C, 0x0C2D, 0x0C2E, 0x0C2F, 0x0C30, 0x0C31, 0x0C32, 0x0C33, 0x0C34, 0x0C35, 0x0C36, 0x0C37, 0x0C38, 0x0C39, 0x0C3A,   // B440 - B44F
	0x0C3B, 0x0C47, 0x0C48, 0x0C49, 0x0C4A, 0x0C51, 0x0C52, 0x0C53, 0x0C54, 0x0C55, 0x0C56, 0x0C57, 0x0C58, 0x0C59, 0x0C5A, 0x0C5B,   // B450 - B45F
	0x0C5C, 0x0C5D, 0x0C5E, 0x0C5F, 0x0C60, 0x0C61, 0x0C62, 0x0C63, 0x0C64, 0x0C65, 0x0C66, 0x0C67, 0x0C68, 0x0C69, 0x0C6A, 0x0C6B,   // B460 - B46F
	0x0C6C, 0x0C6D, 0x0C6E, 0x0C6F, 0x0C70, 0x0C71, 0x0C72, 0x0C73, 0x0C74, 0x0C75, 0x0C76, 0x0C77, 0x0C78, 0x0C79, 0x0C7A, 0x0C7B,   // B470 - B47F
	0x0C7C, 0x0C7D, 0x0C7E, 0x0C7F, 0x0C80, 0x0C81, 0x0C82, 0x0C83, 0x0C84, 0x0C85, 0x0C86, 0x0C87, 0x0C88, 0x0C89, 0x0C8A, 0x0C8B,   // B480 - B48F
	0x0C8C, 0x0C8D, 0x0C8E, 0x0C8F, 0x0C90, 0x0C91, 0x0C92, 0x0C93, 0x0C94, 0x0C95, 0x0C96, 0x0C97, 0x0C98, 0x0C99, 0x0C9A, 0x0C9B,   // B490 - B49F
	0x0C9C, 0x0C9D, 0x0C9E, 0x0C9F, 0x0CA0, 0x0CA1, 0x0CA2, 0x0CA3, 0x0CA4, 0x0CA5, 0x0CA6, 0x0CA7, 0x0CA8, 0x0CA9, 0x0CAA, 0x0CAB,   // B4A0 - B4AF
	0x0CAC, 0x0CAD, 0x0CAE, 0x0CAF, 0x0CB0, 0x0CB1, 0x0CB2, 0x0CB3, 0x0CB4, 0x0CB5, 0x0CB6, 0x0CB7, 0x0CB8, 0x0CB9, 0x0CBA, 0x0CBB,   // B4B0 - B4BF
	0x0CBC, 0x0CBD, 0x0CBE, 0x0CBF, 0x0CC0, 0x0CC1, 0x0CC2, 0x0CC3, 0x0CC4, 0x0CC5, 0x0CC6, 0x0CC7, 0x0CC8, 0x0CC9, 0x0CCA, 0x0CCB,   // B4C0 - B4CF
	0x0CCC, 0x0CCD, 0x0CCE, 0x0CCF, 0x0CD0, 0x0CD1, 0x0CD2, 0x0CD3, 0x0CD4, 0x0CD5, 0x0CD6, 0x0CD7, 0x0CD8, 0x0CD9, 0x0CDB, 0x0CDC,   // B4D0 - B4DF
	0x0CDD, 0x0CDE, 0x0CDF, 0x0CE0, 0x0CE1, 0x0CE2, 0x0CE3, 0x0CE4, 0x0CE5, 0x0CE6, 0x0CE7, 0x0CE8, 0x0CE9, 0x0CEA, 0x0CEB, 0x0CEC,   // B4E0 - B4EF
	0x0CED, 0x0CEE, 0x0CF8, 0x0CF9, 0x0CFA, 0x0CFB, 0x0CFC, 0x0CFD, 0x0CFE, 0x0CFF, 0x0D00, 0x0D01, 0x0D02, 0x0D03, 0x0D04, 0x0D05,   // B4F0 - B4FF
	0x0D06, 0x0D07, 0x0D08, 0x0D09, 0x0D0A, 0x0D0B, 0x0D0C, 0x0D0D, 0x0D0E, 0x0D0F, 0x0D10, 0x0D11, 0x0D12, 0x0D13, 0x0D14, 0x0D15,   // B500 - B50F
	0x0D16, 0x0D17, 0x0D18, 0x0D19, 0x0D1A, 0x0D1B, 0x0D1C, 0x0D1D, 0x0D1E, 0x0D1F, 0x0D20, 0x0D21, 0x0D22, 0x0D23, 0x0D24, 0x0D25,   // B510 - B51F
	0x0D26, 0x0D27, 0x0D28, 0x0D29, 0x0D2A, 0x0D2B, 0x0D2C, 0x0D2D, 0x0D2E, 0x0D2F, 0x0D30, 0x0D31, 0x0D32, 0x0D33, 0x0D34, 0x0D35,   // B520 - B52F
	0x0D36, 0x0D37, 0x0D38, 0x0D39, 0x0D3A, 0x0D3B, 0x0D3C, 0x0D3D, 0x0D3E, 0x0D3F, 0x0D40, 0x0D41, 0x0D42, 0x0D43, 0x0D44, 0x0D45,   // B530 - B53F
	0x0D46, 0x0D47, 0x0D48, 0x0D49, 0x0D4A, 0x0D4B, 0x0D4C, 0x0D4D, 0x0D4E, 0x0D4F, 0x0D50, 0x0D51, 0x0D52, 0x0D53, 0x0D54, 0x0D55,   // B540 - B54F
	0x0D56, 0x0D57, 0x0D58, 0x0D59, 0x0D5A, 0x0D5B, 0x0D5C, 0x0D5D, 0x0D5E, 0x0D5F, 0x0D60, 0x0D61, 0x0D62, 0x0D63, 0x0D64, 0x0D65,   // B550 - B55F
	0x0D66, 0x0D67, 0x0D68, 0x0D69, 0x0D6A, 0x0D6B, 0x0D6C, 0x0D6D, 0x0D6E, 0x0D6F, 0x0D70, 0x0D71, 0x0D72, 0x0D73, 0x0D74, 0x0D75,   // B560 - B56F
	0x0D76, 0x0D77, 0x0D78, 0x0D79, 0x0D7A, 0x0D7B, 0x0D7C, 0x0D7D, 0x0D7E, 0x0D7F, 0x0D80, 0x0D81, 0x0D82, 0x0D83, 0x0D84, 0x0D85,   // B570 - B57F
	0x0D86, 0x0D87, 0x0D88, 0x0D89, 0x0D8A, 0x0D8B, 0x0D8C, 0x0D8D, 0x0D8E, 0x0D8F, 0x0D90, 0x0D91, 0x0D92, 0x0D93, 0x0D94, 0x0D95,   // B580 - B58F
	0x0D96, 0x0D97, 0x0D98, 0x0D99, 0x0D9A, 0x0D9B, 0x0D9C, 0x0D9D, 0x0D9E, 0x0D9F, 0x0DA0, 0x0DA1, 0x0DA2, 0x0DA3, 0x0DA4, 0x0DA5,   // B590 - B59F
	0x0DA6, 0x0DA7, 0x0DA8, 0x0DA9, 0x0DAA, 0x0DAB, 0x0DAC, 0x0DAD, 0x0DAE, 0x0DAF, 0x0DB0, 0x0DB1, 0x0DB2, 0x0DB3, 0x0DB4, 0x0DB5,   // B5A0 - B5AF
	0x0DB6, 0x0DB7, 0x0DB8, 0x0DB9, 0x0DBA, 0x0DBB, 0x0DBC, 0x0DBD, 0x0DBE, 0x0DBF, 0x0DC0, 0x0DC1, 0x0DC2, 0x0DC3, 0x0DC4, 0x0DC5,   // B5B0 - B5BF
	0x0DC6, 0x0DC7, 0x0DC8, 0x0DC9, 0x0DCA, 0x0DCB, 0x0DCC, 0x0DCD, 0x0DCE, 0x0DCF, 0x0DD0, 0x0DD1, 0x0DD2, 0x0DD3, 0x0DD4, 0x0DD5,   // B5C0 - B5CF
	0x0DD6, 0x0DD7, 0x0DD8, 0x0DD9, 0x0DDA, 0x0DDB, 0x0DDC, 0x0DDD, 0x0DDE, 0x0DDF, 0x0DE0, 0x0DE1, 0x0DE2, 0x0DE3, 0x0DE4, 0x0DE5,   // B5D0 - B5DF
	0x0DE6, 0x0DE7, 0x0DE8, 0x0DE9, 0x0DEA, 0x0DEB, 0x0DEC, 0x0DED, 0x0DEE, 0x0DEF, 0x0DF0, 0x0DF1, 0x0DF2, 0x0DF3, 0x0DF4, 0x0DF5,   // B5E0 - B5EF
	0x0DF6, 0x0DF7, 0x0DF8, 0x0DF9, 0x0DFA, 0x0DFB, 0x0DFC, 0x0DFD, 0x0DFE, 0x0DFF, 0x0E00, 0x0E01, 0x0E02, 0x0E03, 0x0E04, 0x0E05,   // B5F0 - B5FF
	0x0E06, 0x0E07, 0x0E08, 0x0E09, 0x0E0A, 0x0E0B, 0x0E0C, 0x0E0D, 0x0E0E, 0x0E0F, 0x0E10, 0x0E11, 0x0E12, 0x0E13, 0x0E14, 0x0E15,   // B600 - B60F
	0x0E16, 0x0E17, 0x0E18, 0x0E19, 0x0E1A, 0x0E1B, 0x0E1C, 0x0E1D, 0x0E1E, 0x0E1F, 0x0E20, 0x0E21, 0x0E22, 0x0E23, 0x0E24, 0x0E25,   // B610 - B61F
	0x0E26, 0x0E27, 0x0E28, 0x0E29, 0x0E2A, 0x0E2B, 0x0E2C, 0x0E2D, 0x0E2E, 0x0E2F, 0x0E30, 0x0E31, 0x0E32, 0x0E33, 0x0E34, 0x0E35,   // B620 - B62F
	0x0E36, 0x0E37, 0x0E38, 0x0E39, 0x0E3A, 0x0E3B, 0x0E3C, 0x0E3D, 0x0E3E, 0x0E3F, 0x0E40, 0x0E41, 0x0E42, 0x0E43, 0x0E44, 0x0E45,   // B630 - B63F
	0x0E46, 0x0E47, 0x0E48, 0x0E49, 0x0E4A, 0x0E4B, 0x0E4C, 0x0E4D, 0x0E4E, 0x0E4F, 0x0E50, 0x0E51, 0x0E52, 0x0E53, 0x0E54, 0x0E55,   // B640 - B64F
	0x0E56, 0x0E57, 0x0E58, 0x0E59, 0x0E5A, 0x0E5B, 0x0E5C, 0x0E5D, 0x0E5E, 0x0E5F, 0x0E60, 0x0E61, 0x0E62, 0x0E63, 0x0E64, 0x0E65,   // B650 - B65F
	0x0E66, 0x0E67, 0x0E68, 0x0E69, 0x0E6A, 0x0E6B, 0x0E6C, 0x0E6D, 0x0E6E, 0x0E6F, 0x0E70, 0x0E71, 0x0E72, 0x0E73, 0x0E74, 0x0E75,   // B660 - B66F
	0x0E76, 0x0E77, 0x0E78, 0x0E79, 0x0E7A, 0x0E7B, 0x0E7C, 0x0E7D, 0x0E7E, 0x0E7F, 0x0E80, 0x0E81, 0x0E82, 0x0E83, 0x0E84, 0x0E85,   // B670 - B67F
	0x0E86, 0x0E87, 0x0E88, 0x0E89, 0x0E8A, 0x0E8B, 0x0E8C, 0x0E8D, 0x0E8E, 0x0E8F, 0x0E90, 0x0E91, 0x0E92, 0x0E93, 0x0E94, 0x0E95,   // B680 - B68F
	0x0E96, 0x0E97, 0x0E98, 0x0E99, 0x0E9A, 0x0E9B, 0x0E9C, 0x0E9D, 0x0E9E, 0x0E9F, 0x0EA0, 0x0EA1, 0x0EA2, 0x0EA3, 0x0EA4, 0x0EA5,   // B690 - B69F
	0x0EA6, 0x0EA7, 0x0EA8, 0x0EA9, 0x0EAA, 0x0EAB, 0x0EAC, 0x0EAD, 0x0EAE, 0x0EAF, 0x0EB0, 0x0EB1, 0x0EB2, 0x0EB3, 0x0EB4, 0x0EB5,   // B6A0 - B6AF
	0x0EB6, 0x0EB7, 0x0EB8, 0x0EB9, 0x0EBA, 0x0EBB, 0x0EBC, 0x0EBD, 0x0EBE, 0x0EBF, 0x0EC0, 0x0EC1, 0x0EC2, 0x0EC3, 0x0EC4, 0x0EC5,   // B6B0 - B6BF
	0x0EC6, 0x0EC7, 0x0EC8, 0x0EC9, 0x0ECA, 0x0ECB, 0x0ECC, 0x0ECD, 0x0ECE, 0x0ECF, 0x0ED0, 0x0ED1, 0x0ED2, 0x0ED3, 0x0ED4, 0x0ED5,   // B6C0 - B6CF
	0x0ED6, 0x0ED7, 0x0ED8, 0x0ED9, 0x0EDA, 0x0EDB, 0x0EDC, 0x0EDD, 0x0EDE, 0x0EDF, 0x0EE0, 0x0EE1, 0x0EE2, 0x0EE3, 0x0EE4, 0x0EE5,   // B6D0 - B6DF
	0x0EE6, 0x0EE7, 0x0EE8, 0x0EE9, 0x0EEA, 0x0EEB, 0x0EEC, 0x0EED, 0x0EEE, 0x0EEF, 0x0EF0, 0x0EF1, 0x0EF2, 0x0EF3, 0x0EF4, 0x0EF5,   // B6E0 - B6EF
	0x0EF6, 0x0EF7, 0x0EF8, 0x0EF9, 0x0EFA, 0x0EFB, 0x0EFC, 0x0EFD, 0x0EFE, 0x0EFF, 0x0F00, 0x0F01, 0x0F02, 0x0F03, 0x0F04, 0x0F05,   // B6F0 - B6FF
	0x0F06, 0x0F07, 0x0F08, 0x0F09, 0x0F0A, 0x0F0B, 0x0F0C, 0x0F0D, 0x0F0E, 0x0F0F, 0x0F10, 0x0F11, 0x0F12, 0x0F13, 0x0F14, 0x0F15,   // B700 - B70F
	0x0F16, 0x0F17, 0x0F18, 0x0F19, 0x0F1A, 0x0F1B, 0x0F1C, 0x0F1D, 0x0F1E, 0x0F1F, 0x0F20, 0x0F21, 0x0F22, 0x0F23, 0x0F24, 0x0F25,   // B710 - B71F
	0x0F26, 0x0F27, 0x0F28, 0x0F29, 0x0F2A, 0x0F2B, 0x0F2C, 0x0F2D, 0x0F2E, 0x0F2F, 0x0F30, 0x0F31, 0x0F32, 0x0F33, 0x0F34, 0x0F35,   // B720 - B72F
	0x0F36, 0x0F37, 0x0F38, 0x0F39, 0x0F3A, 0x0F3B, 0x0F3C, 0x0F3D, 0x0F3E, 0x0F3F, 0x0F40, 0x0F41, 0x0F42, 0x0F43, 0x0F44, 0x0F45,   // B730 - B73F
	0x0F46, 0x0F47, 0x0F48, 0x0F49, 0x0F4A, 0x0F4B, 0x0F4C, 0x0F4D, 0x0F4E, 0x0F4F, 0x0F50, 0x0F51, 0x0F52, 0x0F53, 0x0F54, 0x0F55,   // B740 - B74F
	0x0F56, 0x0F57, 0x0F58, 0x0F59, 0x0F5A, 0x0F5B, 0x0F5C, 0x0F5D, 0x0F5E, 0x0F5F, 0x0F60, 0x0F61, 0x0F62, 0x0F63, 0x0F64, 0x0F65,   // B750 - B75F
	0x0F66, 0x0F67, 0x0F68, 0x0F69, 0x0F6A, 0x0F6B, 0x0F6C, 0x0F6D, 0x0F6E, 0x0F6F, 0x0F70, 0x0F71, 0x0F72, 0x0F73, 0x0F74, 0x0F75,   // B760 - B76F
	0x0F76, 0x0F77, 0x0F78, 0x0F79, 0x0F7A, 0x0F7B, 0x0F7C, 0x0F7D, 0x0F7E, 0x0F7F, 0x0F80, 0x0F81, 0x0F82, 0x0F8C, 0x0F96, 0x0F97,   // B770 - B77F
	0x0F98, 0x0FA2, 0x0FA3, 0x0FA4, 0x0FA5, 0x0FA8, 0x0FA9, 0x0FAA, 0x0FAB, 0x0FAC, 0x0FAD, 0x0FAE, 0x0FAF, 0x0FBA, 0x0FBE, 0x0FBF,   // B780 - B78F
	0x0FC0, 0x0FC1, 0x0FCA, 0x0FCB, 0x0FCC, 0x0FCD, 0x0FCE, 0x0FCF, 0x0FD0, 0x0FD5, 0x0FD6, 0x0FD7, 0x0FD8, 0x0FD9, 0x0FDA, 0x0FDB,   // B790 - B79F
	0x0FDC, 0x0FDD, 0x0FDE, 0x0FDF, 0x0FE0, 0x0FE1, 0x0FE2, 0x0FE3, 0x0FE4, 0x0FE5, 0x0FE6, 0x0FE7, 0x0FE8, 0x0FE9, 0x0FEB, 0x0FEC,   // B7A0 - B7AF
	0x0FED, 0x0FEE, 0x0FEF, 0x0FF0, 0x0FF1, 0x0FF2, 0x0FF5, 0x0FF6, 0x0FF7, 0x0FF8, 0x0FF9, 0x0FFA, 0x0FFB, 0x0FFC, 0x0FFD, 0x0FFE,   // B7B0 - B7BF
	0x0FFF, 0x1000, 0x1001, 0x1002, 0x1003, 0x1004, 0x1005, 0x1006, 0x1007, 0x1008, 0x1016, 0x1017, 0x1018, 0x1019, 0x101A, 0x101B,   // B7C0 - B7CF
	0x101C, 0x101D, 0x101E, 0x101F, 0x1020, 0x1021, 0x1022, 0x1023, 0x1024, 0x1025, 0x1026, 0x1027, 0x1028, 0x1029, 0x102A, 0x102B,   // B7D0 - B7DF
	0x102C, 0x102D, 0x102E, 0x102F, 0x1030, 0x1031, 0x1032, 0x1033, 0x1034, 0x1035, 0x1036, 0x1037, 0x1038, 0x1039, 0x103A, 0x103B,   // B7E0 - B7EF
	0x103C, 0x103D, 0x103E, 0x103F, 0x1040, 0x1041, 0x1042, 0x1043, 0x1044, 0x1045, 0x1046, 0x1047, 0x1048, 0x1049, 0x104A, 0x104B,   // B7F0 - B7FF
	0x104C, 0x104D, 0x104E, 0x104F, 0x1050, 0x1051, 0x1052, 0x1053, 0x1054, 0x1055, 0x1056, 0x1057, 0x1058, 0x1059, 0x105A, 0x105B,   // B800 - B80F
	0x105C, 0x105D, 0x105E, 0x105F, 0x1060, 0x1061, 0x1062, 0x1063, 0x1064, 0x1065, 0x1066, 0x1067, 0x1068, 0x1069, 0x106A, 0x106B,   // B810 - B81F
	0x106C, 0x106D, 0x106E, 0x106F, 0x1070, 0x1083, 0x108B, 0x108C, 0x108D, 0x109A, 0x109B, 0x109C, 0x109D, 0x10A4, 0x10A5, 0x10A6,   // B820 - B82F
	0x10A7, 0x10A8, 0x10A9, 0x10AA, 0x10AB, 0x10B1, 0x10B3, 0x10B4, 0x10B5, 0x10B6, 0x10C9, 0x10CA, 0x10CB, 0x10CC, 0x10CD, 0x10CE,   // B830 - B83F
	0x10CF, 0x10D5, 0x10D6, 0x10D7, 0x10D8, 0x10D9, 0x10DA, 0x10DB, 0x10DC, 0x10DD, 0x10DE, 0x10DF, 0x10E0, 0x10E1, 0x10E2, 0x10E3,   // B840 - B84F
	0x10E4, 0x10E5, 0x10E6, 0x10E7, 0x10E8, 0x10E9, 0x10EA, 0x10EB, 0x10EC, 0x10ED, 0x10EE, 0x10EF, 0x10F0, 0x1103, 0x110B, 0x110C,   // B850 - B85F
	0x110D, 0x110F, 0x1110, 0x1111, 0x1112, 0x1113, 0x1114, 0x1115, 0x1116, 0x1117, 0x1118, 0x1119, 0x111A, 0x111B, 0x111C, 0x111D,   // B860 - B86F
	0x111E, 0x111F, 0x1127, 0x1128, 0x1129, 0x112A, 0x112B, 0x112C, 0x112D, 0x112E, 0x112F, 0x1130, 0x1131, 0x1132, 0x1133, 0x1134,   // B870 - B87F
	0x1135, 0x1136, 0x1137, 0x1138, 0x1139, 0x113A, 0x113B, 0x113C, 0x113D, 0x113E, 0x113F, 0x1140, 0x1141, 0x1142, 0x1143, 0x1144,   // B880 - B88F
	0x1145, 0x1146, 0x1147, 0x1148, 0x1149, 0x114A, 0x114B, 0x114C, 0x114D, 0x114E, 0x114F, 0x1150, 0x1151, 0x1152, 0x1153, 0x1154,   // B890 - B89F
	0x1155, 0x1156, 0x1157, 0x1158, 0x1159, 0x115A, 0x115B, 0x115C, 0x115D, 0x115E, 0x115F, 0x1160, 0x1161, 0x1162, 0x1163, 0x1164,   // B8A0 - B8AF
	0x1165, 0x116E, 0x116F, 0x1170, 0x1171, 0x1172, 0x1173, 0x1174, 0x1175, 0x1176, 0x1177, 0x1178, 0x1179, 0x117A, 0x117B, 0x117C,   // B8B0 - B8BF
	0x117D, 0x117E, 0x117F, 0x1180, 0x1181, 0x1182, 0x1183, 0x1184, 0x1185, 0x1186, 0x1187, 0x1188, 0x1189, 0x1196, 0x1197, 0x1198,   // B8C0 - B8CF
	0x1199, 0x119A, 0x119B, 0x119C, 0x119D, 0x119E, 0x119F, 0x11A0, 0x11A1, 0x11A2, 0x11A3, 0x11A4, 0x11A5, 0x11A6, 0x11A7, 0x11A8,   // B8D0 - B8DF
	0x11A9, 0x11AA, 0x11AC, 0x11AD, 0x11AE, 0x11AF, 0x11B0, 0x11B1, 0x11B2, 0x11C0, 0x11C1, 0x11C2, 0x11C3, 0x11C4, 0x11C5, 0x11C6,   // B8E0 - B8EF
	0x11C7, 0x11C8, 0x11C9, 0x11CA, 0x11CB, 0x11CC, 0x11CD, 0x11CE, 0x11CF, 0x11D0, 0x11D1, 0x11D2, 0x11D3, 0x11D4, 0x11D5, 0x11D6,   // B8F0 - B8FF
	0x11D7, 0x11D8, 0x11D9, 0x11DA, 0x11DB, 0x11DC, 0x11DD, 0x11DE, 0x11DF, 0x11E0, 0x11E1, 0x11E2, 0x11E3, 0x11E4, 0x11E5, 0x11E6,   // B900 - B90F
	0x11E7, 0x11E8, 0x11E9, 0x11EA, 0x11EB, 0x11EC, 0x11ED, 0x11EE, 0x11EF, 0x11F0, 0x11F1, 0x11F2, 0x11F3, 0x11F4, 0x11F5, 0x11F6,   // B910 - B91F
	0x11F7, 0x11F8, 0x11F9, 0x11FA, 0x11FB, 0x11FC, 0x11FD, 0x11FE, 0x11FF, 0x1200, 0x1201, 0x1202, 0x1203, 0x1204, 0x1205, 0x1206,   // B920 - B92F
	0x1207, 0x1208, 0x1209, 0x120A, 0x120B, 0x120C, 0x120D, 0x120E, 0x120F, 0x1210, 0x1211, 0x1212, 0x1213, 0x1214, 0x1215, 0x1216,   // B930 - B93F
	0x1217, 0x1218, 0x1219, 0x121A, 0x121B, 0x121C, 0x121D, 0x121E, 0x121F, 0x1220, 0x1221, 0x1222, 0x1223, 0x1224, 0x1225, 0x1226,   // B940 - B94F
	0x1227, 0x1228, 0x1229, 0x122A, 0x122B, 0x122C, 0x122D, 0x122E, 0x122F, 0x123E, 0x1242, 0x1243, 0x1244, 0x124B, 0x124C, 0x124D,   // B950 - B95F
	0x124E, 0x1253, 0x1254, 0x1255, 0x1256, 0x1257, 0x1258, 0x1259, 0x125A, 0x125B, 0x125C, 0x125D, 0x125E, 0x125F, 0x1261, 0x1262,   // B960 - B96F
	0x1263, 0x1264, 0x1265, 0x1266, 0x1267, 0x1268, 0x126B, 0x126C, 0x126D, 0x126E, 0x126F, 0x1270, 0x1271, 0x1272, 0x1273, 0x1274,   // B970 - B97F
	0x1275, 0x1276, 0x1277, 0x1278, 0x1279, 0x127B, 0x127C, 0x127D, 0x127E, 0x127F, 0x1286, 0x1287, 0x1288, 0x1289, 0x128A, 0x128B,   // B980 - B98F
	0x128C, 0x128D, 0x128E, 0x128F, 0x1290, 0x1291, 0x1292, 0x1293, 0x1294, 0x1295, 0x1296, 0x1297, 0x1298, 0x1299, 0x129A, 0x129B,   // B990 - B99F
	0x129C, 0x129D, 0x129E, 0x129F, 0x12A0, 0x12A1, 0x12A2, 0x12A3, 0x12A4, 0x12A5, 0x12A6, 0x12A7, 0x12A8, 0x12C3, 0x12C4, 0x12C5,   // B9A0 - B9AF
	0x12C6, 0x12D0, 0x12D1, 0x12D2, 0x12D3, 0x12D4, 0x12D5, 0x12D6, 0x12D7, 0x12D8, 0x12D9, 0x12DA, 0x12DB, 0x12E1, 0x12E6, 0x12E7,   // B9B0 - B9BF
	0x12E8, 0x12E9, 0x12EA, 0x12EB, 0x12EC, 0x12ED, 0x12EE, 0x12EF, 0x12F0, 0x12F9, 0x1300, 0x1301, 0x1302, 0x1316, 0x1317, 0x1318,   // B9C0 - B9CF
	0x1319, 0x1321, 0x1322, 0x1323, 0x1324, 0x1325, 0x1326, 0x1327, 0x1328, 0x1329, 0x132A, 0x132B, 0x132C, 0x132D, 0x133A, 0x133B,   // B9D0 - B9DF
	0x133C, 0x133D, 0x133E, 0x133F, 0x1340, 0x134F, 0x1355, 0x1356, 0x1357, 0x1358, 0x1359, 0x135A, 0x135B, 0x135C, 0x135D, 0x135E,   // B9E0 - B9EF
	0x135F, 0x1360, 0x1361, 0x1362, 0x1363, 0x1364, 0x1365, 0x1366, 0x1367, 0x1368, 0x136F, 0x1370, 0x1371, 0x1372, 0x1373, 0x1374,   // B9F0 - B9FF
	0x1375, 0x1376, 0x1377, 0x1378, 0x1379, 0x137A, 0x137B, 0x137C, 0x137D, 0x137E, 0x137F, 0x1380, 0x1381, 0x1382, 0x1383, 0x1384,   // BA00 - BA0F
	0x1385, 0x1386, 0x1387, 0x1388, 0x1389, 0x138A, 0x138B, 0x138C, 0x138D, 0x138E, 0x138F, 0x1390, 0x1391, 0x1392, 0x1393, 0x1394,   // BA10 - BA1F
	0x1395, 0x1396, 0x1397, 0x1398, 0x1399, 0x139A, 0x139B, 0x139C, 0x139D, 0x139E, 0x139F, 0x13A0, 0x13A1, 0x13A2, 0x13A3, 0x13A4,   // BA20 - BA2F
	0x13A5, 0x13A6, 0x13A7, 0x13A8, 0x13A9, 0x13AA, 0x13AB, 0x13AC, 0x13AD, 0x13AE, 0x13AF, 0x13B0, 0x13B1, 0x13B2, 0x13B3, 0x13B4,   // BA30 - BA3F
	0x13B5, 0x13B6, 0x13B7, 0x13B8, 0x13B9, 0x13BA, 0x13BB, 0x13BC, 0x13BD, 0x13BE, 0x13BF, 0x13C0, 0x13C1, 0x13C2, 0x13C3, 0x13C4,   // BA40 - BA4F
	0x13C5, 0x13C6, 0x13C7, 0x13C8, 0x13C9, 0x13CA, 0x13CB, 0x13CC, 0x13CD, 0x13CE, 0x13CF, 0x13D0, 0x13D1, 0x13D2, 0x13D3, 0x13D4,   // BA50 - BA5F
	0x13D5, 0x13D6, 0x13D7, 0x13D8, 0x13D9, 0x13DA, 0x13DB, 0x13DC, 0x13DD, 0x13DE, 0x13DF, 0x13E0, 0x13E1, 0x13E2, 0x13E3, 0x13E4,   // BA60 - BA6F
	0x13E5, 0x13E6, 0x13E9, 0x13EA, 0x13EB, 0x13F7, 0x13F8, 0x13F9, 0x13FA, 0x13FD, 0x13FE, 0x13FF, 0x1400, 0x1401, 0x1402, 0x1403,   // BA70 - BA7F
	0x1404, 0x1405, 0x1406, 0x1407, 0x1408, 0x1409, 0x1419, 0x141A, 0x141B, 0x141C, 0x141D, 0x141E, 0x141F, 0x1421, 0x1422, 0x1423,   // BA80 - BA8F
	0x1424, 0x1425, 0x1426, 0x1427, 0x1428, 0x1429, 0x142A, 0x142B, 0x142C, 0x142D, 0x142E, 0x142F, 0x1430, 0x1431, 0x1432, 0x1433,   // BA90 - BA9F
	0x1434, 0x1435, 0x1436, 0x1437, 0x1438, 0x1439, 0x143A, 0x143B, 0x143C, 0x1455, 0x145D, 0x145E, 0x145F, 0x1460, 0x1461, 0x1462,   // BAA0 - BAAF
	0x1463, 0x1466, 0x1467, 0x1468, 0x1469, 0x146A, 0x146B, 0x146C, 0x146D, 0x146E, 0x146F, 0x1470, 0x1471, 0x1472, 0x1476, 0x1477,   // BAB0 - BABF
	0x1478, 0x1479, 0x147A, 0x147B, 0x147C, 0x147D, 0x147E, 0x147F, 0x1480, 0x1481, 0x1482, 0x1483, 0x1484, 0x1485, 0x1486, 0x1487,   // BAC0 - BACF
	0x1488, 0x1489, 0x148A, 0x148B, 0x148C, 0x148D, 0x148E, 0x148F, 0x1490, 0x1491, 0x1492, 0x1493, 0x1494, 0x1495, 0x1496, 0x1497,   // BAD0 - BADF
	0x1498, 0x1499, 0x149A, 0x149B, 0x149C, 0x149D, 0x149E, 0x149F, 0x14A0, 0x14A1, 0x14A2, 0x14A3, 0x14A4, 0x14A5, 0x14A6, 0x14A7,   // BAE0 - BAEF
	0x14A8, 0x14A9, 0x14AA, 0x14AB, 0x14AC, 0x14AD, 0x14AE, 0x14AF, 0x14B0, 0x14B1, 0x14B2, 0x14B3, 0x14B4, 0x14B5, 0x14B6, 0x14B7,   // BAF0 - BAFF
	0x14B8, 0x14B9, 0x14BA, 0x14BB, 0x14BC, 0x14BD, 0x14BE, 0x14BF, 0x14C0, 0x14C1, 0x14C2, 0x14C3, 0x14C4, 0x14C5, 0x14C6, 0x14C7,   // BB00 - BB0F
	0x14C8, 0x14C9, 0x14CA, 0x14CB, 0x14CC, 0x14CD, 0x14CE, 0x14CF, 0x14D0, 0x14DD, 0x14DE, 0x14DF, 0x14E0, 0x14E1, 0x14E2, 0x14E3,   // BB10 - BB1F
	0x14E4, 0x14E5, 0x14E6, 0x14E7, 0x14E8, 0x14E9, 0x14EA, 0x14EB, 0x14EC, 0x14ED, 0x14EE, 0x14EF, 0x14F0, 0x14F1, 0x14F2, 0x14F3,   // BB20 - BB2F
	0x14F4, 0x14F5, 0x14F6, 0x14F7, 0x14F8, 0x150F, 0x1512, 0x1513, 0x1514, 0x1521, 0x1522, 0x1523, 0x1524, 0x1528, 0x1529, 0x152A,   // BB30 - BB3F
	0x152B, 0x152C, 0x152D, 0x152E, 0x152F, 0x1530, 0x1531, 0x1532, 0x1533, 0x1534, 0x1535, 0x1536, 0x1537, 0x1538, 0x1539, 0x153A,   // BB40 - BB4F
	0x153B, 0x153C, 0x153D, 0x153E, 0x153F, 0x1540, 0x1541, 0x1542, 0x1543, 0x1544, 0x1545, 0x1546, 0x1547, 0x1548, 0x1549, 0x154A,   // BB50 - BB5F
	0x154B, 0x154C, 0x154D, 0x154E, 0x154F, 0x1550, 0x1551, 0x1552, 0x1553, 0x1554, 0x1555, 0x1556, 0x1557, 0x1558, 0x1559, 0x155A,   // BB60 - BB6F
	0x155B, 0x155C, 0x155D, 0x155E, 0x155F, 0x1560, 0x1561, 0x1562, 0x1563, 0x1564, 0x1565, 0x1566, 0x1567, 0x1568, 0x1569, 0x156A,   // BB70 - BB7F
	0x156B, 0x156C, 0x156D, 0x156E, 0x156F, 0x1570, 0x1571, 0x1572, 0x1573, 0x1574, 0x1575, 0x1576, 0x1577, 0x1578, 0x1579, 0x157A,   // BB80 - BB8F
	0x157B, 0x157C, 0x157D, 0x157E, 0x157F, 0x1580, 0x1581, 0x1582, 0x1583, 0x1584, 0x1585, 0x1586, 0x1587, 0x1588, 0x1589, 0x158A,   // BB90 - BB9F
	0x158B, 0x158C, 0x158D, 0x158E, 0x158F, 0x1590, 0x1591, 0x1592, 0x1593, 0x1594, 0x1595, 0x1596, 0x1597, 0x1598, 0x1599, 0x159A,   // BBA0 - BBAF
	0x159B, 0x159C, 0x159D, 0x159E, 0x159F, 0x15A0, 0x15A1, 0x15A2, 0x15A3, 0x15A4, 0x15A5, 0x15A6, 0x15A7, 0x15A8, 0x15A9, 0x15AA,   // BBB0 - BBBF
	0x15AB, 0x15AC, 0x15AD, 0x15AE, 0x15AF, 0x15B0, 0x15B1, 0x15B2, 0x15B3, 0x15B4, 0x15B5, 0x15B6, 0x15B7, 0x15B8, 0x15B9, 0x15BA,   // BBC0 - BBCF
	0x15BB, 0x15BC, 0x15BD, 0x15BE, 0x15BF, 0x15C0, 0x15C1, 0x15C2, 0x15C3, 0x15C4, 0x15C5, 0x15C6, 0x15C7, 0x15C8, 0x15C9, 0x15CA,   // BBD0 - BBDF
	0x15CB, 0x15CC, 0x15CD, 0x15CE, 0x15CF, 0x15D0, 0x15D1, 0x15D2, 0x15D3, 0x15D4, 0x15D5, 0x15D6, 0x15D7, 0x15D8, 0x15D9, 0x15DA,   // BBE0 - BBEF
	0x15DB, 0x15DC, 0x15DD, 0x15DE, 0x15DF, 0x15E0, 0x15E1, 0x15E2, 0x15E3, 0x15F7, 0x15F8, 0x15F9, 0x15FA, 0x1608, 0x1609, 0x160A,   // BBF0 - BBFF
	0x160B, 0x160F, 0x1610, 0x1611, 0x1612, 0x1613, 0x1614, 0x1615, 0x1616, 0x1617, 0x1618, 0x1619, 0x161A, 0x161B, 0x161C, 0x161D,   // BC00 - BC0F
	0x161E, 0x161F, 0x1620, 0x1621, 0x1622, 0x1623, 0x1637, 0x1638, 0x1639, 0x1653, 0x1654, 0x1655, 0x1656, 0x1662, 0x1663, 0x1664,   // BC10 - BC1F
	0x1665, 0x1666, 0x1667, 0x1668, 0x1669, 0x166A, 0x166B, 0x166C, 0x166D, 0x166E, 0x168B, 0x168C, 0x168D, 0x168E, 0x168F, 0x1690,   // BC20 - BC2F
	0x1691, 0x16A6, 0x16AF, 0x16B0, 0x16B1, 0x16B2, 0x16B3, 0x16B4, 0x16B5, 0x16B6, 0x16B7, 0x16B8, 0x16B9, 0x16BA, 0x16BB, 0x16BC,   // BC30 - BC3F
	0x16BD, 0x16BE, 0x16BF, 0x16C0, 0x16C1, 0x16C2, 0x16C3, 0x16C4, 0x16C5, 0x16C6, 0x16C7, 0x16C8, 0x16C9, 0x16CA, 0x16CB, 0x16CC,   // BC40 - BC4F
	0x16CD, 0x16CE, 0x16CF, 0x16D0, 0x16D1, 0x16D2, 0x16D3, 0x16D4, 0x16D5, 0x16D6, 0x16D7, 0x16D8, 0x16D9, 0x16DA, 0x16DB, 0x16DC,   // BC50 - BC5F
	0x16DD, 0x16DE, 0x16DF, 0x16E0, 0x16E1, 0x16E2, 0x16E3, 0x16E4, 0x16E5, 0x16E6, 0x16E7, 0x16E8, 0x16E9, 0x16EA, 0x16EB, 0x16EC,   // BC60 - BC6F
	0x16ED, 0x16EE, 0x16EF, 0x16F0, 0x16F1, 0x16F2, 0x16F3, 0x16F4, 0x16F5, 0x16F6, 0x16F7, 0x16F8, 0x16F9, 0x16FA, 0x16FB, 0x16FC,   // BC70 - BC7F
	0x16FD, 0x16FE, 0x16FF, 0x1700, 0x1701, 0x1702, 0x1703, 0x1704, 0x1705, 0x1710, 0x1711, 0x1712, 0x1713, 0x1718, 0x1719, 0x171A,   // BC80 - BC8F
	0x171B, 0x171C, 0x171D, 0x171E, 0x171F, 0x1729, 0x172C, 0x172D, 0x172E, 0x172F, 0x1730, 0x1731, 0x1732, 0x1733, 0x1734, 0x1735,   // BC90 - BC9F
	0x1736, 0x1737, 0x1738, 0x1739, 0x173A, 0x173B, 0x173C, 0x173D, 0x173E, 0x173F, 0x1740, 0x1741, 0x1742, 0x1743, 0x1744, 0x1745,   // BCA0 - BCAF
	0x1746, 0x1747, 0x1748, 0x1749, 0x174A, 0x174B, 0x174C, 0x174D, 0x174E, 0x174F, 0x1750, 0x1751, 0x1752, 0x1753, 0x175F, 0x1760,   // BCB0 - BCBF
	0x1761, 0x1769, 0x176A, 0x176B, 0x176C, 0x1771, 0x1772, 0x1773, 0x1774, 0x1775, 0x1776, 0x1777, 0x1778, 0x1779, 0x177A, 0x177B,   // BCC0 - BCCF
	0x177C, 0x177D, 0x178F, 0x1790, 0x1791, 0x1792, 0x1793, 0x1794, 0x1795, 0x1796, 0x1797, 0x1798, 0x1799, 0x179A, 0x179B, 0x179C,   // BCD0 - BCDF
	0x179D, 0x179E, 0x179F, 0x17A0, 0x17A1, 0x17A2, 0x17A3, 0x17A4, 0x17A5, 0x17A6, 0x17A7, 0x17A8, 0x17A9, 0x17AA, 0x17AB, 0x17AC,   // BCE0 - BCEF
	0x17AD, 0x17AE, 0x17AF, 0x17B0, 0x17B1, 0x17C2, 0x17D4, 0x17D5, 0x17D6, 0x17D8, 0x17D9, 0x17DA, 0x17DB, 0x17DD, 0x17DE, 0x17DF,   // BCF0 - BCFF
	0x17E0, 0x17E1, 0x17E2, 0x17E3, 0x17E4, 0x17E5, 0x17E6, 0x17E7, 0x17E8, 0x17E9, 0x17FA, 0x17FB, 0x17FC, 0x17FD, 0x17FE, 0x17FF,   // BD00 - BD0F
	0x1800, 0x1801, 0x1802, 0x1803, 0x1804, 0x1805, 0x1806, 0x1807, 0x1808, 0x1809, 0x180A, 0x180B, 0x180C, 0x180D, 0x180E, 0x180F,   // BD10 - BD1F
	0x1810, 0x1811, 0x1812, 0x1813, 0x1814, 0x1815, 0x1816, 0x1817, 0x1818, 0x1819, 0x181A, 0x181B, 0x181C, 0x181D, 0x181E, 0x181F,   // BD20 - BD2F
	0x1820, 0x1821, 0x1822, 0x1823, 0x1824, 0x1825, 0x1826, 0x1827, 0x1828, 0x1829, 0x182A, 0x182B, 0x182C, 0x182D, 0x182E, 0x182F,   // BD30 - BD3F
	0x1830, 0x1831, 0x1832, 0x1833, 0x1834, 0x1835, 0x1836, 0x1837, 0x1838, 0x1839, 0x183A, 0x183B, 0x183C, 0x183D, 0x183E, 0x183F,   // BD40 - BD4F
	0x1840, 0x1841, 0x1842, 0x1843, 0x1844, 0x1845, 0x1846, 0x1847, 0x1848, 0x1849, 0x184A, 0x184B, 0x184C, 0x184D, 0x184E, 0x184F,   // BD50 - BD5F
	0x1850, 0x1851, 0x1852, 0x1853, 0x1854, 0x1855, 0x1856, 0x1857, 0x1858, 0x1859, 0x185A, 0x185B, 0x185C, 0x185D, 0x185E, 0x185F,   // BD60 - BD6F
	0x1860, 0x1861, 0x1862, 0x1863, 0x1864, 0x1865, 0x1866, 0x1867, 0x1868, 0x1869, 0x186A, 0x186B, 0x186C, 0x186D, 0x186E, 0x186F,   // BD70 - BD7F
	0x1870, 0x189C, 0x189E, 0x189F, 0x18A0, 0x18B4, 0x18B5, 0x18B6, 0x18B7, 0x18BD, 0x18BE, 0x18BF, 0x18C0, 0x18C1, 0x18C2, 0x18C3,   // BD80 - BD8F
	0x18C4, 0x18C5, 0x18C6, 0x18C7, 0x18C8, 0x18C9, 0x18D0, 0x18D1, 0x18D2, 0x18D3, 0x18D4, 0x18D5, 0x18D6, 0x18D7, 0x18D8, 0x18D9,   // BD90 - BD9F
	0x18DA, 0x18DB, 0x18DC, 0x18DD, 0x18DE, 0x18DF, 0x18E0, 0x18E1, 0x18E2, 0x18E3, 0x18E4, 0x18E5, 0x18E6, 0x18E7, 0x18E8, 0x18E9,   // BDA0 - BDAF
	0x18EA, 0x18EB, 0x18EC, 0x18ED, 0x18EE, 0x18EF, 0x18F0, 0x18F1, 0x18F2, 0x18F3, 0x18F4, 0x18F5, 0x18F6, 0x18F7, 0x18F8, 0x18F9,   // BDB0 - BDBF
	0x18FA, 0x18FB, 0x18FC, 0x18FD, 0x18FE, 0x18FF, 0x1900, 0x1901, 0x1902, 0x1903, 0x1904, 0x1905, 0x1906, 0x1907, 0x1908, 0x1909,   // BDC0 - BDCF
	0x190A, 0x190B, 0x190C, 0x190D, 0x190E, 0x190F, 0x1910, 0x1911, 0x1912, 0x1913, 0x1914, 0x1915, 0x1916, 0x1917, 0x1918, 0x1919,   // BDD0 - BDDF
	0x191A, 0x191B, 0x191C, 0x191D, 0x191E, 0x191F, 0x1920, 0x1921, 0x1922, 0x1923, 0x1924, 0x1925, 0x1926, 0x1927, 0x1928, 0x1929,   // BDE0 - BDEF
	0x192A, 0x192B, 0x192C, 0x192D, 0x192E, 0x192F, 0x1930, 0x1931, 0x1932, 0x1933, 0x1934, 0x1935, 0x1936, 0x1937, 0x1938, 0x1939,   // BDF0 - BDFF
	0x193A, 0x193B, 0x193C, 0x193D, 0x193E, 0x193F, 0x1940, 0x1941, 0x1942, 0x1943, 0x1944, 0x1945, 0x1946, 0x1947, 0x1948, 0x1949,   // BE00 - BE0F
	0x194A, 0x194B, 0x194C, 0x194D, 0x194E, 0x194F, 0x1950, 0x1951, 0x1952, 0x1953, 0x1954, 0x1955, 0x1956, 0x1957, 0x1958, 0x1959,   // BE10 - BE1F
	0x195A, 0x195B, 0x195C, 0x195D, 0x195E, 0x195F, 0x1960, 0x1961, 0x1962, 0x1963, 0x1964, 0x1965, 0x1966, 0x1967, 0x1968, 0x1969,   // BE20 - BE2F
	0x196A, 0x196B, 0x196C, 0x196D, 0x196E, 0x196F, 0x1970, 0x1971, 0x1972, 0x1973, 0x1974, 0x1975, 0x1976, 0x1977, 0x1978, 0x1979,   // BE30 - BE3F
	0x197A, 0x197B, 0x197C, 0x197D, 0x197E, 0x19AA, 0x19AB, 0x19AC, 0x19AD, 0x19BC, 0x19BD, 0x19BE, 0x19BF, 0x19C0, 0x19C1, 0x19C2,   // BE40 - BE4F
	0x19C3, 0x19C4, 0x19C5, 0x19C6, 0x19C7, 0x19C8, 0x19C9, 0x19CA, 0x19CB, 0x19CC, 0x19D1, 0x19D2, 0x19D3, 0x19D4, 0x19D5, 0x19D6,   // BE50 - BE5F
	0x19D7, 0x19D8, 0x19D9, 0x19DA, 0x19DB, 0x19DC, 0x19DD, 0x19DE, 0x19DF, 0x19E0, 0x19E1, 0x19E2, 0x19E3, 0x19E4, 0x19E5, 0x19E6,   // BE60 - BE6F
	0x19E7, 0x19E8, 0x19E9, 0x19EA, 0x19EB, 0x19EC, 0x19ED, 0x19EE, 0x19EF, 0x19F0, 0x19F1, 0x19F2, 0x19F3, 0x19F4, 0x19F5, 0x19F6,   // BE70 - BE7F
	0x19F7, 0x19F8, 0x19F9, 0x19FA, 0x19FB, 0x19FC, 0x19FD, 0x19FE, 0x19FF, 0x1A00, 0x1A01, 0x1A02, 0x1A03, 0x1A04, 0x1A05, 0x1A06,   // BE80 - BE8F
	0x1A07, 0x1A08, 0x1A09, 0x1A0A, 0x1A0B, 0x1A0C, 0x1A0D, 0x1A0E, 0x1A0F, 0x1A10, 0x1A11, 0x1A12, 0x1A13, 0x1A14, 0x1A15, 0x1A16,   // BE90 - BE9F
	0x1A17, 0x1A18, 0x1A19, 0x1A1A, 0x1A1B, 0x1A1C, 0x1A1D, 0x1A1E, 0x1A1F, 0x1A20, 0x1A21, 0x1A22, 0x1A23, 0x1A24, 0x1A25, 0x1A26,   // BEA0 - BEAF
	0x1A27, 0x1A28, 0x1A29, 0x1A2A, 0x1A2B, 0x1A2C, 0x1A2D, 0x1A2E, 0x1A2F, 0x1A30, 0x1A31, 0x1A32, 0x1A33, 0x1A34, 0x1A35, 0x1A36,   // BEB0 - BEBF
	0x1A37, 0x1A38, 0x1A39, 0x1A3A, 0x1A3B, 0x1A3C, 0x1A3D, 0x1A3E, 0x1A3F, 0x1A40, 0x1A41, 0x1A42, 0x1A43, 0x1A44, 0x1A45, 0x1A46,   // BEC0 - BECF
	0x1A47, 0x1A48, 0x1A49, 0x1A4A, 0x1A4B, 0x1A4C, 0x1A4D, 0x1A4E, 0x1A4F, 0x1A50, 0x1A51, 0x1A52, 0x1A53, 0x1A54, 0x1A55, 0x1A56,   // BED0 - BEDF
	0x1A57, 0x1A58, 0x1A59, 0x1A5A, 0x1A5B, 0x1A5C, 0x1A5D, 0x1A5E, 0x1A5F, 0x1A60, 0x1A61, 0x1A62, 0x1A63, 0x1A64, 0x1A65, 0x1A66,   // BEE0 - BEEF
	0x1A67, 0x1A68, 0x1A69, 0x1A6A, 0x1A6B, 0x1A6C, 0x1A6D, 0x1A6E, 0x1A6F, 0x1A70, 0x1A71, 0x1A72, 0x1A73, 0x1A74, 0x1A75, 0x1A76,   // BEF0 - BEFF
	0x1A77, 0x1A78, 0x1A79, 0x1A7A, 0x1A7B, 0x1A7C, 0x1A7D, 0x1A7E, 0x1A7F, 0x1A80, 0x1A81, 0x1A82, 0x1A83, 0x1A84, 0x1A85, 0x1A86,   // BF00 - BF0F
	0x1A87, 0x1A88, 0x1A89, 0x1A8A, 0x1A8B, 0x1A8C, 0x1A8D, 0x1A8E, 0x1A8F, 0x1A90, 0x1A91, 0x1A92, 0x1A93, 0x1A94, 0x1A95, 0x1A96,   // BF10 - BF1F
	0x1A97, 0x1A98, 0x1A99, 0x1A9A, 0x1A9B, 0x1A9C, 0x1A9D, 0x1A9E, 0x1A9F, 0x1AA0, 0x1AA1, 0x1AA2, 0x1AA3, 0x1AA4, 0x1AA5, 0x1AA6,   // BF20 - BF2F
	0x1AA7, 0x1AA8, 0x1AA9, 0x1AAA, 0x1AAB, 0x1AAC, 0x1AAD, 0x1AAE, 0x1AAF, 0x1AB0, 0x1AB1, 0x1AB2, 0x1AB3, 0x1AB4, 0x1AB5, 0x1AB6,   // BF30 - BF3F
	0x1AB7, 0x1AB8, 0x1AB9, 0x1ABA, 0x1ABB, 0x1ABC, 0x1ABD, 0x1ABE, 0x1ABF, 0x1AC0, 0x1AC1, 0x1AC2, 0x1AC3, 0x1AC4, 0x1AC5, 0x1AC6,   // BF40 - BF4F
	0x1AC7, 0x1AC8, 0x1AC9, 0x1ACA, 0x1ACB, 0x1ACC, 0x1ACD, 0x1ACE, 0x1ACF, 0x1AD0, 0x1AD1, 0x1AD2, 0x1AD3, 0x1AD4, 0x1AD5, 0x1AD6,   // BF50 - BF5F
	0x1AD7, 0x1AD8, 0x1AD9, 0x1ADA, 0x1ADB, 0x1ADC, 0x1ADD, 0x1ADE, 0x1ADF, 0x1AE0, 0x1AE1, 0x1AE2, 0x1AE3, 0x1AE4, 0x1AE5, 0x1AE6,   // BF60 - BF6F
	0x1AE7, 0x1AE8, 0x1AE9, 0x1AEA, 0x1AEB, 0x1AEC, 0x1AED, 0x1AEE, 0x1AEF, 0x1AF0, 0x1AF1, 0x1AF2, 0x1AF3, 0x1AF4, 0x1AF5, 0x1AF6,   // BF70 - BF7F
	0x1AF7, 0x1AF8, 0x1AF9, 0x1AFA, 0x1AFB, 0x1AFC, 0x1AFD, 0x1AFE, 0x1AFF, 0x1B00, 0x1B01, 0x1B02, 0x1B03, 0x1B04, 0x1B05, 0x1B06,   // BF80 - BF8F
	0x1B07, 0x1B08, 0x1B09, 0x1B0A, 0x1B0B, 0x1B0C, 0x1B0D, 0x1B0E, 0x1B0F, 0x1B10, 0x1B11, 0x1B12, 0x1B13, 0x1B14, 0x1B15, 0x1B16,   // BF90 - BF9F
	0x1B17, 0x1B18, 0x1B19, 0x1B1A, 0x1B1B, 0x1B1C, 0x1B1D, 0x1B1E, 0x1B1F, 0x1B20, 0x1B21, 0x1B22, 0x1B23, 0x1B24, 0x1B25, 0x1B26,   // BFA0 - BFAF
	0x1B27, 0x1B28, 0x1B29, 0x1B2A, 0x1B2B, 0x1B2C, 0x1B2D, 0x1B2E, 0x1B2F, 0x1B30, 0x1B31, 0x1B32, 0x1B33, 0x1B34, 0x1B35, 0x1B36,   // BFB0 - BFBF
	0x1B37, 0x1B38, 0x1B39, 0x1B3A, 0x1B3B, 0x1B3C, 0x1B3D, 0x1B3E, 0x1B3F, 0x1B40, 0x1B41, 0x1B42, 0x1B43, 0x1B44, 0x1B45, 0x1B46,   // BFC0 - BFCF
	0x1B47, 0x1B48, 0x1B49, 0x1B4A, 0x1B4B, 0x1B4C, 0x1B4D, 0x1B4E, 0x1B4F, 0x1B50, 0x1B51, 0x1B52, 0x1B53, 0x1B54, 0x1B55, 0x1B56,   // BFD0 - BFDF
	0x1B57, 0x1B58, 0x1B59, 0x1B5A, 0x1B5B, 0x1B5C, 0x1B5D, 0x1B5E, 0x1B5F, 0x1B60, 0x1B61, 0x1B62, 0x1B63, 0x1B64, 0x1B65, 0x1B66,   // BFE0 - BFEF
	0x1B67, 0x1B68, 0x1B69, 0x1B6A, 0x1B6B, 0x1B6C, 0x1B6D, 0x1B6E, 0x1B6F, 0x1B70, 0x1B71, 0x1B72, 0x1B73, 0x1B74, 0x1B75, 0x1B76,   // BFF0 - BFFF
	0x1B77, 0x1B78, 0x1B79, 0x1B7A, 0x1B7B, 0x1B7C, 0x1B7D, 0x1B7E, 0x1B7F, 0x1B80, 0x1B81, 0x1B82, 0x1B83, 0x1B84, 0x1B85, 0x1B86,   // C000 - C00F
	0x1B87, 0x1B88, 0x1B89, 0x1B8A, 0x1B8B, 0x1B8C, 0x1B8D, 0x1B8E, 0x1B8F, 0x1B90, 0x1B91, 0x1B92, 0x1B93, 0x1B94, 0x1B95, 0x1B96,   // C010 - C01F
	0x1B97, 0x1B98, 0x1B99, 0x1B9A, 0x1B9B, 0x1B9C, 0x1B9D, 0x1B9E, 0x1B9F, 0x1BA0, 0x1BA1, 0x1BA2, 0x1BA3, 0x1BA4, 0x1BA5, 0x1BA6,   // C020 - C02F
	0x1BA7, 0x1BA8, 0x1BA9, 0x1BAA, 0x1BAB, 0x1BAC, 0x1BAD, 0x1BAE, 0x1BAF, 0x1BB0, 0x1BB1, 0x1BB2, 0x1BB3, 0x1BB4, 0x1BB5, 0x1BB6,   // C030 - C03F
	0x1BB7, 0x1BB8, 0x1BB9, 0x1BBA, 0x1BBB, 0x1BBC, 0x1BBD, 0x1BBE, 0x1BBF, 0x1BC0, 0x1BC1, 0x1BC2, 0x1BC3, 0x1BC4, 0x1BC5, 0x1BC6,   // C040 - C04F
	0x1BC7, 0x1BC8, 0x1BC9, 0x1BCA, 0x1BCB, 0x1BCC, 0x1BCD, 0x1BCE, 0x1BCF, 0x1BD0, 0x1BD1, 0x1BD2, 0x1BD3, 0x1BD4, 0x1BD5, 0x1BD6,   // C050 - C05F
	0x1BD7, 0x1BD8, 0x1BD9, 0x1BDA, 0x1BDB, 0x1BDC, 0x1BDD, 0x1BDE, 0x1BDF, 0x1BE0, 0x1BE1, 0x1BE2, 0x1BE3, 0x1BE4, 0x1BE5, 0x1BE6,   // C060 - C06F
	0x1BE7, 0x1BE8, 0x1BE9, 0x1BEA, 0x1BEB, 0x1BEC, 0x1BED, 0x1BEE, 0x1BEF, 0x1BF0, 0x1BF1, 0x1BF2, 0x1BF3, 0x1BF4, 0x1BF5, 0x1BF6,   // C070 - C07F
	0x1BF7, 0x1BF8, 0x1BF9, 0x1BFA, 0x1BFB, 0x1BFC, 0x1BFD, 0x1BFE, 0x1BFF, 0x1C00, 0x1C01, 0x1C02, 0x1C03, 0x1C04, 0x1C05, 0x1C06,   // C080 - C08F
	0x1C07, 0x1C08, 0x1C09, 0x1C0A, 0x1C0B, 0x1C0C, 0x1C0D, 0x1C0E, 0x1C0F, 0x1C10, 0x1C11, 0x1C12, 0x1C13, 0x1C14, 0x1C15, 0x1C16,   // C090 - C09F
	0x1C17, 0x1C18, 0x1C19, 0x1C1A, 0x1C1B, 0x1C1C, 0x1C1D, 0x1C1E, 0x1C1F, 0x1C20, 0x1C21, 0x1C22, 0x1C23, 0x1C60, 0x1C65, 0x1C66,   // C0A0 - C0AF
	0x1C67, 0x1C74, 0x1C75, 0x1C76, 0x1C77, 0x1C7D, 0x1C7E, 0x1C7F, 0x1C80, 0x1C81, 0x1C82, 0x1C83, 0x1C84, 0x1C8D, 0x1C92, 0x1C93,   // C0B0 - C0BF
	0x1C94, 0x1C95, 0x1CB5, 0x1CB6, 0x1CB7, 0x1CB8, 0x1CB9, 0x1CBA, 0x1CBB, 0x1CBF, 0x1CC5, 0x1CC6, 0x1CC7, 0x1CC8, 0x1CC9, 0x1CCA,   // C0C0 - C0CF
	0x1CCB, 0x1CCC, 0x1CCD, 0x1CCE, 0x1CCF, 0x1CD0, 0x1CD1, 0x1CD2, 0x1CD3, 0x1CD4, 0x1CD5, 0x1CD6, 0x1CD7, 0x1CD8, 0x1CDE, 0x1CDF,   // C0D0 - C0DF
	0x1CE0, 0x1CE1, 0x1CE2, 0x1CE3, 0x1CE4, 0x1CE5, 0x1CE6, 0x1CE7, 0x1CE8, 0x1CE9, 0x1CEA, 0x1CEB, 0x1CEC, 0x1CED, 0x1CEE, 0x1CEF,   // C0E0 - C0EF
	0x1CF0, 0x1CF1, 0x1CF2, 0x1CF3, 0x1CF4, 0x1CF5, 0x1CF6, 0x1CF7, 0x1CF8, 0x1CF9, 0x1CFA, 0x1CFB, 0x1CFC, 0x1CFD, 0x1CFE, 0x1CFF,   // C0F0 - C0FF
	0x1D00, 0x1D01, 0x1D02, 0x1D03, 0x1D04, 0x1D05, 0x1D06, 0x1D07, 0x1D08, 0x1D09, 0x1D0A, 0x1D0B, 0x1D0C, 0x1D0D, 0x1D0E, 0x1D0F,   // C100 - C10F
	0x1D10, 0x1D11, 0x1D12, 0x1D13, 0x1D14, 0x1D15, 0x1D16, 0x1D17, 0x1D18, 0x1D19, 0x1D1A, 0x1D1B, 0x1D1C, 0x1D3B, 0x1D4B, 0x1D4C,   // C110 - C11F
	0x1D4D, 0x1D6E, 0x1D6F, 0x1D70, 0x1D71, 0x1D7F, 0x1D80, 0x1D81, 0x1D82, 0x1D83, 0x1D84, 0x1D85, 0x1D86, 0x1D8F, 0x1D94, 0x1D95,   // C120 - C12F
	0x1D96, 0x1D97, 0x1DAA, 0x1DAB, 0x1DAC, 0x1DAD, 0x1DAE, 0x1DAF, 0x1DB0, 0x1DBA, 0x1DBB, 0x1DBC, 0x1DBD, 0x1DBE, 0x1DBF, 0x1DC0,   // C130 - C13F
	0x1DC1, 0x1DC2, 0x1DC3, 0x1DC4, 0x1DC5, 0x1DC6, 0x1DC7, 0x1DC8, 0x1DC9, 0x1DCA, 0x1DCB, 0x1DCC, 0x1DCD, 0x1DCE, 0x1DCF, 0x1DD0,   // C140 - C14F
	0x1DD1, 0x1DD2, 0x1DD3, 0x1DD4, 0x1DD5, 0x1DD6, 0x1DD7, 0x1DD8, 0x1DD9, 0x1DDA, 0x1DDB, 0x1DDC, 0x1DDD, 0x1DDE, 0x1DDF, 0x1DE0,   // C150 - C15F
	0x1DE1, 0x1DE2, 0x1DE3, 0x1DE4, 0x1DE5, 0x1DE6, 0x1DE7, 0x1DE8, 0x1DE9, 0x1DEA, 0x1DEB, 0x1DEC, 0x1DED, 0x1DEE, 0x1DEF, 0x1DF0,   // C160 - C16F
	0x1DF1, 0x1DF2, 0x1DF3, 0x1DF4, 0x1DF5, 0x1DF6, 0x1DF7, 0x1DF8, 0x1DF9, 0x1DFA, 0x1DFB, 0x1DFC, 0x1DFD, 0x1DFE, 0x1DFF, 0x1E00,   // C170 - C17F
	0x1E01, 0x1E02, 0x1E03, 0x1E04, 0x1E05, 0x1E06, 0x1E07, 0x1E08, 0x1E09, 0x1E0A, 0x1E0B, 0x1E0C, 0x1E0D, 0x1E33, 0x1E3D, 0x1E3E,   // C180 - C18F
	0x1E3F, 0x1E46, 0x1E47, 0x1E48, 0x1E49, 0x1E4B, 0x1E4C, 0x1E4D, 0x1E4E, 0x1E4F, 0x1E50, 0x1E51, 0x1E52, 0x1E53, 0x1E54, 0x1E55,   // C190 - C19F
	0x1E56, 0x1E57, 0x1E60, 0x1E61, 0x1E62, 0x1E63, 0x1E64, 0x1E65, 0x1E66, 0x1E67, 0x1E68, 0x1E69, 0x1E6A, 0x1E6B, 0x1E6C, 0x1E6D,   // C1A0 - C1AF
	0x1E6E, 0x1E6F, 0x1E70, 0x1E71, 0x1E72, 0x1E73, 0x1E74, 0x1E75, 0x1E76, 0x1E77, 0x1E78, 0x1E79, 0x1E7A, 0x1E7B, 0x1E7C, 0x1E7D,   // C1B0 - C1BF
	0x1E7E, 0x1E7F, 0x1E80, 0x1E81, 0x1E82, 0x1E88, 0x1E89, 0x1E8A, 0x1E8B, 0x1E8C, 0x1E8D, 0x1E8E, 0x1E8F, 0x1E90, 0x1E91, 0x1E92,   // C1C0 - C1CF
	0x1E93, 0x1E94, 0x1E95, 0x1E96, 0x1E97, 0x1E98, 0x1E99, 0x1E9A, 0x1E9B, 0x1E9C, 0x1E9D, 0x1E9E, 0x1E9F, 0x1EA0, 0x1EA1, 0x1EA2,   // C1D0 - C1DF
	0x1EA3, 0x1EA6, 0x1EA7, 0x1EA8, 0x1EA9, 0x1EAA, 0x1EAB, 0x1EAC, 0x1EAD, 0x1EAE, 0x1EAF, 0x1EB0, 0x1EB1, 0x1EB2, 0x1EB3, 0x1EB4,   // C1E0 - C1EF
	0x1EB5, 0x1EB6, 0x1EB7, 0x1EB8, 0x1EB9, 0x1EBA, 0x1EBB, 0x1EBC, 0x1EBD, 0x1EBE, 0x1EBF, 0x1EC0, 0x1EC1, 0x1EC2, 0x1EC3, 0x1EC4,   // C1F0 - C1FF
	0x1EC5, 0x1EC6, 0x1EC7, 0x1EC8, 0x1EC9, 0x1ECA, 0x1ECB, 0x1ECC, 0x1ECD, 0x1ECE, 0x1ECF, 0x1ED0, 0x1ED1, 0x1ED2, 0x1ED3, 0x1ED4,   // C200 - C20F
	0x1ED5, 0x1ED6, 0x1ED7, 0x1ED8, 0x1ED9, 0x1EDA, 0x1EDB, 0x1EDC, 0x1EDD, 0x1F1B, 0x1F28, 0x1F29, 0x1F2A, 0x1F46, 0x1F47, 0x1F48,   // C210 - C21F
	0x1F49, 0x1F4E, 0x1F4F, 0x1F50, 0x1F51, 0x1F52, 0x1F53, 0x1F54, 0x1F55, 0x1F56, 0x1F57, 0x1F58, 0x1F59, 0x1F5A, 0x1F5E, 0x1F5F,   // C220 - C22F
	0x1F60, 0x1F61, 0x1F62, 0x1F63, 0x1F64, 0x1F65, 0x1F66, 0x1F67, 0x1F68, 0x1F69, 0x1F6A, 0x1F6B, 0x1F6C, 0x1F6D, 0x1F6E, 0x1F6F,   // C230 - C23F
	0x1F70, 0x1F71, 0x1F72, 0x1F73, 0x1F74, 0x1F75, 0x1F76, 0x1F77, 0x1F78, 0x1F79, 0x1F7A, 0x1F7B, 0x1F7C, 0x1F7D, 0x1F7E, 0x1F7F,   // C240 - C24F
	0x1F80, 0x1F81, 0x1F82, 0x1F83, 0x1F84, 0x1F85, 0x1F86, 0x1F87, 0x1F88, 0x1F89, 0x1F8A, 0x1F8B, 0x1F8C, 0x1F8D, 0x1F8E, 0x1F8F,   // C250 - C25F
	0x1F90, 0x1F91, 0x1F92, 0x1F93, 0x1F94, 0x1F95, 0x1F96, 0x1F97, 0x1F98, 0x1F99, 0x1F9A, 0x1F9B, 0x1F9C, 0x1F9D, 0x1F9E, 0x1F9F,   // C260 - C26F
	0x1FA0, 0x1FA1, 0x1FA2, 0x1FA3, 0x1FA4, 0x1FA5, 0x1FA6, 0x1FA7, 0x1FA8, 0x1FA9, 0x1FAA, 0x1FAB, 0x1FAC, 0x1FAD, 0x1FAE, 0x1FAF,   // C270 - C27F
	0x1FB0, 0x1FB1, 0x1FB2, 0x1FB3, 0x1FB4, 0x1FB5, 0x1FB6, 0x1FB7, 0x1FB8, 0x1FB9, 0x1FBA, 0x1FBB, 0x1FBC, 0x1FBD, 0x1FBE, 0x1FBF,   // C280 - C28F
	0x1FC0, 0x1FC1, 0x1FC2, 0x1FC3, 0x1FC4, 0x1FC5, 0x1FC6, 0x1FC7, 0x1FC8, 0x1FC9, 0x1FCA, 0x1FCB, 0x1FCC, 0x1FCD, 0x1FCE, 0x1FCF,   // C290 - C29F
	0x1FD0, 0x1FD1, 0x1FD2, 0x1FD3, 0x1FD4, 0x1FD5, 0x1FD6, 0x1FD7, 0x1FD8, 0x1FD9, 0x1FDA, 0x1FDB, 0x1FDC, 0x1FE0, 0x1FE1, 0x1FE2,   // C2A0 - C2AF
	0x1FE3, 0x1FE4, 0x1FE5, 0x1FE6, 0x1FE7, 0x1FE8, 0x1FEE, 0x1FEF, 0x1FF0, 0x1FF1, 0x1FFC, 0x1FFD, 0x1FFE, 0x1FFF, 0x2000, 0x2001,   // C2B0 - C2BF
	0x2002, 0x2003, 0x2004, 0x2005, 0x2006, 0x2007, 0x2008, 0x2009, 0x200A, 0x200B, 0x200C, 0x200D, 0x200E, 0x200F, 0x2010, 0x2011,   // C2C0 - C2CF
	0x2012, 0x2013, 0x2014, 0x2015, 0x2016, 0x2017, 0x2018, 0x2019, 0x201A, 0x201B, 0x201C, 0x201D, 0x201E, 0x203B, 0x204B, 0x204C,   // C2D0 - C2DF
	0x204D, 0x2066, 0x2067, 0x2068, 0x2069, 0x206E, 0x206F, 0x2070, 0x2071, 0x2072, 0x2073, 0x2074, 0x2075, 0x2080, 0x2084, 0x2085,   // C2E0 - C2EF
	0x2086, 0x2087, 0x2088, 0x2089, 0x208A, 0x208B, 0x208C, 0x208D, 0x208E, 0x208F, 0x2090, 0x2091, 0x2092, 0x2093, 0x2094, 0x2095,   // C2F0 - C2FF
	0x2096, 0x2097, 0x2098, 0x2099, 0x209A, 0x209B, 0x209C, 0x209D, 0x209E, 0x209F, 0x20A0, 0x20A1, 0x20A2, 0x20A3, 0x20A5, 0x20A6,   // C300 - C30F
	0x20A7, 0x20A8, 0x20A9, 0x20AA, 0x20AB, 0x20AC, 0x20AD, 0x20AE, 0x20AF, 0x20B0, 0x20B1, 0x20B2, 0x20B3, 0x20B4, 0x20B5, 0x20B6,   // C310 - C31F
	0x20B7, 0x20B8, 0x20B9, 0x20BA, 0x20BB, 0x20BC, 0x20BD, 0x20BE, 0x20BF, 0x20C0, 0x20C1, 0x20C2, 0x20C3, 0x20C4, 0x20C5, 0x20C6,   // C320 - C32F
	0x20C7, 0x20C8, 0x20C9, 0x20CA, 0x20CB, 0x20CC, 0x20CD, 0x20CE, 0x20CF, 0x20D0, 0x20D1, 0x20D2, 0x20D3, 0x20D4, 0x20D5, 0x20D6,   // C330 - C33F
	0x20D7, 0x20D8, 0x20D9, 0x20DA, 0x20DB, 0x20DC, 0x20DD, 0x20DE, 0x20DF, 0x20E0, 0x20E1, 0x20E2, 0x20E3, 0x20E4, 0x20E5, 0x20E6,   // C340 - C34F
	0x20E7, 0x20E8, 0x20E9, 0x20EA, 0x20EB, 0x20EC, 0x20ED, 0x20EE, 0x20EF, 0x20F0, 0x20F1, 0x20F2, 0x20F3, 0x20F4, 0x20F5, 0x20F6,   // C350 - C35F
	0x20F7, 0x20F8, 0x20F9, 0x20FA, 0x20FB, 0x20FC, 0x20FD, 0x20FE, 0x20FF, 0x2100, 0x2101, 0x2102, 0x2103, 0x2104, 0x2105, 0x2106,   // C360 - C36F
	0x2107, 0x2108, 0x2109, 0x210A, 0x210B, 0x210C, 0x210D, 0x210E, 0x210F, 0x2110, 0x2111, 0x2112, 0x2113, 0x2114, 0x2115, 0x2116,   // C370 - C37F
	0x2117, 0x2118, 0x2119, 0x211A, 0x211B, 0x211C, 0x211D, 0x211E, 0x211F, 0x2120, 0x2121, 0x2122, 0x2123, 0x2124, 0x2125, 0x2126,   // C380 - C38F
	0x2127, 0x2128, 0x2129, 0x212A, 0x212B, 0x212C, 0x212D, 0x212E, 0x212F, 0x2130, 0x2131, 0x2132, 0x2133, 0x2134, 0x2135, 0x2136,   // C390 - C39F
	0x2137, 0x2138, 0x2139, 0x213A, 0x213B, 0x213C, 0x213D, 0x213E, 0x213F, 0x2140, 0x2141, 0x2142, 0x2143, 0x2144, 0x2145, 0x2146,   // C3A0 - C3AF
	0x2147, 0x2148, 0x2149, 0x214A, 0x214B, 0x214C, 0x214D, 0x214E, 0x214F, 0x2150, 0x2151, 0x2152, 0x2153, 0x2154, 0x2155, 0x2156,   // C3B0 - C3BF
	0x2157, 0x2158, 0x2159, 0x215A, 0x215B, 0x215C, 0x215D, 0x215E, 0x215F, 0x2160, 0x2161, 0x2162, 0x2163, 0x2164, 0x2165, 0x2166,   // C3C0 - C3CF
	0x2167, 0x2168, 0x2169, 0x216A, 0x216B, 0x216C, 0x216D, 0x216E, 0x216F, 0x2170, 0x2171, 0x2172, 0x2173, 0x2174, 0x2175, 0x2176,   // C3D0 - C3DF
	0x2177, 0x2178, 0x2179, 0x217A, 0x217B, 0x217C, 0x217D, 0x217E, 0x217F, 0x2180, 0x2181, 0x2182, 0x2183, 0x2184, 0x2185, 0x2186,   // C3E0 - C3EF
	0x2187, 0x2188, 0x2189, 0x218A, 0x218B, 0x218C, 0x218D, 0x218E, 0x218F, 0x2190, 0x2191, 0x2192, 0x2193, 0x2194, 0x2195, 0x2196,   // C3F0 - C3FF
	0x2197, 0x2198, 0x2199, 0x219A, 0x219B, 0x219C, 0x219D, 0x219E, 0x219F, 0x21A0, 0x21A1, 0x21A2, 0x21A3, 0x21A4, 0x21A5, 0x21A6,   // C400 - C40F
	0x21A7, 0x21A8, 0x21A9, 0x21AA, 0x21AB, 0x21AC, 0x21AD, 0x21AE, 0x21AF, 0x21B0, 0x21B1, 0x21B2, 0x21B3, 0x21B4, 0x21B5, 0x21B6,   // C410 - C41F
	0x21B7, 0x21B8, 0x21B9, 0x21BA, 0x21BB, 0x21BC, 0x21BD, 0x21BE, 0x21BF, 0x21C0, 0x21C1, 0x21C2, 0x21C3, 0x21C4, 0x21C5, 0x21C6,   // C420 - C42F
	0x21C7, 0x21C8, 0x21C9, 0x21CA, 0x21CB, 0x21CC, 0x21CD, 0x21CE, 0x21CF, 0x21D0, 0x21D1, 0x21D2, 0x21D3, 0x21D4, 0x21D5, 0x21D6,   // C430 - C43F
	0x21D7, 0x21D8, 0x21D9, 0x21DA, 0x21DB, 0x21DC, 0x21DD, 0x21DE, 0x21DF, 0x21E0, 0x21E1, 0x21E2, 0x21E3, 0x21E4, 0x21E5, 0x21E6,   // C440 - C44F
	0x21E7, 0x21E8, 0x21E9, 0x21EA, 0x21EB, 0x21EC, 0x21ED, 0x21EE, 0x21EF, 0x21F0, 0x21F1, 0x21F2, 0x21F3, 0x21F4, 0x21F5, 0x21F6,   // C450 - C45F
	0x21F7, 0x21F8, 0x21F9, 0x21FA, 0x21FB, 0x21FC, 0x21FD, 0x21FE, 0x21FF, 0x2200, 0x2201, 0x2202, 0x2203, 0x2204, 0x2205, 0x2206,   // C460 - C46F
	0x2207, 0x2208, 0x2209, 0x220A, 0x220B, 0x220C, 0x220D, 0x220E, 0x220F, 0x2210, 0x2211, 0x2212, 0x2213, 0x2214, 0x2215, 0x2216,   // C470 - C47F
	0x2217, 0x2218, 0x2219, 0x221A, 0x221B, 0x221C, 0x221D, 0x221E, 0x221F, 0x2220, 0x2221, 0x2222, 0x2223, 0x2224, 0x2225, 0x2226,   // C480 - C48F
	0x2227, 0x2228, 0x2229, 0x222A, 0x222B, 0x222C, 0x222D, 0x222E, 0x222F, 0x2230, 0x2231, 0x2232, 0x2233, 0x2234, 0x2235, 0x2236,   // C490 - C49F
	0x2237, 0x2238, 0x2239, 0x223A, 0x223B, 0x223C, 0x223D, 0x223E, 0x223F, 0x2240, 0x2241, 0x2242, 0x2243, 0x2244, 0x2245, 0x2246,   // C4A0 - C4AF
	0x2247, 0x2248, 0x2249, 0x224A, 0x224B, 0x224C, 0x224D, 0x224E, 0x224F, 0x2250, 0x2251, 0x2252, 0x2253, 0x2254, 0x2255, 0x2256,   // C4B0 - C4BF
	0x2257, 0x2258, 0x2259, 0x225A, 0x225B, 0x225C, 0x225D, 0x225E, 0x225F, 0x2260, 0x2261, 0x2262, 0x2263, 0x2264, 0x2265, 0x2266,   // C4C0 - C4CF
	0x2267, 0x2268, 0x2269, 0x226A, 0x226B, 0x226C, 0x226D, 0x226E, 0x226F, 0x2270, 0x2271, 0x2272, 0x2273, 0x2274, 0x2275, 0x2276,   // C4D0 - C4DF
	0x2277, 0x2278, 0x2279, 0x227A, 0x227B, 0x227C, 0x227D, 0x227E, 0x227F, 0x2280, 0x2281, 0x2282, 0x2283, 0x2284, 0x2285, 0x2286,   // C4E0 - C4EF
	0x2287, 0x2288, 0x2289, 0x228A, 0x228B, 0x228C, 0x228D, 0x228E, 0x228F, 0x2290, 0x2291, 0x2292, 0x2293, 0x2294, 0x2295, 0x2296,   // C4F0 - C4FF
	0x2297, 0x2298, 0x2299, 0x229A, 0x229B, 0x229C, 0x229D, 0x229E, 0x229F, 0x22A0, 0x22A1, 0x22A2, 0x22A3, 0x22A4, 0x22A5, 0x22A6,   // C500 - C50F
	0x22A7, 0x22A8, 0x22A9, 0x22AA, 0x22AB, 0x22AC, 0x22AD, 0x22AE, 0x22AF, 0x22B0, 0x22B1, 0x22B2, 0x22B3, 0x22B4, 0x22B5, 0x22B6,   // C510 - C51F
	0x22B7, 0x22B8, 0x22B9, 0x22BA, 0x22BB, 0x22BC, 0x22BD, 0x22BE, 0x22BF, 0x22C1, 0x22C2, 0x22C3, 0x22C4, 0x22C5, 0x22C6, 0x22C7,   // C520 - C52F
	0x22C8, 0x22C9, 0x22CA, 0x22CB, 0x22CC, 0x22CD, 0x22CE, 0x22CF, 0x22D0, 0x22D1, 0x22D2, 0x22D3, 0x22D4, 0x22D5, 0x22D6, 0x22D7,   // C530 - C53F
	0x22D8, 0x22D9, 0x22DA, 0x22DB, 0x22DC, 0x22EF, 0x22FE, 0x22FF, 0x2300, 0x230B, 0x230C, 0x230D, 0x230E, 0x2313, 0x2314, 0x2315,   // C540 - C54F
	0x2316, 0x2317, 0x2318, 0x2319, 0x231A, 0x2323, 0x2328, 0x2329, 0x232A, 0x232B, 0x2333, 0x2334, 0x2335, 0x2336, 0x2337, 0x2338,   // C550 - C55F
	0x2339, 0x2345, 0x234D, 0x234E, 0x234F, 0x2350, 0x2351, 0x2352, 0x2353, 0x2354, 0x2355, 0x2356, 0x2357, 0x2358, 0x2359, 0x235A,   // C560 - C56F
	0x235B, 0x235C, 0x235D, 0x235E, 0x235F, 0x2360, 0x2365, 0x2366, 0x2367, 0x2368, 0x2369, 0x236A, 0x236B, 0x2377, 0x2381, 0x2382,   // C570 - C57F
	0x2383, 0x2384, 0x2385, 0x2386, 0x2387, 0x2388, 0x2389, 0x238A, 0x238B, 0x238C, 0x238D, 0x238E, 0x238F, 0x2390, 0x2391, 0x2392,   // C580 - C58F
	0x2393, 0x2394, 0x23B4, 0x23B5, 0x23B6, 0x23B7, 0x23B8, 0x23B9, 0x23BA, 0x23BB, 0x23BC, 0x23BD, 0x23BE, 0x23BF, 0x23C0, 0x23C1,   // C590 - C59F
	0x23C2, 0x23C3, 0x23C4, 0x23C5, 0x23C6, 0x23C7, 0x23C8, 0x23C9, 0x23CA, 0x23CB, 0x23CC, 0x23CD, 0x23CE, 0x23CF, 0x23D0, 0x23D1,   // C5A0 - C5AF
	0x23D2, 0x23D3, 0x23D4, 0x23D5, 0x23D6, 0x23E1, 0x23E7, 0x23E8, 0x23E9, 0x23F0, 0x23F1, 0x23F2, 0x23F3, 0x23F6, 0x23F7, 0x23F8,   // C5B0 - C5BF
	0x23F9, 0x23FA, 0x23FB, 0x23FC, 0x23FD, 0x2404, 0x2407, 0x2408, 0x2409, 0x240A, 0x240B, 0x240C, 0x240D, 0x240E, 0x240F, 0x2410,   // C5C0 - C5CF
	0x2411, 0x2412, 0x2413, 0x2414, 0x2415, 0x2417, 0x2418, 0x2419, 0x241A, 0x241B, 0x241C, 0x241D, 0x241E, 0x241F, 0x2420, 0x2421,   // C5D0 - C5DF
	0x2422, 0x2423, 0x2424, 0x2425, 0x2426, 0x2427, 0x2428, 0x2429, 0x242A, 0x242B, 0x242C, 0x242D, 0x242E, 0x2447, 0x2455, 0x2456,   // C5E0 - C5EF
	0x2457, 0x2483, 0x2484, 0x2485, 0x2486, 0x2491, 0x2492, 0x2493, 0x2494, 0x2495, 0x2496, 0x2497, 0x2498, 0x24A8, 0x24AD, 0x24AE,   // C5F0 - C5FF
	0x24AF, 0x24B0, 0x24D9, 0x24DA, 0x24DB, 0x24DC, 0x24DD, 0x24DE, 0x24DF, 0x24F8, 0x24F9, 0x24FA, 0x24FB, 0x24FC, 0x24FD, 0x24FE,   // C600 - C60F
	0x24FF, 0x2500, 0x2501, 0x2502, 0x2503, 0x2504, 0x2505, 0x2506, 0x2507, 0x2508, 0x2509, 0x250A, 0x250B, 0x250C, 0x250D, 0x250E,   // C610 - C61F
	0x250F, 0x2510, 0x2511, 0x2512, 0x2513, 0x2532, 0x2538, 0x2539, 0x253A, 0x2541, 0x2542, 0x2543, 0x2544, 0x2546, 0x2547, 0x2548,   // C620 - C62F
	0x2549, 0x254A, 0x254B, 0x254C, 0x254D, 0x254E, 0x254F, 0x2550, 0x2551, 0x2552, 0x255C, 0x255D, 0x255E, 0x255F, 0x2560, 0x2561,   // C630 - C63F
	0x2562, 0x256B, 0x256C, 0x256D, 0x256E, 0x2581, 0x2582, 0x2583, 0x2584, 0x2586, 0x2587, 0x2588, 0x2589, 0x258A, 0x258B, 0x258C,   // C640 - C64F
	0x258D, 0x258E, 0x258F, 0x2590, 0x2591, 0x2592, 0x2598, 0x2599, 0x259A, 0x259B, 0x259C, 0x259D, 0x259E, 0x25A3, 0x25A4, 0x25A5,   // C650 - C65F
	0x25A6, 0x25A7, 0x25A8, 0x25A9, 0x25AA, 0x25AB, 0x25AC, 0x25AD, 0x25AE, 0x25AF, 0x25B0, 0x25B1, 0x25B2, 0x25B3, 0x25B4, 0x25B5,   // C660 - C66F
	0x25B6, 0x25B7, 0x25B8, 0x25B9, 0x25BA, 0x25BB, 0x25BC, 0x25BD, 0x25BE, 0x25C4, 0x25C5, 0x25C6, 0x25C7, 0x25C8, 0x25C9, 0x25CA,   // C670 - C67F
	0x25CB, 0x25CC, 0x25CD, 0x25CE, 0x25CF, 0x25D0, 0x25D1, 0x25D2, 0x25D3, 0x25D4, 0x25D5, 0x25D6, 0x25D7, 0x25D8, 0x25D9, 0x25DA,   // C680 - C68F
	0x25DB, 0x25DC, 0x25DD, 0x25DE, 0x25DF, 0x2606, 0x260D, 0x260E, 0x260F, 0x2610, 0x2611, 0x2612, 0x2613, 0x2614, 0x2615, 0x2616,   // C690 - C69F
	0x2617, 0x2618, 0x2619, 0x261A, 0x261B, 0x261C, 0x261D, 0x261E, 0x261F, 0x2620, 0x2639, 0x263A, 0x263B, 0x263C, 0x263D, 0x263E,   // C6A0 - C6AF
	0x263F, 0x2660, 0x266A, 0x266B, 0x266C, 0x267A, 0x267B, 0x267C, 0x267D, 0x2681, 0x2682, 0x2683, 0x2684, 0x2685, 0x2686, 0x2687,   // C6B0 - C6BF
	0x2688, 0x2689, 0x268A, 0x268B, 0x268C, 0x268D, 0x2690, 0x2691, 0x2692, 0x2693, 0x2694, 0x2695, 0x2696, 0x2697, 0x2698, 0x2699,   // C6C0 - C6CF
	0x269A, 0x26B6, 0x26B7, 0x26B8, 0x26B9, 0x26BD, 0x26BE, 0x26BF, 0x26C0, 0x26C1, 0x26C2, 0x26C3, 0x26C4, 0x26C5, 0x26C6, 0x26C7,   // C6D0 - C6DF
	0x26C8, 0x26C9, 0x26CA, 0x26CB, 0x26CC, 0x26CD, 0x26CE, 0x26CF, 0x26D0, 0x26D1, 0x26D2, 0x26D3, 0x26D4, 0x26D5, 0x26D6, 0x26D7,   // C6E0 - C6EF
	0x26D8, 0x26D9, 0x26DA, 0x26DB, 0x26DC, 0x26DD, 0x26DE, 0x26DF, 0x26E0, 0x26E1, 0x26E2, 0x26E3, 0x26E4, 0x26E5, 0x26E6, 0x26E7,   // C6F0 - C6FF
	0x26E8, 0x26E9, 0x26EA, 0x26EB, 0x26EC, 0x2706, 0x2707, 0x2708, 0x2709, 0x270A, 0x270B, 0x270C, 0x270D, 0x270E, 0x270F, 0x2710,   // C700 - C70F
	0x2711, 0x2712, 0x2713, 0x2714, 0x2715, 0x2716, 0x2717, 0x2718, 0x2719, 0x271A, 0x271B, 0x271C, 0x271D, 0x271E, 0x271F, 0x2720,   // C710 - C71F
	0x2721, 0x275A, 0x2762, 0x2763, 0x2764, 0x2772, 0x2773, 0x2774, 0x2775, 0x277B, 0x277C, 0x277D, 0x277E, 0x277F, 0x2780, 0x2781,   // C720 - C72F
	0x2782, 0x2783, 0x2784, 0x2785, 0x2786, 0x2787, 0x278D, 0x278E, 0x278F, 0x2790, 0x2791, 0x2792, 0x2793, 0x2794, 0x2795, 0x2796,   // C730 - C73F
	0x2797, 0x279F, 0x27A0, 0x27A1, 0x27A2, 0x27A4, 0x27A5, 0x27A6, 0x27A7, 0x27A8, 0x27A9, 0x27AA, 0x27AB, 0x27B2, 0x27B6, 0x27B7,   // C740 - C74F
	0x27B8, 0x27B9, 0x27BE, 0x27BF, 0x27C0, 0x27C1, 0x27C2, 0x27C3, 0x27C4, 0x27D8, 0x27D9, 0x27DA, 0x27DB, 0x27DC, 0x27DD, 0x27DE,   // C750 - C75F
	0x27DF, 0x27E0, 0x27E1, 0x27E2, 0x27E3, 0x27E4, 0x27E5, 0x27E6, 0x27E7, 0x27E8, 0x27E9, 0x27EA, 0x27EB, 0x27EC, 0x27ED, 0x27EE,   // C760 - C76F
	0x27EF, 0x27F0, 0x27F1, 0x27F2, 0x27F3, 0x281A, 0x2823, 0x2824, 0x2825, 0x283E, 0x283F, 0x2840, 0x2841, 0x284B, 0x284C, 0x284D,   // C770 - C77F
	0x284E, 0x284F, 0x2850, 0x2851, 0x2852, 0x285E, 0x2864, 0x2865, 0x2866, 0x2867, 0x286C, 0x286D, 0x286E, 0x286F, 0x2870, 0x2871,   // C780 - C78F
	0x2872, 0x288D, 0x289B, 0x289C, 0x289D, 0x28A3, 0x28A4, 0x28A5, 0x28A6, 0x28A7, 0x28A8, 0x28A9, 0x28AA, 0x28AB, 0x28AC, 0x28AD,   // C790 - C79F
	0x28AE, 0x28B5, 0x28B7, 0x28B8, 0x28B9, 0x28BA, 0x28E0, 0x28E1, 0x28E2, 0x28E3, 0x28E4, 0x28E5, 0x28E6, 0x28F8, 0x28F9, 0x28FA,   // C7A0 - C7AF
	0x28FB, 0x28FC, 0x28FD, 0x28FE, 0x28FF, 0x2900, 0x2901, 0x2902, 0x2903, 0x2904, 0x2905, 0x2906, 0x2907, 0x2908, 0x2909, 0x290A,   // C7B0 - C7BF
	0x290B, 0x290C, 0x2911, 0x2912, 0x2913, 0x2914, 0x2915, 0x2916, 0x2917, 0x2918, 0x2919, 0x291A, 0x291B, 0x291C, 0x291D, 0x291E,   // C7C0 - C7CF
	0x291F, 0x2920, 0x2921, 0x2922, 0x2923, 0x2924, 0x2925, 0x2926, 0x2927, 0x2928, 0x2929, 0x292A, 0x292B, 0x292C, 0x292D, 0x292E,   // C7D0 - C7DF
	0x292F, 0x2930, 0x2931, 0x2932, 0x2933, 0x2934, 0x2935, 0x2936, 0x2937, 0x2938, 0x2939, 0x293A, 0x293B, 0x293C, 0x293D, 0x293E,   // C7E0 - C7EF
	0x293F, 0x2940, 0x2941, 0x2942, 0x2943, 0x2944, 0x2945, 0x2946, 0x2947, 0x2948, 0x2949, 0x294A, 0x294B, 0x294C, 0x294D, 0x294E,   // C7F0 - C7FF
	0x294F, 0x296C, 0x2986, 0x2987, 0x2988, 0x29B2, 0x29B3, 0x29B4, 0x29B5, 0x29BE, 0x29BF, 0x29C0, 0x29C1, 0x29C2, 0x29C3, 0x29C4,   // C800 - C80F
	0x29C5, 0x29CF, 0x29D3, 0x29D4, 0x29D5, 0x29D6, 0x2A0E, 0x2A0F, 0x2A10, 0x2A11, 0x2A12, 0x2A13, 0x2A14, 0x2A2C, 0x2A2D, 0x2A2E,   // C810 - C81F
	0x2A2F, 0x2A30, 0x2A31, 0x2A32, 0x2A33, 0x2A34, 0x2A35, 0x2A36, 0x2A37, 0x2A38, 0x2A39, 0x2A3A, 0x2A3B, 0x2A3C, 0x2A3D, 0x2A3E,   // C820 - C82F
	0x2A3F, 0x2A40, 0x2A41, 0x2A42, 0x2A43, 0x2A44, 0x2A45, 0x2A46, 0x2A47, 0x2A48, 0x2A49, 0x2A4A, 0x2A4B, 0x2A4C, 0x2A4D, 0x2A4E,   // C830 - C83F
	0x2A4F, 0x2A50, 0x2A51, 0x2A52, 0x2A53, 0x2A54, 0x2A55, 0x2A56, 0x2A57, 0x2A58, 0x2A59, 0x2A5A, 0x2A5B, 0x2A5C, 0x2A5D, 0x2A5E,   // C840 - C84F
	0x2A5F, 0x2A60, 0x2A61, 0x2A62, 0x2A63, 0x2A64, 0x2A65, 0x2A66, 0x2A67, 0x2A68, 0x2A69, 0x2A6A, 0x2A6B, 0x2A6C, 0x2A6D, 0x2A6E,   // C850 - C85F
	0x2A6F, 0x2A70, 0x2A71, 0x2A72, 0x2A73, 0x2A74, 0x2A75, 0x2A76, 0x2A77, 0x2A78, 0x2A79, 0x2A7A, 0x2A7B, 0x2A7C, 0x2A7D, 0x2A7E,   // C860 - C86F
	0x2A7F, 0x2AAE, 0x2AB3, 0x2AB4, 0x2AB5, 0x2AB8, 0x2AB9, 0x2ABA, 0x2ABB, 0x2ABF, 0x2AC0, 0x2AC1, 0x2AC2, 0x2AC3, 0x2AC4, 0x2AC5,   // C870 - C87F
	0x2AC6, 0x2AC7, 0x2AC8, 0x2AC9, 0x2ACA, 0x2ACB, 0x2ADD, 0x2ADE, 0x2ADF, 0x2AE0, 0x2AE1, 0x2AE2, 0x2AE3, 0x2AE9, 0x2AEA, 0x2AEB,   // C880 - C88F
	0x2AEC, 0x2AED, 0x2AEE, 0x2AEF, 0x2AF0, 0x2AF1, 0x2AF2, 0x2AF3, 0x2AF4, 0x2AF5, 0x2AF6, 0x2AF7, 0x2AF8, 0x2AF9, 0x2AFA, 0x2AFB,   // C890 - C89F
	0x2AFC, 0x2AFD, 0x2AFE, 0x2AFF, 0x2B00, 0x2B01, 0x2B02, 0x2B03, 0x2B04, 0x2B05, 0x2B06, 0x2B07, 0x2B08, 0x2B09, 0x2B0A, 0x2B0B,   // C8A0 - C8AF
	0x2B0C, 0x2B0D, 0x2B0E, 0x2B0F, 0x2B10, 0x2B11, 0x2B12, 0x2B13, 0x2B14, 0x2B15, 0x2B16, 0x2B17, 0x2B18, 0x2B19, 0x2B1A, 0x2B1B,   // C8B0 - C8BF
	0x2B1C, 0x2B1D, 0x2B1E, 0x2B1F, 0x2B20, 0x2B22, 0x2B23, 0x2B24, 0x2B25, 0x2B26, 0x2B27, 0x2B28, 0x2B29, 0x2B2A, 0x2B2B, 0x2B2C,   // C8C0 - C8CF
	0x2B2D, 0x2B2E, 0x2B2F, 0x2B30, 0x2B31, 0x2B32, 0x2B33, 0x2B34, 0x2B35, 0x2B36, 0x2B37, 0x2B38, 0x2B39, 0x2B3A, 0x2B3B, 0x2B3C,   // C8D0 - C8DF
	0x2B3D, 0x2B3E, 0x2B3F, 0x2B40, 0x2B41, 0x2B42, 0x2B43, 0x2B44, 0x2B45, 0x2B46, 0x2B47, 0x2B48, 0x2B49, 0x2B4A, 0x2B4B, 0x2B4C,   // C8E0 - C8EF
	0x2B4D, 0x2B4E, 0x2B4F, 0x2B50, 0x2B51, 0x2B52, 0x2B53, 0x2B54, 0x2B55, 0x2B56, 0x2B57, 0x2B58, 0x2B59, 0x2B82, 0x2B85, 0x2B86,   // C8F0 - C8FF
	0x2B87, 0x2B9B, 0x2B9C, 0x2B9D, 0x2B9E, 0x2BA0, 0x2BA1, 0x2BA2, 0x2BA3, 0x2BA4, 0x2BA5, 0x2BA6, 0x2BA7, 0x2BA8, 0x2BA9, 0x2BAA,   // C900 - C90F
	0x2BAB, 0x2BAC, 0x2BB1, 0x2BB2, 0x2BB3, 0x2BB4, 0x2BB5, 0x2BB6, 0x2BB7, 0x2BB8, 0x2BB9, 0x2BBA, 0x2BBB, 0x2BBC, 0x2BBD, 0x2BBE,   // C910 - C91F
	0x2BBF, 0x2BC0, 0x2BC1, 0x2BC2, 0x2BC3, 0x2BC4, 0x2BC5, 0x2BC6, 0x2BC7, 0x2BC8, 0x2BC9, 0x2BCA, 0x2BCB, 0x2BCC, 0x2BCD, 0x2BCE,   // C920 - C92F
	0x2BCF, 0x2BD0, 0x2BD1, 0x2BD2, 0x2BD3, 0x2BD4, 0x2BD5, 0x2BD6, 0x2BD7, 0x2BD8, 0x2BD9, 0x2BDA, 0x2BDB, 0x2BDC, 0x2BDD, 0x2BDE,   // C930 - C93F
	0x2BDF, 0x2BE0, 0x2BE1, 0x2BE2, 0x2BE3, 0x2BE4, 0x2BE5, 0x2BE6, 0x2BE7, 0x2BE8, 0x2BE9, 0x2BEA, 0x2BEB, 0x2BEC, 0x2BED, 0x2BEE,   // C940 - C94F
	0x2BEF, 0x2BF0, 0x2BF1, 0x2BF2, 0x2BF3, 0x2BF4, 0x2BF5, 0x2BF6, 0x2BF7, 0x2BF8, 0x2BF9, 0x2BFA, 0x2BFB, 0x2BFC, 0x2BFD, 0x2BFE,   // C950 - C95F
	0x2BFF, 0x2C00, 0x2C01, 0x2C02, 0x2C03, 0x2C04, 0x2C05, 0x2C06, 0x2C07, 0x2C08, 0x2C09, 0x2C0A, 0x2C0B, 0x2C0C, 0x2C0D, 0x2C0E,   // C960 - C96F
	0x2C0F, 0x2C10, 0x2C11, 0x2C12, 0x2C13, 0x2C14, 0x2C15, 0x2C16, 0x2C17, 0x2C18, 0x2C19, 0x2C1A, 0x2C1B, 0x2C1C, 0x2C1D, 0x2C1E,   // C970 - C97F
	0x2C1F, 0x2C20, 0x2C21, 0x2C22, 0x2C23, 0x2C24, 0x2C25, 0x2C26, 0x2C27, 0x2C28, 0x2C2A, 0x2C2B, 0x2C2C, 0x2C2D, 0x2C2E, 0x2C2F,   // C980 - C98F
	0x2C30, 0x2C32, 0x2C33, 0x2C34, 0x2C35, 0x2C36, 0x2C37, 0x2C38, 0x2C39, 0x2C3A, 0x2C3E, 0x2C3F, 0x2C40, 0x2C41, 0x2C4D, 0x2C4E,   // C990 - C99F
	0x2C4F, 0x2C50, 0x2C51, 0x2C52, 0x2C53, 0x2C54, 0x2C55, 0x2C56, 0x2C57, 0x2C58, 0x2C59, 0x2C5A, 0x2C5B, 0x2C5C, 0x2C5D, 0x2C5E,   // C9A0 - C9AF
	0x2C5F, 0x2C60, 0x2C61, 0x2C62, 0x2C63, 0x2C64, 0x2C65, 0x2C66, 0x2C67, 0x2C68, 0x2C69, 0x2C6A, 0x2C6B, 0x2C6C, 0x2C6D, 0x2C6E,   // C9B0 - C9BF
	0x2C6F, 0x2C92, 0x2C98, 0x2C99, 0x2C9A, 0x2CBE, 0x2CBF, 0x2CC0, 0x2CC1, 0x2CD1, 0x2CD2, 0x2CD3, 0x2CD4, 0x2CD5, 0x2CD6, 0x2CD7,   // C9C0 - C9CF
	0x2CD8, 0x2CDB, 0x2CE3, 0x2CE4, 0x2CE5, 0x2CE6, 0x2CEA, 0x2CEB, 0x2CEC, 0x2CED, 0x2CEE, 0x2CEF, 0x2CF0, 0x2CF1, 0x2CF2, 0x2CF3,   // C9D0 - C9DF
	0x2CF4, 0x2CF5, 0x2CF6, 0x2CF7, 0x2CF8, 0x2CF9, 0x2CFA, 0x2CFB, 0x2CFC, 0x2CFD, 0x2CFE, 0x2CFF, 0x2D00, 0x2D01, 0x2D02, 0x2D03,   // C9E0 - C9EF
	0x2D04, 0x2D05, 0x2D06, 0x2D07, 0x2D08, 0x2D09, 0x2D0A, 0x2D0B, 0x2D0C, 0x2D0D, 0x2D0E, 0x2D0F, 0x2D10, 0x2D11, 0x2D12, 0x2D13,   // C9F0 - C9FF
	0x2D14, 0x2D15, 0x2D16, 0x2D17, 0x2D18, 0x2D19, 0x2D1A, 0x2D1B, 0x2D1C, 0x2D1D, 0x2D1E, 0x2D1F, 0x2D20, 0x2D21, 0x2D22, 0x2D23,   // CA00 - CA0F
	0x2D24, 0x2D25, 0x2D26, 0x2D27, 0x2D28, 0x2D29, 0x2D2A, 0x2D2B, 0x2D2C, 0x2D2D, 0x2D2E, 0x2D2F, 0x2D30, 0x2D31, 0x2D32, 0x2D33,   // CA10 - CA1F
	0x2D34, 0x2D35, 0x2D36, 0x2D37, 0x2D38, 0x2D39, 0x2D3A, 0x2D3B, 0x2D3C, 0x2D3D, 0x2D3E, 0x2D3F, 0x2D40, 0x2D41, 0x2D42, 0x2D43,   // CA20 - CA2F
	0x2D44, 0x2D45, 0x2D46, 0x2D47, 0x2D48, 0x2D49, 0x2D4A, 0x2D4B, 0x2D4C, 0x2D4D, 0x2D4E, 0x2D4F, 0x2D50, 0x2D51, 0x2D52, 0x2D53,   // CA30 - CA3F
	0x2D54, 0x2D55, 0x2D56, 0x2D57, 0x2D58, 0x2D59, 0x2D5A, 0x2D5B, 0x2D5C, 0x2D5D, 0x2D5E, 0x2D5F, 0x2D60, 0x2D61, 0x2D62, 0x2D63,   // CA40 - CA4F
	0x2D64, 0x2D65, 0x2D66, 0x2D67, 0x2D68, 0x2D69, 0x2D6A, 0x2D6B, 0x2D6C, 0x2D6D, 0x2D6E, 0x2D6F, 0x2D70, 0x2D71, 0x2D72, 0x2D73,   // CA50 - CA5F
	0x2D74, 0x2D75, 0x2D76, 0x2D77, 0x2D78, 0x2D79, 0x2D7A, 0x2D7B, 0x2D7C, 0x2D7D, 0x2D7E, 0x2D7F, 0x2D80, 0x2D81, 0x2D82, 0x2D83,   // CA60 - CA6F
	0x2D84, 0x2D85, 0x2D86, 0x2D87, 0x2D88, 0x2D89, 0x2D8A, 0x2D8B, 0x2D8C, 0x2D8D, 0x2D8E, 0x2D8F, 0x2D90, 0x2D91, 0x2D92, 0x2D93,   // CA70 - CA7F
	0x2D94, 0x2D95, 0x2D96, 0x2D97, 0x2D98, 0x2D99, 0x2D9A, 0x2D9B, 0x2D9C, 0x2D9D, 0x2D9E, 0x2D9F, 0x2DA0, 0x2DA1, 0x2DA2, 0x2DA3,   // CA80 - CA8F
	0x2DA4, 0x2DA5, 0x2DA6, 0x2DA7, 0x2DA8, 0x2DA9, 0x2DAA, 0x2DAB, 0x2DAC, 0x2DAD, 0x2DAE, 0x2DAF, 0x2DB0, 0x2DB1, 0x2DB2, 0x2DB3,   // CA90 - CA9F
	0x2DB4, 0x2DB5, 0x2DB6, 0x2DB7, 0x2DB8, 0x2DB9, 0x2DBA, 0x2DBB, 0x2DBC, 0x2DBD, 0x2DBE, 0x2DBF, 0x2DC0, 0x2DC1, 0x2DC2, 0x2DC3,   // CAA0 - CAAF
	0x2DC4, 0x2DC5, 0x2DC6, 0x2DC7, 0x2DC8, 0x2DC9, 0x2DCA, 0x2DCB, 0x2DCC, 0x2DCD, 0x2DCE, 0x2DCF, 0x2DD0, 0x2DD1, 0x2DD2, 0x2DD3,   // CAB0 - CABF
	0x2DD4, 0x2DD5, 0x2DD6, 0x2DD7, 0x2DD8, 0x2DD9, 0x2DDA, 0x2DDB, 0x2DDC, 0x2DDD, 0x2DDE, 0x2DDF, 0x2DE0, 0x2DE1, 0x2DE2, 0x2DE3,   // CAC0 - CACF
	0x2DE4, 0x2DE5, 0x2DE6, 0x2DE7, 0x2DE8, 0x2DE9, 0x2DEA, 0x2DEB, 0x2DEC, 0x2DED, 0x2DEE, 0x2DEF, 0x2DF0, 0x2DF1, 0x2DF2, 0x2DF3,   // CAD0 - CADF
	0x2DF4, 0x2DF5, 0x2DF6, 0x2DF7, 0x2DF8, 0x2DF9, 0x2DFA, 0x2DFB, 0x2DFC, 0x2DFD, 0x2DFE, 0x2DFF, 0x2E00, 0x2E01, 0x2E02, 0x2E03,   // CAE0 - CAEF
	0x2E04, 0x2E05, 0x2E06, 0x2E07, 0x2E08, 0x2E09, 0x2E0A, 0x2E0B, 0x2E0C, 0x2E0D, 0x2E0E, 0x2E0F, 0x2E10, 0x2E11, 0x2E12, 0x2E13,   // CAF0 - CAFF
	0x2E14, 0x2E15, 0x2E16, 0x2E17, 0x2E18, 0x2E19, 0x2E1A, 0x2E1B, 0x2E1C, 0x2E1D, 0x2E1E, 0x2E1F, 0x2E20, 0x2E21, 0x2E22, 0x2E23,   // CB00 - CB0F
	0x2E24, 0x2E25, 0x2E26, 0x2E27, 0x2E28, 0x2E29, 0x2E2A, 0x2E2B, 0x2E2C, 0x2E2D, 0x2E2E, 0x2E2F, 0x2E30, 0x2E31, 0x2E32, 0x2E33,   // CB10 - CB1F
	0x2E34, 0x2E35, 0x2E36, 0x2E37, 0x2E38, 0x2E39, 0x2E3A, 0x2E3B, 0x2E3C, 0x2E3D, 0x2E3E, 0x2E3F, 0x2E40, 0x2E41, 0x2E42, 0x2E43,   // CB20 - CB2F
	0x2E44, 0x2E45, 0x2E46, 0x2E47, 0x2E48, 0x2E49, 0x2E4A, 0x2E4B, 0x2E4C, 0x2E4D, 0x2E4E, 0x2E4F, 0x2E50, 0x2E51, 0x2E52, 0x2E53,   // CB30 - CB3F
	0x2E54, 0x2E55, 0x2E56, 0x2E57, 0x2E58, 0x2E59, 0x2E5A, 0x2E5B, 0x2E5C, 0x2E5D, 0x2E5E, 0x2E5F, 0x2E60, 0x2E61, 0x2E62, 0x2E63,   // CB40 - CB4F
	0x2E64, 0x2E65, 0x2E66, 0x2E67, 0x2E68, 0x2E69, 0x2E6A, 0x2E6B, 0x2E6C, 0x2E6D, 0x2E6E, 0x2E6F, 0x2E70, 0x2E71, 0x2E72, 0x2E73,   // CB50 - CB5F
	0x2E74, 0x2E75, 0x2E76, 0x2E77, 0x2E78, 0x2E79, 0x2E7A, 0x2E7B, 0x2E7C, 0x2E7D, 0x2E7E, 0x2E7F, 0x2E80, 0x2E81, 0x2E82, 0x2E83,   // CB60 - CB6F
	0x2E84, 0x2E85, 0x2E86, 0x2E87, 0x2E88, 0x2E89, 0x2E8A, 0x2E8B, 0x2E8C, 0x2E8D, 0x2E8E, 0x2E8F, 0x2E90, 0x2E91, 0x2E92, 0x2E93,   // CB70 - CB7F
	0x2E94, 0x2E95, 0x2E96, 0x2E97, 0x2E98, 0x2E99, 0x2E9A, 0x2E9B, 0x2E9C, 0x2E9D, 0x2E9E, 0x2E9F, 0x2EA0, 0x2EA1, 0x2EA2, 0x2EA3,   // CB80 - CB8F
	0x2EA4, 0x2EA5, 0x2EA6, 0x2EA7, 0x2EA8, 0x2EA9, 0x2EAA, 0x2EAB, 0x2EAC, 0x2EAD, 0x2EAE, 0x2EAF, 0x2EB0, 0x2EB1, 0x2EB2, 0x2EB3,   // CB90 - CB9F
	0x2EB4, 0x2EB5, 0x2EB6, 0x2EB7, 0x2EB8, 0x2EB9, 0x2EBA, 0x2EBB, 0x2EBC, 0x2EBD, 0x2EBE, 0x2EBF, 0x2EC0, 0x2EC1, 0x2EC2, 0x2EC3,   // CBA0 - CBAF
	0x2EC4, 0x2EC5, 0x2EC6, 0x2EC7, 0x2EC8, 0x2EC9, 0x2ECA, 0x2ECB, 0x2ECC, 0x2ECD, 0x2ECE, 0x2ECF, 0x2ED0, 0x2ED1, 0x2ED2, 0x2ED3,   // CBB0 - CBBF
	0x2ED4, 0x2ED5, 0x2ED6, 0x2ED7, 0x2ED8, 0x2ED9, 0x2EDA, 0x2EDB, 0x2EDC, 0x2EDD, 0x2EDE, 0x2EDF, 0x2EE0, 0x2EE1, 0x2EE2, 0x2EE3,   // CBC0 - CBCF
	0x2EE4, 0x2EE5, 0x2EE6, 0x2EE7, 0x2EE8, 0x2EE9, 0x2EEA, 0x2EEB, 0x2EEC, 0x2EED, 0x2EEE, 0x2EEF, 0x2EF0, 0x2EF1, 0x2EF2, 0x2EF3,   // CBD0 - CBDF
	0x2EF4, 0x2EF5, 0x2EF6, 0x2EF7, 0x2EF8, 0x2EF9, 0x2EFA, 0x2EFB, 0x2EFC, 0x2EFD, 0x2EFE, 0x2EFF, 0x2F00, 0x2F01, 0x2F02, 0x2F03,   // CBE0 - CBEF
	0x2F04, 0x2F05, 0x2F06, 0x2F07, 0x2F08, 0x2F09, 0x2F0A, 0x2F0B, 0x2F0C, 0x2F0D, 0x2F0E, 0x2F0F, 0x2F10, 0x2F11, 0x2F12, 0x2F13,   // CBF0 - CBFF
	0x2F14, 0x2F15, 0x2F16, 0x2F17, 0x2F18, 0x2F19, 0x2F1A, 0x2F1B, 0x2F1C, 0x2F1D, 0x2F1E, 0x2F1F, 0x2F20, 0x2F21, 0x2F22, 0x2F23,   // CC00 - CC0F
	0x2F24, 0x2F25, 0x2F26, 0x2F27, 0x2F28, 0x2F29, 0x2F2A, 0x2F2B, 0x2F2C, 0x2F2D, 0x2F2E, 0x2F2F, 0x2F30, 0x2F31, 0x2F32, 0x2F33,   // CC10 - CC1F
	0x2F34, 0x2F35, 0x2F36, 0x2F37, 0x2F38, 0x2F39, 0x2F3A, 0x2F3B, 0x2F3C, 0x2F4C, 0x2F54, 0x2F55, 0x2F56, 0x2F66, 0x2F67, 0x2F68,   // CC20 - CC2F
	0x2F69, 0x2F6F, 0x2F70, 0x2F71, 0x2F72, 0x2F73, 0x2F74, 0x2F75, 0x2F76, 0x2F81, 0x2F82, 0x2F83, 0x2F84, 0x2F85, 0x2F9C, 0x2F9D,   // CC30 - CC3F
	0x2F9E, 0x2F9F, 0x2FA0, 0x2FA1, 0x2FA2, 0x2FAF, 0x2FB4, 0x2FB5, 0x2FB6, 0x2FB7, 0x2FB8, 0x2FB9, 0x2FBA, 0x2FBB, 0x2FBC, 0x2FBD,   // CC40 - CC4F
	0x2FBE, 0x2FBF, 0x2FC0, 0x2FC1, 0x2FC2, 0x2FC3, 0x2FC4, 0x2FC5, 0x2FC6, 0x2FC7, 0x2FC8, 0x2FC9, 0x2FCA, 0x2FCB, 0x2FCC, 0x2FCD,   // CC50 - CC5F
	0x2FCE, 0x2FCF, 0x2FD0, 0x2FD1, 0x2FD2, 0x2FD3, 0x2FD4, 0x2FD5, 0x2FD6, 0x2FD7, 0x2FD8, 0x2FD9, 0x2FDA, 0x2FDB, 0x2FDC, 0x2FDD,   // CC60 - CC6F
	0x2FDE, 0x2FDF, 0x2FE0, 0x2FE1, 0x2FE2, 0x2FE3, 0x2FE4, 0x2FE5, 0x2FE6, 0x2FE7, 0x2FE8, 0x2FE9, 0x2FEA, 0x2FEB, 0x2FEC, 0x2FED,   // CC70 - CC7F
	0x2FEE, 0x2FEF, 0x2FF0, 0x2FF1, 0x2FF2, 0x2FF3, 0x2FF4, 0x2FF5, 0x2FF6, 0x2FF7, 0x2FF8, 0x2FF9, 0x2FFA, 0x2FFB, 0x2FFC, 0x2FFD,   // CC80 - CC8F
	0x2FFE, 0x2FFF, 0x3000, 0x3001, 0x3002, 0x3003, 0x3004, 0x3005, 0x3006, 0x300B, 0x301B, 0x301C, 0x301D, 0x3031, 0x3032, 0x3033,   // CC90 - CC9F
	0x3034, 0x303F, 0x3040, 0x3041, 0x3042, 0x3043, 0x3044, 0x3045, 0x3046, 0x3051, 0x305C, 0x305D, 0x305E, 0x305F, 0x3068, 0x3069,   // CCA0 - CCAF
	0x306A, 0x306B, 0x306C, 0x306D, 0x306E, 0x3079, 0x307A, 0x307B, 0x307C, 0x307D, 0x307E, 0x307F, 0x3080, 0x3081, 0x3082, 0x3083,   // CCB0 - CCBF
	0x3084, 0x3085, 0x3086, 0x3087, 0x3088, 0x3089, 0x308A, 0x308B, 0x308C, 0x308D, 0x308E, 0x308F, 0x3090, 0x3091, 0x3092, 0x3093,   // CCC0 - CCCF
	0x3094, 0x3095, 0x3096, 0x3097, 0x3098, 0x3099, 0x309A, 0x309B, 0x309C, 0x309D, 0x309E, 0x309F, 0x30A0, 0x30A1, 0x30A2, 0x30A3,   // CCD0 - CCDF
	0x30A4, 0x30A5, 0x30A6, 0x30A7, 0x30A8, 0x30A9, 0x30AA, 0x30AB, 0x30AC, 0x30AD, 0x30AE, 0x30AF, 0x30B0, 0x30B1, 0x30B2, 0x30B3,   // CCE0 - CCEF
	0x30B4, 0x30B5, 0x30B6, 0x30B7, 0x30B8, 0x30B9, 0x30BA, 0x30BB, 0x30BC, 0x30BD, 0x30BE, 0x30BF, 0x30C0, 0x30C1, 0x30C2, 0x30C3,   // CCF0 - CCFF
	0x30C4, 0x30C5, 0x30C6, 0x30C7, 0x30C8, 0x30C9, 0x30CA, 0x30CB, 0x30CC, 0x30E8, 0x30EF, 0x30F0, 0x30F1, 0x30F6, 0x30F7, 0x30F8,   // CD00 - CD0F
	0x30F9, 0x30FA, 0x30FB, 0x30FC, 0x30FD, 0x30FE, 0x30FF, 0x3100, 0x3101, 0x3102, 0x3103, 0x3104, 0x3105, 0x3106, 0x3111, 0x3112,   // CD10 - CD1F
	0x3113, 0x3114, 0x3115, 0x3116, 0x3117, 0x3118, 0x3119, 0x311A, 0x311B, 0x311C, 0x311D, 0x311E, 0x311F, 0x3121, 0x3122, 0x3123,   // CD20 - CD2F
	0x3124, 0x3125, 0x3126, 0x3127, 0x3128, 0x3129, 0x312A, 0x312B, 0x312C, 0x312D, 0x312E, 0x312F, 0x3130, 0x3131, 0x3132, 0x3133,   // CD30 - CD3F
	0x3134, 0x3135, 0x3136, 0x3137, 0x3138, 0x3139, 0x313A, 0x313B, 0x313C, 0x313D, 0x313E, 0x313F, 0x3140, 0x3141, 0x3142, 0x3143,   // CD40 - CD4F
	0x3144, 0x3145, 0x3146, 0x3147, 0x3148, 0x3149, 0x314A, 0x314B, 0x314C, 0x314D, 0x314E, 0x314F, 0x3150, 0x3154, 0x3155, 0x3156,   // CD50 - CD5F
	0x3157, 0x3158, 0x3159, 0x315A, 0x315B, 0x315C, 0x315D, 0x315E, 0x315F, 0x3160, 0x3161, 0x3162, 0x3163, 0x3164, 0x3165, 0x3166,   // CD60 - CD6F
	0x3167, 0x3168, 0x3169, 0x316A, 0x316B, 0x316C, 0x316D, 0x316E, 0x316F, 0x3170, 0x3171, 0x3172, 0x3173, 0x3174, 0x3175, 0x3176,   // CD70 - CD7F
	0x3177, 0x3178, 0x3179, 0x317A, 0x317B, 0x317C, 0x317D, 0x317E, 0x317F, 0x3180, 0x3181, 0x3182, 0x3183, 0x3184, 0x3185, 0x3186,   // CD80 - CD8F
	0x3187, 0x3188, 0x3189, 0x318A, 0x318B, 0x31A3, 0x31B0, 0x31B1, 0x31B2, 0x31B6, 0x31B7, 0x31B8, 0x31B9, 0x31BD, 0x31BE, 0x31BF,   // CD90 - CD9F
	0x31C0, 0x31C1, 0x31C2, 0x31C3, 0x31C4, 0x31C5, 0x31C6, 0x31C7, 0x31C8, 0x31C9, 0x31D0, 0x31D1, 0x31D2, 0x31D3, 0x31D4, 0x31D5,   // CDA0 - CDAF
	0x31D6, 0x31D7, 0x31D8, 0x31D9, 0x31DA, 0x31DB, 0x31DC, 0x31DD, 0x31DE, 0x31DF, 0x31E0, 0x31E1, 0x31E2, 0x31E3, 0x31E4, 0x31E5,   // CDB0 - CDBF
	0x31E6, 0x31E7, 0x31E8, 0x31E9, 0x31EA, 0x31EB, 0x31EC, 0x31ED, 0x31EE, 0x31EF, 0x31F0, 0x31F1, 0x31F2, 0x31F7, 0x31F8, 0x31F9,   // CDC0 - CDCF
	0x31FA, 0x31FB, 0x31FC, 0x31FD, 0x31FE, 0x31FF, 0x3200, 0x3201, 0x3202, 0x3203, 0x3204, 0x3205, 0x3206, 0x3207, 0x3208, 0x3209,   // CDD0 - CDDF
	0x320A, 0x320B, 0x320C, 0x320D, 0x320E, 0x320F, 0x3210, 0x3211, 0x3212, 0x3221, 0x3222, 0x3223, 0x3224, 0x3225, 0x3226, 0x3227,   // CDE0 - CDEF
	0x3228, 0x3229, 0x322A, 0x322B, 0x322C, 0x322D, 0x322E, 0x322F, 0x3230, 0x3231, 0x3232, 0x3233, 0x3234, 0x3235, 0x3236, 0x3237,   // CDF0 - CDFF
	0x3238, 0x3239, 0x323A, 0x323B, 0x323C, 0x323D, 0x323E, 0x323F, 0x3240, 0x3241, 0x3242, 0x3243, 0x3244, 0x3245, 0x3246, 0x3247,   // CE00 - CE0F
	0x3248, 0x3249, 0x324A, 0x324B, 0x324C, 0x324D, 0x324E, 0x324F, 0x3250, 0x3251, 0x3252, 0x3253, 0x3254, 0x3255, 0x3256, 0x3257,   // CE10 - CE1F
	0x3258, 0x3259, 0x325F, 0x3260, 0x3261, 0x3262, 0x3263, 0x3264, 0x3265, 0x3266, 0x3267, 0x3268, 0x3269, 0x326A, 0x326B, 0x326C,   // CE20 - CE2F
	0x326D, 0x326E, 0x326F, 0x3270, 0x3271, 0x3272, 0x3274, 0x3275, 0x3276, 0x3277, 0x3278, 0x3279, 0x327A, 0x327B, 0x327C, 0x327D,   // CE30 - CE3F
	0x327E, 0x327F, 0x3280, 0x3281, 0x3282, 0x3283, 0x3284, 0x3285, 0x3286, 0x3287, 0x3288, 0x3289, 0x328A, 0x328B, 0x328C, 0x328D,   // CE40 - CE4F
	0x328E, 0x328F, 0x3290, 0x3291, 0x3292, 0x3293, 0x3294, 0x3295, 0x3296, 0x32AF, 0x32B3, 0x32B4, 0x32B5, 0x32B7, 0x32B8, 0x32B9,   // CE50 - CE5F
	0x32BA, 0x32BE, 0x32BF, 0x32C0, 0x32C1, 0x32C2, 0x32C3, 0x32C4, 0x32C5, 0x32CF, 0x32D1, 0x32D2, 0x32D3, 0x32D4, 0x32D7, 0x32D8,   // CE60 - CE6F
	0x32D9, 0x32DA, 0x32DB, 0x32DC, 0x32DD, 0x32DE, 0x32DF, 0x32E0, 0x32E1, 0x32E2, 0x32E3, 0x32E4, 0x32E5, 0x32E6, 0x32E7, 0x32E8,   // CE70 - CE7F
	0x32E9, 0x32EA, 0x32EB, 0x32EC, 0x32ED, 0x32EE, 0x32EF, 0x32F0, 0x32F1, 0x32F2, 0x32F3, 0x32F4, 0x32F5, 0x32F6, 0x32F7, 0x32F8,   // CE80 - CE8F
	0x32F9, 0x32FA, 0x32FB, 0x32FC, 0x32FD, 0x32FE, 0x32FF, 0x3300, 0x3301, 0x3302, 0x3303, 0x3304, 0x3305, 0x3306, 0x3307, 0x3308,   // CE90 - CE9F
	0x3309, 0x330A, 0x330B, 0x330C, 0x330D, 0x330E, 0x330F, 0x3310, 0x3311, 0x3312, 0x3313, 0x3314, 0x3315, 0x3316, 0x3317, 0x3318,   // CEA0 - CEAF
	0x3319, 0x331A, 0x331B, 0x331C, 0x331D, 0x331E, 0x331F, 0x3320, 0x3321, 0x3322, 0x3323, 0x3324, 0x3325, 0x3326, 0x3327, 0x3328,   // CEB0 - CEBF
	0x3329, 0x332A, 0x332B, 0x332C, 0x332D, 0x332E, 0x332F, 0x3330, 0x3331, 0x3332, 0x3333, 0x3334, 0x3335, 0x3336, 0x3337, 0x3338,   // CEC0 - CECF
	0x3339, 0x333A, 0x333B, 0x333C, 0x333D, 0x333E, 0x333F, 0x3340, 0x3341, 0x3342, 0x3343, 0x3344, 0x3345, 0x3346, 0x3347, 0x3348,   // CED0 - CEDF
	0x3349, 0x334A, 0x334B, 0x334C, 0x334D, 0x334E, 0x334F, 0x3350, 0x3351, 0x3352, 0x3353, 0x3354, 0x3355, 0x3356, 0x3357, 0x3358,   // CEE0 - CEEF
	0x3359, 0x335A, 0x335B, 0x335C, 0x335D, 0x335E, 0x335F, 0x3360, 0x3361, 0x3362, 0x3363, 0x3364, 0x3365, 0x3366, 0x3367, 0x3368,   // CEF0 - CEFF
	0x3369, 0x336A, 0x336B, 0x336C, 0x336D, 0x336E, 0x336F, 0x3370, 0x3371, 0x3372, 0x3373, 0x3374, 0x3375, 0x3376, 0x3377, 0x3378,   // CF00 - CF0F
	0x3379, 0x337A, 0x337B, 0x337C, 0x337D, 0x337E, 0x337F, 0x3380, 0x3381, 0x3382, 0x3383, 0x3384, 0x3385, 0x3386, 0x3387, 0x3388,   // CF10 - CF1F
	0x3389, 0x338A, 0x338B, 0x338C, 0x338D, 0x338E, 0x338F, 0x3390, 0x3391, 0x3392, 0x3393, 0x3394, 0x3395, 0x3396, 0x3397, 0x3398,   // CF20 - CF2F
	0x3399, 0x339A, 0x339B, 0x339C, 0x339D, 0x339E, 0x339F, 0x33A0, 0x33A1, 0x33A2, 0x33A3, 0x33A4, 0x33A5, 0x33A6, 0x33A7, 0x33A8,   // CF30 - CF3F
	0x33A9, 0x33AA, 0x33AB, 0x33AC, 0x33AD, 0x33AE, 0x33AF, 0x33B0, 0x33B1, 0x33B2, 0x33B3, 0x33B4, 0x33B5, 0x33B6, 0x33B7, 0x33B8,   // CF40 - CF4F
	0x33B9, 0x33BA, 0x33BB, 0x33BC, 0x33BD, 0x33BE, 0x33BF, 0x33C0, 0x33C1, 0x33C2, 0x33C3, 0x33C4, 0x33C5, 0x33C6, 0x33C7, 0x33C8,   // CF50 - CF5F
	0x33C9, 0x33CA, 0x33CB, 0x33CC, 0x33CD, 0x33CE, 0x33CF, 0x33D0, 0x33D1, 0x33D2, 0x33D3, 0x33D4, 0x33D5, 0x33D6, 0x33D7, 0x33D8,   // CF60 - CF6F
	0x33D9, 0x33DA, 0x33DB, 0x33DC, 0x33DD, 0x33DE, 0x33DF, 0x33E0, 0x33E1, 0x33E2, 0x33E3, 0x33E4, 0x33E5, 0x33E6, 0x33E7, 0x33E8,   // CF70 - CF7F
	0x33E9, 0x33EA, 0x33EB, 0x33EC, 0x33ED, 0x33EE, 0x33EF, 0x33F0, 0x33F1, 0x33F2, 0x33F3, 0x33F4, 0x33F5, 0x33F7, 0x33F8, 0x33F9,   // CF80 - CF8F
	0x33FA, 0x33FB, 0x33FC, 0x33FD, 0x33FE, 0x33FF, 0x3400, 0x3401, 0x3402, 0x3403, 0x3404, 0x3405, 0x3406, 0x3407, 0x3408, 0x3409,   // CF90 - CF9F
	0x340A, 0x340B, 0x340C, 0x340D, 0x340E, 0x340F, 0x3410, 0x3411, 0x3412, 0x3413, 0x3414, 0x3415, 0x3416, 0x3417, 0x3418, 0x3419,   // CFA0 - CFAF
	0x341A, 0x341B, 0x341C, 0x341D, 0x341E, 0x341F, 0x3420, 0x3421, 0x3422, 0x3423, 0x3424, 0x3425, 0x3426, 0x3427, 0x3428, 0x3429,   // CFB0 - CFBF
	0x342A, 0x342B, 0x342C, 0x342D, 0x342E, 0x342F, 0x3430, 0x3431, 0x3432, 0x3433, 0x3434, 0x3435, 0x3436, 0x3437, 0x3438, 0x3439,   // CFC0 - CFCF
	0x343A, 0x343B, 0x343C, 0x343D, 0x343E, 0x343F, 0x3440, 0x3441, 0x3442, 0x3443, 0x3444, 0x3445, 0x3446, 0x3447, 0x3448, 0x3449,   // CFD0 - CFDF
	0x344A, 0x344B, 0x344C, 0x344D, 0x344E, 0x344F, 0x3450, 0x3451, 0x3452, 0x3453, 0x3454, 0x3455, 0x3456, 0x3457, 0x3458, 0x3459,   // CFE0 - CFEF
	0x345A, 0x345B, 0x345C, 0x345D, 0x345E, 0x345F, 0x3460, 0x3461, 0x3462, 0x3463, 0x3464, 0x3465, 0x3466, 0x3467, 0x3468, 0x3469,   // CFF0 - CFFF
	0x346A, 0x346B, 0x346C, 0x346D, 0x346E, 0x346F, 0x3470, 0x3471, 0x3472, 0x3473, 0x3474, 0x3475, 0x3476, 0x3477, 0x3478, 0x3479,   // D000 - D00F
	0x347A, 0x347B, 0x347C, 0x347D, 0x347E, 0x347F, 0x3480, 0x3481, 0x3482, 0x3483, 0x3484, 0x3485, 0x3486, 0x3487, 0x3488, 0x3489,   // D010 - D01F
	0x348A, 0x348B, 0x348C, 0x348D, 0x348E, 0x348F, 0x3490, 0x3491, 0x3492, 0x3493, 0x3494, 0x3495, 0x3496, 0x3497, 0x3498, 0x3499,   // D020 - D02F
	0x349A, 0x349B, 0x349C, 0x349D, 0x349E, 0x349F, 0x34A0, 0x34A1, 0x34A2, 0x34A3, 0x34A4, 0x34A5, 0x34A6, 0x34A7, 0x34A8, 0x34A9,   // D030 - D03F
	0x34AA, 0x34AB, 0x34AC, 0x34AD, 0x34AE, 0x34AF, 0x34B0, 0x34B1, 0x34B2, 0x34B3, 0x34B4, 0x34B5, 0x34B6, 0x34B7, 0x34B8, 0x34B9,   // D040 - D04F
	0x34BA, 0x34BB, 0x34BC, 0x34BD, 0x34BE, 0x34BF, 0x34C0, 0x34C1, 0x34C2, 0x34C3, 0x34C4, 0x34C5, 0x34C6, 0x34C7, 0x34C8, 0x34C9,   // D050 - D05F
	0x34CA, 0x34CB, 0x34CC, 0x34CD, 0x34CE, 0x34CF, 0x34D0, 0x34D1, 0x34D2, 0x34D3, 0x34D4, 0x34D5, 0x34D6, 0x34D7, 0x34D8, 0x34D9,   // D060 - D06F
	0x34DA, 0x34DB, 0x34DC, 0x34DD, 0x34DE, 0x34DF, 0x34E0, 0x34E1, 0x34E2, 0x34E3, 0x34E4, 0x34E5, 0x34E6, 0x34E7, 0x34E8, 0x34E9,   // D070 - D07F
	0x34EA, 0x34EB, 0x34EC, 0x34ED, 0x34EE, 0x34EF, 0x34F0, 0x34F1, 0x34F2, 0x34F3, 0x34F4, 0x34F5, 0x34F6, 0x34F7, 0x34F8, 0x34F9,   // D080 - D08F
	0x34FA, 0x34FB, 0x34FC, 0x34FD, 0x34FE, 0x34FF, 0x3500, 0x3501, 0x3502, 0x3503, 0x3504, 0x3505, 0x3506, 0x3507, 0x3508, 0x3509,   // D090 - D09F
	0x350A, 0x350B, 0x350C, 0x350D, 0x350E, 0x350F, 0x3510, 0x3511, 0x3512, 0x3513, 0x3514, 0x3515, 0x3516, 0x3517, 0x3518, 0x3519,   // D0A0 - D0AF
	0x351A, 0x351B, 0x351C, 0x351D, 0x351E, 0x351F, 0x3520, 0x3521, 0x3522, 0x3523, 0x3524, 0x3525, 0x3526, 0x3527, 0x3528, 0x3529,   // D0B0 - D0BF
	0x352A, 0x3539, 0x354A, 0x354B, 0x354C, 0x3557, 0x3558, 0x3559, 0x355A, 0x355D, 0x355E, 0x355F, 0x3560, 0x3561, 0x3562, 0x3563,   // D0C0 - D0CF
	0x3564, 0x3569, 0x356D, 0x356E, 0x356F, 0x3570, 0x3576, 0x3577, 0x3578, 0x3579, 0x357A, 0x357B, 0x357C, 0x358B, 0x358F, 0x3590,   // D0D0 - D0DF
	0x3591, 0x3592, 0x3593, 0x3594, 0x3595, 0x3596, 0x3597, 0x3598, 0x3599, 0x359A, 0x359B, 0x359C, 0x359D, 0x359E, 0x359F, 0x35A0,   // D0E0 - D0EF
	0x35A1, 0x35A2, 0x35A4, 0x35A5, 0x35A6, 0x35A7, 0x35A8, 0x35A9, 0x35AA, 0x35AB, 0x35AC, 0x35AD, 0x35AE, 0x35AF, 0x35B0, 0x35B1,   // D0F0 - D0FF
	0x35B2, 0x35B3, 0x35B4, 0x35B5, 0x35B6, 0x35B7, 0x35B8, 0x35B9, 0x35BA, 0x35BB, 0x35BC, 0x35BD, 0x35BE, 0x35BF, 0x35C0, 0x35C1,   // D100 - D10F
	0x35C2, 0x35C3, 0x35C4, 0x35C5, 0x35C6, 0x35C7, 0x35C8, 0x35C9, 0x35CA, 0x35CB, 0x35CC, 0x35CD, 0x35CE, 0x35CF, 0x35D0, 0x35D1,   // D110 - D11F
	0x35D2, 0x35D3, 0x35D4, 0x35D5, 0x35D6, 0x35D7, 0x35D8, 0x35D9, 0x35DA, 0x35DB, 0x35DC, 0x35DD, 0x35DE, 0x35DF, 0x35E0, 0x35E1,   // D120 - D12F
	0x35E2, 0x35E4, 0x35E5, 0x35E6, 0x35E7, 0x35E8, 0x35E9, 0x35EA, 0x35EB, 0x35EC, 0x35ED, 0x35EE, 0x35EF, 0x35F0, 0x35F1, 0x35F2,   // D130 - D13F
	0x35F3, 0x35F4, 0x35F5, 0x35F6, 0x35F7, 0x35F8, 0x35F9, 0x35FA, 0x35FB, 0x35FC, 0x35FD, 0x35FE, 0x35FF, 0x3600, 0x3601, 0x3602,   // D140 - D14F
	0x3603, 0x3604, 0x3605, 0x3606, 0x3607, 0x3608, 0x3609, 0x360A, 0x360B, 0x360C, 0x360D, 0x360E, 0x360F, 0x3610, 0x3611, 0x3612,   // D150 - D15F
	0x3613, 0x3614, 0x3615, 0x3616, 0x3617, 0x3618, 0x3619, 0x361A, 0x361B, 0x361C, 0x361D, 0x361E, 0x361F, 0x3620, 0x3621, 0x3622,   // D160 - D16F
	0x3623, 0x3624, 0x3625, 0x3626, 0x3627, 0x3628, 0x3629, 0x362A, 0x362B, 0x362C, 0x362D, 0x362E, 0x362F, 0x3630, 0x3631, 0x3632,   // D170 - D17F
	0x3633, 0x3634, 0x3635, 0x3636, 0x3637, 0x3638, 0x3639, 0x363A, 0x363B, 0x363C, 0x363D, 0x363E, 0x363F, 0x3640, 0x3641, 0x3642,   // D180 - D18F
	0x3643, 0x3644, 0x3645, 0x3646, 0x3647, 0x3648, 0x3649, 0x364A, 0x364B, 0x364C, 0x364D, 0x364E, 0x364F, 0x3650, 0x3651, 0x3652,   // D190 - D19F
	0x3653, 0x3658, 0x3659, 0x365A, 0x365B, 0x365C, 0x365D, 0x365E, 0x365F, 0x3660, 0x3661, 0x3662, 0x3663, 0x3664, 0x3665, 0x3666,   // D1A0 - D1AF
	0x3667, 0x3668, 0x3669, 0x366A, 0x366B, 0x366C, 0x3674, 0x3675, 0x3676, 0x3677, 0x3678, 0x3679, 0x367A, 0x367B, 0x367C, 0x367D,   // D1B0 - D1BF
	0x367E, 0x367F, 0x3680, 0x3681, 0x3682, 0x3683, 0x3684, 0x3685, 0x3686, 0x3687, 0x3688, 0x3689, 0x368A, 0x368B, 0x368C, 0x368D,   // D1C0 - D1CF
	0x368E, 0x368F, 0x3690, 0x3691, 0x3692, 0x3693, 0x3694, 0x3695, 0x3696, 0x3697, 0x3698, 0x3699, 0x369A, 0x369B, 0x369C, 0x369D,   // D1D0 - D1DF
	0x369E, 0x369F, 0x36A0, 0x36A1, 0x36A2, 0x36A3, 0x36A4, 0x36A5, 0x36A6, 0x36A7, 0x36A8, 0x36A9, 0x36AA, 0x36AB, 0x36AC, 0x36AD,   // D1E0 - D1EF
	0x36AE, 0x36AF, 0x36B0, 0x36B1, 0x36B2, 0x36B9, 0x36BA, 0x36BB, 0x36BC, 0x36BD, 0x36BE, 0x36BF, 0x36C0, 0x36C1, 0x36C2, 0x36C3,   // D1F0 - D1FF
	0x36C4, 0x36C5, 0x36C6, 0x36C7, 0x36C8, 0x36C9, 0x36CA, 0x36CB, 0x36CC, 0x36CD, 0x36CE, 0x36CF, 0x36D0, 0x36D1, 0x36D2, 0x36D3,   // D200 - D20F
	0x36D4, 0x36D5, 0x36D6, 0x36D7, 0x36D8, 0x36D9, 0x36DA, 0x36DB, 0x36DC, 0x36DD, 0x36DE, 0x36DF, 0x36E0, 0x36E1, 0x36E2, 0x36E3,   // D210 - D21F
	0x36E4, 0x36E5, 0x36E6, 0x36E7, 0x36E8, 0x36E9, 0x36EA, 0x36EB, 0x36EC, 0x36ED, 0x36EE, 0x36EF, 0x36F0, 0x36F7, 0x36F8, 0x36F9,   // D220 - D22F
	0x36FA, 0x36FB, 0x36FC, 0x36FD, 0x36FE, 0x36FF, 0x3700, 0x3701, 0x3702, 0x3703, 0x3704, 0x3705, 0x3706, 0x3707, 0x3708, 0x3709,   // D230 - D23F
	0x370A, 0x370B, 0x370C, 0x370D, 0x370E, 0x370F, 0x3710, 0x3711, 0x3712, 0x3713, 0x3714, 0x3715, 0x3716, 0x3717, 0x3718, 0x3719,   // D240 - D24F
	0x371A, 0x371B, 0x371C, 0x371D, 0x371E, 0x371F, 0x3720, 0x3721, 0x3722, 0x3723, 0x3724, 0x3725, 0x3726, 0x3727, 0x3728, 0x3729,   // D250 - D25F
	0x372A, 0x372B, 0x372C, 0x372D, 0x372E, 0x372F, 0x3730, 0x3731, 0x3732, 0x3733, 0x3734, 0x3735, 0x3736, 0x3737, 0x3738, 0x3739,   // D260 - D26F
	0x373A, 0x373B, 0x373C, 0x373D, 0x373E, 0x373F, 0x3740, 0x3741, 0x3742, 0x3743, 0x3744, 0x3745, 0x3746, 0x3747, 0x3748, 0x3749,   // D270 - D27F
	0x374A, 0x374B, 0x374C, 0x374D, 0x374E, 0x374F, 0x3750, 0x3751, 0x3752, 0x3753, 0x3754, 0x3755, 0x3756, 0x3757, 0x3758, 0x3759,   // D280 - D28F
	0x375A, 0x375B, 0x375C, 0x375D, 0x375E, 0x375F, 0x3760, 0x3761, 0x3762, 0x3763, 0x3764, 0x3765, 0x3766, 0x3767, 0x3768, 0x3769,   // D290 - D29F
	0x376A, 0x376B, 0x376C, 0x376D, 0x376E, 0x376F, 0x3770, 0x3771, 0x3772, 0x3773, 0x3774, 0x3775, 0x3776, 0x3777, 0x3778, 0x3779,   // D2A0 - D2AF
	0x377A, 0x377B, 0x377C, 0x377D, 0x377E, 0x377F, 0x3780, 0x3781, 0x3782, 0x3783, 0x3786, 0x3787, 0x3788, 0x3789, 0x378A, 0x378B,   // D2B0 - D2BF
	0x378C, 0x378D, 0x378E, 0x378F, 0x3790, 0x3791, 0x3792, 0x3793, 0x3794, 0x3796, 0x3797, 0x3798, 0x3799, 0x379A, 0x379B, 0x379C,   // D2C0 - D2CF
	0x379D, 0x379E, 0x379F, 0x37A0, 0x37A1, 0x37A2, 0x37A3, 0x37A4, 0x37A5, 0x37A6, 0x37A7, 0x37A8, 0x37A9, 0x37AA, 0x37AB, 0x37AC,   // D2D0 - D2DF
	0x37AD, 0x37AE, 0x37AF, 0x37B0, 0x37B1, 0x37B2, 0x37B3, 0x37B4, 0x37B5, 0x37B6, 0x37B7, 0x37B8, 0x37B9, 0x37BA, 0x37BB, 0x37BC,   // D2E0 - D2EF
	0x37BD, 0x37BE, 0x37BF, 0x37C0, 0x37C1, 0x37C2, 0x37C3, 0x37C4, 0x37C5, 0x37C6, 0x37C7, 0x37C8, 0x37C9, 0x37CA, 0x37CB, 0x37CC,   // D2F0 - D2FF
	0x37CD, 0x37CE, 0x37CF, 0x37D0, 0x37D1, 0x37D2, 0x37D3, 0x37D4, 0x37D5, 0x37D6, 0x37D7, 0x37D8, 0x37D9, 0x37EA, 0x37EB, 0x37EC,   // D300 - D30F
	0x37ED, 0x37F7, 0x37F8, 0x37F9, 0x37FA, 0x37FE, 0x37FF, 0x3800, 0x3801, 0x3802, 0x3803, 0x3804, 0x3805, 0x3806, 0x3807, 0x3808,   // D310 - D31F
	0x3809, 0x380A, 0x380B, 0x380C, 0x380D, 0x380E, 0x380F, 0x3810, 0x3811, 0x381D, 0x381E, 0x381F, 0x3820, 0x3821, 0x3822, 0x3823,   // D320 - D32F
	0x3824, 0x3825, 0x3826, 0x3827, 0x3828, 0x3829, 0x382A, 0x382B, 0x382C, 0x382D, 0x382E, 0x382F, 0x3830, 0x3831, 0x3836, 0x3837,   // D330 - D33F
	0x3838, 0x3839, 0x383A, 0x383B, 0x383C, 0x383D, 0x383F, 0x3840, 0x3841, 0x3842, 0x3843, 0x3844, 0x3845, 0x3846, 0x3847, 0x3848,   // D340 - D34F
	0x3849, 0x384A, 0x384B, 0x384C, 0x384D, 0x384E, 0x384F, 0x3850, 0x3851, 0x3852, 0x3853, 0x3854, 0x3855, 0x3856, 0x3857, 0x3858,   // D350 - D35F
	0x3859, 0x385A, 0x385B, 0x385C, 0x385D, 0x385E, 0x385F, 0x3860, 0x3861, 0x3862, 0x3863, 0x3864, 0x3865, 0x3866, 0x3867, 0x3868,   // D360 - D36F
	0x3869, 0x386A, 0x386B, 0x386C, 0x386D, 0x386E, 0x386F, 0x3870, 0x3871, 0x3872, 0x3873, 0x3874, 0x3875, 0x3876, 0x3877, 0x3878,   // D370 - D37F
	0x3879, 0x387A, 0x387B, 0x387C, 0x387D, 0x387E, 0x387F, 0x3880, 0x3881, 0x3882, 0x3883, 0x3884, 0x3885, 0x3886, 0x3887, 0x3888,   // D380 - D38F
	0x3889, 0x388A, 0x388B, 0x388C, 0x388D, 0x388E, 0x388F, 0x3890, 0x3891, 0x3892, 0x3893, 0x3894, 0x3895, 0x3896, 0x3897, 0x3898,   // D390 - D39F
	0x3899, 0x389A, 0x389B, 0x389C, 0x389D, 0x389E, 0x389F, 0x38A0, 0x38A1, 0x38A2, 0x38A3, 0x38A4, 0x38A5, 0x38A6, 0x38A7, 0x38A8,   // D3A0 - D3AF
	0x38A9, 0x38AA, 0x38AB, 0x38AC, 0x38AD, 0x38AE, 0x38AF, 0x38B0, 0x38B1, 0x38BC, 0x38BD, 0x38BE, 0x38BF, 0x38C0, 0x38C1, 0x38C2,   // D3B0 - D3BF
	0x38C3, 0x38C4, 0x38C5, 0x38C6, 0x38C7, 0x38C9, 0x38CA, 0x38CB, 0x38CC, 0x38CD, 0x38D3, 0x38D4, 0x38D5, 0x38D6, 0x38D7, 0x38D8,   // D3C0 - D3CF
	0x38D9, 0x38E4, 0x38E5, 0x38E6, 0x38E7, 0x38E8, 0x38E9, 0x38EA, 0x38EB, 0x38EC, 0x38ED, 0x38EE, 0x38EF, 0x38F0, 0x38F1, 0x38F2,   // D3D0 - D3DF
	0x38F3, 0x38F4, 0x38F5, 0x38F6, 0x38F7, 0x38F8, 0x38F9, 0x38FA, 0x38FB, 0x38FC, 0x38FD, 0x38FE, 0x38FF, 0x391C, 0x3923, 0x3924,   // D3E0 - D3EF
	0x3925, 0x3926, 0x3927, 0x3928, 0x3929, 0x392A, 0x392B, 0x392C, 0x392D, 0x392E, 0x392F, 0x3930, 0x3931, 0x3932, 0x3933, 0x3934,   // D3F0 - D3FF
	0x3935, 0x3936, 0x3937, 0x3938, 0x3939, 0x393A, 0x393B, 0x393C, 0x393D, 0x393E, 0x393F, 0x3940, 0x3941, 0x3942, 0x3943, 0x3944,   // D400 - D40F
	0x3945, 0x3946, 0x3947, 0x3948, 0x3949, 0x394A, 0x394B, 0x394C, 0x394D, 0x394E, 0x394F, 0x3950, 0x3951, 0x3952, 0x3953, 0x3954,   // D410 - D41F
	0x3955, 0x3956, 0x3957, 0x3958, 0x3959, 0x395A, 0x395B, 0x395C, 0x395D, 0x395E, 0x395F, 0x3960, 0x3961, 0x3962, 0x3963, 0x3964,   // D420 - D42F
	0x3965, 0x3966, 0x3967, 0x3968, 0x3969, 0x396A, 0x396B, 0x396C, 0x396D, 0x396E, 0x396F, 0x3970, 0x3971, 0x3972, 0x3973, 0x3974,   // D430 - D43F
	0x3975, 0x3976, 0x3977, 0x3978, 0x3979, 0x397A, 0x397B, 0x397C, 0x397D, 0x397E, 0x397F, 0x3980, 0x3981, 0x3982, 0x3983, 0x3984,   // D440 - D44F
	0x3985, 0x3986, 0x3987, 0x3988, 0x3989, 0x398A, 0x398B, 0x398C, 0x398D, 0x398E, 0x398F, 0x3990, 0x3991, 0x39A0, 0x39A1, 0x39A2,   // D450 - D45F
	0x39A3, 0x39A4, 0x39A5, 0x39A6, 0x39A7, 0x39A8, 0x39A9, 0x39AA, 0x39AB, 0x39AC, 0x39AD, 0x39AE, 0x39AF, 0x39B0, 0x39B1, 0x39B2,   // D460 - D46F
	0x39B3, 0x39B4, 0x39B5, 0x39B6, 0x39B7, 0x39B8, 0x39B9, 0x39BA, 0x39BB, 0x39BC, 0x39BD, 0x39BE, 0x39BF, 0x39C0, 0x39C1, 0x39C2,   // D470 - D47F
	0x39C3, 0x39C4, 0x39C5, 0x39C6, 0x39C7, 0x39C8, 0x39C9, 0x39CA, 0x39CB, 0x39CE, 0x39CF, 0x39D0, 0x39D1, 0x39D2, 0x39D8, 0x39D9,   // D480 - D48F
	0x39DA, 0x39DB, 0x39DC, 0x39DD, 0x39DE, 0x39DF, 0x39E0, 0x39E1, 0x39E2, 0x39E3, 0x39E4, 0x39E5, 0x39E6, 0x39E7, 0x39E8, 0x39E9,   // D490 - D49F
	0x39EA, 0x39EB, 0x39EC, 0x39ED, 0x39EE, 0x39EF, 0x39F0, 0x39F1, 0x39F2, 0x39F3, 0x39F4, 0x39F5, 0x39F6, 0x39F7, 0x39F8, 0x39F9,   // D4A0 - D4AF
	0x39FA, 0x39FB, 0x39FC, 0x39FD, 0x39FE, 0x39FF, 0x3A00, 0x3A01, 0x3A02, 0x3A03, 0x3A04, 0x3A05, 0x3A06, 0x3A07, 0x3A08, 0x3A09,   // D4B0 - D4BF
	0x3A0A, 0x3A0B, 0x3A0C, 0x3A0D, 0x3A0E, 0x3A0F, 0x3A10, 0x3A11, 0x3A12, 0x3A13, 0x3A14, 0x3A15, 0x3A16, 0x3A17, 0x3A18, 0x3A19,   // D4C0 - D4CF
	0x3A1A, 0x3A1B, 0x3A1C, 0x3A1D, 0x3A1E, 0x3A1F, 0x3A20, 0x3A21, 0x3A22, 0x3A23, 0x3A24, 0x3A25, 0x3A26, 0x3A27, 0x3A28, 0x3A29,   // D4D0 - D4DF
	0x3A2A, 0x3A2B, 0x3A2C, 0x3A2D, 0x3A2E, 0x3A2F, 0x3A30, 0x3A31, 0x3A32, 0x3A33, 0x3A34, 0x3A35, 0x3A36, 0x3A37, 0x3A38, 0x3A39,   // D4E0 - D4EF
	0x3A3A, 0x3A3B, 0x3A3C, 0x3A3D, 0x3A3E, 0x3A3F, 0x3A40, 0x3A41, 0x3A42, 0x3A43, 0x3A44, 0x3A45, 0x3A46, 0x3A47, 0x3A48, 0x3A49,   // D4F0 - D4FF
	0x3A4A, 0x3A4B, 0x3A4C, 0x3A4D, 0x3A4E, 0x3A4F, 0x3A50, 0x3A51, 0x3A52, 0x3A53, 0x3A54, 0x3A55, 0x3A56, 0x3A57, 0x3A58, 0x3A59,   // D500 - D50F
	0x3A5A, 0x3A5B, 0x3A5C, 0x3A5D, 0x3A5E, 0x3A5F, 0x3A60, 0x3A61, 0x3A62, 0x3A63, 0x3A64, 0x3A65, 0x3A66, 0x3A67, 0x3A68, 0x3A69,   // D510 - D51F
	0x3A6A, 0x3A6B, 0x3A6C, 0x3A6D, 0x3A6E, 0x3A6F, 0x3A70, 0x3A71, 0x3A72, 0x3A73, 0x3A74, 0x3A75, 0x3A76, 0x3A77, 0x3A78, 0x3A79,   // D520 - D52F
	0x3A7A, 0x3A7B, 0x3A7C, 0x3A7D, 0x3A7E, 0x3A7F, 0x3A80, 0x3A81, 0x3A82, 0x3A83, 0x3A84, 0x3A85, 0x3A86, 0x3A8E, 0x3A8F, 0x3A90,   // D530 - D53F
	0x3A91, 0x3A92, 0x3A93, 0x3A94, 0x3A95, 0x3AA0, 0x3AA1, 0x3AA2, 0x3AA3, 0x3AA4, 0x3AA5, 0x3AA6, 0x3AA7, 0x3AA8, 0x3AAB, 0x3AAC,   // D540 - D54F
	0x3AAD, 0x3AAE, 0x3AAF, 0x3AB0, 0x3AB1, 0x3AB2, 0x3AB3, 0x3AB4, 0x3AB5, 0x3AC4, 0x3ACA, 0x3ACB, 0x3ACC, 0x3ADB, 0x3ADC, 0x3ADD,   // D550 - D55F
	0x3ADE, 0x3AE1, 0x3AE2, 0x3AE3, 0x3AE4, 0x3AE5, 0x3AE6, 0x3AE7, 0x3AE8, 0x3AF5, 0x3AFD, 0x3AFE, 0x3AFF, 0x3B00, 0x3B12, 0x3B13,   // D560 - D56F
	0x3B14, 0x3B15, 0x3B16, 0x3B17, 0x3B18, 0x3B2B, 0x3B2E, 0x3B2F, 0x3B30, 0x3B31, 0x3B32, 0x3B33, 0x3B34, 0x3B35, 0x3B36, 0x3B37,   // D570 - D57F
	0x3B38, 0x3B39, 0x3B3A, 0x3B3B, 0x3B3C, 0x3B3D, 0x3B3E, 0x3B3F, 0x3B40, 0x3B41, 0x3B47, 0x3B48, 0x3B49, 0x3B4A, 0x3B4B, 0x3B4C,   // D580 - D58F
	0x3B4D, 0x3B4E, 0x3B4F, 0x3B50, 0x3B51, 0x3B52, 0x3B53, 0x3B54, 0x3B55, 0x3B56, 0x3B57, 0x3B58, 0x3B59, 0x3B5A, 0x3B5B, 0x3B5C,   // D590 - D59F
	0x3B5D, 0x3B5E, 0x3B5F, 0x3B60, 0x3B61, 0x3B62, 0x3B6C, 0x3B6D, 0x3B6E, 0x3B6F, 0x3B70, 0x3B71, 0x3B72, 0x3B73, 0x3B74, 0x3B75,   // D5A0 - D5AF
	0x3B76, 0x3B77, 0x3B78, 0x3B79, 0x3B7A, 0x3B7B, 0x3B7C, 0x3B7D, 0x3B7E, 0x3B7F, 0x3B80, 0x3B81, 0x3B82, 0x3B83, 0x3B84, 0x3B85,   // D5B0 - D5BF
	0x3B86, 0x3B87, 0x3B88, 0x3B89, 0x3B8A, 0x3B8B, 0x3B8C, 0x3B8D, 0x3B8E, 0x3B93, 0x3B94, 0x3B95, 0x3B96, 0x3B9B, 0x3B9C, 0x3B9D,   // D5C0 - D5CF
	0x3B9E, 0x3BA0, 0x3BA1, 0x3BA2, 0x3BA3, 0x3BA4, 0x3BA5, 0x3BA6, 0x3BA7, 0x3BAA, 0x3BAB, 0x3BAC, 0x3BAD, 0x3BAE, 0x3BAF, 0x3BB0,   // D5D0 - D5DF
	0x3BB1, 0x3BB2, 0x3BB3, 0x3BB4, 0x3BB5, 0x3BB6, 0x3BB7, 0x3BB8, 0x3BB9, 0x3BBA, 0x3BBB, 0x3BBC, 0x3BBD, 0x3BBE, 0x3BBF, 0x3BC0,   // D5E0 - D5EF
	0x3BC1, 0x3BC2, 0x3BC3, 0x3BC4, 0x3BC5, 0x3BC6, 0x3BC7, 0x3BC8, 0x3BC9, 0x3BCA, 0x3BCB, 0x3BCC, 0x3BCD, 0x3BCE, 0x3BCF, 0x3BD0,   // D5F0 - D5FF
	0x3BD1, 0x3BD2, 0x3BD7, 0x3BD8, 0x3BD9, 0x3BEF, 0x3BF0, 0x3BF1, 0x3BF2, 0x3BF7, 0x3BF8, 0x3BF9, 0x3BFA, 0x3BFB, 0x3BFC, 0x3BFD,   // D600 - D60F
	0x3BFE, 0x3C00, 0x3C0D, 0x3C0E, 0x3C0F, 0x3C10, 0x3C25, 0x3C26, 0x3C27, 0x3C28, 0x3C29, 0x3C2A, 0x3C2B, 0x3C35, 0x3C36, 0x3C37,   // D610 - D61F
	0x3C38, 0x3C39, 0x3C3A, 0x3C3B, 0x3C3C, 0x3C3D, 0x3C3E, 0x3C3F, 0x3C40, 0x3C41, 0x3C42, 0x3C43, 0x3C44, 0x3C45, 0x3C46, 0x3C47,   // D620 - D62F
	0x3C48, 0x3C49, 0x3C4A, 0x3C4B, 0x3C4C, 0x3C4D, 0x3C4E, 0x3C4F, 0x3C50, 0x3C7A, 0x3C7E, 0x3C7F, 0x3C80, 0x3C87, 0x3C88, 0x3C89,   // D630 - D63F
	0x3C8A, 0x3C8E, 0x3C8F, 0x3C90, 0x3C91, 0x3C92, 0x3C93, 0x3C94, 0x3C95, 0x3C96, 0x3C97, 0x3C98, 0x3C99, 0x3C9A, 0x3CA5, 0x3CA6,   // D640 - D64F
	0x3CA7, 0x3CA8, 0x3CA9, 0x3CAA, 0x3CAB, 0x3CBA, 0x3CC1, 0x3CC2, 0x3CC3, 0x3CD5, 0x3CD6, 0x3CD7, 0x3CD8, 0x3CDE, 0x3CDF, 0x3CE0,   // D650 - D65F
	0x3CE1, 0x3CE2, 0x3CE3, 0x3CE4, 0x3CE5, 0x3CE6, 0x3CE7, 0x3CE8, 0x3CE9, 0x3CEA, 0x3D03, 0x3D04, 0x3D05, 0x3D06, 0x3D07, 0x3D08,   // D660 - D66F
	0x3D09, 0x3D0A, 0x3D0B, 0x3D0C, 0x3D0D, 0x3D0E, 0x3D0F, 0x3D10, 0x3D11, 0x3D12, 0x3D13, 0x3D14, 0x3D15, 0x3D16, 0x3D17, 0x3D18,   // D670 - D67F
	0x3D19, 0x3D1A, 0x3D1B, 0x3D1C, 0x3D1D, 0x3D1E, 0x3D1F, 0x3D20, 0x3D21, 0x3D22, 0x3D23, 0x3D24, 0x3D25, 0x3D3A, 0x3D3D, 0x3D3E,   // D680 - D68F
	0x3D3F, 0x3D40, 0x3D41, 0x3D42, 0x3D43, 0x3D44, 0x3D45, 0x3D46, 0x3D47, 0x3D48, 0x3D49, 0x3D4A, 0x3D4B, 0x3D4C, 0x3D4D, 0x3D4E,   // D690 - D69F
	0x3D4F, 0x3D50, 0x3D54, 0x3D55, 0x3D56, 0x3D57, 0x3D58, 0x3D59, 0x3D5A, 0x3D68, 0x3D69, 0x3D6A, 0x3D6B, 0x3D6C, 0x3D6D, 0x3D6E,   // D6A0 - D6AF
	0x3D6F, 0x3D70, 0x3D71, 0x3D72, 0x3D73, 0x3D74, 0x3D75, 0x3D76, 0x3D77, 0x3D78, 0x3D79, 0x3D7A, 0x3D7B, 0x3D7C, 0x3D7D, 0x3D7E,   // D6B0 - D6BF
	0x3D7F, 0x3D80, 0x3D81, 0x3D82, 0x3D83, 0x3D91, 0x3D92, 0x3D93, 0x3D94, 0x3D9F, 0x3DA0, 0x3DA1, 0x3DA2, 0x3DA3, 0x3DA4, 0x3DA5,   // D6C0 - D6CF
	0x3DA6, 0x3DA7, 0x3DA8, 0x3DA9, 0x3DAA, 0x3DAB, 0x3DAC, 0x3DAD, 0x3DAE, 0x3DAF, 0x3DB1, 0x3DB2, 0x3DB3, 0x3DB4, 0x3DB5, 0x3DB6,   // D6D0 - D6DF
	0x3DB7, 0x3DB8, 0x3DB9, 0x3DBA, 0x3DBB, 0x3DC0, 0x3DC1, 0x3DC2, 0x3DC3, 0x3DC4, 0x3DC5, 0x3DC6, 0x3DC7, 0x3DC8, 0x3DC9, 0x3DCA,   // D6E0 - D6EF
	0x3DCB, 0x3DCC, 0x3DCD, 0x3DCE, 0x3DCF, 0x3DD0, 0x3DD1, 0x3DD2, 0x3DD3, 0x3DD4, 0x3DD5, 0x3DD6, 0x3DD7, 0x3DDB, 0x3DDC, 0x3DDD,   // D6F0 - D6FF
	0x3DDE, 0x3DDF, 0x3DE0, 0x3DE1, 0x3DE2, 0x3DE3, 0x3DE4, 0x3DE5, 0x3DE6, 0x3DE7, 0x3DE8, 0x3DE9, 0x3DEA, 0x3DEB, 0x3DEC, 0x3DED,   // D700 - D70F
	0x3DEE, 0x3DEF, 0x3DF0, 0x3DF1, 0x3DF2, 0x3DF3, 0x3DF4, 0x3DF5, 0x3DF6, 0x3DFF, 0x3E00, 0x3E01, 0x3E02, 0x3E03, 0x3E04, 0x3E05,   // D710 - D71F
	0x3E06, 0x3E07, 0x3E08, 0x3E09, 0x3E0A, 0x3E0B, 0x3E0C, 0x3E0D, 0x3E0E, 0x3E0F, 0x3E10, 0x3E11, 0x3E12, 0x3E13, 0x3E14, 0x3E15,   // D720 - D72F
	0x3E16, 0x3E17, 0x3E18, 0x3E19, 0x3E1A, 0x3E20, 0x3E21, 0x3E22, 0x3E23, 0x3E24, 0x3E25, 0x3E26, 0x3E27, 0x3E2B, 0x3E2C, 0x3E2D,   // D730 - D73F
	0x3E2E, 0x3E2F, 0x3E30, 0x3E31, 0x3E32, 0x3E33, 0x3E34, 0x3E35, 0x3E36, 0x3E37, 0x3E3D, 0x3E3E, 0x3E3F, 0x3E40, 0x3E41, 0x3E42,   // D740 - D74F
	0x3E43, 0x3E44, 0x3E46, 0x3E47, 0x3E48, 0x3E4D, 0x3E4E, 0x3E4F, 0x3E50, 0x3E55, 0x3E56, 0x3E57, 0x3E58, 0x3E59, 0x3E5A, 0x3E5B,   // D750 - D75F
	0x3E5C, 0x3E60, 0x3E65, 0x3E66, 0x3E67, 0x3E68, 0x3E6A, 0x3E6B, 0x3E6C, 0x3E6D, 0x3E6E, 0x3E6F, 0x3E70, 0x3E85, 0x3E86, 0x3E87,   // D760 - D76F
	0x3E88, 0x3E89, 0x3E8A, 0x3E8B, 0x3E8C, 0x3E8D, 0x3E8E, 0x3E8F, 0x3E90, 0x3E91, 0x3E92, 0x3E93, 0x3E94, 0x3E95, 0x3E96, 0x3E97,   // D770 - D77F
	0x3E98, 0x3E99, 0x3E9A, 0x3E9B, 0x3E9C, 0x3E9D, 0x3E9E, 0x3E9F, 0x3EA0, 0x3EA1, 0x3EA2, 0x3EA3, 0x3EA4, 0x3EA5, 0x3EA6, 0x3EA7,   // D780 - D78F
	0x3EA8, 0x3EAA, 0x3EAB, 0x3EAC, 0x3EAD, 0x3EAE, 0x3EAF, 0x3EB0, 0x3EB1, 0x3EB2, 0x3EB3, 0x3EB4, 0x3EB5, 0x3EB6, 0x3EB7, 0x3EB8,   // D790 - D79F
	0x3EB9, 0x3EBA, 0x3EBB, 0x3EBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7A0 - D7AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7B0 - D7BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7C0 - D7CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7D0 - D7DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7E0 - D7EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7F0 - D7FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F700 - F70F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F710 - F71F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F720 - F72F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F730 - F73F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F740 - F74F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x3EBD, 0x3EBE,   // F750 - F75F
	0x3EBF, 0x3EC0, 0x3EC1, 0x3EC2, 0x3EC3, 0x3EC4, 0x3EC5, 0x3EC6, 0x3EC7, 0x3EC8, 0x3EC9, 0x3ECA, 0x3ECB, 0x3ECC, 0x3ECD, 0x3ECE,   // F760 - F76F
	0x3ECF, 0x3ED0, 0x3ED1, 0x3ED2, 0x3ED3, 0x3ED4, 0x3ED5, 0x3ED6, 0x3ED7, 0x3ED8, 0x3ED9, 0x3EDA, 0x3EDB, 0x3EDC, 0x3EDD, 0x3EDE,   // F770 - F77F
	0x3EDF, 0x3EE0, 0x3EE1, 0x3EE2, 0x3EE3, 0x3EE4, 0x3EE5, 0x3EE6, 0x3EE7, 0x3EE8, 0x3EE9, 0x3EEA, 0x3EEB, 0x3EEC, 0x3EED, 0x3EEE,   // F780 - F78F
	0x3EEF, 0x3EF0, 0x3EF1, 0x3EF2, 0x3EF3, 0x3EF4, 0x3EF5, 0x3EF6, 0x3EF7, 0x3EF8, 0x3EF9, 0x3EFA, 0x3EFB, 0x3EFC, 0x3EFD, 0x3EFE,   // F790 - F79F
	0x3EFF, 0x3F00, 0x3F01, 0x3F02, 0x3F03, 0x3F04, 0x3F05, 0x3F06, 0x3F07, 0x3F08, 0x3F09, 0x3F0A, 0x3F0B, 0x3F0C, 0x3F0D, 0x3F0E,   // F7A0 - F7AF
	0x3F0F, 0x3F10, 0x3F11, 0x3F12, 0x3F13, 0x3F14, 0x3F15, 0x3F16, 0x3F17, 0x3F18, 0x3F19, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F7B0 - F7BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F7C0 - F7CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F7D0 - F7DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F7E0 - F7EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F7F0 - F7FF
	0x00AB, 0x00C6, 0x0116, 0x022A, 0x024B, 0x0286, 0x03F2, 0x03F7, 0x042D, 0x0465, 0x047A, 0x075F, 0x0760, 0x0763, 0x0766, 0x0767,   // F900 - F90F
	0x0768, 0x0769, 0x076A, 0x076B, 0x076E, 0x076F, 0x0770, 0x0771, 0x0772, 0x0774, 0x0775, 0x0779, 0x077A, 0x077C, 0x077E, 0x077F,   // F910 - F91F
	0x0781, 0x0791, 0x0795, 0x0797, 0x0798, 0x079A, 0x079C, 0x079D, 0x07A5, 0x07A6, 0x07A7, 0x07A8, 0x07A9, 0x07B2, 0x07CC, 0x0887,   // F920 - F92F
	0x088B, 0x088C, 0x088D, 0x088F, 0x0890, 0x0891, 0x0892, 0x0893, 0x0894, 0x0896, 0x0897, 0x0899, 0x089A, 0x089B, 0x089C, 0x089D,   // F930 - F93F
	0x089E, 0x08A2, 0x08B4, 0x08B5, 0x08B7, 0x08B8, 0x08FB, 0x08FC, 0x08FE, 0x08FF, 0x0939, 0x093A, 0x093B, 0x093C, 0x093D, 0x093E,   // F940 - F94F
	0x093F, 0x0940, 0x09D2, 0x09D3, 0x09E3, 0x09E9, 0x09EA, 0x09EB, 0x09ED, 0x09EE, 0x0C43, 0x0F85, 0x0F8D, 0x0F93, 0x0F99, 0x10BA,   // F950 - F95F
	0x10F2, 0x1252, 0x12B7, 0x1694, 0x170B, 0x1762, 0x1880, 0x18B8, 0x1993, 0x1C62, 0x1C64, 0x1C86, 0x1CC1, 0x1CDC, 0x1D93, 0x1DB8,   // F960 - F96F
	0x1E84, 0x2064, 0x207A, 0x2083, 0x2375, 0x2379, 0x237A, 0x2395, 0x2397, 0x2398, 0x23A0, 0x23AA, 0x23AC, 0x23AE, 0x23B2, 0x2431,   // F970 - F97F
	0x2432, 0x2433, 0x2435, 0x2436, 0x2439, 0x243C, 0x2442, 0x2444, 0x2445, 0x2446, 0x2449, 0x244D, 0x244E, 0x2452, 0x245D, 0x245F,   // F980 - F98F
	0x2460, 0x2463, 0x246B, 0x246F, 0x2472, 0x2475, 0x2478, 0x247A, 0x247D, 0x247E, 0x247F, 0x2481, 0x2487, 0x2488, 0x2489, 0x248C,   // F990 - F99F
	0x248E, 0x248F, 0x249A, 0x249B, 0x249C, 0x249E, 0x24A4, 0x24AA, 0x24B1, 0x24B2, 0x24B4, 0x24B5, 0x24B8, 0x24C7, 0x24C9, 0x24CE,   // F9A0 - F9AF
	0x24CF, 0x24D3, 0x24D5, 0x24D7, 0x24D8, 0x24E2, 0x24EE, 0x24F3, 0x24F5, 0x2522, 0x25E0, 0x25E1, 0x25E9, 0x25EA, 0x25F0, 0x25F2,   // F9B0 - F9BF
	0x25F4, 0x25F7, 0x25FE, 0x2603, 0x2638, 0x266E, 0x26B2, 0x2726, 0x2735, 0x2738, 0x273D, 0x273F, 0x2743, 0x2746, 0x2748, 0x2749,   // F9C0 - F9CF
	0x2759, 0x275B, 0x275D, 0x2761, 0x2765, 0x2769, 0x276A, 0x276F, 0x2776, 0x2777, 0x2778, 0x2779, 0x278C, 0x27F7, 0x27F8, 0x27FB,   // F9D0 - F9DF
	0x2800, 0x2801, 0x2802, 0x2803, 0x2806, 0x2809, 0x280B, 0x2811, 0x2812, 0x2816, 0x2817, 0x281B, 0x281C, 0x282A, 0x2832, 0x2833,   // F9E0 - F9EF
	0x2836, 0x2839, 0x283C, 0x283D, 0x2858, 0x2859, 0x285B, 0x2861, 0x2862, 0x2863, 0x28CE, 0x2975, 0x2C8E, 0x2CDC, 0x2F48, 0x300D,   // F9F0 - F9FF
	0x306F, 0x353E, 0x3540, 0x3574, 0x358C, 0x366F, 0x390C, 0x3922, 0x3B0F, 0x3B10, 0x3BEB, 0x3CBB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA00 - FA0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA10 - FA1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA20 - FA2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA30 - FA3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA40 - FA4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA50 - FA5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA60 - FA6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA70 - FA7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA80 - FA8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA90 - FA9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAA0 - FAAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAB0 - FABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAC0 - FACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAD0 - FADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAE0 - FAEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAF0 - FAFF
};

sal_Int32 SAL_CALL Collator_ko_KR_dict::compareSubstring (
            const ::rtl::OUString& str1, sal_Int32 off1, sal_Int32 len1,
            const ::rtl::OUString& str2, sal_Int32 off2, sal_Int32 len2)
            throw (::com::sun::star::uno::RuntimeException) {
        return compare(str1, off1, len1, str2, off2, len2, index, weight);
}

sal_Int32 SAL_CALL Collator_ko_KR_dict::compareString (
            const ::rtl::OUString& str1,
            const ::rtl::OUString& str2)
            throw (::com::sun::star::uno::RuntimeException) {
        return compare(str1, 0, str1.getLength(), str2, 0, str2.getLength(), index, weight);
}

