/*************************************************************************
 *
 *  $RCSfile: collator_ko_KR_charset.cxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: bustamam $ $Date: 2001/12/15 13:39:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <collator_CJK.hxx>

static sal_uInt16 index[] = {
	0x0000, 0x0100, 0x0200, 0x0300, 0x0400, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 1000
	0x0500, 0x0600, 0x0700, 0x0800, 0x0900, 0x0A00, 0x0B00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2000
	0x0C00, 0x0D00, 0x0E00, 0x0F00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1000, 0x1100,   // 4000
	0x1200, 0x1300, 0x1400, 0x1500, 0x1600, 0x1700, 0x1800, 0x1900, 0x1A00, 0x1B00, 0x1C00, 0x1D00, 0x1E00, 0x1F00, 0x2000, 0x2100,   // 5000
	0x2200, 0x2300, 0x2400, 0x2500, 0x2600, 0x2700, 0x2800, 0x2900, 0x2A00, 0x2B00, 0x2C00, 0x2D00, 0x2E00, 0x2F00, 0x3000, 0x3100,   // 6000
	0x3200, 0x3300, 0x3400, 0x3500, 0x3600, 0x3700, 0x3800, 0x3900, 0x3A00, 0x3B00, 0x3C00, 0x3D00, 0x3E00, 0x3F00, 0x4000, 0x4100,   // 7000
	0x4200, 0x4300, 0x4400, 0x4500, 0x4600, 0x4700, 0x4800, 0x4900, 0x4A00, 0x4B00, 0x4C00, 0x4D00, 0x4E00, 0x4F00, 0x5000, 0x5100,   // 8000
	0x5200, 0x5300, 0x5400, 0x5500, 0x5600, 0x5700, 0x5800, 0x5900, 0x5A00, 0x5B00, 0x5C00, 0x5D00, 0x5E00, 0x5F00, 0x6000, 0x6100,   // 9000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x6200, 0x6300, 0x6400, 0x6500,   // A000
	0x6600, 0x6700, 0x6800, 0x6900, 0x6A00, 0x6B00, 0x6C00, 0x6D00, 0x6E00, 0x6F00, 0x7000, 0x7100, 0x7200, 0x7300, 0x7400, 0x7500,   // B000
	0x7600, 0x7700, 0x7800, 0x7900, 0x7A00, 0x7B00, 0x7C00, 0x7D00, 0x7E00, 0x7F00, 0x8000, 0x8100, 0x8200, 0x8300, 0x8400, 0x8500,   // C000
	0x8600, 0x8700, 0x8800, 0x8900, 0x8A00, 0x8B00, 0x8C00, 0x8D00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // E000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x8E00, 0x8F00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x9000,   // F000
};

static sal_uInt16 weight[] = {
	0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007, 0x0008, 0x0009, 0x000A, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F, 0x0010,   // 0000 - 000F
	0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017, 0x0018, 0x0019, 0x001A, 0x001B, 0x001C, 0x001D, 0x001E, 0x001F, 0x0020,   // 0010 - 001F
	0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027, 0x0028, 0x0029, 0x002A, 0x002B, 0x002C, 0x002D, 0x002E, 0x002F, 0x0030,   // 0020 - 002F
	0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037, 0x0038, 0x0039, 0x003A, 0x003B, 0x003C, 0x003D, 0x003E, 0x003F, 0x0040,   // 0030 - 003F
	0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047, 0x0048, 0x0049, 0x004A, 0x004B, 0x004C, 0x004D, 0x004E, 0x004F, 0x0050,   // 0040 - 004F
	0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057, 0x0058, 0x0059, 0x005A, 0x005B, 0x005C, 0x005D, 0x005E, 0x005F, 0x0060,   // 0050 - 005F
	0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067, 0x0068, 0x0069, 0x006A, 0x006B, 0x006C, 0x006D, 0x006E, 0x006F, 0x0070,   // 0060 - 006F
	0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077, 0x0078, 0x0079, 0x007A, 0x007B, 0x007C, 0x007D, 0x007E, 0x007F, 0x0080,   // 0070 - 007F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0080 - 008F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0090 - 009F
	0xFFFF, 0x00EC, 0xFFFF, 0xFFFF, 0x00F2, 0xFFFF, 0xFFFF, 0x00B7, 0x0087, 0xFFFF, 0x02B9, 0xFFFF, 0xFFFF, 0x0089, 0xFFFF, 0xFFFF,   // 00A0 - 00AF
	0x00A6, 0x009E, 0x0368, 0x0369, 0x00E3, 0xFFFF, 0x0110, 0x0084, 0x00EA, 0x0367, 0x02C0, 0xFFFF, 0x030C, 0x0309, 0x030D, 0x00ED,   // 00B0 - 00BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02B7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 00C0 - 00CF
	0x02B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x009F, 0x02BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02C1, 0x031D,   // 00D0 - 00DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0312, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 00E0 - 00EF
	0x0314, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00A0, 0x031B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x031E, 0xFFFF,   // 00F0 - 00FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0100 - 010F
	0xFFFF, 0x0313, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0110 - 011F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02BA, 0x0315, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0120 - 012F
	0xFFFF, 0x0316, 0x02BB, 0x0317, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0318, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02BC,   // 0130 - 013F
	0x0319, 0x02BD, 0x031A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0321, 0x02C3, 0x0320, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0140 - 014F
	0xFFFF, 0xFFFF, 0x02BF, 0x031C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0150 - 015F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x02C2, 0x031F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0160 - 016F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0170 - 017F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0180 - 018F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0190 - 019F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 01A0 - 01AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 01B0 - 01BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 01C0 - 01CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 01D0 - 01DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 01E0 - 01EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 01F0 - 01FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0200 - 020F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0210 - 021F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0220 - 022F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0230 - 023F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0240 - 024F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0250 - 025F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0260 - 026F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0270 - 027F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0280 - 028F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0290 - 029F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 02A0 - 02AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 02B0 - 02BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 02C0 - 02CF
	0x00EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00E6, 0x00E9, 0x00E8, 0x00EB, 0xFFFF, 0x00E7, 0xFFFF, 0xFFFF,   // 02D0 - 02DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 02E0 - 02EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 02F0 - 02FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0300 - 030F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0310 - 031F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0320 - 032F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0330 - 033F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0340 - 034F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0350 - 035F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0360 - 036F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0370 - 037F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0380 - 038F
	0xFFFF, 0x01F4, 0x01F5, 0x01F6, 0x01F7, 0x01F8, 0x01F9, 0x01FA, 0x01FB, 0x01FC, 0x01FD, 0x01FE, 0x01FF, 0x0200, 0x0201, 0x0202,   // 0390 - 039F
	0x0203, 0x0204, 0xFFFF, 0x0205, 0x0206, 0x0207, 0x0208, 0x0209, 0x020A, 0x020B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 03A0 - 03AF
	0xFFFF, 0x020C, 0x020D, 0x020E, 0x020F, 0x0210, 0x0211, 0x0212, 0x0213, 0x0214, 0x0215, 0x0216, 0x0217, 0x0218, 0x0219, 0x021A,   // 03B0 - 03BF
	0x021B, 0x021C, 0xFFFF, 0x021D, 0x021E, 0x021F, 0x0220, 0x0221, 0x0222, 0x0223, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 03C0 - 03CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 03D0 - 03DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 03E0 - 03EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 03F0 - 03FF
	0xFFFF, 0x041F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0400 - 040F
	0x0419, 0x041A, 0x041B, 0x041C, 0x041D, 0x041E, 0x0420, 0x0421, 0x0422, 0x0423, 0x0424, 0x0425, 0x0426, 0x0427, 0x0428, 0x0429,   // 0410 - 041F
	0x042A, 0x042B, 0x042C, 0x042D, 0x042E, 0x042F, 0x0430, 0x0431, 0x0432, 0x0433, 0x0434, 0x0435, 0x0436, 0x0437, 0x0438, 0x0439,   // 0420 - 042F
	0x043A, 0x043B, 0x043C, 0x043D, 0x043E, 0x043F, 0x0441, 0x0442, 0x0443, 0x0444, 0x0445, 0x0446, 0x0447, 0x0448, 0x0449, 0x044A,   // 0430 - 043F
	0x044B, 0x044C, 0x044D, 0x044E, 0x044F, 0x0450, 0x0451, 0x0452, 0x0453, 0x0454, 0x0455, 0x0456, 0x0457, 0x0458, 0x0459, 0x045A,   // 0440 - 044F
	0xFFFF, 0x0440, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0450 - 045F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0460 - 046F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0470 - 047F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0480 - 048F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0490 - 049F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 04A0 - 04AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 04B0 - 04BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 04C0 - 04CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 04D0 - 04DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 04E0 - 04EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 04F0 - 04FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2000 - 200F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x008A, 0xFFFF, 0xFFFF, 0x008E, 0x008F, 0xFFFF, 0xFFFF, 0x0090, 0x0091, 0xFFFF, 0xFFFF,   // 2010 - 201F
	0x0111, 0x0112, 0xFFFF, 0xFFFF, 0xFFFF, 0x0085, 0x0086, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2020 - 202F
	0x00F4, 0xFFFF, 0x00A7, 0x00A8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2030 - 203F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2040 - 204F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2050 - 205F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2060 - 206F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x036A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x036B,   // 2070 - 207F
	0xFFFF, 0x036C, 0x036D, 0x036E, 0x036F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2080 - 208F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2090 - 209F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 20A0 - 20AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 20B0 - 20BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 20C0 - 20CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 20D0 - 20DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 20E0 - 20EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 20F0 - 20FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x00A9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00F3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2100 - 210F
	0xFFFF, 0xFFFF, 0xFFFF, 0x026B, 0xFFFF, 0xFFFF, 0x011E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2110 - 211F
	0xFFFF, 0x0123, 0x0120, 0xFFFF, 0xFFFF, 0xFFFF, 0x02A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2120 - 212F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2130 - 213F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2140 - 214F
	0xFFFF, 0xFFFF, 0xFFFF, 0x030A, 0x030B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x030E, 0x030F, 0x0310, 0x0311, 0xFFFF,   // 2150 - 215F
	0x01EA, 0x01EB, 0x01EC, 0x01ED, 0x01EE, 0x01EF, 0x01F0, 0x01F1, 0x01F2, 0x01F3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2160 - 216F
	0x01E0, 0x01E1, 0x01E2, 0x01E3, 0x01E4, 0x01E5, 0x01E6, 0x01E7, 0x01E8, 0x01E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2170 - 217F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2180 - 218F
	0x00C7, 0x00C8, 0x00C6, 0x00C9, 0x00CA, 0x0113, 0x0116, 0x0114, 0x0117, 0x0115, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2190 - 219F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 21A0 - 21AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 21B0 - 21BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 21C0 - 21CF
	0xFFFF, 0xFFFF, 0x00DF, 0xFFFF, 0x00E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 21D0 - 21DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 21E0 - 21EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 21F0 - 21FF
	0x00E1, 0xFFFF, 0x00B3, 0x00E2, 0xFFFF, 0xFFFF, 0xFFFF, 0x00B4, 0x00D4, 0xFFFF, 0xFFFF, 0x00D5, 0xFFFF, 0xFFFF, 0xFFFF, 0x00F1,   // 2200 - 220F
	0xFFFF, 0x00F0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00CE, 0xFFFF, 0xFFFF, 0x00D0, 0x00A4, 0xFFFF,   // 2210 - 221F
	0x00B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x008B, 0xFFFF, 0x00DC, 0x00DD, 0x00DB, 0x00DA, 0x00D2, 0x00D3, 0xFFFF, 0x00EF, 0xFFFF,   // 2220 - 222F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00A5, 0x00D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x008D, 0x00CF, 0xFFFF, 0xFFFF,   // 2230 - 223F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2240 - 224F
	0xFFFF, 0xFFFF, 0x00B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2250 - 225F
	0x00A1, 0x00B5, 0xFFFF, 0xFFFF, 0x00A2, 0x00A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00CC, 0x00CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2260 - 226F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2270 - 227F
	0xFFFF, 0xFFFF, 0x00D8, 0x00D9, 0xFFFF, 0xFFFF, 0x00D6, 0x00D7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2280 - 228F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2290 - 229F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 22A0 - 22AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 22B0 - 22BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 22C0 - 22CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 22D0 - 22DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 22E0 - 22EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 22F0 - 22FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2300 - 230F
	0xFFFF, 0xFFFF, 0x00B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2310 - 231F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2320 - 232F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2330 - 233F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2340 - 234F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2350 - 235F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2360 - 236F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2370 - 237F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2380 - 238F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2390 - 239F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 23A0 - 23AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 23B0 - 23BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 23C0 - 23CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 23D0 - 23DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 23E0 - 23EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 23F0 - 23FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2400 - 240F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2410 - 241F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2420 - 242F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2430 - 243F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2440 - 244F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2450 - 245F
	0x02FA, 0x02FB, 0x02FC, 0x02FD, 0x02FE, 0x02FF, 0x0300, 0x0301, 0x0302, 0x0303, 0x0304, 0x0305, 0x0306, 0x0307, 0x0308, 0xFFFF,   // 2460 - 246F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0358, 0x0359, 0x035A, 0x035B, 0x035C, 0x035D, 0x035E, 0x035F, 0x0360, 0x0361, 0x0362, 0x0363,   // 2470 - 247F
	0x0364, 0x0365, 0x0366, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2480 - 248F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x033E, 0x033F, 0x0340, 0x0341,   // 2490 - 249F
	0x0342, 0x0343, 0x0344, 0x0345, 0x0346, 0x0347, 0x0348, 0x0349, 0x034A, 0x034B, 0x034C, 0x034D, 0x034E, 0x034F, 0x0350, 0x0351,   // 24A0 - 24AF
	0x0352, 0x0353, 0x0354, 0x0355, 0x0356, 0x0357, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 24B0 - 24BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 24C0 - 24CF
	0x02E0, 0x02E1, 0x02E2, 0x02E3, 0x02E4, 0x02E5, 0x02E6, 0x02E7, 0x02E8, 0x02E9, 0x02EA, 0x02EB, 0x02EC, 0x02ED, 0x02EE, 0x02EF,   // 24D0 - 24DF
	0x02F0, 0x02F1, 0x02F2, 0x02F3, 0x02F4, 0x02F5, 0x02F6, 0x02F7, 0x02F8, 0x02F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 24E0 - 24EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 24F0 - 24FF
	0x0224, 0x022F, 0x0225, 0x0230, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0226, 0x024B, 0x024A, 0x0231,   // 2500 - 250F
	0x0227, 0x0245, 0x0244, 0x0232, 0x0229, 0x0249, 0x0248, 0x0234, 0x0228, 0x0247, 0x0246, 0x0233, 0x022A, 0x023F, 0x024C, 0x024D,   // 2510 - 251F
	0x023A, 0x024E, 0x024F, 0x0235, 0x022C, 0x0241, 0x0250, 0x0251, 0x023C, 0x0252, 0x0253, 0x0237, 0x022B, 0x0254, 0x0255, 0x023B,   // 2520 - 252F
	0x0240, 0x0256, 0x0257, 0x0236, 0x022D, 0x0258, 0x0259, 0x023D, 0x0242, 0x025A, 0x025B, 0x0238, 0x022E, 0x025C, 0x025D, 0x023E,   // 2530 - 253F
	0x025E, 0x025F, 0x0243, 0x0260, 0x0261, 0x0262, 0x0263, 0x0264, 0x0265, 0x0266, 0x0267, 0x0239, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2540 - 254F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2550 - 255F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2560 - 256F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2570 - 257F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2580 - 258F
	0xFFFF, 0xFFFF, 0x0104, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2590 - 259F
	0x00C1, 0x00C0, 0xFFFF, 0x0101, 0x0105, 0x0106, 0x0109, 0x0108, 0x0107, 0x010A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 25A0 - 25AF
	0xFFFF, 0xFFFF, 0x00C3, 0x00C2, 0xFFFF, 0xFFFF, 0x00F8, 0x00F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00C5, 0x00C4, 0xFFFF, 0xFFFF,   // 25B0 - 25BF
	0x00F6, 0x00F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00BF, 0x00BE, 0x0100, 0xFFFF, 0xFFFF, 0x00BB, 0xFFFF, 0xFFFF, 0x00BD, 0x00BC,   // 25C0 - 25CF
	0x0102, 0x0103, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 25D0 - 25DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 25E0 - 25EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 25F0 - 25FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x00BA, 0x00B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x010D, 0x010C,   // 2600 - 260F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x010E, 0xFFFF, 0x010F, 0xFFFF,   // 2610 - 261F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2620 - 262F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2630 - 263F
	0x00AF, 0xFFFF, 0x00AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2640 - 264F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2650 - 265F
	0x00FA, 0x00FB, 0xFFFF, 0x00FE, 0x00F9, 0x00FC, 0xFFFF, 0x00FD, 0x010B, 0x0119, 0x011A, 0xFFFF, 0x011B, 0x0118, 0xFFFF, 0xFFFF,   // 2660 - 266F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2670 - 267F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2680 - 268F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2690 - 269F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 26A0 - 26AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 26B0 - 26BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 26C0 - 26CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 26D0 - 26DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 26E0 - 26EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 26F0 - 26FF
	0x0081, 0x0082, 0x0083, 0x0088, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0094, 0x0095, 0x0096, 0x0097, 0x0098, 0x0099, 0x009A, 0x009B,   // 3000 - 300F
	0x009C, 0x009D, 0xFFFF, 0x00CB, 0x0092, 0x0093, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3010 - 301F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3020 - 302F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3030 - 303F
	0xFFFF, 0x0370, 0x0371, 0x0372, 0x0373, 0x0374, 0x0375, 0x0376, 0x0377, 0x0378, 0x0379, 0x037A, 0x037B, 0x037C, 0x037D, 0x037E,   // 3040 - 304F
	0x037F, 0x0380, 0x0381, 0x0382, 0x0383, 0x0384, 0x0385, 0x0386, 0x0387, 0x0388, 0x0389, 0x038A, 0x038B, 0x038C, 0x038D, 0x038E,   // 3050 - 305F
	0x038F, 0x0390, 0x0391, 0x0392, 0x0393, 0x0394, 0x0395, 0x0396, 0x0397, 0x0398, 0x0399, 0x039A, 0x039B, 0x039C, 0x039D, 0x039E,   // 3060 - 306F
	0x039F, 0x03A0, 0x03A1, 0x03A2, 0x03A3, 0x03A4, 0x03A5, 0x03A6, 0x03A7, 0x03A8, 0x03A9, 0x03AA, 0x03AB, 0x03AC, 0x03AD, 0x03AE,   // 3070 - 307F
	0x03AF, 0x03B0, 0x03B1, 0x03B2, 0x03B3, 0x03B4, 0x03B5, 0x03B6, 0x03B7, 0x03B8, 0x03B9, 0x03BA, 0x03BB, 0x03BC, 0x03BD, 0x03BE,   // 3080 - 308F
	0x03BF, 0x03C0, 0x03C1, 0x03C2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3090 - 309F
	0xFFFF, 0x03C3, 0x03C4, 0x03C5, 0x03C6, 0x03C7, 0x03C8, 0x03C9, 0x03CA, 0x03CB, 0x03CC, 0x03CD, 0x03CE, 0x03CF, 0x03D0, 0x03D1,   // 30A0 - 30AF
	0x03D2, 0x03D3, 0x03D4, 0x03D5, 0x03D6, 0x03D7, 0x03D8, 0x03D9, 0x03DA, 0x03DB, 0x03DC, 0x03DD, 0x03DE, 0x03DF, 0x03E0, 0x03E1,   // 30B0 - 30BF
	0x03E2, 0x03E3, 0x03E4, 0x03E5, 0x03E6, 0x03E7, 0x03E8, 0x03E9, 0x03EA, 0x03EB, 0x03EC, 0x03ED, 0x03EE, 0x03EF, 0x03F0, 0x03F1,   // 30C0 - 30CF
	0x03F2, 0x03F3, 0x03F4, 0x03F5, 0x03F6, 0x03F7, 0x03F8, 0x03F9, 0x03FA, 0x03FB, 0x03FC, 0x03FD, 0x03FE, 0x03FF, 0x0400, 0x0401,   // 30D0 - 30DF
	0x0402, 0x0403, 0x0404, 0x0405, 0x0406, 0x0407, 0x0408, 0x0409, 0x040A, 0x040B, 0x040C, 0x040D, 0x040E, 0x040F, 0x0410, 0x0411,   // 30E0 - 30EF
	0x0412, 0x0413, 0x0414, 0x0415, 0x0416, 0x0417, 0x0418, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 30F0 - 30FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3100 - 310F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3110 - 311F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3120 - 312F
	0xFFFF, 0x0182, 0x0183, 0x0184, 0x0185, 0x0186, 0x0187, 0x0188, 0x0189, 0x018A, 0x018B, 0x018C, 0x018D, 0x018E, 0x018F, 0x0190,   // 3130 - 313F
	0x0191, 0x0192, 0x0193, 0x0194, 0x0195, 0x0196, 0x0197, 0x0198, 0x0199, 0x019A, 0x019B, 0x019C, 0x019D, 0x019E, 0x019F, 0x01A0,   // 3140 - 314F
	0x01A1, 0x01A2, 0x01A3, 0x01A4, 0x01A5, 0x01A6, 0x01A7, 0x01A8, 0x01A9, 0x01AA, 0x01AB, 0x01AC, 0x01AD, 0x01AE, 0x01AF, 0x01B0,   // 3150 - 315F
	0x01B1, 0x01B2, 0x01B3, 0x01B4, 0x01B5, 0x01B6, 0x01B7, 0x01B8, 0x01B9, 0x01BA, 0x01BB, 0x01BC, 0x01BD, 0x01BE, 0x01BF, 0x01C0,   // 3160 - 316F
	0x01C1, 0x01C2, 0x01C3, 0x01C4, 0x01C5, 0x01C6, 0x01C7, 0x01C8, 0x01C9, 0x01CA, 0x01CB, 0x01CC, 0x01CD, 0x01CE, 0x01CF, 0x01D0,   // 3170 - 317F
	0x01D1, 0x01D2, 0x01D3, 0x01D4, 0x01D5, 0x01D6, 0x01D7, 0x01D8, 0x01D9, 0x01DA, 0x01DB, 0x01DC, 0x01DD, 0x01DE, 0x01DF, 0xFFFF,   // 3180 - 318F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3190 - 319F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 31A0 - 31AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 31B0 - 31BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 31C0 - 31CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 31D0 - 31DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 31E0 - 31EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 31F0 - 31FF
	0x0322, 0x0323, 0x0324, 0x0325, 0x0326, 0x0327, 0x0328, 0x0329, 0x032A, 0x032B, 0x032C, 0x032D, 0x032E, 0x032F, 0x0330, 0x0331,   // 3200 - 320F
	0x0332, 0x0333, 0x0334, 0x0335, 0x0336, 0x0337, 0x0338, 0x0339, 0x033A, 0x033B, 0x033C, 0x033D, 0x011D, 0xFFFF, 0xFFFF, 0xFFFF,   // 3210 - 321F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3220 - 322F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3230 - 323F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3240 - 324F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3250 - 325F
	0x02C4, 0x02C5, 0x02C6, 0x02C7, 0x02C8, 0x02C9, 0x02CA, 0x02CB, 0x02CC, 0x02CD, 0x02CE, 0x02CF, 0x02D0, 0x02D1, 0x02D2, 0x02D3,   // 3260 - 326F
	0x02D4, 0x02D5, 0x02D6, 0x02D7, 0x02D8, 0x02D9, 0x02DA, 0x02DB, 0x02DC, 0x02DD, 0x02DE, 0x02DF, 0xFFFF, 0xFFFF, 0xFFFF, 0x011C,   // 3270 - 327F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3280 - 328F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3290 - 329F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 32A0 - 32AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 32B0 - 32BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 32C0 - 32CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 32D0 - 32DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 32E0 - 32EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 32F0 - 32FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3300 - 330F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3310 - 331F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3320 - 332F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3330 - 333F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3340 - 334F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3350 - 335F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3360 - 336F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3370 - 337F
	0x0290, 0x0291, 0x0292, 0x0293, 0x0294, 0xFFFF, 0xFFFF, 0xFFFF, 0x0281, 0x0282, 0x02A3, 0x02A4, 0x02A5, 0x027D, 0x027E, 0x027F,   // 3380 - 338F
	0x029B, 0x029C, 0x029D, 0x029E, 0x029F, 0x0268, 0x0269, 0x026A, 0x026C, 0x0272, 0x0273, 0x0274, 0x0275, 0x0276, 0x0277, 0x0278,   // 3390 - 339F
	0x0279, 0x027A, 0x027B, 0x026E, 0x026F, 0x0270, 0x0271, 0x0284, 0x0285, 0x02AC, 0x02AD, 0x02AE, 0x02AF, 0x02A8, 0x02A9, 0x02AA,   // 33A0 - 33AF
	0x0286, 0x0287, 0x0288, 0x0289, 0x028A, 0x028B, 0x028C, 0x028D, 0x028E, 0x028F, 0x0295, 0x0296, 0x0297, 0x0298, 0x0299, 0x029A,   // 33B0 - 33BF
	0x02A1, 0x02A2, 0x0121, 0x02B3, 0x026D, 0x02A7, 0x02B6, 0x011F, 0x0283, 0x02B4, 0x027C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0280,   // 33C0 - 33CF
	0x02B1, 0xFFFF, 0xFFFF, 0x02B2, 0xFFFF, 0xFFFF, 0x02A6, 0xFFFF, 0x0122, 0xFFFF, 0xFFFF, 0x02AB, 0x02B5, 0x02B0, 0xFFFF, 0xFFFF,   // 33D0 - 33DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 33E0 - 33EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 33F0 - 33FF
	0x1A4D, 0x1B49, 0xFFFF, 0x1DE2, 0xFFFF, 0xFFFF, 0xFFFF, 0x12BE, 0x1A9D, 0x1550, 0x155C, 0x1EE5, 0xFFFF, 0x1478, 0xFFFF, 0xFFFF,   // 4E00 - 4E0F
	0xFFFF, 0x1D96, 0xFFFF, 0xFFFF, 0x1C9C, 0x14C2, 0x1600, 0xFFFF, 0x0F58, 0x1434, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16C0, 0xFFFF,   // 4E10 - 4E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C23, 0xFFFF, 0xFFFF,   // 4E20 - 4E2F
	0xFFFF, 0xFFFF, 0x0EFC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FF3, 0x10D7, 0xFFFF, 0x1BE5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4E30 - 4E3F
	0xFFFF, 0xFFFF, 0x185F, 0x1084, 0xFFFF, 0x0F59, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C37, 0xFFFF, 0x14FF, 0x1FA0, 0x1EE3,   // 4E40 - 4E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F32, 0xFFFF, 0x16C1, 0x19E6, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F5A, 0x0E3D, 0x1777,   // 4E50 - 4E5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DC9, 0xFFFF, 0x1160, 0xFFFF, 0xFFFF,   // 4E60 - 4E6F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1989, 0xFFFF, 0xFFFF, 0x1467, 0x154B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E31, 0xFFFF,   // 4E70 - 4E7F
	0xFFFF, 0xFFFF, 0x11A1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1245, 0xFFFF, 0x17CA, 0xFFFF, 0xFFFF, 0x1500, 0x1A07, 0xFFFF, 0x1917, 0xFFFF,   // 4E80 - 4E8F
	0x194F, 0x1940, 0x1FA1, 0xFFFF, 0x1877, 0x1B4A, 0xFFFF, 0xFFFF, 0x1002, 0xFFFF, 0xFFFF, 0x1501, 0xFFFF, 0xFFFF, 0x1720, 0xFFFF,   // 4E90 - 4E9F
	0xFFFF, 0x12D8, 0x1F1B, 0xFFFF, 0x0F3F, 0x1F2C, 0x17E2, 0xFFFF, 0x1F83, 0xFFFF, 0xFFFF, 0x1F45, 0x0E6C, 0x1B4B, 0x11C7, 0xFFFF,   // 4EA0 - 4EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10D8, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A35, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4EB0 - 4EBF
	0x171B, 0x1A36, 0xFFFF, 0xFFFF, 0x1DC1, 0xFFFF, 0xFFFF, 0x0F5B, 0xFFFF, 0xFFFF, 0x0FED, 0x0E05, 0xFFFF, 0x1A66, 0xFFFF, 0xFFFF,   // 4EC0 - 4ECF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A6A, 0x1502, 0x1DF2, 0x1A9E, 0x1479, 0x15B5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1162, 0xFFFF, 0x1D09,   // 4ED0 - 4EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1111, 0x1205, 0x1A08, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4EE0 - 4EEF
	0x175A, 0xFFFF, 0x1C24, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E32, 0x0E06, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A56, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4EF0 - 4EFF
	0xFFFF, 0x1006, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F1C, 0x1A09, 0x0FFB, 0xFFFF, 0x1878, 0x1007, 0x1455,   // 4F00 - 4F0F
	0x140F, 0x206E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4F10 - 4F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13FD,   // 4F20 - 4F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13A9, 0xFFFF, 0x1206, 0xFFFF, 0x16F5, 0xFFFF, 0x1503, 0xFFFF, 0x1504, 0x0D89, 0xFFFF, 0xFFFF,   // 4F30 - 4F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1B0C, 0xFFFF, 0xFFFF, 0x10D9, 0x1AD7, 0x1E9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1970, 0x1AD8, 0x1BE6,   // 4F40 - 4F4F
	0x1BDF, 0x1918, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE6, 0xFFFF, 0xFFFF, 0xFFFF, 0x17CB, 0x1A4E, 0x14B8, 0x1A84, 0xFFFF, 0xFFFF, 0xFFFF,   // 4F50 - 4F5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E71, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x178C,   // 4F60 - 4F6F
	0x13FE, 0xFFFF, 0xFFFF, 0x0D8A, 0xFFFF, 0xFFFF, 0x1047, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B0D, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A4F, 0x1505,   // 4F70 - 4F7F
	0xFFFF, 0x16F6, 0xFFFF, 0x0DB1, 0x1C81, 0xFFFF, 0x11C0, 0xFFFF, 0x1DC6, 0xFFFF, 0x0F22, 0x1217, 0xFFFF, 0x16CA, 0xFFFF, 0x1BE7,   // 4F80 - 4F8F
	0xFFFF, 0x198A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1270, 0xFFFF, 0x1C9D, 0xFFFF, 0xFFFF, 0x0EEC, 0xFFFF, 0x19F4, 0xFFFF, 0xFFFF,   // 4F90 - 4F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x131C, 0x2047,   // 4FA0 - 4FAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DE5, 0x11D4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E81,   // 4FB0 - 4FBF
	0xFFFF, 0xFFFF, 0x0E99, 0x1D67, 0x1721, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1879, 0x1C0F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B97, 0xFFFF,   // 4FC0 - 4FCF
	0xFFFF, 0x18FF, 0xFFFF, 0x0E6D, 0x1F5D, 0xFFFF, 0xFFFF, 0x162E, 0xFFFF, 0xFFFF, 0x1284, 0xFFFF, 0xFFFF, 0x1445, 0xFFFF, 0x1506,   // 4FD0 - 4FDF
	0x1F77, 0x16F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x164D, 0x147A,   // 4FE0 - 4FEF
	0xFFFF, 0x0F5C, 0xFFFF, 0x13EA, 0xFFFF, 0x1EBD, 0xFFFF, 0xFFFF, 0x1468, 0xFFFF, 0x17C1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 4FF0 - 4FFF
	0xFFFF, 0xFFFF, 0x1435, 0xFFFF, 0xFFFF, 0xFFFF, 0x11C8, 0xFFFF, 0xFFFF, 0x1CD0, 0xFFFF, 0x0E07, 0xFFFF, 0x13E9, 0xFFFF, 0xFFFF,   // 5000 - 500F
	0xFFFF, 0x1364, 0x1124, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F40, 0xFFFF, 0xFFFF, 0x2048, 0x19F5, 0xFFFF, 0x1CFA, 0xFFFF, 0x0E6E, 0x1C9E,   // 5010 - 501F
	0xFFFF, 0x1CD1, 0xFFFF, 0x13CD, 0x1DC7, 0xFFFF, 0x0FA4, 0x1BCE, 0x0E20, 0xFFFF, 0x1860, 0x1271, 0x1E00, 0x18CA, 0xFFFF, 0xFFFF,   // 5020 - 502F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1778, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5030 - 503F
	0xFFFF, 0xFFFF, 0xFFFF, 0x17B9, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D8B, 0x0E4B, 0x1971, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E82,   // 5040 - 504F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F2D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BE8, 0xFFFF, 0x1B4C, 0xFFFF, 0xFFFF, 0xFFFF,   // 5050 - 505F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5060 - 506F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DC0, 0x1B4D, 0x1919, 0xFFFF, 0x1E4C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5070 - 507F
	0x0F33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x147B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13CE, 0xFFFF, 0xFFFF,   // 5080 - 508F
	0xFFFF, 0x0E3E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x153F, 0x14C3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5090 - 509F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D7C, 0x1900, 0xFFFF, 0xFFFF,   // 50A0 - 50AF
	0xFFFF, 0xFFFF, 0x187A, 0x1B0E, 0xFFFF, 0x1CE6, 0xFFFF, 0x155D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E6F, 0xFFFF,   // 50B0 - 50BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FDD, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D26, 0x15B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x155E,   // 50C0 - 50CF
	0xFFFF, 0x0F40, 0xFFFF, 0xFFFF, 0xFFFF, 0x1456, 0x208C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1246, 0xFFFF, 0xFFFF, 0xFFFF, 0x1972, 0xFFFF,   // 50D0 - 50DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18D5, 0xFFFF, 0x16C2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CC6, 0xFFFF, 0xFFFF,   // 50E0 - 50EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D8C, 0xFFFF, 0x141E, 0xFFFF, 0xFFFF, 0xFFFF, 0x1507,   // 50F0 - 50FF
	0x19F6, 0x1C10, 0xFFFF, 0xFFFF, 0x17B4, 0xFFFF, 0x0E70, 0xFFFF, 0xFFFF, 0x0E41, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5100 - 510F
	0xFFFF, 0xFFFF, 0x198B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x155F,   // 5110 - 511F
	0xFFFF, 0x123D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x191A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5120 - 512F
	0xFFFF, 0xFFFF, 0x1AD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11D5, 0xFFFF, 0xFFFF, 0x104D, 0xFFFF, 0x17C2, 0xFFFF, 0xFFFF, 0xFFFF,   // 5130 - 513F
	0x18A0, 0x19C9, 0xFFFF, 0x1952, 0x1F84, 0x1DA8, 0x1B98, 0x2076, 0x15B7, 0x0F23, 0xFFFF, 0x0FD6, 0x1E28, 0x12FF, 0x1E3B, 0xFFFF,   // 5140 - 514F
	0xFFFF, 0xFFFF, 0x1722, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1173, 0xFFFF, 0xFFFF, 0xFFFF,   // 5150 - 515F
	0xFFFF, 0xFFFF, 0x1003, 0xFFFF, 0xFFFF, 0x1A61, 0xFFFF, 0x1086, 0x1B0F, 0x11C9, 0x198C, 0x1E6E, 0x0EED, 0x126D, 0x1F97, 0xFFFF,   // 5160 - 516F
	0xFFFF, 0x0EEE, 0xFFFF, 0xFFFF, 0xFFFF, 0x1436, 0x1008, 0x0F5D, 0x1B10, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E66, 0xFFFF, 0xFFFF, 0xFFFF,   // 5170 - 517F
	0x1009, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17C9, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CF2, 0xFFFF, 0xFFFF, 0x1AC2, 0xFFFF, 0xFFFF,   // 5180 - 518F
	0xFFFF, 0xFFFF, 0x131D, 0xFFFF, 0xFFFF, 0x1300, 0xFFFF, 0x1901, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5190 - 519F
	0x0F0E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x130C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12FD, 0xFFFF, 0x1163, 0xFFFF, 0xFFFF, 0xFFFF,   // 51A0 - 51AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1779, 0x11C4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11F9, 0xFFFF, 0xFFFF,   // 51B0 - 51BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CF6, 0xFFFF, 0x1C11, 0xFFFF, 0xFFFF, 0x11CA, 0xFFFF, 0x1B99, 0x127E, 0x1164, 0xFFFF, 0xFFFF,   // 51C0 - 51CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x127D, 0x19F0, 0x208D, 0xFFFF,   // 51D0 - 51DF
	0xFFFF, 0x1413, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 51E0 - 51EF
	0x2009, 0x0E08, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2077, 0xFFFF, 0x1D1C, 0x18D6, 0x1DA5, 0xFFFF, 0xFFFF, 0x1F08, 0xFFFF, 0xFFFF,   // 51F0 - 51FF
	0x1125, 0xFFFF, 0xFFFF, 0x1A37, 0xFFFF, 0xFFFF, 0x14A4, 0x1B35, 0x1862, 0xFFFF, 0x0DB2, 0xFFFF, 0xFFFF, 0xFFFF, 0x1365, 0xFFFF,   // 5200 - 520F
	0xFFFF, 0x1F85, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11FA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D4C, 0xFFFF, 0xFFFF,   // 5210 - 521F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E65, 0x1430, 0xFFFF, 0xFFFF, 0xFFFF, 0x1285, 0x1540, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F1E, 0xFFFF,   // 5220 - 522F
	0x1126, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B80, 0x1646, 0x0FA5, 0x1CC1, 0x1A6B, 0x0DA6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5230 - 523F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1D43, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DDE, 0xFFFF, 0xFFFF, 0x153B, 0x0FD7, 0x11A9, 0x1B11, 0xFFFF, 0xFFFF,   // 5240 - 524F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CFC, 0xFFFF, 0x147C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DED, 0xFFFF, 0x1396, 0xFFFF, 0xFFFF,   // 5250 - 525F
	0xFFFF, 0x15E2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A67, 0x1B12, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x147D,   // 5260 - 526F
	0xFFFF, 0xFFFF, 0x1F06, 0xFFFF, 0xFFFF, 0x1CD2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EBE, 0xFFFF, 0x1D4D,   // 5270 - 527F
	0xFFFF, 0xFFFF, 0xFFFF, 0x2035, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD8, 0x141F, 0x125F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E42, 0xFFFF, 0xFFFF,   // 5280 - 528F
	0xFFFF, 0x1B81, 0x0E43, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11E6, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EEF,   // 5290 - 529F
	0x0D8D, 0xFFFF, 0xFFFF, 0x11FB, 0x0FDE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B9A, 0x1095, 0x0E48, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 52A0 - 52AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F3E, 0xFFFF,   // 52B0 - 52BF
	0xFFFF, 0x0E71, 0xFFFF, 0x13C2, 0xFFFF, 0x1DDF, 0xFFFF, 0x1902, 0xFFFF, 0x1301, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E72, 0xFFFF, 0xFFFF,   // 52C0 - 52CF
	0xFFFF, 0xFFFF, 0x127B, 0xFFFF, 0xFFFF, 0x1165, 0x1937, 0xFFFF, 0x0DD3, 0x134C, 0xFFFF, 0x2054, 0xFFFF, 0x16C3, 0x121C, 0x131E,   // 52D0 - 52DF
	0xFFFF, 0xFFFF, 0x1601, 0x1AF3, 0x0FDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 52E0 - 52EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2055, 0xFFFF, 0x11D6, 0xFFFF, 0xFFFF, 0x0FA6, 0xFFFF, 0x1A85, 0x0FCE, 0xFFFF, 0xFFFF, 0x0F5E, 0x1370,   // 52F0 - 52FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E9C, 0xFFFF, 0xFFFF, 0x2078, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E9D, 0xFFFF, 0x1E9E,   // 5300 - 530F
	0x1457, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14C4, 0x1FDF, 0x14A3, 0xFFFF, 0x16CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5310 - 531F
	0x1A9F, 0x0F24, 0xFFFF, 0x0DE7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2021,   // 5320 - 532F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ED9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10D3,   // 5330 - 533F
	0x0F5F, 0x171C, 0xFFFF, 0x1D0A, 0x1A62, 0xFFFF, 0xFFFF, 0x16C4, 0x187B, 0x2063, 0x13AA, 0xFFFF, 0xFFFF, 0x12BF, 0xFFFF, 0xFFFF,   // 5340 - 534F
	0xFFFF, 0x14C6, 0x1BCB, 0x1E01, 0x1F78, 0xFFFF, 0xFFFF, 0x106F, 0xFFFF, 0xFFFF, 0x1397, 0xFFFF, 0x1458, 0xFFFF, 0x142A, 0xFFFF,   // 5350 - 535F
	0x1B3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F2F, 0xFFFF, 0x15D5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1340,   // 5360 - 536F
	0x1A38, 0x1973, 0xFFFF, 0xFFFF, 0x0DA7, 0x11A2, 0xFFFF, 0x0FA7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C27, 0xFFFF, 0x0E73,   // 5370 - 537F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x176C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5380 - 538F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1761, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1286, 0xFFFF, 0x2049, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1953,   // 5390 - 539F
	0x1DC2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FAE, 0x1EE7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1824, 0xFFFF, 0xFFFF,   // 53A0 - 53AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E21, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 53B0 - 53BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1CC7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x191B, 0x1C9F, 0x0FFC, 0x191C, 0xFFFF, 0x13AB, 0xFFFF, 0xFFFF,   // 53C0 - 53CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x168A, 0xFFFF, 0x1DB2, 0x164E, 0xFFFF, 0xFFFF, 0xFFFF, 0x13AC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 53D0 - 53DF
	0xFFFF, 0x1863, 0x1D71, 0x0F60, 0x0EB1, 0x0F61, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EB2, 0x1C38, 0x0FBF, 0x1609, 0x1E6F, 0xFFFF, 0x0D8E,   // 53E0 - 53EF
	0x1E29, 0x1C82, 0x1508, 0x191D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1509, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 53F0 - 53FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2080, 0x0DA8, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F14, 0x1048, 0x1AF4, 0xFFFF, 0x1166, 0x130D, 0x204A, 0x1287,   // 5400 - 540F
	0x1E3C, 0x1F46, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F94, 0xFFFF, 0x129E, 0xFFFF, 0x19E7,   // 5410 - 541F
	0x1E91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x147E, 0xFFFF, 0xFFFF, 0x14A5, 0xFFFF, 0x1F09, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5420 - 542F
	0xFFFF, 0xFFFF, 0xFFFF, 0x187D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2087, 0x1DB3, 0xFFFF, 0x1366, 0x204B, 0xFFFF, 0x187C, 0xFFFF,   // 5430 - 543F
	0xFFFF, 0xFFFF, 0x11D7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B4E, 0xFFFF, 0x0EB3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5440 - 544F
	0xFFFF, 0x1E10, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5450 - 545F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BEC, 0xFFFF, 0x1BEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5460 - 546F
	0xFFFF, 0x0EB4, 0xFFFF, 0x1373, 0xFFFF, 0x0D8F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16F8, 0x1FA2, 0x130E, 0xFFFF, 0xFFFF,   // 5470 - 547F
	0x1ADA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE0, 0xFFFF, 0x0F62, 0xFFFF,   // 5480 - 548F
	0x147F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5490 - 549F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DF3, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A6C, 0xFFFF, 0xFFFF, 0x1C39, 0x0F41, 0xFFFF, 0xFFFF, 0xFFFF,   // 54A0 - 54AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F2E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F0A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A3A, 0xFFFF, 0xFFFF,   // 54B0 - 54BF
	0x1762, 0x1ECB, 0xFFFF, 0xFFFF, 0x1FD5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F15, 0x1AC3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 54C0 - 54CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 54D0 - 54DF
	0xFFFF, 0x1954, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D90, 0xFFFF, 0xFFFF, 0x1D4E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ED8, 0x203A, 0xFFFF,   // 54E0 - 54EF
	0xFFFF, 0xFFFF, 0x1D1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EA0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 54F0 - 54FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E72, 0xFFFF, 0x150A, 0x1C5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1288, 0xFFFF,   // 5500 - 550F
	0x1106, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12D1, 0xFFFF, 0xFFFF, 0xFFFF,   // 5510 - 551F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x198E,   // 5520 - 552F
	0xFFFF, 0x1CD3, 0xFFFF, 0xFFFF, 0xFFFF, 0x174E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DF4, 0xFFFF,   // 5530 - 553F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E02, 0xFFFF, 0x1560, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1367,   // 5540 - 554F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0E9A, 0xFFFF, 0xFFFF, 0x10F0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1723, 0xFFFF,   // 5550 - 555F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F0B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5560 - 556F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B82, 0xFFFF, 0xFFFF, 0xFFFF,   // 5570 - 557F
	0x0E19, 0xFFFF, 0xFFFF, 0xFFFF, 0x15B8, 0xFFFF, 0x1D1E, 0x118E, 0xFFFF, 0x204C, 0x1F0C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5580 - 558F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D0B, 0x2064, 0x1FF4, 0xFFFF, 0x208E, 0x0DCA, 0xFFFF, 0xFFFF,   // 5590 - 559F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x205F, 0xFFFF, 0x198F, 0x1561, 0x104C, 0x0F42, 0xFFFF, 0x10DA, 0xFFFF,   // 55A0 - 55AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 55B0 - 55BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x204D, 0xFFFF, 0x157E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 55C0 - 55CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C5F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x187E, 0xFFFF, 0x100A, 0xFFFF, 0xFFFF, 0x1CA0,   // 55D0 - 55DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x150B, 0x1DC8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 55E0 - 55EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x164F, 0x1BED, 0xFFFF,   // 55F0 - 55FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E11, 0xFFFF, 0xFFFF, 0x0D91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5600 - 560F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F63, 0xFFFF, 0xFFFF, 0x1562, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5610 - 561F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x160A,   // 5620 - 562F
	0xFFFF, 0xFFFF, 0x1B9B, 0xFFFF, 0x1DB4, 0xFFFF, 0x16CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5630 - 563F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5640 - 564F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F4E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5650 - 565F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x100B, 0xFFFF, 0xFFFF, 0x208F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5660 - 566F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5670 - 567F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x203B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5680 - 568F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5690 - 569F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17EF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14ED, 0xFFFF, 0x1F47, 0xFFFF,   // 56A0 - 56AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17C3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A86, 0xFFFF, 0xFFFF, 0xFFFF,   // 56B0 - 56BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x107D, 0xFFFF, 0xFFFF, 0x2090, 0xFFFF, 0xFFFF,   // 56C0 - 56CF
	0xFFFF, 0x1D68, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1650, 0x150C, 0xFFFF, 0xFFFF, 0x2022, 0xFFFF,   // 56D0 - 56DF
	0x1A3B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 56E0 - 56EF
	0x0EDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1207, 0x0EB5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 56F0 - 56FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1EA1, 0x17AA, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FA8, 0xFFFF, 0xFFFF, 0x0F8E, 0xFFFF, 0x1974, 0xFFFF, 0xFFFF,   // 5700 - 570F
	0xFFFF, 0xFFFF, 0x1956, 0x1955, 0xFFFF, 0xFFFF, 0x1127, 0xFFFF, 0x10DB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E3D,   // 5710 - 571F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AC4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC0, 0xFFFF, 0xFFFF,   // 5720 - 572F
	0x1C3A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x100C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5730 - 573F
	0x1C3B, 0xFFFF, 0x1E66, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FCF, 0xFFFF, 0xFFFF, 0x13CF, 0xFFFF, 0xFFFF, 0x10F1, 0x0DD4, 0xFFFF,   // 5740 - 574F
	0x1BE0, 0x0E1B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5750 - 575F
	0xFFFF, 0x1E55, 0xFFFF, 0xFFFF, 0x0EE0, 0xFFFF, 0x1E12, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E8C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1113, 0xFFFF,   // 5760 - 576F
	0x0E74, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E03, 0xFFFF, 0xFFFF, 0xFFFF,   // 5770 - 577F
	0xFFFF, 0xFFFF, 0x1651, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1112, 0xFFFF, 0xFFFF, 0x1F86, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5780 - 578F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F2F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5790 - 579F
	0x19DF, 0xFFFF, 0x0F65, 0x1957, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 57A0 - 57AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 57B0 - 57BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1763, 0xFFFF, 0xFFFF, 0xFFFF, 0x1903, 0x1C12, 0xFFFF, 0xFFFF, 0x12E4, 0xFFFF, 0xFFFF, 0x15EE, 0xFFFF,   // 57C0 - 57CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17E4,   // 57D0 - 57DF
	0x1480, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 57E0 - 57EF
	0x1CE7, 0xFFFF, 0xFFFF, 0xFFFF, 0x16E6, 0xFFFF, 0xFFFF, 0x1C93, 0xFFFF, 0x13EC, 0x100D, 0xFFFF, 0x100E, 0xFFFF, 0xFFFF, 0xFFFF,   // 57F0 - 57FF
	0x0F9A, 0xFFFF, 0x1107, 0xFFFF, 0xFFFF, 0x0E55, 0x1E46, 0xFFFF, 0x0DEE, 0x19C2, 0x1732, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5800 - 580F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D30, 0xFFFF,   // 5810 - 581F
	0xFFFF, 0x1446, 0xFFFF, 0xFFFF, 0x1B83, 0xFFFF, 0xFFFF, 0x17F0, 0xFFFF, 0xFFFF, 0x0DD5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18D7,   // 5820 - 582F
	0x17BA, 0x1447, 0xFFFF, 0xFFFF, 0x1AA0, 0x1128, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5830 - 583F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F34, 0x1839, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E09,   // 5840 - 584F
	0xFFFF, 0x160B, 0xFFFF, 0xFFFF, 0x1E20, 0xFFFF, 0xFFFF, 0x1129, 0x1108, 0xFFFF, 0x1D72, 0xFFFF, 0xFFFF, 0xFFFF, 0x157B, 0xFFFF,   // 5850 - 585F
	0xFFFF, 0x1B13, 0x187F, 0xFFFF, 0x2056, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5860 - 586F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C60, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CC8, 0xFFFF, 0xFFFF, 0x1B14, 0xFFFF, 0x168B, 0xFFFF,   // 5870 - 587F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0E75, 0xFFFF, 0x1588, 0xFFFF, 0xFFFF, 0xFFFF, 0x1904, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5880 - 588F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1341, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D7F, 0xFFFF, 0x1C2C, 0x1F4F,   // 5890 - 589F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1362, 0x1156, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DF5, 0xFFFF,   // 58A0 - 58AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x14A7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1880, 0x1AA1, 0xFFFF, 0xFFFF, 0x0DB3, 0xFFFF,   // 58B0 - 58BF
	0xFFFF, 0x1420, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A1, 0xFFFF, 0x10DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2057, 0xFFFF,   // 58C0 - 58CF
	0xFFFF, 0x1EF3, 0xFFFF, 0x1756, 0xFFFF, 0x1FA3, 0xFFFF, 0xFFFF, 0x1252, 0x0F25, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F35, 0x1236,   // 58D0 - 58DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x178F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x150D, 0x1A57, 0xFFFF, 0xFFFF, 0x1AA2,   // 58E0 - 58EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A50, 0x1FA4, 0x1589, 0xFFFF, 0x1652, 0xFFFF, 0xFFFF,   // 58F0 - 58FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE8,   // 5900 - 590F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x100F, 0x15A6, 0x18CE, 0xFFFF, 0xFFFF, 0x168C, 0x10D5, 0xFFFF, 0x177A, 0xFFFF, 0xFFFF, 0xFFFF,   // 5910 - 591F
	0xFFFF, 0xFFFF, 0x133D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1114, 0xFFFF, 0x1D0C, 0x1E2A, 0x1481, 0xFFFF, 0x18D8, 0x175B, 0xFFFF,   // 5920 - 592F
	0xFFFF, 0x170D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A0C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F79, 0xFFFF,   // 5930 - 593F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17C4, 0xFFFF, 0xFFFF, 0x1010, 0x1087, 0x1469, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC1, 0x1BEE,   // 5940 - 594F
	0x1FF5, 0x0E9C, 0xFFFF, 0xFFFF, 0x14A8, 0x1F59, 0xFFFF, 0x1E4D, 0xFFFF, 0xFFFF, 0x1F30, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5950 - 595F
	0x1B15, 0xFFFF, 0x150E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1881, 0xFFFF, 0xFFFF, 0x1E1A, 0x19CA, 0x1AA3, 0x15A7, 0x14A9, 0xFFFF,   // 5960 - 596F
	0xFFFF, 0xFFFF, 0xFFFF, 0x108B, 0x1097, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DB4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FA5, 0xFFFF, 0xFFFF,   // 5970 - 597F
	0xFFFF, 0xFFFF, 0x17CF, 0x14C7, 0x12D9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A58, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5980 - 598F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1011, 0xFFFF, 0xFFFF, 0x18D9, 0x0FEE, 0xFFFF, 0x1342, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5990 - 599F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DF6, 0xFFFF, 0xFFFF, 0x13D0, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E4E, 0xFFFF, 0xFFFF, 0xFFFF,   // 59A0 - 59AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12E5, 0xFFFF, 0x1CF7, 0xFFFF, 0xFFFF, 0x1D31, 0xFFFF,   // 59B0 - 59BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1B4F, 0xFFFF, 0xFFFF, 0x131F, 0xFFFF, 0xFFFF, 0x1A6D, 0xFFFF, 0x16CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 59C0 - 59CF
	0x1ADB, 0x0EB6, 0xFFFF, 0x15EF, 0x1975, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A59, 0x18DA, 0xFFFF, 0x0DEF, 0x1BE9, 0xFFFF, 0xFFFF,   // 59D0 - 59DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DB5, 0xFFFF, 0x1A0D, 0xFFFF, 0x1C83, 0xFFFF, 0x2091, 0xFFFF, 0x1F1D, 0xFFFF,   // 59E0 - 59EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17F1, 0xFFFF, 0xFFFF, 0x1A3C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A6E,   // 59F0 - 59FF
	0xFFFF, 0x1976, 0xFFFF, 0x18CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A00 - 5A0F
	0xFFFF, 0x150F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x107E, 0xFFFF, 0xFFFF, 0x1882, 0x1050, 0xFFFF, 0xFFFF, 0x17F2,   // 5A10 - 5A1F
	0x16F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1724, 0xFFFF, 0xFFFF, 0xFFFF, 0x12C0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A20 - 5A2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DB5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CD4, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A30 - 5A3F
	0xFFFF, 0x1253, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E56, 0xFFFF, 0xFFFF, 0x18B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A40 - 5A4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FCC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A50 - 5A5F
	0xFFFF, 0xFFFF, 0x14C8, 0xFFFF, 0xFFFF, 0xFFFF, 0x1482, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A60 - 5A6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A70 - 5A7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A80 - 5A8F
	0xFFFF, 0xFFFF, 0x12E6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1374, 0x1958, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5A90 - 5A9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AA0 - 5AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AB0 - 5ABF
	0xFFFF, 0x0D92, 0x1653, 0xFFFF, 0x1959, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C84, 0xFFFF, 0xFFFF, 0x1F76, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AC0 - 5ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AD0 - 5ADF
	0xFFFF, 0x1AF5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F1E, 0xFFFF, 0xFFFF, 0x10C4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AE0 - 5AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5AF0 - 5AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE1, 0xFFFF, 0xFFFF, 0xFFFF, 0x2092, 0xFFFF, 0x15B9, 0x0F43, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B00 - 5B0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E92, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B10 - 5B1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B20 - 5B2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B30 - 5B3F
	0x1563, 0xFFFF, 0xFFFF, 0x1790, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B40 - 5B4F
	0x1A6F, 0x1F72, 0xFFFF, 0xFFFF, 0x0EF0, 0x1A68, 0xFFFF, 0x1A70, 0x1BC9, 0xFFFF, 0x1483, 0xFFFF, 0x1A71, 0x203C, 0xFFFF, 0x12F7,   // 5B50 - 5B5F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0E9D, 0x0EB7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F31, 0xFFFF, 0x1637, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B60 - 5B6F
	0x168D, 0x1A91, 0xFFFF, 0xFFFF, 0xFFFF, 0x1484, 0xFFFF, 0xFFFF, 0x1EF4, 0xFFFF, 0x1990, 0xFFFF, 0x17BF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B70 - 5B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1121, 0xFFFF, 0x191E, 0x1654, 0x1740, 0xFFFF, 0x163E, 0x18B3, 0xFFFF, 0xFFFF, 0x0F3B,   // 5B80 - 5B8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1459, 0xFFFF, 0x1E23, 0x2037, 0x1BCF, 0x0F0F, 0x1BEF, 0x1B50, 0x18B4, 0x19F7, 0xFFFF, 0xFFFF, 0xFFFF,   // 5B90 - 5B9F
	0xFFFF, 0xFFFF, 0x0E1A, 0x15BA, 0x170E, 0x1991, 0x1FF6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15F0, 0xFFFF, 0x0F9E, 0xFFFF,   // 5BA0 - 5BAF
	0x1AC5, 0xFFFF, 0xFFFF, 0x1F32, 0x17F3, 0x160C, 0x0D93, 0xFFFF, 0x16FA, 0x1905, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x168E,   // 5BB0 - 5BBF
	0x1CE8, 0xFFFF, 0x1AF6, 0x195A, 0x1012, 0x1A3D, 0x1393, 0x0F66, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1485, 0xFFFF, 0xFFFF, 0xFFFF,   // 5BC0 - 5BCF
	0x12E7, 0xFFFF, 0x1EF8, 0x191F, 0x16E7, 0xFFFF, 0xFFFF, 0x1094, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B8, 0x1CC2,   // 5BD0 - 5BDF
	0xFFFF, 0x0EFD, 0x1DE6, 0xFFFF, 0x1883, 0x18DB, 0x170F, 0x1093, 0x1CE9, 0x1711, 0xFFFF, 0x1510, 0x0F10, 0xFFFF, 0x1247, 0x1C13,   // 5BE0 - 5BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D73, 0x1448, 0xFFFF, 0x1D6D, 0xFFFF, 0x1511, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5BF0 - 5BFF
	0xFFFF, 0x146A, 0xFFFF, 0xFFFF, 0x1512, 0xFFFF, 0xFFFF, 0x1AA4, 0x1B16, 0x1977, 0x1BCA, 0x1712, 0xFFFF, 0x1115, 0x112A, 0x160D,   // 5C00 - 5C0F
	0xFFFF, 0x160E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D27, 0xFFFF, 0xFFFF, 0x1564, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C10 - 5C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1920, 0xFFFF, 0xFFFF, 0xFFFF, 0x13D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C20 - 5C2F
	0xFFFF, 0x1DB6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16CF, 0x19CB, 0x1CFD, 0x0EB8, 0x10D1, 0xFFFF, 0x1375, 0x10BB,   // 5C30 - 5C3F
	0x0F8F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E22, 0x0E9E, 0xFFFF, 0x0F9B, 0xFFFF, 0xFFFF, 0x1895, 0xFFFF, 0x16D1, 0x16D0, 0xFFFF,   // 5C40 - 5C4F
	0xFFFF, 0x15D6, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B17, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1437, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C50 - 5C5F
	0x112B, 0xFFFF, 0x1254, 0xFFFF, 0x1DC5, 0x1289, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x162F, 0xFFFF, 0xFFFF, 0x117E,   // 5C60 - 5C6F
	0xFFFF, 0x1541, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2081, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C70 - 5C7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C80 - 5C8F
	0x1013, 0x1A96, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5C90 - 5C9F
	0xFFFF, 0x0DF0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x174F, 0xFFFF, 0x1655, 0x0DE8, 0xFFFF, 0xFFFF, 0xFFFF,   // 5CA0 - 5CAF
	0xFFFF, 0x1116, 0xFFFF, 0x1733, 0xFFFF, 0x1FA6, 0xFFFF, 0x1386, 0x1741, 0xFFFF, 0x1209, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B3E, 0xFFFF,   // 5CB0 - 5CBF
	0x1656, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5CC0 - 5CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DC9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5CD0 - 5CDF
	0x1565, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1725, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x146B,   // 5CE0 - 5CEF
	0x146C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5E, 0xFFFF, 0x112C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C14, 0xFFFF, 0x1F7A, 0xFFFF, 0xFFFF,   // 5CF0 - 5CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11C1, 0x1014, 0xFFFF,   // 5D00 - 5D0F
	0xFFFF, 0x0EE1, 0xFFFF, 0xFFFF, 0x1D7D, 0xFFFF, 0x1764, 0x0DF1, 0xFFFF, 0x1272, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D10 - 5D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16B6, 0xFFFF, 0x14BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D20 - 5D2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D30 - 5D3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1376, 0x0DD6, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D40 - 5D4F
	0x11AB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D50 - 5D5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16B7, 0xFFFF, 0xFFFF, 0x18CF, 0xFFFF, 0xFFFF, 0x1CA1,   // 5D60 - 5D6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D70 - 5D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F67, 0xFFFF, 0xFFFF, 0xFFFF, 0x112D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5D80 - 5D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1185, 0xFFFF, 0xFFFF,   // 5D90 - 5D9F
	0x0F44, 0xFFFF, 0x18DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17C7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5DA0 - 5DAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x183C, 0xFFFF, 0x120A, 0xFFFF, 0x158A, 0x1734, 0xFFFF, 0xFFFF,   // 5DB0 - 5DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18D0, 0xFFFF, 0xFFFF,   // 5DC0 - 5DCF
	0xFFFF, 0xFFFF, 0x12C1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1750, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D0D, 0x1BF0, 0xFFFF,   // 5DD0 - 5DDF
	0xFFFF, 0x1696, 0x160F, 0xFFFF, 0xFFFF, 0x0EF1, 0x1BE1, 0x0F45, 0x0E23, 0xFFFF, 0xFFFF, 0x134D, 0xFFFF, 0xFFFF, 0x1CA2, 0xFFFF,   // 5DE0 - 5DEF
	0xFFFF, 0x1015, 0x1A0F, 0x1513, 0x1E57, 0xFFFF, 0xFFFF, 0x1F1F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1638, 0x0E34, 0xFFFF,   // 5DF0 - 5DFF
	0xFFFF, 0xFFFF, 0x16D2, 0x1EA2, 0xFFFF, 0xFFFF, 0x1414, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2093, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E00 - 5E0F
	0xFFFF, 0x1E24, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D32, 0xFFFF, 0xFFFF, 0x1C85, 0xFFFF, 0x13FF, 0xFFFF, 0x1B84, 0xFFFF, 0xFFFF,   // 5E10 - 5E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1657, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1514, 0xFFFF, 0x15A8, 0xFFFF, 0xFFFF,   // 5E20 - 5E2F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1AA5, 0xFFFF, 0xFFFF, 0x1117, 0xFFFF, 0x1566, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1320, 0xFFFF, 0x204E,   // 5E30 - 5E3F
	0x1B51, 0xFFFF, 0xFFFF, 0xFFFF, 0x1735, 0x1EB7, 0xFFFF, 0x13D2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x200A, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E40 - 5E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DCA,   // 5E50 - 5E5F
	0xFFFF, 0x1405, 0x1109, 0x1E93, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E60 - 5E6F
	0xFFFF, 0xFFFF, 0x0DB6, 0x1E8D, 0x108C, 0xFFFF, 0xFFFF, 0x1438, 0x1F41, 0x0DB7, 0xFFFF, 0x1FF7, 0x1992, 0x1993, 0x1016, 0xFFFF,   // 5E70 - 5E7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AA6, 0xFFFF, 0xFFFF, 0x14C9, 0xFFFF, 0xFFFF, 0x1567, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x158B,   // 5E80 - 5E8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ADC, 0xFFFF, 0x1B3F, 0xFFFF, 0xFFFF, 0x0E76, 0xFFFF, 0x1486, 0xFFFF, 0xFFFF, 0xFFFF,   // 5E90 - 5E9F
	0x1568, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x112E, 0x1BE2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EB9, 0xFFFF, 0x1B52, 0xFFFF, 0xFFFF,   // 5EA0 - 5EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1751, 0x158C, 0x0DF2, 0x1906, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1994, 0xFFFF,   // 5EB0 - 5EBF
	0xFFFF, 0xFFFF, 0x1569, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE9, 0x11FF, 0x11B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5EC0 - 5ECF
	0x0F68, 0xFFFF, 0xFFFF, 0x0F09, 0xFFFF, 0xFFFF, 0x1248, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BF1, 0x1B18, 0xFFFF, 0xFFFF, 0xFFFF, 0x1343,   // 5ED0 - 5EDF
	0x1CD5, 0xFFFF, 0x1E94, 0x0F26, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11D8, 0xFFFF, 0xFFFF, 0xFFFF,   // 5EE0 - 5EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1D3A, 0xFFFF, 0xFFFF, 0x17F5, 0x1B53, 0xFFFF, 0xFFFF, 0x0E35, 0x2023, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5EF0 - 5EFF
	0xFFFF, 0x142B, 0xFFFF, 0xFFFF, 0x1237, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E95, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16E8,   // 5F00 - 5F0F
	0xFFFF, 0x16D3, 0xFFFF, 0x0F9F, 0x1B9C, 0x1A3E, 0xFFFF, 0x14B9, 0x1FD6, 0xFFFF, 0xFFFF, 0x1A10, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B85,   // 5F10 - 5F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5F, 0x1FA7, 0xFFFF, 0x1098, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F20 - 5F2F
	0xFFFF, 0x1782, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AA7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DF3, 0xFFFF, 0x1EDA, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F30 - 5F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E13, 0xFFFF, 0x0DF4, 0xFFFF, 0x1377, 0xFFFF, 0x12C2, 0xFFFF,   // 5F40 - 5F4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10DD, 0x1F98, 0xFFFF, 0x2066, 0xFFFF, 0x1A11, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F50 - 5F5F
	0xFFFF, 0xFFFF, 0x1F87, 0xFFFF, 0xFFFF, 0xFFFF, 0x17BB, 0x1938, 0xFFFF, 0x1CEA, 0x1EBF, 0x1B9D, 0x14EF, 0x1E7C, 0xFFFF, 0xFFFF,   // 5F60 - 5F6F
	0x1CD6, 0x183D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13D3, 0xFFFF, 0x17E5, 0xFFFF, 0xFFFF, 0x1ED2, 0xFFFF, 0xFFFF, 0x14BA,   // 5F70 - 5F7F
	0x18C5, 0x1B54, 0xFFFF, 0xFFFF, 0xFFFF, 0x1118, 0xFFFF, 0x1697, 0xFFFF, 0xFFFF, 0x2024, 0x1276, 0x204F, 0xFFFF, 0xFFFF, 0xFFFF,   // 5F80 - 5F8F
	0x158D, 0x0E77, 0x112F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1184, 0x13ED, 0x1515, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BD0, 0xFFFF,   // 5F90 - 5F9F
	0x11C2, 0x17AB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x200B, 0x145A, 0x1698, 0xFFFF, 0xFFFF, 0xFFFF, 0x1378, 0xFFFF,   // 5FA0 - 5FAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C99, 0xFFFF, 0x1122, 0xFFFF, 0x1D1F, 0xFFFF, 0xFFFF, 0xFFFF, 0x2067, 0xFFFF, 0xFFFF,   // 5FB0 - 5FBF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1713, 0xFFFF, 0x1EDB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1017, 0x1A3F, 0xFFFF, 0xFFFF,   // 5FC0 - 5FCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D6E, 0x1C3C, 0x12DA, 0x12DB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5FD0 - 5FDF
	0x1DA9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DF1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 5FE0 - 5FEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x108F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FD2, 0xFFFF, 0x14AA,   // 5FF0 - 5FFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x175C,   // 6000 - 600F
	0xFFFF, 0xFFFF, 0x1099, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EA3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x120B, 0x1516, 0xFFFF, 0xFFFF,   // 6010 - 601F
	0x1E2B, 0x1A12, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FFD, 0xFFFF, 0x15F1, 0x195B, 0xFFFF, 0x0F36, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E49,   // 6020 - 602F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6030 - 603F
	0xFFFF, 0x1A5A, 0x1699, 0x16D4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x200C, 0xFFFF, 0xFFFF,   // 6040 - 604F
	0x0EF2, 0xFFFF, 0x1F20, 0xFFFF, 0xFFFF, 0x158E, 0xFFFF, 0xFFFF, 0xFFFF, 0x1791, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F1F, 0xFFFF, 0xFFFF,   // 6050 - 605F
	0xFFFF, 0xFFFF, 0x2025, 0x1A72, 0x2073, 0x1DCB, 0xFFFF, 0xFFFF, 0x1EF9, 0x19E0, 0x0DA9, 0xFFFF, 0x1090, 0x0EF3, 0xFFFF, 0x16E9,   // 6060 - 606F
	0x2088, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6070 - 607F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x181D, 0xFFFF, 0xFFFF, 0xFFFF, 0x1710, 0xFFFF, 0xFFFF, 0x1B86, 0x1EFA, 0xFFFF, 0xFFFF,   // 6080 - 608F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2026, 0xFFFF, 0x1E73, 0xFFFF, 0xFFFF, 0xFFFF, 0x163F, 0x1B19, 0xFFFF, 0xFFFF, 0xFFFF, 0x1884,   // 6090 - 609F
	0x1995, 0xFFFF, 0xFFFF, 0x1FF8, 0x1D74, 0xFFFF, 0xFFFF, 0x128A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60A0 - 60AF
	0x1BD1, 0xFFFF, 0x14CA, 0x1123, 0x1DAE, 0xFFFF, 0x1387, 0xFFFF, 0x0E9F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1130, 0x1CF8, 0xFFFF, 0xFFFF,   // 60B0 - 60BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B55, 0xFFFF, 0x1157, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60C0 - 60CF
	0xFFFF, 0x1FC9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FD3, 0xFFFF, 0x15A9, 0xFFFF, 0xFFFF, 0x1996,   // 60D0 - 60DF
	0x1F99, 0x1736, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60E0 - 60EF
	0x1DF7, 0x10B5, 0xFFFF, 0x156A, 0xFFFF, 0xFFFF, 0x200D, 0xFFFF, 0xFFFF, 0x177B, 0x15F2, 0x1DC3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 60F0 - 60FF
	0xFFFF, 0x1658, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E36, 0xFFFF, 0x1997, 0x1998, 0xFFFF, 0xFFFF, 0xFFFF, 0x1388, 0x1E80, 0x19F8,   // 6100 - 610F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1737, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1921, 0x1765, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DD7,   // 6110 - 611F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F37, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6120 - 612F
	0x200E, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CD7, 0xFFFF, 0xFFFF, 0x0E0A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16FB, 0xFFFF, 0x0E0B, 0x195C,   // 6130 - 613F
	0xFFFF, 0xFFFF, 0x1907, 0xFFFF, 0x1277, 0xFFFF, 0xFFFF, 0x19E1, 0x1A73, 0xFFFF, 0x0E67, 0x1E2C, 0x200F, 0xFFFF, 0xFFFF, 0xFFFF,   // 6140 - 614F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1EC0, 0xFFFF, 0x1321, 0xFFFF, 0xFFFF, 0x1CC9, 0x1CCA, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E52, 0xFFFF, 0x1E3F,   // 6150 - 615F
	0xFFFF, 0xFFFF, 0x12C3, 0x0F11, 0x0DAA, 0xFFFF, 0xFFFF, 0x1F9A, 0x0E0C, 0xFFFF, 0xFFFF, 0x1BD2, 0xFFFF, 0xFFFF, 0x11D9, 0xFFFF,   // 6160 - 616F
	0x1978, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E78, 0x0DF5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CFE, 0x18F9, 0xFFFF,   // 6170 - 617F
	0xFFFF, 0x1D75, 0x1922, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C2D, 0xFFFF,   // 6180 - 618F
	0x11ED, 0x14FB, 0xFFFF, 0xFFFF, 0x1D4F, 0xFFFF, 0xFFFF, 0xFFFF, 0x2095, 0x2094, 0x1E14, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6190 - 619F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14AB, 0xFFFF, 0xFFFF, 0x1167, 0xFFFF, 0x0E4C, 0xFFFF, 0x1389, 0x0E79, 0xFFFF, 0x134E, 0xFFFF,   // 61A0 - 61AF
	0xFFFF, 0xFFFF, 0x1F52, 0xFFFF, 0xFFFF, 0xFFFF, 0x17B5, 0xFFFF, 0xFFFF, 0xFFFF, 0x10F2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DD8, 0xFFFF,   // 61B0 - 61BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0FE0, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DB8, 0x1F33, 0x19F1, 0x1886, 0x134F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 61C0 - 61CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 61D0 - 61DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1051, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 61E0 - 61EF
	0xFFFF, 0xFFFF, 0x1C9A, 0xFFFF, 0xFFFF, 0xFFFF, 0x118F, 0x2027, 0x1F60, 0xFFFF, 0x1CCB, 0xFFFF, 0x0F69, 0xFFFF, 0xFFFF, 0x19F9,   // 61F0 - 61FF
	0x11EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x110A, 0x0EFE, 0xFFFF, 0x1350, 0xFFFF, 0x16B1, 0x1659, 0x19DA, 0xFFFF,   // 6200 - 620F
	0x15F3, 0x1726, 0x0EA0, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FCA, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD9,   // 6210 - 621F
	0xFFFF, 0x0DD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B36, 0xFFFF, 0xFFFF, 0xFFFF, 0x126E, 0xFFFF,   // 6220 - 622F
	0x1B1A, 0x2096, 0xFFFF, 0xFFFF, 0x1119, 0xFFFF, 0x1FA8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11DA, 0x13D4,   // 6230 - 623F
	0x1610, 0x1E83, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15BB, 0x1FA9, 0x14CC, 0xFFFF, 0x165A, 0xFFFF, 0x1AC6, 0xFFFF, 0xFFFF,   // 6240 - 624F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1DF8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E05, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6250 - 625F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14AC, 0xFFFF,   // 6260 - 626F
	0xFFFF, 0x0FFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1488, 0xFFFF, 0xFFFF, 0x14CD, 0xFFFF, 0xFFFF, 0x176D, 0xFFFF, 0xFFFF, 0x16C5,   // 6270 - 627F
	0x1018, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D50, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E60, 0x1E58, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6280 - 628F
	0xFFFF, 0x17B6, 0x158F, 0xFFFF, 0xFFFF, 0x1E4F, 0xFFFF, 0x1F21, 0x1B37, 0xFFFF, 0xFFFF, 0x1EA4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6290 - 629F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ED3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 62A0 - 62AF
	0xFFFF, 0x1EA5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ADD, 0xFFFF, 0xFFFF, 0xFFFF, 0x12D2, 0xFFFF, 0xFFFF, 0x1757, 0x1D80, 0xFFFF, 0xFFFF,   // 62B0 - 62BF
	0xFFFF, 0xFFFF, 0x14BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1351, 0x1091, 0x11B5, 0xFFFF, 0xFFFF, 0x13AD, 0x1398, 0xFFFF, 0x1053,   // 62C0 - 62CF
	0x0F38, 0xFFFF, 0x0E24, 0x1D00, 0x13C3, 0xFFFF, 0x1DF9, 0x18DF, 0x0F6A, 0x1BCC, 0xFFFF, 0x1D51, 0x13EE, 0xFFFF, 0xFFFF, 0xFFFF,   // 62D0 - 62DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F20, 0x16EA, 0x1049, 0x1C2F,   // 62E0 - 62EF
	0xFFFF, 0x0EF4, 0xFFFF, 0x0FA9, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EBA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16BC, 0x1054,   // 62F0 - 62FF
	0xFFFF, 0x1C3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C3E, 0xFFFF, 0x1742, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6300 - 630F
	0xFFFF, 0x1131, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6310 - 631F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BE3, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C61,   // 6320 - 632F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B56, 0x17F9, 0xFFFF, 0x12C4, 0x1F7B, 0xFFFF,   // 6330 - 633F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CAB, 0xFFFF, 0xFFFF, 0x1E70, 0xFFFF, 0xFFFF, 0x106D,   // 6340 - 634F
	0x17F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EA6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6350 - 635F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x146D, 0x1517, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E25, 0xFFFF,   // 6360 - 636F
	0xFFFF, 0xFFFF, 0x0FAA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D33, 0xFFFF, 0xFFFF, 0x106E, 0x1092, 0xFFFF, 0xFFFF, 0xFFFF, 0x1590,   // 6370 - 637F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1611, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x165B, 0x1132, 0xFFFF, 0xFFFF, 0x1AA8, 0xFFFF, 0xFFFF, 0xFFFF,   // 6380 - 638F
	0xFFFF, 0xFFFF, 0x13EF, 0xFFFF, 0xFFFF, 0xFFFF, 0x176E, 0xFFFF, 0x0F9C, 0xFFFF, 0xFFFF, 0x0F30, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6390 - 639F
	0x11C5, 0x1CEB, 0x1E1C, 0xFFFF, 0xFFFF, 0x1B46, 0xFFFF, 0x0EF5, 0x1D81, 0x17C5, 0x1B9E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63A0 - 63AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63B0 - 63BF
	0x0DB9, 0xFFFF, 0xFFFF, 0xFFFF, 0x1999, 0xFFFF, 0x0FC2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1344,   // 63C0 - 63CF
	0x1B87, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19ED, 0xFFFF, 0xFFFF, 0xFFFF, 0x1792, 0x1FF9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63D0 - 63DF
	0xFFFF, 0x1738, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E4D, 0x2068, 0xFFFF,   // 63E0 - 63EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x195D, 0xFFFF, 0x177C, 0x1558, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 63F0 - 63FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1639, 0xFFFF, 0x1399,   // 6400 - 640F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1612, 0xFFFF, 0x18E0, 0x1133, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x165C, 0xFFFF, 0xFFFF, 0xFFFF,   // 6410 - 641F
	0xFFFF, 0xFFFF, 0x1C62, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13AE, 0x1E21, 0xFFFF, 0xFFFF,   // 6420 - 642F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x206F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CAC, 0xFFFF,   // 6430 - 643F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6440 - 644F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AF7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6450 - 645F
	0x1D76, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C3F,   // 6460 - 646F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1322, 0x1323, 0x1B47, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6470 - 647F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x121E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6480 - 648F
	0xFFFF, 0x1E39, 0x154C, 0x18E1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x108D, 0xFFFF, 0xFFFF, 0xFFFF, 0x110B, 0xFFFF,   // 6490 - 649F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D20, 0x13C4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1352, 0xFFFF, 0x1E59, 0x1D7B, 0xFFFF,   // 64A0 - 64AF
	0x1CB2, 0xFFFF, 0x139A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 64B0 - 64BF
	0xFFFF, 0x18A2, 0xFFFF, 0xFFFF, 0x121F, 0x1D0E, 0xFFFF, 0x1E37, 0xFFFF, 0xFFFF, 0x0E4E, 0xFFFF, 0xFFFF, 0x1B9F, 0x0E7A, 0xFFFF,   // 64C0 - 64CF
	0xFFFF, 0xFFFF, 0x0FEF, 0xFFFF, 0x10F3, 0xFFFF, 0xFFFF, 0xFFFF, 0x1421, 0xFFFF, 0x0E26, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 64D0 - 64DF
	0xFFFF, 0x111A, 0x1E07, 0xFFFF, 0xFFFF, 0x11AC, 0x1CC3, 0x0E27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19FA, 0xFFFF, 0xFFFF, 0xFFFF,   // 64E0 - 64EF
	0xFFFF, 0xFFFF, 0x1D01, 0xFFFF, 0x1FEE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E5A, 0xFFFF, 0xFFFF, 0xFFFF, 0x18E2, 0xFFFF,   // 64F0 - 64FF
	0x13AF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E3A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6500 - 650F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1793, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15EA, 0xFFFF, 0xFFFF,   // 6510 - 651F
	0xFFFF, 0xFFFF, 0xFFFF, 0x11EF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F46, 0x1FEF, 0x11AD, 0xFFFF, 0xFFFF, 0x1C40,   // 6520 - 652F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x165D, 0x0EBB, 0x199A, 0x0E0D, 0xFFFF, 0x0EF6, 0xFFFF, 0xFFFF, 0x13D5, 0x1B57,   // 6530 - 653F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EBC, 0xFFFF, 0xFFFF, 0x203D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1591, 0x0F47, 0x138A,   // 6540 - 654F
	0xFFFF, 0x0F6B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1887, 0x1E74, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CD8, 0xFFFF,   // 6550 - 655F
	0xFFFF, 0xFFFF, 0x0DDA, 0x1542, 0xFFFF, 0xFFFF, 0x1158, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E7B, 0x1794, 0xFFFF, 0xFFFF,   // 6560 - 656F
	0xFFFF, 0xFFFF, 0x0EBD, 0xFFFF, 0x1B58, 0x1AF8, 0xFFFF, 0x1489, 0x165E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15BC, 0xFFFF,   // 6570 - 657F
	0xFFFF, 0xFFFF, 0x1200, 0x1E96, 0xFFFF, 0x203E, 0xFFFF, 0x1368, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14F0, 0xFFFF, 0xFFFF, 0xFFFF,   // 6580 - 658F
	0x14CE, 0x13B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1174, 0xFFFF, 0x1249, 0xFFFF, 0x0ED9, 0x1518, 0xFFFF, 0xFFFF, 0x1C90,   // 6590 - 659F
	0xFFFF, 0x174A, 0xFFFF, 0xFFFF, 0x0FE1, 0x1D02, 0xFFFF, 0x148A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A87, 0x1CCC, 0xFFFF, 0xFFFF, 0x1519,   // 65A0 - 65AF
	0x16FC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10DE, 0xFFFF, 0x13D6, 0xFFFF, 0xFFFF, 0x17AC, 0x16D5, 0xFFFF, 0xFFFF,   // 65B0 - 65BF
	0xFFFF, 0x13D7, 0xFFFF, 0xFFFF, 0xFFFF, 0x11DB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15BD, 0x1B59, 0xFFFF, 0xFFFF, 0x1BC5,   // 65C0 - 65CF
	0xFFFF, 0xFFFF, 0x1260, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1019, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 65D0 - 65DF
	0x1353, 0xFFFF, 0xFFFF, 0x101A, 0xFFFF, 0x1A51, 0x10DF, 0xFFFF, 0x1C41, 0x1BA0, 0xFFFF, 0xFFFF, 0x169A, 0x1939, 0xFFFF, 0xFFFF,   // 65E0 - 65EF
	0xFFFF, 0x1EFB, 0xFFFF, 0xFFFF, 0x1923, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18C6, 0x138B, 0x138C, 0x1159, 0xFFFF, 0x1888,   // 65F0 - 65FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EE2, 0x16C6, 0xFFFF, 0x13D8, 0x1FAA, 0xFFFF, 0x1CD9, 0xFFFF, 0x130F, 0x1FCD,   // 6600 - 660F
	0x14AD, 0x0FF0, 0xFFFF, 0x17E6, 0x15AA, 0x207C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1439, 0x15F4,   // 6610 - 661F
	0x183F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA2, 0xFFFF, 0x12E8, 0x1A88, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1613, 0xFFFF, 0x16D6,   // 6620 - 662F
	0x1EEA, 0x193A, 0xFFFF, 0xFFFF, 0x1345, 0xFFFF, 0x1CDA, 0xFFFF, 0xFFFF, 0xFFFF, 0x143A, 0x175D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6630 - 663F
	0xFFFF, 0x1BA1, 0x16D7, 0x2010, 0x2011, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C63, 0xFFFF, 0x1C64, 0xFFFF, 0xFFFF, 0xFFFF, 0x1743,   // 6640 - 664F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C15, 0xFFFF, 0x1F61, 0xFFFF, 0x1BF2, 0x2097, 0x15F5,   // 6650 - 665F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1889, 0x1FFB, 0x2028, 0x1FAB, 0x16FD, 0x12C5, 0xFFFF, 0x1E08, 0xFFFF, 0xFFFF, 0x1449, 0x0E7C,   // 6660 - 666F
	0xFFFF, 0xFFFF, 0xFFFF, 0x15AB, 0x1D3B, 0xFFFF, 0x1B5A, 0x0FBA, 0x1B5B, 0xFFFF, 0x1C42, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6670 - 667F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2060, 0xFFFF, 0xFFFF, 0x0D94, 0x205D, 0x2069, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1840, 0xFFFF,   // 6680 - 668F
	0x1979, 0x1592, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1066, 0x1752, 0x1795, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1310, 0xFFFF, 0xFFFF,   // 6690 - 669F
	0x0EBE, 0xFFFF, 0x1CDB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A97, 0xFFFF, 0xFFFF, 0x1324, 0xFFFF,   // 66A0 - 66AF
	0xFFFF, 0xFFFF, 0x1AA9, 0x1F9B, 0x1EB8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15E3, 0xFFFF, 0x0E7D, 0xFFFF, 0xFFFF, 0x115A, 0xFFFF,   // 66B0 - 66BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1833, 0xFFFF, 0x11E7, 0x10F4, 0xFFFF, 0x203F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 66C0 - 66CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1766, 0xFFFF, 0xFFFF, 0x1593, 0xFFFF, 0xFFFF, 0x18E4, 0x1EB9, 0xFFFF, 0xFFFF,   // 66D0 - 66DF
	0x0F27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2098, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 66E0 - 66EF
	0x18C4, 0xFFFF, 0x0EDA, 0x1864, 0x0E7E, 0xFFFF, 0xFFFF, 0x0DCB, 0x1594, 0x1BA3, 0x1BA2, 0xFFFF, 0x12C6, 0xFFFF, 0x1C2E, 0x1D44,   // 66F0 - 66FF
	0x1D7E, 0xFFFF, 0xFFFF, 0x2029, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x196D, 0x199B, 0xFFFF, 0x14BD, 0xFFFF, 0x145B, 0xFFFF, 0xFFFF,   // 6700 - 670F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x153D, 0x1C91, 0xFFFF, 0x11B9, 0xFFFF, 0xFFFF, 0xFFFF, 0x12DC, 0xFFFF, 0x1BA4, 0x101B, 0x101C,   // 6710 - 671F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x133E, 0x1238, 0x1334, 0xFFFF, 0x1379, 0x12D3, 0x1466, 0x1CC4, 0x1DA6, 0xFFFF,   // 6720 - 672F
	0xFFFF, 0x1BF3, 0xFFFF, 0xFFFF, 0x139B, 0xFFFF, 0x1DFA, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FB3, 0xFFFF, 0xFFFF, 0x2050, 0xFFFF, 0xFFFF,   // 6730 - 673F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DBA, 0xFFFF, 0xFFFF, 0x1552, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x128B, 0x1F42,   // 6740 - 674F
	0x1AC7, 0x1D6F, 0xFFFF, 0x1EC1, 0xFFFF, 0xFFFF, 0x1AAA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1175, 0xFFFF, 0x101D, 0x1630,   // 6750 - 675F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F22, 0xFFFF, 0x13F0,   // 6760 - 676F
	0x0E3F, 0x1168, 0xFFFF, 0x1346, 0xFFFF, 0x1ADE, 0xFFFF, 0x1E5B, 0xFFFF, 0xFFFF, 0xFFFF, 0x10C6, 0xFFFF, 0xFFFF, 0x1640, 0x1E67,   // 6770 - 677F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14CF, 0xFFFF, 0x18C7, 0xFFFF, 0x13D9, 0xFFFF, 0xFFFF, 0xFFFF, 0x1071,   // 6780 - 678F
	0x15AC, 0xFFFF, 0xFFFF, 0x1176, 0xFFFF, 0x1DE7, 0xFFFF, 0x12A7, 0xFFFF, 0xFFFF, 0x12E9, 0xFFFF, 0x0EFF, 0x1C43, 0xFFFF, 0xFFFF,   // 6790 - 679F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EBF,   // 67A0 - 67AF
	0x1E8E, 0xFFFF, 0xFFFF, 0x1C44, 0xFFFF, 0xFFFF, 0x0D95, 0x0D96, 0x0F6C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16D8, 0xFFFF,   // 67B0 - 67BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x143B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1400,   // 67C0 - 67CF
	0x1325, 0x0DDB, 0x1DE3, 0x1828, 0x199D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x199E, 0xFFFF, 0xFFFF, 0x1E09, 0xFFFF, 0xFFFF,   // 67D0 - 67DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F6D, 0xFFFF, 0xFFFF, 0x0DBB, 0xFFFF, 0xFFFF, 0x0D97,   // 67E0 - 67EF
	0x1088, 0x1BF4, 0xFFFF, 0x1261, 0x16D9, 0x1CF3, 0x151A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x151B, 0xFFFF, 0xFFFF, 0x1B5C, 0xFFFF,   // 67F0 - 67FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6800 - 680F
	0xFFFF, 0xFFFF, 0x169B, 0x1B1B, 0xFFFF, 0xFFFF, 0x1595, 0x1278, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6810 - 681F
	0xFFFF, 0x0F48, 0x1401, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BF5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x193B,   // 6820 - 682F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F3F, 0x0FE2, 0xFFFF, 0xFFFF, 0x0E4F, 0x1AC8, 0xFFFF, 0xFFFF,   // 6830 - 683F
	0x0E40, 0x1F23, 0x0EA1, 0x1134, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1744, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C86, 0xFFFF,   // 6840 - 684F
	0x1169, 0x156B, 0xFFFF, 0x1FFC, 0x104A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6850 - 685F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C65, 0xFFFF, 0xFFFF,   // 6860 - 686F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E40, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DBC,   // 6870 - 687F
	0xFFFF, 0x11CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x12EA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EDB,   // 6880 - 688F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1AC9, 0x1DCC, 0xFFFF, 0xFFFF, 0x0E7F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BA5, 0xFFFF, 0x2040,   // 6890 - 689F
	0xFFFF, 0x18B5, 0x1D52, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x188A, 0x128C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x151C, 0xFFFF, 0x1B88,   // 68A0 - 68AF
	0x0EA2, 0x0EE3, 0xFFFF, 0x1614, 0xFFFF, 0x1415, 0x137A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 68B0 - 68BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x101F, 0x143C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1302, 0xFFFF, 0x101E, 0xFFFF, 0x0EE4, 0xFFFF, 0xFFFF,   // 68C0 - 68CF
	0xFFFF, 0xFFFF, 0x146E, 0xFFFF, 0xFFFF, 0x1BD3, 0xFFFF, 0x1BA6, 0x0FDA, 0xFFFF, 0x14BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x116A,   // 68D0 - 68DF
	0x110C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A92, 0x0EA3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1553, 0xFFFF,   // 68E0 - 68EF
	0xFFFF, 0xFFFF, 0x1596, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1135, 0x0F12, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 68F0 - 68FF
	0x18B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19FB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16EB, 0x1D82, 0xFFFF,   // 6900 - 690F
	0xFFFF, 0xFFFF, 0x1D53, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6910 - 691F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1311, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6920 - 692F
	0x177D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17FB, 0xFFFF, 0x1DA3,   // 6930 - 693F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1797, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6940 - 694F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1ECD, 0x15D7, 0x1DFB, 0xFFFF, 0x0E37, 0xFFFF, 0x1354, 0x1D54, 0xFFFF, 0xFFFF, 0xFFFF, 0x127F, 0xFFFF,   // 6950 - 695F
	0x1072, 0x19A0, 0x19A1, 0x137B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B5D, 0xFFFF, 0xFFFF, 0x1C29, 0xFFFF, 0x17C8, 0x1ADF, 0x169C,   // 6960 - 696F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FDB, 0xFFFF, 0x1F34, 0x1D83, 0x1841, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6970 - 697F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6980 - 698F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1908, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C66, 0x13DA, 0xFFFF, 0xFFFF, 0xFFFF,   // 6990 - 699F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2012, 0xFFFF, 0x14D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1842, 0xFFFF,   // 69A0 - 69AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1262, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E22, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 69B0 - 69BF
	0xFFFF, 0x0EC0, 0xFFFF, 0x13B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F6E, 0x1E47, 0x1CDC, 0xFFFF, 0xFFFF,   // 69C0 - 69CF
	0x0F39, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 69D0 - 69DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F0A, 0xFFFF, 0x0E0E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 69E0 - 69EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC3, 0xFFFF, 0x1BA7, 0xFFFF, 0x0FE3,   // 69F0 - 69FF
	0xFFFF, 0xFFFF, 0x1739, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1406, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A00 - 6A0F
	0xFFFF, 0x11CC, 0xFFFF, 0x1255, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AE0, 0xFFFF, 0x1EC2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D84, 0x1AAB,   // 6A10 - 6A1F
	0xFFFF, 0x1326, 0xFFFF, 0x1798, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A20 - 6A2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D55, 0xFFFF, 0xFFFF, 0x139C, 0x165F, 0x1FE2, 0xFFFF, 0xFFFF, 0x1C16, 0xFFFF, 0xFFFF,   // 6A30 - 6A3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DDC, 0xFFFF, 0xFFFF, 0xFFFF, 0x18E6, 0xFFFF, 0xFFFF, 0x0F49, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A40 - 6A4F
	0xFFFF, 0xFFFF, 0x1942, 0x169D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD5, 0x1186, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1020,   // 6A50 - 6A5F
	0xFFFF, 0x156C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2038, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A60 - 6A6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A70 - 6A7F
	0x10E0, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E50, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B5E, 0xFFFF, 0xFFFF, 0xFFFF, 0x17B7, 0x0FF1, 0xFFFF,   // 6A80 - 6A8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1422, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x202A, 0xFFFF, 0xFFFF, 0xFFFF,   // 6A90 - 6A9F
	0xFFFF, 0xFFFF, 0x0E44, 0x1AAC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AA0 - 6AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0x14F1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F0D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AB0 - 6ABF
	0xFFFF, 0xFFFF, 0x1136, 0x0FB4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AC0 - 6ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1220, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11DC, 0x1C28, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AD0 - 6ADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AE0 - 6AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F53, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1773, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6AF0 - 6AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FAB, 0xFFFF, 0x1AAD, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B00 - 6B0F
	0xFFFF, 0xFFFF, 0x11A4, 0xFFFF, 0xFFFF, 0xFFFF, 0x11AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B10 - 6B1F
	0x2084, 0x1CA3, 0xFFFF, 0x207D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B20 - 6B2F
	0xFFFF, 0xFFFF, 0x18FA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1021, 0xFFFF, 0xFFFF, 0x2085, 0x0F13, 0xFFFF,   // 6B30 - 6B3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2086, 0x1F56, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D98, 0xFFFF, 0x1E15, 0xFFFF,   // 6B40 - 6B4F
	0x0F6F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17D2,   // 6B50 - 6B5F
	0xFFFF, 0x1FFA, 0x1C45, 0x1B5F, 0x1CA4, 0x144A, 0x1355, 0xFFFF, 0xFFFF, 0xFFFF, 0x18CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B60 - 6B6F
	0xFFFF, 0xFFFF, 0x1602, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11E8, 0x0FBB, 0xFFFF, 0xFFFF, 0x151D, 0xFFFF, 0xFFFF, 0xFFFF, 0x133B,   // 6B70 - 6B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0x175E, 0x1C67, 0xFFFF, 0x1E2D, 0xFFFF, 0xFFFF, 0x169E, 0x1660, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6B80 - 6B8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16EC, 0xFFFF, 0x1A93, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1943, 0xFFFF,   // 6B90 - 6B9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1201, 0x14F2,   // 6BA0 - 6BAF
	0xFFFF, 0xFFFF, 0x15E4, 0xFFFF, 0xFFFF, 0x10E1, 0xFFFF, 0x19E2, 0xFFFF, 0xFFFF, 0x154D, 0xFFFF, 0x0DAB, 0xFFFF, 0xFFFF, 0x1B1C,   // 6BB0 - 6BBF
	0xFFFF, 0x2065, 0xFFFF, 0xFFFF, 0xFFFF, 0x19FC, 0x0F70, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1356, 0xFFFF, 0x1327, 0xFFFF, 0x12EB,   // 6BC0 - 6BCF
	0xFFFF, 0xFFFF, 0x114C, 0x19C4, 0x14D1, 0xFFFF, 0x14D2, 0x14D3, 0x14D4, 0xFFFF, 0xFFFF, 0x1328, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6BD0 - 6BDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FAC, 0x0F71, 0xFFFF, 0xFFFF, 0xFFFF,   // 6BE0 - 6BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6BF0 - 6BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x171F,   // 6C00 - 6C0F
	0xFFFF, 0x138D, 0xFFFF, 0x12F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C10 - 6C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1022, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C20 - 6C2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1661, 0xFFFF, 0xFFFF, 0x14FC, 0x1843, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1416, 0xFFFF,   // 6C30 - 6C3F
	0x1B60, 0x1C2A, 0x0F72, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1417, 0xFFFF,   // 6C40 - 6C4F
	0x15AD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1543, 0xFFFF, 0x1EFC, 0xFFFF, 0xFFFF, 0x188B, 0xFFFF, 0xFFFF, 0x17D3, 0x1FD7, 0x0DF6,   // 6C50 - 6C5F
	0x1C46, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EE9, 0xFFFF, 0x18C8, 0xFFFF, 0xFFFF, 0x1865, 0xFFFF, 0xFFFF,   // 6C60 - 6C6F
	0x1E2E, 0xFFFF, 0x0FFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1369, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E61, 0xFFFF, 0xFFFF, 0x1023, 0x14AE, 0xFFFF,   // 6C70 - 6C7F
	0xFFFF, 0x1714, 0x1024, 0x1896, 0xFFFF, 0x195E, 0x1F24, 0x17FC, 0x1DE8, 0xFFFF, 0xFFFF, 0xFFFF, 0x115B, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C80 - 6C8F
	0x1335, 0xFFFF, 0x133C, 0x1101, 0x1303, 0x1371, 0x1DAA, 0xFFFF, 0xFFFF, 0x151E, 0x1C47, 0x1E75, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6C90 - 6C9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12D4, 0xFFFF, 0xFFFF, 0x1AE1, 0xFFFF,   // 6CA0 - 6CAF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1EEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14D5, 0x19A2, 0xFFFF, 0x1DCD, 0x1615, 0x0EC1, 0x1D28, 0x17FD,   // 6CB0 - 6CBF
	0xFFFF, 0x2013, 0x1F88, 0xFFFF, 0x15D8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D0F, 0x139D, 0xFFFF, 0x1EDC, 0xFFFF, 0xFFFF, 0xFFFF,   // 6CC0 - 6CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1FD8, 0xFFFF, 0x141C, 0xFFFF, 0x151F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1418, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6CD0 - 6CDF
	0xFFFF, 0x1EA8, 0x1E5C, 0x19EE, 0xFFFF, 0x10D2, 0xFFFF, 0xFFFF, 0x1BF6, 0xFFFF, 0xFFFF, 0x1F62, 0xFFFF, 0xFFFF, 0x13B2, 0x138E,   // 6CE0 - 6CEF
	0x1E2F, 0xFFFF, 0xFFFF, 0x1844, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6CF0 - 6CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1799, 0x11FC, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D00 - 6D0F
	0xFFFF, 0x144B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1603, 0xFFFF, 0x1662, 0xFFFF, 0x1198, 0xFFFF, 0xFFFF, 0x116B, 0xFFFF,   // 6D10 - 6D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C68, 0xFFFF, 0x19A3, 0xFFFF, 0x15D9, 0x1FD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D20 - 6D2F
	0xFFFF, 0xFFFF, 0x1BF7, 0xFFFF, 0xFFFF, 0x169F, 0x2079, 0xFFFF, 0x0F28, 0x195F, 0xFFFF, 0x2004, 0xFFFF, 0x2089, 0x1E5D, 0xFFFF,   // 6D30 - 6D3F
	0xFFFF, 0x1263, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D40 - 6D4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B38, 0x1C17, 0xFFFF, 0x14F3, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D50 - 6D5F
	0xFFFF, 0xFFFF, 0xFFFF, 0x18B7, 0xFFFF, 0xFFFF, 0x1EA9, 0xFFFF, 0xFFFF, 0x1FAD, 0x11BA, 0xFFFF, 0x128D, 0xFFFF, 0x148B, 0xFFFF,   // 6D60 - 6D6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18FB, 0xFFFF, 0xFFFF, 0x1F35, 0x1DE9, 0x1F7C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E76,   // 6D70 - 6D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x181E, 0xFFFF, 0x0E80, 0x1616, 0x15EB, 0xFFFF, 0xFFFF, 0x1909, 0x2041, 0x17FE, 0xFFFF,   // 6D80 - 6D8F
	0xFFFF, 0x1631, 0xFFFF, 0x17FF, 0xFFFF, 0x1D45, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6D90 - 6D9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1767,   // 6DA0 - 6DAF
	0xFFFF, 0xFFFF, 0x176F, 0xFFFF, 0xFFFF, 0x1F0E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6DB0 - 6DBF
	0x1B61, 0xFFFF, 0xFFFF, 0x0FAC, 0x1DCE, 0x15AE, 0x2042, 0x1025, 0xFFFF, 0xFFFF, 0xFFFF, 0x12A8, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FAE,   // 6DC0 - 6DCF
	0xFFFF, 0x168F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1137, 0x1BD4, 0x1256, 0xFFFF, 0xFFFF, 0xFFFF, 0x1641, 0xFFFF,   // 6DD0 - 6DDF
	0xFFFF, 0x10F5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B62, 0xFFFF, 0x1273, 0x19E8, 0xFFFF, 0xFFFF, 0x202B, 0xFFFF,   // 6DE0 - 6DEF
	0xFFFF, 0x1716, 0xFFFF, 0x16A0, 0xFFFF, 0x1800, 0xFFFF, 0x1FCE, 0x1D3C, 0x17C6, 0x1D10, 0x1D29, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6DF0 - 6DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6E00 - 6E0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1554, 0xFFFF, 0x1FFD, 0x1AE2, 0x0DDD, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B63,   // 6E10 - 6E1F
	0x0E28, 0x1138, 0xFFFF, 0x1520, 0x13C5, 0x173A, 0x18AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15DA, 0x1DC4, 0x197A, 0xFFFF, 0x1F25,   // 6E20 - 6E2F
	0xFFFF, 0xFFFF, 0x15BE, 0xFFFF, 0x0DCC, 0xFFFF, 0x1845, 0xFFFF, 0x19A5, 0xFFFF, 0x1347, 0xFFFF, 0x137C, 0x1ACA, 0x1FCF, 0xFFFF,   // 6E30 - 6E3F
	0xFFFF, 0xFFFF, 0xFFFF, 0x13F1, 0x137D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BF8, 0xFFFF, 0xFFFF, 0x10E2, 0xFFFF, 0xFFFF,   // 6E40 - 6E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FAF, 0xFFFF, 0x156D, 0xFFFF, 0xFFFF, 0x10F6, 0x16ED, 0xFFFF, 0x1B64, 0x2014,   // 6E50 - 6E5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x190A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D85, 0xFFFF, 0xFFFF, 0x1A40, 0x1E25,   // 6E60 - 6E6F
	0xFFFF, 0xFFFF, 0x1960, 0x1073, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x144C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6E70 - 6E7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6E80 - 6E8F
	0x1961, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C18, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1264, 0x0F73, 0xFFFF, 0x1312,   // 6E90 - 6E9F
	0xFFFF, 0xFFFF, 0x1A52, 0xFFFF, 0xFFFF, 0x148C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EA4, 0x189A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1617,   // 6EA0 - 6EAF
	0xFFFF, 0x1C69, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x190B, 0xFFFF, 0xFFFF, 0xFFFF, 0x10D4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6EB0 - 6EBF
	0xFFFF, 0xFFFF, 0x13DB, 0xFFFF, 0x1CDD, 0x130A, 0xFFFF, 0xFFFF, 0xFFFF, 0x2015, 0xFFFF, 0x1A74, 0x1D03, 0xFFFF, 0x1F89, 0xFFFF,   // 6EC0 - 6ECF
	0xFFFF, 0x2005, 0xFFFF, 0x1ACB, 0x1139, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6ED0 - 6EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D46,   // 6EE0 - 6EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AF9, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FB0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EE5, 0x12C7,   // 6EF0 - 6EFF
	0xFFFF, 0x17AD, 0x1EC3, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DE4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1257,   // 6F00 - 6F0F
	0xFFFF, 0x0E0F, 0xFFFF, 0xFFFF, 0x1801, 0x1BA8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F10 - 6F1F
	0x12BA, 0xFFFF, 0x1EFD, 0x11F0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12C8, 0x1C48, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F20 - 6F2F
	0xFFFF, 0x1663, 0x1CDE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B40, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AAE,   // 6F30 - 6F3F
	0xFFFF, 0x1846, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F40 - 6F4F
	0xFFFF, 0x13C6, 0xFFFF, 0xFFFF, 0x0E62, 0xFFFF, 0xFFFF, 0x1C94, 0x13B3, 0xFFFF, 0x1690, 0x1A98, 0xFFFF, 0xFFFF, 0x1221, 0x15AF,   // 6F50 - 6F5F
	0xFFFF, 0xFFFF, 0x2016, 0xFFFF, 0x19CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10F7, 0x1BA9, 0xFFFF,   // 6F60 - 6F6F
	0x0FB5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A94, 0xFFFF, 0x116C, 0x144D, 0x129F, 0xFFFF,   // 6F70 - 6F7F
	0xFFFF, 0x1559, 0xFFFF, 0xFFFF, 0x1C9B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D21, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BF9, 0x1E7D, 0xFFFF,   // 6F80 - 6F8F
	0x1944, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FB1, 0xFFFF, 0xFFFF, 0x0DBD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6F90 - 6F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1EFE, 0x1E38, 0xFFFF, 0xFFFF, 0x1218, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x202C, 0x1CB3,   // 6FA0 - 6FAF
	0xFFFF, 0x1B1E, 0xFFFF, 0x188C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10EC, 0xFFFF,   // 6FB0 - 6FBF
	0x0E51, 0x1E0A, 0x1202, 0x10B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1866, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 6FC0 - 6FCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1847, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B89,   // 6FD0 - 6FDF
	0x1FB2, 0x19A7, 0xFFFF, 0xFFFF, 0x113A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FB3, 0xFFFF, 0x11AF, 0x1C19, 0xFFFF, 0xFFFF, 0x1E0B,   // 6FE0 - 6FEF
	0xFFFF, 0x14F4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11DD, 0xFFFF,   // 6FF0 - 6FFF
	0xFFFF, 0x179A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F8A, 0x114D, 0xFFFF, 0xFFFF, 0x1521, 0xFFFF, 0x1717, 0xFFFF, 0xFFFF, 0xFFFF, 0x1265,   // 7000 - 700F
	0xFFFF, 0x1EBA, 0xFFFF, 0xFFFF, 0xFFFF, 0x14F5, 0xFFFF, 0xFFFF, 0x1222, 0xFFFF, 0x1EFF, 0x1848, 0x19DB, 0x11E9, 0x1B65, 0x1618,   // 7010 - 701F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F36, 0xFFFF, 0xFFFF, 0xFFFF, 0x1239, 0x123E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1849,   // 7020 - 702F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A2F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11A5, 0xFFFF,   // 7030 - 703F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F14, 0xFFFF, 0xFFFF, 0xFFFF,   // 7040 - 704F
	0x1F8B, 0x1648, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E16, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FB4, 0xFFFF, 0xFFFF,   // 7050 - 705F
	0xFFFF, 0xFFFF, 0xFFFF, 0x12C9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7060 - 706F
	0x202D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F74, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A89, 0x1ACC, 0xFFFF, 0xFFFF,   // 7070 - 707F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E81, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DB7, 0xFFFF, 0xFFFF, 0xFFFF, 0x182A, 0xFFFF,   // 7080 - 708F
	0xFFFF, 0xFFFF, 0x1D56, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x207E, 0x1A75, 0x0F29, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7090 - 709F
	0xFFFF, 0x1B66, 0xFFFF, 0xFFFF, 0x1619, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F63, 0x0E29, 0x1E17, 0xFFFF, 0x1F8C,   // 70A0 - 70AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x143D, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BFA, 0x1A8A, 0x1B41, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 70B0 - 70BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11FD, 0xFFFF, 0xFFFF, 0x2070, 0xFFFF, 0xFFFF, 0xFFFF, 0x188D,   // 70C0 - 70CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FDA, 0x1199, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C30, 0xFFFF, 0x1803,   // 70D0 - 70DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 70E0 - 70EF
	0xFFFF, 0x0E82, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E7E, 0xFFFF, 0xFFFF, 0xFFFF, 0x146F, 0xFFFF, 0xFFFF,   // 70F0 - 70FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2058, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17BC, 0xFFFF, 0xFFFF, 0x1C1A, 0xFFFF, 0xFFFF, 0xFFFF,   // 7100 - 710F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13F2, 0x14AF, 0xFFFF, 0xFFFF, 0xFFFF, 0x115C, 0xFFFF,   // 7110 - 711F
	0xFFFF, 0x1357, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D57, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7120 - 712F
	0x182B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1804, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7130 - 713F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x206A, 0xFFFF, 0x11F1, 0x2061, 0xFFFF, 0x2017, 0xFFFF, 0x1B1F, 0xFFFF,   // 7140 - 714F
	0x184A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1068, 0xFFFF, 0xFFFF, 0x1805, 0xFFFF, 0xFFFF, 0x193C, 0xFFFF, 0x154E, 0xFFFF,   // 7150 - 715F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12EC, 0x1FFE, 0x2051, 0x1BAA, 0xFFFF, 0x1407, 0xFFFF, 0xFFFF, 0x179B, 0xFFFF, 0x1A76, 0xFFFF,   // 7160 - 716F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15BF, 0xFFFF, 0xFFFF,   // 7170 - 717F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1945, 0x1950, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2059,   // 7180 - 718F
	0xFFFF, 0xFFFF, 0x1F8D, 0xFFFF, 0x190C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2099, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1691,   // 7190 - 719F
	0xFFFF, 0xFFFF, 0x1470, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x188E, 0xFFFF, 0xFFFF, 0xFFFF,   // 71A0 - 71AF
	0xFFFF, 0x1820, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x209A, 0x209B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DCF, 0xFFFF,   // 71B0 - 71BF
	0xFFFF, 0x1835, 0xFFFF, 0x1807, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1187, 0x115D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x124A, 0xFFFF,   // 71C0 - 71CF
	0x12A0, 0xFFFF, 0x161A, 0xFFFF, 0x1408, 0x1808, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x184B,   // 71D0 - 71DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BAB, 0x1CB4, 0x1664, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D69, 0x15EC, 0xFFFF,   // 71E0 - 71EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x205A, 0x16FE, 0xFFFF, 0x113B, 0x18E8,   // 71F0 - 71FF
	0x1F5A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EBB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7200 - 720F
	0x1223, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7210 - 721F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BAC, 0xFFFF, 0x1E5E, 0x1AD3, 0xFFFF, 0xFFFF,   // 7220 - 722F
	0x1962, 0xFFFF, 0x197B, 0xFFFF, 0xFFFF, 0x1A8B, 0x148D, 0xFFFF, 0xFFFF, 0xFFFF, 0x177E, 0x2043, 0xFFFF, 0x156E, 0x1A17, 0xFFFF,   // 7230 - 723F
	0x156F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AAF, 0x1E84, 0x1E68, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E77, 0xFFFF, 0xFFFF, 0xFFFF,   // 7240 - 724F
	0xFFFF, 0xFFFF, 0x1D34, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x114E, 0x1727, 0xFFFF, 0x1924, 0xFFFF, 0x14F6, 0xFFFF, 0x1329,   // 7250 - 725F
	0xFFFF, 0x132A, 0x123F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1336, 0xFFFF, 0x1372, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7260 - 726F
	0xFFFF, 0xFFFF, 0x1583, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E53, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E56, 0xFFFF, 0xFFFF,   // 7270 - 727F
	0x1597, 0x128E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7280 - 728F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7290 - 729F
	0xFFFF, 0xFFFF, 0x114F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x209C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E57, 0xFFFF, 0xFFFF, 0x1419,   // 72A0 - 72AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 72B0 - 72BF
	0x1570, 0xFFFF, 0x0F2A, 0xFFFF, 0x1AFA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1758, 0xFFFF,   // 72C0 - 72CF
	0x1FB5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F75, 0xFFFF, 0x1AE3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 72D0 - 72DF
	0xFFFF, 0x0F4A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1665, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 72E0 - 72EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x128F, 0x1F7D, 0xFFFF, 0xFFFF, 0x11BB, 0x1E78, 0xFFFF, 0xFFFF,   // 72F0 - 72FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1867, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7300 - 730F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F9, 0x16DA, 0x1BCD, 0xFFFF, 0xFFFF,   // 7310 - 731F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18D1, 0xFFFF, 0xFFFF, 0xFFFF, 0x15F6, 0x1AE4, 0x1348, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7320 - 732F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19A8, 0x19A9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2006, 0x1963,   // 7330 - 733F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1897, 0x1522, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7340 - 734F
	0x1AB1, 0xFFFF, 0x188F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FAF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7350 - 735F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1150, 0xFFFF, 0x202E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7360 - 736F
	0x184C, 0xFFFF, 0x2036, 0xFFFF, 0xFFFF, 0x1204, 0xFFFF, 0xFFFF, 0x1666, 0xFFFF, 0x10ED, 0x1F54, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7370 - 737F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F64, 0xFFFF, 0x1A77, 0x163D, 0xFFFF, 0x1898, 0xFFFF, 0x18C9, 0xFFFF, 0xFFFF, 0x1B67, 0xFFFF,   // 7380 - 738F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D11, 0xFFFF, 0x0F76, 0x1925, 0x1026, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x138F,   // 7390 - 739F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19CF, 0xFFFF, 0x18B8, 0xFFFF, 0xFFFF, 0xFFFF, 0x14F7, 0xFFFF, 0xFFFF,   // 73A0 - 73AF
	0xFFFF, 0xFFFF, 0x120C, 0x111B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 73B0 - 73BF
	0x139E, 0xFFFF, 0x0D99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1390, 0x1544, 0xFFFF, 0x1EDD, 0x1C6A, 0xFFFF, 0x0DAC,   // 73C0 - 73CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F2B, 0xFFFF, 0xFFFF, 0x0EF7, 0xFFFF, 0xFFFF, 0xFFFF, 0x2052, 0x119A, 0xFFFF,   // 73D0 - 73DF
	0x1BFB, 0xFFFF, 0xFFFF, 0x16A1, 0x144E, 0x1A18, 0x1F48, 0xFFFF, 0xFFFF, 0x1F8E, 0x0FC4, 0xFFFF, 0xFFFF, 0x13B4, 0xFFFF, 0xFFFF,   // 73E0 - 73EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1358, 0xFFFF, 0x15F7, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B68, 0x1F66, 0xFFFF,   // 73F0 - 73FF
	0xFFFF, 0x15C0, 0xFFFF, 0x0F77, 0xFFFF, 0x11BC, 0x1290, 0x1667, 0xFFFF, 0x1266, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7400 - 740F
	0xFFFF, 0xFFFF, 0xFFFF, 0x18B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DEA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7410 - 741F
	0x1B20, 0x1692, 0x1E0C, 0xFFFF, 0xFFFF, 0x1FB6, 0x1027, 0xFFFF, 0x0EE6, 0xFFFF, 0x1028, 0x1471, 0x18BA, 0xFFFF, 0x1BD5, 0x0F15,   // 7420 - 742F
	0x182C, 0xFFFF, 0xFFFF, 0x12A9, 0x0FF2, 0x14D7, 0x1E5F, 0xFFFF, 0x1E0D, 0xFFFF, 0x141D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FD0,   // 7430 - 743F
	0x1926, 0x132B, 0xFFFF, 0x1DA4, 0x15C1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x197C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7440 - 744F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EEC, 0xFFFF, 0x1964, 0xFFFF, 0x109D, 0x1FB7, 0x184E, 0x19AB, 0xFFFF, 0x1598, 0x16B8,   // 7450 - 745F
	0x1267, 0xFFFF, 0x190D, 0xFFFF, 0x18E9, 0x189B, 0xFFFF, 0xFFFF, 0x1C6B, 0x1F8F, 0x12B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11BD,   // 7460 - 746F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FE4, 0xFFFF,   // 7470 - 747F
	0xFFFF, 0xFFFF, 0x1029, 0x1291, 0xFFFF, 0xFFFF, 0xFFFF, 0x15C2, 0xFFFF, 0x11F2, 0xFFFF, 0x1AB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7480 - 748F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12A1, 0xFFFF, 0xFFFF, 0xFFFF, 0x2018, 0xFFFF, 0x139F, 0x0E83,   // 7490 - 749F
	0xFFFF, 0x1C6C, 0xFFFF, 0x102A, 0xFFFF, 0x0E84, 0xFFFF, 0x1423, 0x1CB5, 0xFFFF, 0x1BAD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 74A0 - 74AF
	0x1FFF, 0xFFFF, 0x1668, 0xFFFF, 0xFFFF, 0x17D5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1693, 0xFFFF, 0xFFFF, 0xFFFF, 0x157C, 0xFFFF, 0x15C3,   // 74B0 - 74BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C87, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E85, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x123A,   // 74C0 - 74CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1850, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F16, 0xFFFF, 0x1CB6, 0xFFFF, 0x0F00, 0xFFFF, 0xFFFF, 0xFFFF,   // 74D0 - 74DF
	0x1FB8, 0xFFFF, 0x1EC4, 0x1E69, 0xFFFF, 0xFFFF, 0x18AB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A3, 0xFFFF,   // 74E0 - 74EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A78, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 74F0 - 74FF
	0xFFFF, 0x143E, 0xFFFF, 0xFFFF, 0x0E58, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7500 - 750F
	0xFFFF, 0x1C31, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A4, 0xFFFF, 0xFFFF, 0x0DDE, 0xFFFF, 0x1718, 0x1D2A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1584,   // 7510 - 751F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1545, 0xFFFF, 0x1585, 0x161B, 0xFFFF, 0x190E, 0xFFFF, 0xFFFF, 0x144F, 0x190F, 0xFFFF, 0xFFFF, 0xFFFF,   // 7520 - 752F
	0x1B21, 0x19AC, 0x0DE9, 0x16FF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1075, 0x1B22, 0xFFFF, 0x1B69, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7530 - 753F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EA5, 0xFFFF, 0xFFFF, 0x18D2,   // 7540 - 754F
	0xFFFF, 0x1B23, 0xFFFF, 0x1102, 0x13B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1268, 0xFFFF, 0x1C6D, 0x1D97, 0x1359, 0xFFFF, 0xFFFF,   // 7550 - 755F
	0xFFFF, 0xFFFF, 0x1EDE, 0xFFFF, 0xFFFF, 0x11C6, 0x2071, 0xFFFF, 0xFFFF, 0xFFFF, 0x1409, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C1B,   // 7560 - 756F
	0x1A1A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE4, 0x110D, 0xFFFF, 0x102B, 0xFFFF, 0x0DF7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x102C,   // 7570 - 757F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DF8, 0x1BFC, 0xFFFF, 0xFFFF, 0x1D35, 0x1EDF, 0xFFFF, 0xFFFF, 0x161D, 0x161C,   // 7580 - 758F
	0xFFFF, 0x19FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1546, 0xFFFF, 0xFFFF,   // 7590 - 759F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E10, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 75A0 - 75AF
	0xFFFF, 0x1EAA, 0x1ED4, 0x0DDF, 0xFFFF, 0x1A79, 0xFFFF, 0xFFFF, 0x10EE, 0x1C6E, 0xFFFF, 0xFFFF, 0x116D, 0x1AE5, 0x1C88, 0xFFFF,   // 75B0 - 75BF
	0xFFFF, 0xFFFF, 0x0D9A, 0xFFFF, 0xFFFF, 0x143F, 0xFFFF, 0x1C32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A1B, 0xFFFF, 0xFFFF,   // 75C0 - 75CF
	0xFFFF, 0xFFFF, 0x179C, 0xFFFF, 0x1DD0, 0x207F, 0xFFFF, 0xFFFF, 0x1177, 0x0E86, 0xFFFF, 0x1E42, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 75D0 - 75DF
	0xFFFF, 0xFFFF, 0x1293, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 75E0 - 75EF
	0x10F9, 0xFFFF, 0x12B2, 0xFFFF, 0x1DD1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14D8, 0xFFFF, 0x0EC2, 0xFFFF, 0xFFFF, 0xFFFF,   // 75F0 - 75FF
	0x17AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x179D, 0xFFFF, 0xFFFF,   // 7600 - 760F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x161E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x189C,   // 7610 - 761F
	0x1D04, 0x1CE0, 0x13B6, 0xFFFF, 0x1269, 0xFFFF, 0x1669, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7620 - 762F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1258, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7630 - 763F
	0xFFFF, 0xFFFF, 0x124B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1753, 0xFFFF, 0x0DBE, 0xFFFF,   // 7640 - 764F
	0xFFFF, 0xFFFF, 0x19AE, 0xFFFF, 0xFFFF, 0xFFFF, 0x1424, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7650 - 765F
	0xFFFF, 0x1DD2, 0xFFFF, 0xFFFF, 0x1B39, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1191, 0xFFFF, 0xFFFF, 0x15C4, 0xFFFF, 0xFFFF, 0xFFFF,   // 7660 - 766F
	0x18A5, 0xFFFF, 0x1B24, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EA6, 0xFFFF, 0xFFFF, 0x1188, 0x13C7, 0x1402, 0x1403, 0xFFFF,   // 7670 - 767F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AFC, 0xFFFF, 0x0E11, 0x2019, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F4B, 0xFFFF,   // 7680 - 768F
	0x0EC3, 0xFFFF, 0xFFFF, 0x1FB9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7690 - 769F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ED5, 0xFFFF,   // 76A0 - 76AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D86, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1313,   // 76B0 - 76BF
	0xFFFF, 0xFFFF, 0x1927, 0x13F3, 0xFFFF, 0xFFFF, 0x14B0, 0xFFFF, 0x1851, 0xFFFF, 0x1A30, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 76C0 - 76CF
	0xFFFF, 0xFFFF, 0x1F16, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E12, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15F8, 0x113C, 0xFFFF, 0x1A95, 0x12FB,   // 76D0 - 76DF
	0xFFFF, 0x1C6F, 0xFFFF, 0x0DE0, 0x13B7, 0xFFFF, 0xFFFF, 0x1224, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1337, 0xFFFF,   // 76E0 - 76EF
	0xFFFF, 0xFFFF, 0x12FA, 0xFFFF, 0x1C59, 0xFFFF, 0xFFFF, 0xFFFF, 0x1571, 0xFFFF, 0xFFFF, 0xFFFF, 0x13B8, 0xFFFF, 0x16A2, 0xFFFF,   // 76F0 - 76FF
	0xFFFF, 0x15F9, 0xFFFF, 0xFFFF, 0x1304, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E1D, 0x137E, 0xFFFF, 0x0DBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7700 - 770F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C70, 0xFFFF,   // 7710 - 771F
	0x1305, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F67, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7720 - 772F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FAD, 0x132C, 0xFFFF, 0x1BAE, 0xFFFF, 0x1745, 0xFFFF, 0xFFFF, 0xFFFF,   // 7730 - 773F
	0x1CAD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F68, 0xFFFF, 0xFFFF,   // 7740 - 774F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7750 - 775F
	0xFFFF, 0x166A, 0xFFFF, 0x1151, 0xFFFF, 0xFFFF, 0x1338, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D36, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7760 - 776F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x113D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EC4, 0x1868,   // 7770 - 777F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C71, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7780 - 778F
	0xFFFF, 0x1314, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12CA, 0xFFFF,   // 7790 - 779F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1431, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16A3, 0x124C, 0xFFFF, 0xFFFF,   // 77A0 - 77AF
	0x0DE1, 0xFFFF, 0xFFFF, 0x116E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D2B, 0x0E45, 0xFFFF, 0xFFFF, 0x0F78,   // 77B0 - 77BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 77C0 - 77CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D6A, 0xFFFF, 0xFFFF, 0xFFFF, 0x132D, 0x1004, 0xFFFF, 0xFFFF, 0xFFFF,   // 77D0 - 77DF
	0xFFFF, 0xFFFF, 0x16DB, 0x19FE, 0xFFFF, 0x1C49, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F79, 0xFFFF, 0xFFFF, 0xFFFF, 0x10E3, 0x18CD, 0x0F4C,   // 77E0 - 77EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x15B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 77F0 - 77FF
	0xFFFF, 0xFFFF, 0x1523, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7800 - 780F
	0xFFFF, 0xFFFF, 0x14D9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7810 - 781F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C4A, 0x1CEC, 0x1DEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12AC, 0xFFFF, 0xFFFF, 0xFFFF,   // 7820 - 782F
	0xFFFF, 0xFFFF, 0x1EAB, 0xFFFF, 0x1E60, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7830 - 783F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x180A,   // 7840 - 784F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D58, 0xFFFF, 0xFFFF,   // 7850 - 785F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x126A, 0x0E87, 0xFFFF, 0xFFFF, 0x180B,   // 7860 - 786F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14BF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7870 - 787F
	0xFFFF, 0x102D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B6B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x122E, 0x1768, 0x1649, 0xFFFF,   // 7880 - 788F
	0xFFFF, 0x14DA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7890 - 789F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0DCD, 0xFFFF, 0xFFFF, 0xFFFF, 0x1425, 0xFFFF, 0x15B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 78A0 - 78AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FF0, 0x1FF1, 0x12B3, 0xFFFF, 0xFFFF, 0xFFFF,   // 78B0 - 78BF
	0xFFFF, 0x1A7A, 0xFFFF, 0xFFFF, 0xFFFF, 0x13DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1240, 0x1CA5, 0xFFFF, 0xFFFF, 0x0EA7, 0xFFFF,   // 78C0 - 78CF
	0x13B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 78D0 - 78DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B4, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E88, 0xFFFF, 0xFFFF, 0x102E,   // 78E0 - 78EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 78F0 - 78FF
	0xFFFF, 0x1D59, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D5A, 0xFFFF,   // 7900 - 790F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17D6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7910 - 791F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11DE, 0x11EA, 0x13BB, 0xFFFF, 0xFFFF, 0xFFFF,   // 7920 - 792F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16DC, 0xFFFF, 0xFFFF, 0xFFFF, 0x1524, 0xFFFF,   // 7930 - 793F
	0x1525, 0x102F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1030, 0x1031, 0x1C4B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7940 - 794F
	0x1928, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BAF, 0x1C4C, 0xFFFF, 0xFFFF, 0x1BB0, 0x0E2A, 0x1FBA, 0x1D98, 0x1700, 0xFFFF,   // 7950 - 795F
	0x1526, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1572, 0xFFFF, 0xFFFF, 0x1EC5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B8A, 0xFFFF, 0xFFFF,   // 7960 - 796F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1032, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x122F,   // 7970 - 797F
	0xFFFF, 0x0FF3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE5, 0x1B6C, 0x145C,   // 7980 - 798F
	0xFFFF, 0x1929, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7990 - 799F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17AF, 0x209D, 0xFFFF, 0xFFFF, 0x15C5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1219, 0xFFFF,   // 79A0 - 79AF
	0xFFFF, 0x113E, 0xFFFF, 0x179E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x192A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FF4, 0x1FE6, 0x1152,   // 79B0 - 79BF
	0x166B, 0x1527, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1440, 0x108E, 0x1D87, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 79C0 - 79CF
	0xFFFF, 0x0F01, 0x1D5B, 0xFFFF, 0xFFFF, 0x14DB, 0xFFFF, 0xFFFF, 0x14DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BB1,   // 79D0 - 79DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DEF, 0xFFFF, 0x1C72, 0x175F, 0xFFFF, 0x1C89, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 79E0 - 79EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 79F0 - 79FF
	0x209E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1604, 0xFFFF, 0xFFFF, 0x0DC1, 0xFFFF, 0xFFFF, 0x1B6D, 0xFFFF, 0x1D5C, 0xFFFF, 0xFFFF,   // 7A00 - 7A0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A5D, 0xFFFF, 0xFFFF, 0x1E79, 0xFFFF, 0x1C5A, 0x1DD3, 0xFFFF, 0x1280, 0xFFFF, 0xFFFF, 0x1ECC,   // 7A10 - 7A1F
	0x1BB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BD6, 0xFFFF,   // 7A20 - 7A2F
	0xFFFF, 0x1DF0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x193D, 0x1C5B, 0xFFFF, 0xFFFF, 0xFFFF, 0x113F, 0x0D9B, 0x0EA8, 0xFFFF, 0x0EC5,   // 7A30 - 7A3F
	0x0EDC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1339, 0xFFFF, 0xFFFF, 0x1DD4, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AFD, 0x1852, 0xFFFF,   // 7A40 - 7A4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x166C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7A50 - 7A5F
	0xFFFF, 0x1580, 0x1869, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x189D, 0xFFFF, 0x1FF2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7A60 - 7A6F
	0x179F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F73, 0xFFFF, 0x0F7A, 0xFFFF, 0xFFFF, 0x0FA0, 0x0EF8, 0xFFFF, 0xFFFF, 0x1B6E, 0xFFFF, 0x1D12,   // 7A70 - 7A7F
	0xFFFF, 0x1161, 0xFFFF, 0xFFFF, 0x1CAE, 0xFFFF, 0xFFFF, 0xFFFF, 0x18EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7A80 - 7A8F
	0xFFFF, 0xFFFF, 0x1C8A, 0x1CE1, 0xFFFF, 0x1BB3, 0xFFFF, 0xFFFF, 0x0F95, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F9D,   // 7A90 - 7A9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18AC, 0x18AD, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FA1, 0x18EC,   // 7AA0 - 7AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7AB0 - 7ABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CB7, 0x0FC7, 0xFFFF, 0x1178, 0xFFFF, 0xFFFF, 0x1B3A, 0x12AD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7AC0 - 7ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1349, 0xFFFF, 0x1CCD, 0xFFFF, 0xFFFF, 0xFFFF, 0x1441, 0xFFFF, 0x0E89,   // 7AD0 - 7ADF
	0x1AB3, 0xFFFF, 0xFFFF, 0x1C1C, 0xFFFF, 0x116F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x166D, 0xFFFF, 0xFFFF, 0x0DCE, 0xFFFF, 0x10E4,   // 7AE0 - 7AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E8A, 0xFFFF, 0xFFFF, 0x1C0D, 0x1D99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DC2,   // 7AF0 - 7AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FD4,   // 7B00 - 7B0F
	0xFFFF, 0x161F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1587, 0xFFFF, 0x1AFE, 0xFFFF, 0xFFFF, 0x1E30, 0xFFFF,   // 7B10 - 7B1F
	0x12AE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x148E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B8B, 0x120D, 0xFFFF, 0xFFFF,   // 7B20 - 7B2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1605, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7B30 - 7B3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE0, 0xFFFF, 0xFFFF, 0x1189, 0xFFFF, 0x0FE5, 0x1B25, 0x16A4, 0xFFFF, 0x1410,   // 7B40 - 7B4F
	0x0F2C, 0x1D9A, 0x1E43, 0xFFFF, 0x1103, 0xFFFF, 0x1CF4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7B50 - 7B5F
	0x0FD1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15FA, 0xFFFF, 0x1599, 0xFFFF,   // 7B60 - 7B6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x180D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1890, 0xFFFF, 0xFFFF,   // 7B70 - 7B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E13, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B26, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AD4,   // 7B80 - 7B8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13A0, 0x1033, 0xFFFF, 0x1547, 0xFFFF, 0xFFFF, 0x1CA6, 0xFFFF, 0xFFFF, 0x0E68, 0xFFFF, 0xFFFF,   // 7B90 - 7B9F
	0xFFFF, 0x0F17, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B27, 0xFFFF, 0xFFFF,   // 7BA0 - 7BAF
	0xFFFF, 0x1573, 0xFFFF, 0xFFFF, 0x1A99, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AE6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BB0 - 7BBF
	0x1B3B, 0x201A, 0xFFFF, 0xFFFF, 0x141A, 0xFFFF, 0x1B28, 0x1E85, 0xFFFF, 0x1D9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BC0 - 7BCF
	0xFFFF, 0xFFFF, 0x16EF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BD0 - 7BDF
	0x1620, 0xFFFF, 0xFFFF, 0xFFFF, 0x1153, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1528, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BE0 - 7BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7BF0 - 7BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BC6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C00 - 7C0F
	0xFFFF, 0xFFFF, 0x1CB8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10E5, 0xFFFF,   // 7C10 - 7C1F
	0xFFFF, 0x0DC3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x201B, 0xFFFF, 0xFFFF, 0x1A9A, 0x1621, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C20 - 7C2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D2C, 0x1203, 0x148F,   // 7C30 - 7C3F
	0xFFFF, 0xFFFF, 0xFFFF, 0x11B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BFD, 0x1AFF, 0xFFFF, 0xFFFF,   // 7C40 - 7C4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C50 - 7C5F
	0x123B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D2D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1294, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C60 - 7C6F
	0xFFFF, 0xFFFF, 0xFFFF, 0x137F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C70 - 7C7F
	0xFFFF, 0xFFFF, 0xFFFF, 0x14DD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7C80 - 7C8F
	0xFFFF, 0xFFFF, 0x12AF, 0xFFFF, 0xFFFF, 0x13A1, 0xFFFF, 0x1BB4, 0x1B42, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1632,   // 7C90 - 7C9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C0E, 0xFFFF, 0x1AB4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11CD, 0xFFFF,   // 7CA0 - 7CAF
	0xFFFF, 0x11CE, 0x1CBA, 0x0E1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x166E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B6F, 0xFFFF,   // 7CB0 - 7CBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FBB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7CC0 - 7CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x110E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14B2, 0x1BB5,   // 7CD0 - 7CDF
	0x0DF9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11CF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7CE0 - 7CEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EA9, 0xFFFF, 0xFFFF, 0x0FC8, 0xFFFF,   // 7CF0 - 7CFF
	0x1034, 0xFFFF, 0x1BFE, 0xFFFF, 0x1785, 0x1FDB, 0x192B, 0x2082, 0x2000, 0xFFFF, 0x136A, 0x136B, 0xFFFF, 0x1079, 0xFFFF, 0xFFFF,   // 7D00 - 7D0F
	0x10C7, 0xFFFF, 0xFFFF, 0xFFFF, 0x16A5, 0xFFFF, 0xFFFF, 0x1529, 0x0F3C, 0x1C4D, 0x1000, 0x14B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D10 - 7D1F
	0x1622, 0x13DD, 0x1581, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A7B, 0x1BFF, 0xFFFF, 0x1CC5, 0x1259,   // 7D20 - 7D2F
	0x1606, 0xFFFF, 0xFFFF, 0x1701, 0xFFFF, 0x1AE7, 0xFFFF, 0xFFFF, 0xFFFF, 0x1623, 0x0DE2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D30 - 7D3F
	0xFFFF, 0xFFFF, 0x1BD7, 0x1F69, 0x1BB6, 0x0E8B, 0x13BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D40 - 7D4F
	0x0E63, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F4D, 0xFFFF,   // 7D50 - 7D5F
	0xFFFF, 0x119B, 0x1F6A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1001, 0xFFFF, 0x19DC, 0xFFFF, 0x1A43, 0xFFFF, 0xFFFF, 0xFFFF, 0x159A, 0xFFFF,   // 7D60 - 7D6F
	0xFFFF, 0x1E44, 0x152A, 0x0DFA, 0xFFFF, 0xFFFF, 0x1B3C, 0xFFFF, 0xFFFF, 0x0E59, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F7B,   // 7D70 - 7D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B70, 0x166F,   // 7D80 - 7D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0E8C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BD8, 0xFFFF, 0xFFFF, 0xFFFF,   // 7D90 - 7D9F
	0x1230, 0xFFFF, 0x1C00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1670, 0x19B1, 0xFFFF, 0xFFFF,   // 7DA0 - 7DAF
	0xFFFF, 0x0DFB, 0x12DD, 0xFFFF, 0x1D22, 0x1CED, 0xFFFF, 0xFFFF, 0x1274, 0xFFFF, 0x1035, 0x1E18, 0xFFFF, 0x1A8C, 0x1281, 0x1306,   // 7DB0 - 7DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DD5, 0xFFFF, 0xFFFF, 0x1046, 0x14DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7DC0 - 7DCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x159B, 0xFFFF, 0x1F0F, 0xFFFF, 0x15C6, 0xFFFF, 0xFFFF, 0x1C95, 0x10E6, 0xFFFF,   // 7DD0 - 7DDF
	0x1D47, 0x1391, 0xFFFF, 0x180E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E86, 0x18BC, 0xFFFF, 0xFFFF, 0x1307, 0xFFFF, 0xFFFF, 0x197D,   // 7DE0 - 7DEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11F3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DD6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7DF0 - 7DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C73, 0x1770, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E00 - 7E0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x189E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13A2, 0xFFFF, 0x1C74, 0x1FBC, 0x18FC,   // 7E10 - 7E1F
	0xFFFF, 0x1ACD, 0xFFFF, 0x1F6B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1472, 0xFFFF, 0xFFFF, 0x1D9C, 0x1810,   // 7E20 - 7E2F
	0xFFFF, 0x1BD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x125A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D77, 0x1B00, 0xFFFF,   // 7E30 - 7E3F
	0xFFFF, 0x140B, 0xFFFF, 0x14C0, 0xFFFF, 0xFFFF, 0x135A, 0x18ED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E40 - 7E4F
	0xFFFF, 0xFFFF, 0x1C33, 0xFFFF, 0x1C5C, 0x15C7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18EE, 0xFFFF,   // 7E50 - 7E5F
	0xFFFF, 0x1671, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16C7, 0x202F, 0x0EAA, 0xFFFF, 0x0E5A, 0xFFFF, 0xFFFF,   // 7E60 - 7E6F
	0x1BB7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17EA, 0xFFFF, 0xFFFF, 0x0EAB, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E70 - 7E7F
	0xFFFF, 0xFFFF, 0x1CB9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1633, 0xFFFF, 0xFFFF, 0x1B29,   // 7E80 - 7E8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1853, 0xFFFF, 0xFFFF, 0x15E5, 0xFFFF, 0x1CBB, 0xFFFF, 0xFFFF, 0x1154, 0x11B1, 0xFFFF, 0xFFFF, 0xFFFF,   // 7E90 - 7E9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EA0 - 7EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EB0 - 7EBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EC0 - 7ECF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7ED0 - 7EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EE0 - 7EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7EF0 - 7EFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F00 - 7F0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F10 - 7F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F20 - 7F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1490, 0xFFFF, 0x1F26, 0xFFFF, 0x0E64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F30 - 7F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1774, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F40 - 7F4F
	0x0F18, 0xFFFF, 0xFFFF, 0xFFFF, 0x12DE, 0x1F00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F50 - 7F5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BE4, 0x0F31, 0xFFFF, 0xFFFF, 0x1DD7, 0xFFFF,   // 7F60 - 7F6F
	0x1411, 0xFFFF, 0x159C, 0xFFFF, 0xFFFF, 0x12ED, 0xFFFF, 0x1E61, 0xFFFF, 0x1295, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7F70 - 7F7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1192, 0xFFFF, 0xFFFF, 0x1036, 0xFFFF, 0x17A1, 0xFFFF, 0x0DFC, 0xFFFF, 0x1380, 0xFFFF,   // 7F80 - 7F8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EC6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x120E, 0xFFFF, 0xFFFF, 0xFFFF, 0x1672, 0xFFFF,   // 7F90 - 7F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F96, 0xFFFF, 0xFFFF, 0xFFFF, 0x15C8, 0x19FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7FA0 - 7FAF
	0xFFFF, 0xFFFF, 0x209F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1296, 0x0E1E, 0xFFFF, 0xFFFF, 0xFFFF, 0x192C, 0xFFFF, 0xFFFF,   // 7FB0 - 7FBF
	0xFFFF, 0x18A6, 0xFFFF, 0xFFFF, 0xFFFF, 0x16DD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A31, 0xFFFF, 0x1A32, 0xFFFF, 0x120F, 0xFFFF,   // 7FC0 - 7FCF
	0xFFFF, 0xFFFF, 0x16BD, 0xFFFF, 0x1574, 0x208A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B01,   // 7FD0 - 7FDF
	0x1DB8, 0x14DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E87, 0xFFFF, 0x18BD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 7FE0 - 7FEF
	0x1F01, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F4E, 0xFFFF, 0xFFFF, 0x1A33, 0xFFFF, 0xFFFF, 0xFFFF,   // 7FF0 - 7FFF
	0x18EF, 0x1225, 0xFFFF, 0x0EC7, 0xFFFF, 0x1A7C, 0x1037, 0xFFFF, 0xFFFF, 0x0F7C, 0xFFFF, 0xFFFF, 0x1A1F, 0xFFFF, 0xFFFF, 0xFFFF,   // 8000 - 800F
	0x1089, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E8D, 0xFFFF, 0x132E, 0x1946, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8010 - 801F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1038, 0xFFFF, 0xFFFF,   // 8020 - 802F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1A20, 0xFFFF, 0xFFFF, 0x177F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E1E, 0xFFFF, 0x0E8E,   // 8030 - 803F
	0xFFFF, 0xFFFF, 0xFFFF, 0x10FA, 0xFFFF, 0xFFFF, 0x1210, 0xFFFF, 0xFFFF, 0xFFFF, 0x124D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8040 - 804F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15FB, 0xFFFF, 0x14FD, 0xFFFF, 0x1DB9, 0xFFFF, 0xFFFF, 0xFFFF, 0x136C, 0xFFFF,   // 8050 - 805F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11F4,   // 8060 - 806F
	0x1D78, 0xFFFF, 0x15FC, 0x1910, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C5D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D3D, 0x123C, 0x19D9,   // 8070 - 807F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A21, 0x1694, 0x152B, 0x1BB8, 0xFFFF, 0x19C5, 0xFFFF, 0x127C, 0x1039, 0xFFFF, 0xFFFF, 0xFFFF,   // 8080 - 808F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D5D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F27, 0xFFFF, 0x0DC4, 0xFFFF, 0xFFFF,   // 8090 - 809F
	0xFFFF, 0x0EC8, 0x1C4E, 0xFFFF, 0xFFFF, 0x14E0, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E5B, 0x13DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1005,   // 80A0 - 80AF
	0xFFFF, 0x0F3D, 0x19C6, 0xFFFF, 0x2044, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 80B0 - 80BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x197E, 0x1BEA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13F4, 0xFFFF, 0x1E31, 0xFFFF,   // 80C0 - 80CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13F5, 0x0DEA, 0xFFFF, 0xFFFF, 0x1EAC, 0xFFFF,   // 80D0 - 80DF
	0xFFFF, 0x1FBD, 0xFFFF, 0xFFFF, 0x19D0, 0x159D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 80E0 - 80EF
	0xFFFF, 0x0F2D, 0xFFFF, 0xFFFF, 0x1170, 0xFFFF, 0xFFFF, 0xFFFF, 0x207A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10CE, 0xFFFF, 0xFFFF,   // 80F0 - 80FF
	0xFFFF, 0xFFFF, 0x1C4F, 0xFFFF, 0xFFFF, 0x1F7E, 0x1DBA, 0x1F7F, 0x12F2, 0xFFFF, 0x1D05, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8100 - 810F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18BE, 0xFFFF, 0x0DAD, 0x0E8F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8110 - 811F
	0xFFFF, 0xFFFF, 0xFFFF, 0x16A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1673, 0xFFFF, 0x1E1B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EAD,   // 8120 - 812F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CE2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14E1, 0xFFFF,   // 8130 - 813F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1771, 0xFFFF, 0xFFFF, 0x1702, 0xFFFF,   // 8140 - 814F
	0x1491, 0x1492, 0xFFFF, 0xFFFF, 0x0DFD, 0x18BF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8150 - 815F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15FD, 0x10B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BDA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8160 - 816F
	0x18F0, 0x0E38, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AB5, 0x145D, 0x15C9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E48,   // 8170 - 817F
	0x13DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E52, 0xFFFF, 0x13A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EC9,   // 8180 - 818F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1493, 0xFFFF, 0x12BB, 0x16B9, 0xFFFF, 0xFFFF,   // 8190 - 819F
	0x0F4F, 0xFFFF, 0xFFFF, 0x1C8B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E7F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 81A0 - 81AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x15CA, 0xFFFF, 0x1DAF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19F2, 0xFFFF, 0xFFFF, 0x10FB, 0x2030, 0x10B3,   // 81B0 - 81BF
	0x117F, 0xFFFF, 0x14E2, 0xFFFF, 0xFFFF, 0xFFFF, 0x17B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B8C, 0xFFFF, 0xFFFF,   // 81C0 - 81CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AB6,   // 81D0 - 81DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1703, 0xFFFF, 0x18AE, 0xFFFF, 0x1AB7, 0x12AA, 0xFFFF, 0x1A7D, 0xFFFF, 0xFFFF, 0x1DBB, 0xFFFF, 0xFFFF,   // 81E0 - 81EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1C50, 0x1DD8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x111C, 0x1C75, 0x0F7D, 0xFFFF, 0x19B2, 0xFFFF,   // 81F0 - 81FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F7E, 0xFFFF, 0x17D8, 0x208B, 0xFFFF, 0x0F7F, 0xFFFF, 0x15DB, 0x152C, 0xFFFF, 0xFFFF,   // 8200 - 820F
	0xFFFF, 0xFFFF, 0x159E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D13, 0x16A7, 0xFFFF, 0x135B, 0x1C01,   // 8210 - 821F
	0xFFFF, 0x0DFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F28, 0x13E0, 0x13BD, 0xFFFF, 0xFFFF, 0xFFFF,   // 8220 - 822F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DFC, 0x13A4, 0x1F6C, 0xFFFF, 0x15CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8230 - 823F
	0x1494, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17D9, 0xFFFF, 0x1B71, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8240 - 824F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CE3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8250 - 825F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A00, 0xFFFF, 0x1F10, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DC5, 0x11D0,   // 8260 - 826F
	0xFFFF, 0x0DC6, 0x1582, 0xFFFF, 0xFFFF, 0xFFFF, 0x182D, 0xFFFF, 0x1D5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1769, 0xFFFF,   // 8270 - 827F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x192D, 0xFFFF, 0x1A8D, 0x0FA2, 0xFFFF,   // 8280 - 828F
	0xFFFF, 0xFFFF, 0x12DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1495, 0x1180, 0xFFFF, 0xFFFF, 0x1C51, 0xFFFF, 0x1555,   // 8290 - 829F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E14, 0x1FBE, 0xFFFF, 0xFFFF, 0x0FF5, 0xFFFF, 0xFFFF, 0x14B4, 0x1E62, 0x186A, 0x1719,   // 82A0 - 82AF
	0xFFFF, 0x1FE7, 0xFFFF, 0x13E1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C52, 0x1947, 0x0FE6, 0xFFFF, 0x1D88, 0x132F, 0x1728, 0xFFFF, 0x1A69,   // 82B0 - 82BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 82C0 - 82CF
	0xFFFF, 0x1965, 0x182E, 0xFFFF, 0x1E32, 0x1D5F, 0xFFFF, 0x134A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D9C, 0xFFFF, 0xFFFF, 0x1EAE, 0x0F80,   // 82D0 - 82DF
	0xFFFF, 0x1A22, 0xFFFF, 0xFFFF, 0xFFFF, 0x1786, 0x0ECA, 0x1AE8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 82E0 - 82EF
	0xFFFF, 0x1856, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ECB, 0x1EE1, 0xFFFF,   // 82F0 - 82FF
	0xFFFF, 0x1C22, 0x135C, 0x141B, 0x0D9D, 0x1330, 0xFFFF, 0xFFFF, 0xFFFF, 0x12D5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8300 - 830F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1315, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8310 - 831F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A7E, 0xFFFF, 0xFFFF, 0x12E0, 0xFFFF, 0xFFFF, 0xFFFF, 0x145E,   // 8320 - 832F
	0xFFFF, 0x1674, 0xFFFF, 0xFFFF, 0x2031, 0x1A44, 0x10D6, 0xFFFF, 0x1911, 0x17DA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8330 - 833F
	0x16A8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F43, 0xFFFF, 0x1D60, 0x1F90, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A5F,   // 8340 - 834F
	0xFFFF, 0x1A23, 0x201C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8350 - 835F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8360 - 836F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1179, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EED, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B02, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8370 - 837F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1297, 0x1AB8, 0xFFFF, 0xFFFF, 0xFFFF, 0x152D, 0xFFFF,   // 8380 - 838F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E90, 0xFFFF, 0x1704, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18C0, 0xFFFF,   // 8390 - 839F
	0xFFFF, 0xFFFF, 0x1F80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1496, 0x1729, 0x12BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 83A0 - 83AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12E1, 0xFFFF, 0xFFFF,   // 83B0 - 83BF
	0xFFFF, 0x1D3E, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F19, 0xFFFF, 0xFFFF, 0xFFFF, 0x1231, 0x0F90, 0xFFFF, 0x0FD2, 0xFFFF, 0xFFFF, 0xFFFF,   // 83C0 - 83CF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0F02, 0xFFFF, 0xFFFF, 0x1CE4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CEE, 0xFFFF, 0xFFFF, 0xFFFF,   // 83D0 - 83DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1450, 0xFFFF, 0x0FE7, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FE8,   // 83E0 - 83EF
	0x0ECC, 0x1282, 0x14E3, 0xFFFF, 0x1754, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AE9, 0xFFFF, 0xFFFF, 0xFFFF, 0x1695, 0xFFFF, 0xFFFF,   // 83F0 - 83FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1DB0, 0x1140, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11C3, 0xFFFF, 0x12FC, 0x1E8F, 0x197F, 0xFFFF,   // 8400 - 840F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8410 - 841F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D89, 0xFFFF, 0xFFFF, 0x12CB, 0xFFFF, 0xFFFF, 0xFFFF,   // 8420 - 842F
	0xFFFF, 0x2062, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x119C, 0xFFFF, 0xFFFF,   // 8430 - 843F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1836, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8440 - 844F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AEA, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DCF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8450 - 845F
	0xFFFF, 0x1EAF, 0xFFFF, 0x1171, 0xFFFF, 0xFFFF, 0x1980, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FBF, 0x1AB9, 0xFFFF, 0xFFFF, 0x1787,   // 8460 - 846F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FC9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C2B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8470 - 847F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8480 - 848F
	0x1675, 0xFFFF, 0xFFFF, 0xFFFF, 0x16DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x133F, 0xFFFF, 0xFFFF, 0x1548, 0xFFFF, 0xFFFF, 0xFFFF,   // 8490 - 849F
	0xFFFF, 0x13E2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 84A0 - 84AF
	0xFFFF, 0xFFFF, 0x1EB0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C34, 0xFFFF, 0xFFFF, 0x1788, 0x1CE5, 0xFFFF, 0xFFFF, 0x1FC0,   // 84B0 - 84BF
	0x163A, 0xFFFF, 0x1316, 0xFFFF, 0x1D9D, 0xFFFF, 0x15B2, 0xFFFF, 0xFFFF, 0x1912, 0xFFFF, 0x0E15, 0xFFFF, 0x16DF, 0xFFFF, 0xFFFF,   // 84C0 - 84CF
	0xFFFF, 0x152E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1676, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 84D0 - 84DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1473, 0xFFFF, 0x11F5, 0xFFFF,   // 84E0 - 84EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16A9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x124E, 0xFFFF, 0xFFFF, 0xFFFF,   // 84F0 - 84FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8500 - 850F
	0xFFFF, 0x130B, 0xFFFF, 0x12CC, 0x145F, 0xFFFF, 0xFFFF, 0x1A7F, 0x1556, 0xFFFF, 0x194D, 0xFFFF, 0xFFFF, 0xFFFF, 0x125B, 0xFFFF,   // 8510 - 851F
	0xFFFF, 0x1CEF, 0xFFFF, 0x1ABA, 0xFFFF, 0x1D79, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1624, 0x19E9, 0xFFFF, 0x1C76,   // 8520 - 852F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E98, 0xFFFF, 0x1981,   // 8530 - 853F
	0xFFFF, 0x10FC, 0xFFFF, 0x140C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D61, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F50, 0xFFFF,   // 8540 - 854F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1948, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F9C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8550 - 855F
	0xFFFF, 0xFFFF, 0xFFFF, 0x16AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FB0, 0x1E27, 0x135D, 0xFFFF, 0xFFFF, 0x1625, 0xFFFF, 0xFFFF,   // 8560 - 856F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8570 - 857F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13A5, 0xFFFF, 0xFFFF, 0x1381, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A01,   // 8580 - 858F
	0xFFFF, 0x0DFF, 0xFFFF, 0xFFFF, 0x1ABB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8590 - 859F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D14, 0xFFFF, 0x205E, 0x154F, 0x1705, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x159F,   // 85A0 - 85AF
	0x205B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B8D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 85B0 - 85BF
	0xFFFF, 0x0ECD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A80, 0xFFFF, 0xFFFF, 0xFFFF, 0x11B2, 0x1706, 0x1ABC,   // 85C0 - 85CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x192E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11DF, 0x186B, 0xFFFF, 0xFFFF,   // 85D0 - 85DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x118A, 0x1789, 0xFFFF, 0xFFFF, 0xFFFF, 0x140D, 0x1677, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 85E0 - 85EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AEB, 0xFFFF, 0xFFFF, 0x12A2, 0x1BB9, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F0B,   // 85F0 - 85FF
	0xFFFF, 0xFFFF, 0x186C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1226, 0x1626, 0xFFFF, 0xFFFF, 0x189F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8600 - 860F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17C0, 0x1426, 0xFFFF, 0xFFFF, 0x15CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8610 - 861F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11A7, 0xFFFF, 0xFFFF,   // 8620 - 862F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1193,   // 8630 - 863F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FC1, 0xFFFF,   // 8640 - 864F
	0x1EF5, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E39, 0x1CF9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F50, 0x1227, 0xFFFF, 0x192F, 0x1FC2,   // 8650 - 865F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2072, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8660 - 866F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FDC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8670 - 867F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x136D, 0xFFFF, 0x13E3, 0xFFFF, 0xFFFF, 0xFFFF,   // 8680 - 868F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1A46, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8690 - 869F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0EF9, 0x1BBA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DD9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 86A0 - 86AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 86B0 - 86BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x152F, 0xFFFF, 0xFFFF, 0xFFFF, 0x10E7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 86C0 - 86CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2032, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18AF, 0xFFFF, 0x1C02, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F51,   // 86D0 - 86DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F17, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C8C, 0xFFFF, 0xFFFF,   // 86E0 - 86EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x172A, 0xFFFF,   // 86F0 - 86FF
	0x1D6B, 0xFFFF, 0x1474, 0x1707, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1891, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8700 - 870F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C53, 0xFFFF, 0x14E4, 0xFFFF, 0x1394, 0xFFFF, 0xFFFF, 0xFFFF,   // 8710 - 871F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8720 - 872F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8730 - 873F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DD1, 0xFFFF,   // 8740 - 874F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16F0, 0xFFFF, 0x201D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1982,   // 8750 - 875F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EEE, 0xFFFF, 0x16BA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8760 - 876F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FC3, 0xFFFF, 0x1B48, 0xFFFF, 0x18B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8770 - 877F
	0xFFFF, 0xFFFF, 0x11BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19DD, 0xFFFF, 0xFFFF,   // 8780 - 878F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1317,   // 8790 - 879F
	0xFFFF, 0xFFFF, 0x1F91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87A0 - 87AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x110F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1194, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87B0 - 87BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DEE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87C0 - 87CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 87D0 - 87DF
	0x13BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15CD, 0xFFFF, 0xFFFF, 0x18F2,   // 87E0 - 87EF
	0xFFFF, 0xFFFF, 0x1DAB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F37, 0xFFFF, 0x1A02, 0xFFFF, 0xFFFF, 0x15E6, 0xFFFF,   // 87F0 - 87FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16C8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8800 - 880F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11B7,   // 8810 - 881F
	0xFFFF, 0xFFFF, 0x1C1D, 0x11E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8820 - 882F
	0xFFFF, 0x0ECE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8830 - 883F
	0x1F74, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C25, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F44, 0x1812, 0xFFFF, 0xFFFF,   // 8840 - 884F
	0xFFFF, 0xFFFF, 0x1F6D, 0x16B2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D9E, 0xFFFF, 0x172B, 0xFFFF, 0x1983, 0xFFFF, 0x1DAC, 0xFFFF, 0xFFFF,   // 8850 - 885F
	0xFFFF, 0x1F92, 0x0F81, 0x1A03, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EC6, 0xFFFF, 0xFFFF, 0x1557, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8860 - 886F
	0x164B, 0xFFFF, 0x107C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DAD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FF6, 0x0FF7,   // 8870 - 887F
	0xFFFF, 0x1966, 0x131B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D9F, 0xFFFF, 0xFFFF, 0x111D, 0xFFFF, 0x1EB1, 0xFFFF, 0xFFFF,   // 8880 - 888F
	0xFFFF, 0xFFFF, 0x10E8, 0xFFFF, 0xFFFF, 0xFFFF, 0x1678, 0x1C77, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EE7, 0xFFFF,   // 8890 - 889F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ED6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 88A0 - 88AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ECF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 88B0 - 88BF
	0xFFFF, 0x1ACE, 0x11FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1298,   // 88C0 - 88CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x186E, 0x19B4, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F97, 0xFFFF, 0xFFFF, 0x1451, 0x1ABD, 0xFFFF, 0x1530,   // 88D0 - 88DF
	0xFFFF, 0x1299, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 88E0 - 88EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1575, 0x13F6, 0x13F7, 0xFFFF, 0xFFFF, 0x1195, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B8E, 0xFFFF, 0xFFFF,   // 88F0 - 88FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1460, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8900 - 890F
	0x0DD0, 0xFFFF, 0x1EB2, 0x1452, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1984, 0x13F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8910 - 891F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E49, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8920 - 892F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16BE, 0xFFFF, 0x125C, 0xFFFF, 0xFFFF, 0x15DD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8930 - 893F
	0xFFFF, 0x0E00, 0xFFFF, 0xFFFF, 0x17A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8940 - 894F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FF8,   // 8950 - 895F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12D6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8960 - 896F
	0xFFFF, 0xFFFF, 0x16BF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15A0,   // 8970 - 897F
	0xFFFF, 0x18F3, 0xFFFF, 0x10FD, 0xFFFF, 0xFFFF, 0x1461, 0x1E7A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E5C, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FCA,   // 8980 - 898F
	0xFFFF, 0xFFFF, 0xFFFF, 0x12FE, 0xFFFF, 0xFFFF, 0x16E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8990 - 899F
	0xFFFF, 0x0E53, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1141, 0x1DE1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89A0 - 89AF
	0xFFFF, 0xFFFF, 0x0FE8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DAE, 0xFFFF, 0xFFFF, 0x11B4, 0xFFFF, 0xFFFF,   // 89B0 - 89BF
	0x0F1A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89C0 - 89CF
	0xFFFF, 0xFFFF, 0x0DAF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89D0 - 89DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F38, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89E0 - 89EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1576, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D6C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 89F0 - 89FF
	0x17BD, 0xFFFF, 0x1B72, 0x1497, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EAC, 0xFFFF, 0x1708, 0xFFFF, 0x1FDD, 0xFFFF, 0x1E3E, 0xFFFF,   // 8A00 - 8A0F
	0xFFFF, 0xFFFF, 0xFFFF, 0x205C, 0xFFFF, 0xFFFF, 0x2083, 0x1E0E, 0x103A, 0xFFFF, 0xFFFF, 0x18B1, 0xFFFF, 0x172C, 0xFFFF, 0x1642,   // 8A10 - 8A1F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0E65, 0xFFFF, 0x10C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13E4, 0xFFFF, 0xFFFF, 0x15DE, 0xFFFF, 0xFFFF,   // 8A20 - 8A2F
	0xFFFF, 0x1F51, 0xFFFF, 0xFFFF, 0x1627, 0xFFFF, 0x0DA0, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C78, 0x1C03, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8A30 - 8A3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8A40 - 8A4F
	0x1531, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BBB, 0x1E90, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AEC, 0xFFFF, 0xFFFF, 0x1532, 0xFFFF,   // 8A50 - 8A5F
	0x1857, 0xFFFF, 0x16AB, 0x186F, 0xFFFF, 0xFFFF, 0x16E1, 0xFFFF, 0xFFFF, 0x16E2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FB6, 0x1B2A, 0xFFFF,   // 8A60 - 8A6F
	0x20A0, 0x1FE9, 0x1F39, 0x1577, 0xFFFF, 0x15CE, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D2E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8A70 - 8A7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C04, 0xFFFF, 0x0F03, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C54, 0x1A47, 0xFFFF, 0xFFFF,   // 8A80 - 8A8F
	0xFFFF, 0xFFFF, 0xFFFF, 0x15A1, 0xFFFF, 0x1E19, 0xFFFF, 0xFFFF, 0x19B5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17B0, 0xFFFF,   // 8A90 - 8A9F
	0x15FE, 0x0EAD, 0xFFFF, 0x135E, 0x1892, 0x0ED0, 0x1643, 0xFFFF, 0x2033, 0xFFFF, 0x15DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8AA0 - 8AAF
	0x1679, 0xFFFF, 0x0F04, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14E6, 0xFFFF, 0xFFFF, 0x1A04, 0xFFFF, 0x19E3, 0x1BBC,   // 8AB0 - 8ABF
	0xFFFF, 0xFFFF, 0x1D2F, 0xFFFF, 0x16AC, 0xFFFF, 0xFFFF, 0x10FE, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D3F, 0xFFFF, 0x1AD5, 0xFFFF, 0x1D8A,   // 8AC0 - 8ACF
	0xFFFF, 0xFFFF, 0x11D1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1235, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19B6, 0x1D37, 0xFFFF, 0xFFFF, 0xFFFF,   // 8AD0 - 8ADF
	0xFFFF, 0x16E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D48, 0x1F3A, 0xFFFF, 0xFFFF, 0x1B73, 0x0DC7, 0xFFFF, 0x19B7, 0x1A81, 0xFFFF,   // 8AE0 - 8AEF
	0xFFFF, 0x206B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x171A, 0x1ECE, 0x1B8F, 0xFFFF, 0x17BE, 0xFFFF, 0xFFFF, 0xFFFF, 0x1061, 0xFFFF,   // 8AF0 - 8AFF
	0x1331, 0x174B, 0x1985, 0xFFFF, 0x118B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1382, 0xFFFF,   // 8B00 - 8B0F
	0x1395, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EF6, 0xFFFF, 0x1634, 0x13E5, 0xFFFF, 0x0E69, 0x1A34, 0x0E01, 0xFFFF, 0x1533, 0xFFFF, 0xFFFF,   // 8B10 - 8B1F
	0x18F4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1332, 0xFFFF, 0xFFFF, 0x1B03, 0x126B, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B20 - 8B2F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0F82, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FE9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B30 - 8B3F
	0xFFFF, 0x1FEA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C35, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2074, 0x103B,   // 8B40 - 8B4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16F1, 0xFFFF, 0x10FF, 0xFFFF, 0x1453, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B50 - 8B5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14E7, 0xFFFF, 0xFFFF, 0x17EB,   // 8B60 - 8B6F
	0x1A05, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E5D, 0xFFFF, 0xFFFF, 0x1FC4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1870, 0xFFFF, 0xFFFF,   // 8B70 - 8B7F
	0x1155, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x142C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B80 - 8B8F
	0x167A, 0xFFFF, 0x1CCE, 0x17A5, 0xFFFF, 0xFFFF, 0x1CCF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8B90 - 8B9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BA0 - 8BAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BB0 - 8BBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BC0 - 8BCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BD0 - 8BDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BE0 - 8BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8BF0 - 8BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C00 - 8C0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C10 - 8C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C20 - 8C2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EDD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EAE,   // 8C30 - 8C3F
	0xFFFF, 0x2007, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x117B, 0xFFFF, 0x103C, 0xFFFF, 0x1ECF, 0xFFFF, 0x18C1, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C40 - 8C4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x115E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C50 - 8C5F
	0xFFFF, 0x1578, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FC5, 0x1871, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C60 - 8C6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EC7, 0x16E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C70 - 8C7F
	0xFFFF, 0xFFFF, 0x1D62, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F3, 0xFFFF, 0x1333, 0xFFFF, 0xFFFF, 0xFFFF,   // 8C80 - 8C8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E7B, 0x1B74, 0xFFFF,   // 8C90 - 8C9F
	0x1498, 0x1ACF, 0x0EFA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14F8, 0x1FEB, 0x1E6A, 0x1E1F, 0x0F1B, 0x1CF5, 0xFFFF, 0xFFFF, 0x1AED,   // 8CA0 - 8CAF
	0x1608, 0xFFFF, 0xFFFF, 0x1A27, 0x0FBC, 0xFFFF, 0x1E8B, 0x12EE, 0x111E, 0xFFFF, 0xFFFF, 0x14E8, 0x1D38, 0x1A26, 0xFFFF, 0x135F,   // 8CB0 - 8CBF
	0x1EEF, 0x14B5, 0x1241, 0x1A60, 0x2034, 0xFFFF, 0xFFFF, 0x1A82, 0x0DA1, 0xFFFF, 0x1B04, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8CC0 - 8CCF
	0xFFFF, 0x1C79, 0xFFFF, 0x14F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1242, 0xFFFF, 0x1534, 0xFFFF, 0x1579, 0xFFFF,   // 8CD0 - 8CDF
	0x13F9, 0xFFFF, 0x1F6F, 0x12EF, 0x1D15, 0xFFFF, 0x1499, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C8D, 0xFFFF, 0xFFFF, 0x1142, 0xFFFF, 0xFFFF,   // 8CE0 - 8CEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1243, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x149A, 0x0F83, 0x157D, 0xFFFF, 0xFFFF,   // 8CF0 - 8CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C56, 0x1DB1, 0xFFFF, 0x19D1, 0x1C36, 0xFFFF, 0x1CBD, 0xFFFF, 0xFFFF, 0x15E7, 0xFFFF, 0xFFFF,   // 8D00 - 8D0F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1ABE, 0xFFFF, 0xFFFF, 0x1635, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D10 - 8D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D20 - 8D2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D30 - 8D3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D40 - 8D4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D50 - 8D5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B05, 0xFFFF, 0x1535, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D60 - 8D6F
	0x1C05, 0xFFFF, 0xFFFF, 0x0FCB, 0x149B, 0xFFFF, 0xFFFF, 0x103D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D70 - 8D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D63, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x196E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D80 - 8D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BBD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8D90 - 8D9F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1DBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D8B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8DA0 - 8DAF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1BC7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x149C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C57, 0xFFFF,   // 8DB0 - 8DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13C8, 0x1C8E, 0xFFFF, 0xFFFF, 0x0DA2,   // 8DC0 - 8DCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E63, 0xFFFF, 0x0E2B, 0xFFFF, 0xFFFF,   // 8DD0 - 8DDF
	0xFFFF, 0x1B06, 0xFFFF, 0x15CF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F05, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1228,   // 8DE0 - 8DEF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1143, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8DF0 - 8DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1913, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1104,   // 8E00 - 8E0F
	0x1D16, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E2C, 0xFFFF,   // 8E10 - 8E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BDB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E20 - 8E2F
	0x19B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BDC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E30 - 8E3F
	0xFFFF, 0xFFFF, 0x19B9, 0xFFFF, 0x1B90, 0xFFFF, 0xFFFF, 0x0E3A, 0x1144, 0x1CA8, 0x1F9D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E40 - 8E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D9E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B07,   // 8E50 - 8E5F
	0x1D06, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E60 - 8E6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D9F, 0xFFFF, 0x0FB1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E70 - 8E7F
	0xFFFF, 0x1BBE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AEE, 0xFFFF, 0xFFFF, 0x1C06, 0xFFFF, 0xFFFF, 0x178A, 0xFFFF, 0xFFFF,   // 8E80 - 8E8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8E90 - 8E9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12A3, 0x1709, 0x0FA3, 0xFFFF, 0xFFFF, 0xFFFF,   // 8EA0 - 8EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8EB0 - 8EBF
	0x0F84, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CA9, 0x174C, 0x0FB7, 0x0F98, 0xFFFF, 0xFFFF,   // 8EC0 - 8ECF
	0xFFFF, 0xFFFF, 0x1F55, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1813,   // 8ED0 - 8EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C7A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8EE0 - 8EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DA0, 0xFFFF, 0xFFFF, 0x0DA3, 0xFFFF, 0xFFFF, 0x16F2, 0xFFFF,   // 8EF0 - 8EFF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0F52, 0xFFFF, 0x1229, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AD0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F00 - 8F0F
	0xFFFF, 0xFFFF, 0x1D39, 0x12CE, 0x1454, 0x0E92, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11D2, 0x1DDA, 0x206C, 0x12E2, 0x1D23,   // 8F10 - 8F1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11F6, 0x1442, 0xFFFF, 0x13FA, 0x1275, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C96,   // 8F20 - 8F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1C07, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x167B, 0x1462, 0xFFFF, 0x1463, 0xFFFF, 0xFFFF, 0x1B2B, 0x17DB,   // 8F30 - 8F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F07, 0x1967, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B2C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D24, 0x0F53, 0xFFFF,   // 8F40 - 8F4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17DC, 0xFFFF, 0x0F3E,   // 8F50 - 8F5F
	0xFFFF, 0xFFFF, 0x11EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F60 - 8F6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F70 - 8F7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F80 - 8F8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x170A, 0x0ED2, 0xFFFF, 0xFFFF, 0xFFFF,   // 8F90 - 8F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0x11AA, 0xFFFF, 0xFFFF, 0x1E6B, 0xFFFF, 0x142D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1536, 0xFFFF, 0x142E,   // 8FA0 - 8FAF
	0x1C7B, 0x18FE, 0x10B4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8FB0 - 8FBF
	0xFFFF, 0xFFFF, 0x1930, 0xFFFF, 0xFFFF, 0x170C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1858, 0xFFFF,   // 8FC0 - 8FCF
	0xFFFF, 0x0FEA, 0xFFFF, 0xFFFF, 0x13BF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 8FD0 - 8FDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DA4, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B08, 0x13A6, 0xFFFF, 0x1C8F, 0xFFFF, 0xFFFF,   // 8FE0 - 8FEF
	0x16B3, 0xFFFF, 0x0E4A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1383, 0xFFFF, 0x1B09, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D8C, 0xFFFF, 0xFFFF,   // 8FF0 - 8FFF
	0x1E4A, 0x1644, 0x0F21, 0x1145, 0xFFFF, 0x2053, 0x17ED, 0xFFFF, 0x1F93, 0xFFFF, 0xFFFF, 0x1EB3, 0xFFFF, 0x1628, 0xFFFF, 0x1E50,   // 9000 - 900F
	0x1DA1, 0x0F85, 0xFFFF, 0xFFFF, 0x1146, 0x0E93, 0xFFFF, 0x117C, 0xFFFF, 0x1AEF, 0x1E45, 0xFFFF, 0xFFFF, 0x15A2, 0x1211, 0x1636,   // 9010 - 901F
	0x1BBF, 0x1C1E, 0x1475, 0x11F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D49, 0xFFFF,   // 9020 - 902F
	0xFFFF, 0x1C08, 0x1C7C, 0xFFFF, 0xFFFF, 0x0FCC, 0xFFFF, 0xFFFF, 0x1A53, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE4, 0xFFFF, 0x19BB, 0xFFFF,   // 9030 - 903F
	0xFFFF, 0x1181, 0x167C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1931, 0xFFFF, 0xFFFF, 0x19BA, 0x1949, 0xFFFF, 0x1E88, 0x0F06, 0xFFFF,   // 9040 - 904F
	0x1EF0, 0x201E, 0xFFFF, 0x1147, 0x10EF, 0x1986, 0xFFFF, 0xFFFF, 0xFFFF, 0x18F5, 0xFFFF, 0xFFFF, 0x163B, 0x1105, 0x1D4A, 0xFFFF,   // 9050 - 905F
	0x1968, 0x1629, 0xFFFF, 0x0E5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B0A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BC0, 0x1CAA, 0x1182,   // 9060 - 906F
	0xFFFF, 0xFFFF, 0x1C58, 0xFFFF, 0xFFFF, 0x1C1F, 0xFFFF, 0x1D17, 0x15D0, 0xFFFF, 0x19BC, 0xFFFF, 0x124F, 0x0E2E, 0xFFFF, 0x1ED7,   // 9070 - 907F
	0x18F7, 0x12F0, 0x1F3B, 0x167D, 0x2001, 0xFFFF, 0xFFFF, 0x1A28, 0x12BD, 0xFFFF, 0x142F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1196,   // 9080 - 908F
	0xFFFF, 0x19EF, 0xFFFF, 0xFFFF, 0xFFFF, 0x18A7, 0xFFFF, 0xFFFF, 0xFFFF, 0x12E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9090 - 909F
	0xFFFF, 0xFFFF, 0x1F94, 0x105B, 0xFFFF, 0xFFFF, 0x13E6, 0xFFFF, 0x1D70, 0xFFFF, 0x1537, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DE3,   // 90A0 - 90AF
	0x1E34, 0x0F86, 0xFFFF, 0xFFFF, 0xFFFF, 0x162A, 0xFFFF, 0xFFFF, 0x1AF0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 90B0 - 90BF
	0xFFFF, 0x193E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F54, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 90C0 - 90CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11BF, 0xFFFF,   // 90D0 - 90DF
	0xFFFF, 0x0F99, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x149D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F0C, 0xFFFF, 0xFFFF,   // 90E0 - 90EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1932, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1148, 0xFFFF, 0xFFFF,   // 90F0 - 90FF
	0xFFFF, 0xFFFF, 0x173B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9100 - 910F
	0xFFFF, 0xFFFF, 0x1D8D, 0xFFFF, 0xFFFF, 0x1F49, 0xFFFF, 0xFFFF, 0xFFFF, 0x14E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9110 - 911F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x118C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B75, 0xFFFF, 0xFFFF,   // 9120 - 912F
	0xFFFF, 0xFFFF, 0x10E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9130 - 913F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19BD, 0x1B76, 0x1D8E, 0x1A8E, 0x13FB, 0x1C09, 0xFFFF,   // 9140 - 914F
	0xFFFF, 0xFFFF, 0x1C0A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9150 - 915F
	0xFFFF, 0xFFFF, 0x1D64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1318, 0x119E, 0xFFFF, 0x167E, 0xFFFF, 0xFFFF, 0xFFFF,   // 9160 - 916F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2045, 0xFFFF, 0x1FCB, 0x1549, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9170 - 917F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x16AD, 0xFFFF, 0x1DBD, 0xFFFF, 0x1D65, 0xFFFF, 0x1B91, 0xFFFF, 0xFFFF,   // 9180 - 918F
	0xFFFF, 0xFFFF, 0x15FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D8F, 0xFFFF, 0xFFFF, 0xFFFF,   // 9190 - 919F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A06, 0x1ABF, 0xFFFF, 0x1D66, 0x1F9E,   // 91A0 - 91AF
	0xFFFF, 0x13C9, 0xFFFF, 0xFFFF, 0x121A, 0x0E1F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 91B0 - 91BF
	0x17A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CF0, 0xFFFF, 0x19BE, 0xFFFF, 0x15B3, 0x129A, 0x1C26, 0x1781, 0x11D3,   // 91C0 - 91CF
	0x129B, 0x104B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x164C, 0x1B77, 0xFFFF, 0xFFFF, 0xFFFF, 0x149E, 0x1DEC, 0xFFFF, 0xFFFF,   // 91D0 - 91DF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1BC1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D18, 0xFFFF, 0xFFFF, 0x1933, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 91E0 - 91EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CF1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 91F0 - 91FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1183, 0xFFFF, 0xFFFF,   // 9200 - 920F
	0x0E46, 0x1E6C, 0x155A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19D3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FD3, 0xFFFF,   // 9210 - 921F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9220 - 922F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1212, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1899, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B2D,   // 9230 - 923F
	0x0DEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E2F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F70, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9240 - 924F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E6A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1817, 0xFFFF, 0xFFFF, 0x196F, 0xFFFF,   // 9250 - 925F
	0xFFFF, 0xFFFF, 0x13CA, 0xFFFF, 0x0F87, 0x16B4, 0x1B78, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9260 - 926F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9270 - 927F
	0x19E4, 0xFFFF, 0xFFFF, 0x1D7A, 0xFFFF, 0x1172, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9280 - 928F
	0xFFFF, 0x15D1, 0xFFFF, 0x1B2E, 0xFFFF, 0xFFFF, 0x167F, 0xFFFF, 0x1319, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F11, 0xFFFF, 0xFFFF, 0xFFFF,   // 9290 - 929F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92A0 - 92AF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1873, 0xFFFF, 0xFFFF, 0x0F88, 0x162B, 0xFFFF, 0x1680, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92B0 - 92BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B79, 0xFFFF, 0xFFFF, 0x1F81,   // 92C0 - 92CF
	0xFFFF, 0xFFFF, 0x1476, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92D0 - 92DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EB4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 92E0 - 92EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E30, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E02, 0xFFFF, 0xFFFF, 0xFFFF,   // 92F0 - 92FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1232, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9300 - 930F
	0x1D90, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D91, 0xFFFF, 0x1AD6, 0xFFFF, 0xFFFF, 0xFFFF, 0x16AE, 0x1100,   // 9310 - 931F
	0x1B7A, 0x103E, 0x1B2F, 0xFFFF, 0x103F, 0xFFFF, 0x0FFA, 0xFFFF, 0x134B, 0xFFFF, 0xFFFF, 0x15B4, 0xFFFF, 0xFFFF, 0x0ED3, 0x1CAF,   // 9320 - 932F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9330 - 933F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x185A, 0xFFFF, 0x11F8, 0x0F07, 0xFFFF, 0x1149, 0xFFFF, 0xFFFF,   // 9340 - 934F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x173C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x10EA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9350 - 935F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x19BF, 0xFFFF,   // 9360 - 936F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E3B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DED, 0xFFFF, 0x1BDD, 0xFFFF,   // 9370 - 937F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E6B, 0xFFFF, 0xFFFF, 0xFFFF,   // 9380 - 938F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1914, 0xFFFF, 0x164A, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D92, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9390 - 939F
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F95, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E17, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FC6, 0x1C7D, 0xFFFF, 0xFFFF,   // 93A0 - 93AF
	0x1A54, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93B0 - 93BF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1BC8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93C0 - 93CF
	0xFFFF, 0x1B0B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1915, 0xFFFF,   // 93D0 - 93DF
	0xFFFF, 0x0E94, 0xFFFF, 0xFFFF, 0x125D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93E0 - 93EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 93F0 - 93FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2039, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9400 - 940F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BDE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9410 - 941F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15D2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B30, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9420 - 942F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D25, 0xFFFF, 0xFFFF, 0x1E0F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9430 - 943F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C0B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9440 - 944F
	0xFFFF, 0x0DE4, 0x0DE5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F2E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9450 - 945F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9460 - 946F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1CBE, 0xFFFF, 0x1CB0,   // 9470 - 947F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9480 - 948F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9490 - 949F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94A0 - 94AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94B0 - 94BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94C0 - 94CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94D0 - 94DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94E0 - 94EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 94F0 - 94FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9500 - 950F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9510 - 951F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9520 - 952F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9530 - 953F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9540 - 954F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9550 - 955F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9560 - 956F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9570 - 957F
	0x136E, 0xFFFF, 0xFFFF, 0x15E8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E99, 0xFFFF, 0x0E18, 0xFFFF, 0xFFFF, 0xFFFF, 0x19D4,   // 9580 - 958F
	0xFFFF, 0x1F02, 0x1F03, 0x0DC8, 0x1392, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DEC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9590 - 959F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0DB0, 0x1F18, 0x1412, 0xFFFF, 0xFFFF, 0x0FCD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x11E1, 0xFFFF, 0xFFFF,   // 95A0 - 95AF
	0xFFFF, 0x1823, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1830, 0x174D, 0xFFFF, 0xFFFF, 0xFFFF,   // 95B0 - 95BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1755, 0xFFFF, 0xFFFF, 0x2008, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 95C0 - 95CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F19, 0x0FB2, 0x1E54, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F1C, 0xFFFF, 0xFFFF, 0xFFFF,   // 95D0 - 95DF
	0xFFFF, 0x1D19, 0x1427, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 95E0 - 95EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 95F0 - 95FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9600 - 960F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x149F, 0xFFFF, 0xFFFF, 0xFFFF,   // 9610 - 961F
	0xFFFF, 0x1D1A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E6D, 0xFFFF, 0xFFFF, 0xFFFF, 0x18C2, 0xFFFF,   // 9620 - 962F
	0xFFFF, 0xFFFF, 0x13E7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BC2, 0xFFFF, 0xFFFF, 0xFFFF, 0x172D,   // 9630 - 963F
	0x1DFD, 0xFFFF, 0x1ED8, 0xFFFF, 0x14A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x125E, 0x12F4, 0x0E03, 0xFFFF, 0xFFFF,   // 9640 - 964F
	0x1F04, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E9A, 0x1F1A, 0x15E9, 0x16C9, 0x1D07,   // 9650 - 965F
	0xFFFF, 0xFFFF, 0x196A, 0x1C7E, 0x1B92, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13FC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9660 - 966F
	0x19EA, 0xFFFF, 0xFFFF, 0x1C7F, 0xFFFF, 0x1283, 0x114A, 0x1F12, 0x126F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17A7, 0xFFFF, 0xFFFF,   // 9670 - 967F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1934, 0x127A, 0xFFFF, 0xFFFF, 0xFFFF, 0x111F, 0x1681, 0xFFFF, 0x201F, 0x0EAF, 0xFFFF,   // 9680 - 968F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E54, 0x194A, 0xFFFF, 0xFFFF, 0x176A, 0x0FDC, 0xFFFF, 0x1B93, 0x1AC1, 0xFFFF, 0xFFFF, 0xFFFF,   // 9690 - 969F
	0xFFFF, 0xFFFF, 0xFFFF, 0x12A4, 0xFFFF, 0xFFFF, 0xFFFF, 0x1682, 0x1683, 0xFFFF, 0x1F57, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 96A0 - 96AF
	0xFFFF, 0x19E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x121B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D08, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 96B0 - 96BF
	0x1A8F, 0x1746, 0xFFFF, 0xFFFF, 0x1951, 0x172E, 0x1C98, 0x0ED4, 0xFFFF, 0x1DDB, 0xFFFF, 0x1C20, 0x1A83, 0x18A8, 0x1AF1, 0xFFFF,   // 96C0 - 96CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BC3, 0x1684, 0xFFFF, 0xFFFF, 0x171E, 0xFFFF, 0x1D93, 0x1A9C, 0xFFFF, 0xFFFF, 0xFFFF,   // 96D0 - 96DF
	0xFFFF, 0xFFFF, 0x129C, 0x106B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1935, 0x1936, 0x15E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x136F,   // 96E0 - 96EF
	0x14B6, 0xFFFF, 0x194B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1213, 0x1244, 0xFFFF, 0x13A7, 0xFFFF, 0x1B31, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 96F0 - 96FF
	0x1685, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B7B, 0x1C80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9700 - 970F
	0xFFFF, 0x1B43, 0xFFFF, 0x1875, 0xFFFF, 0xFFFF, 0x12AB, 0xFFFF, 0xFFFF, 0x185C, 0xFFFF, 0xFFFF, 0x157A, 0xFFFF, 0x1EF1, 0xFFFF,   // 9710 - 971F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1360, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9720 - 972F
	0x154A, 0xFFFF, 0x122A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1428, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B94, 0xFFFF, 0xFFFF,   // 9730 - 973F
	0xFFFF, 0xFFFF, 0x11EC, 0xFFFF, 0x176B, 0xFFFF, 0xFFFF, 0xFFFF, 0x1214, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9740 - 974F
	0xFFFF, 0x1D40, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B7C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B7D, 0xFFFF, 0x14EA, 0xFFFF,   // 9750 - 975F
	0xFFFF, 0x1384, 0x1308, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F5C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A49, 0xFFFF, 0xFFFF,   // 9760 - 976F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FEC, 0xFFFF, 0xFFFF, 0x1A4A, 0xFFFF, 0xFFFF, 0x12D7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9770 - 977F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F9F, 0xFFFF, 0x1747, 0xFFFF, 0x0EFB,   // 9780 - 978F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9790 - 979F
	0x0F91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DD2, 0xFFFF, 0xFFFF, 0x0F92, 0xFFFF, 0x1E89, 0xFFFF, 0xFFFF,   // 97A0 - 97AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 97B0 - 97BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D1B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1987, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 97C0 - 97CF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1F05, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x114B, 0xFFFF, 0xFFFF, 0xFFFF,   // 97D0 - 97DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 97E0 - 97EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x19EB, 0xFFFF, 0xFFFF, 0x162C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x194C, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F4A,   // 97F0 - 97FF
	0x1FC7, 0x1F75, 0x1B7E, 0x0E95, 0xFFFF, 0x1F2B, 0x16AF, 0xFFFF, 0x1686, 0xFFFF, 0x193F, 0xFFFF, 0x1645, 0xFFFF, 0xFFFF, 0xFFFF,   // 9800 - 980F
	0x1876, 0x18C3, 0x13C0, 0x115F, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E64, 0x1215, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9810 - 981F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x117D, 0xFFFF, 0xFFFF,   // 9820 - 982F
	0x1F82, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E96, 0x1E4B, 0xFFFF, 0x14FA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9830 - 983F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F08, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B95, 0x1772, 0x173D, 0xFFFF,   // 9840 - 984F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1748, 0xFFFF, 0xFFFF, 0xFFFF, 0x196B, 0xFFFF, 0x1B32, 0xFFFF, 0xFFFF, 0xFFFF, 0x126C, 0xFFFF,   // 9850 - 985F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FC8, 0xFFFF, 0x0ED5, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B33, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F71,   // 9860 - 986F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9870 - 987F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9880 - 988F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9890 - 989F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1ED0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x155B,   // 98A0 - 98AF
	0xFFFF, 0x1E35, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 98B0 - 98BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EC9, 0xFFFF, 0xFFFF, 0x1EC8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 98C0 - 98CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14EB, 0x140E, 0xFFFF, 0xFFFF, 0x16F3,   // 98D0 - 98DF
	0xFFFF, 0x163C, 0x1040, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DE0, 0x19EC, 0x13C1,   // 98E0 - 98EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A2B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1538, 0x1EB5, 0x16F4, 0xFFFF,   // 98F0 - 98FF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0F55, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F4B, 0x17A9, 0xFFFF, 0x1A2C, 0xFFFF, 0xFFFF, 0xFFFF,   // 9900 - 990F
	0x1CBF, 0xFFFF, 0xFFFF, 0x172F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17DE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B34, 0xFFFF,   // 9910 - 991F
	0x1443, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9920 - 992F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9930 - 993F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12CF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FEB, 0xFFFF, 0x0FB8, 0x1CC0, 0x15D3, 0xFFFF, 0xFFFF,   // 9940 - 994F
	0xFFFF, 0x1041, 0x18F8, 0xFFFF, 0x18A9, 0xFFFF, 0xFFFF, 0x1F4C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9950 - 995F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9960 - 996F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9970 - 997F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9980 - 998F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1687, 0xFFFF, 0xFFFF, 0x1F4D, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EE2, 0xFFFF, 0xFFFF,   // 9990 - 999F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1464, 0xFFFF, 0xFFFF, 0x1F96, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B5, 0x17B1, 0x1ED1, 0xFFFF,   // 99A0 - 99AF
	0xFFFF, 0x1DFE, 0xFFFF, 0x1DDC, 0x16B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1A55, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 99B0 - 99BF
	0xFFFF, 0x13A8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 99C0 - 99CF
	0x1C0C, 0x10A4, 0x0F89, 0xFFFF, 0xFFFF, 0x0DA5, 0xFFFF, 0xFFFF, 0xFFFF, 0x14A1, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DFF, 0xFFFF, 0x1539,   // 99D0 - 99DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F3C, 0xFFFF, 0xFFFF,   // 99E0 - 99EF
	0xFFFF, 0x119F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1C21,   // 99F0 - 99FF
	0xFFFF, 0x14FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1444, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1042, 0x1043,   // 9A00 - 9A0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1E8A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A10 - 9A1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E3C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A20 - 9A2F
	0x118D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D94, 0x162D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A30 - 9A3F
	0x12F5, 0xFFFF, 0xFFFF, 0x1ECA, 0xFFFF, 0x0F8A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2046, 0xFFFF, 0xFFFF,   // 9A40 - 9A4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F56, 0xFFFF, 0x1F58, 0xFFFF, 0xFFFF, 0x0E97, 0x17EE, 0xFFFF, 0xFFFF, 0xFFFF, 0x1DBE,   // 9A50 - 9A5F
	0xFFFF, 0xFFFF, 0x11E2, 0xFFFF, 0xFFFF, 0x1044, 0xFFFF, 0xFFFF, 0xFFFF, 0x2002, 0x11E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A60 - 9A6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A70 - 9A7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A80 - 9A8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9A90 - 9A9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AA0 - 9AAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AB0 - 9ABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AC0 - 9ACF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1688, 0x1D4B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ED6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AD0 - 9ADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1831, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x13CB, 0xFFFF,   // 9AE0 - 9AEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9AF0 - 9AFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B00 - 9B0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1689, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B10 - 9B1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1250, 0xFFFF, 0xFFFF, 0x1E51, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B20 - 9B2F
	0xFFFF, 0x194E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0FBD, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B30 - 9B3F
	0xFFFF, 0x0F3A, 0x1FD1, 0x13CC, 0x1404, 0x12F1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1988,   // 9B40 - 9B4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x17B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B50 - 9B5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x122B,   // 9B60 - 9B6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9B70 - 9B7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B44, 0xFFFF,   // 9B80 - 9B8F
	0xFFFF, 0x1EB6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1749,   // 9B90 - 9B9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F57, 0xFFFF, 0xFFFF, 0x15D4, 0xFFFF,   // 9BA0 - 9BAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BB0 - 9BBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x129D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BC0 - 9BCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D41, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BD0 - 9BDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EE8, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E98, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BE0 - 9BEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9BF0 - 9BFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1D95, 0xFFFF, 0xFFFF,   // 9C00 - 9C0F
	0x173E, 0xFFFF, 0x1465, 0xFFFF, 0xFFFF, 0x1EF2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C10 - 9C1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2003, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C20 - 9C2F
	0xFFFF, 0xFFFF, 0x1893, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C30 - 9C3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0E04, 0xFFFF, 0x1432, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C40 - 9C4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12A5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C50 - 9C5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C60 - 9C6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C70 - 9C7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C80 - 9C8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9C90 - 9C9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CA0 - 9CAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CB0 - 9CBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CC0 - 9CCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CD0 - 9CDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1BC4, 0xFFFF, 0x14A2, 0xFFFF, 0x0F8B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CE0 - 9CEF
	0xFFFF, 0xFFFF, 0xFFFF, 0x1477, 0x131A, 0xFFFF, 0x1819, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9CF0 - 9CFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1730, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D00 - 9D0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x196C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D10 - 9D1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1760, 0xFFFF, 0x1759, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D20 - 9D2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1FDE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D30 - 9D3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D40 - 9D4F
	0xFFFF, 0x0E5F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1731, 0xFFFF, 0xFFFF,   // 9D50 - 9D5F
	0x0EDE, 0x1361, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14C1, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D60 - 9D6F
	0xFFFF, 0xFFFF, 0x1A90, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D70 - 9D7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D80 - 9D8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9D90 - 9D9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x133A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1775,   // 9DA0 - 9DAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1EF7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DB0 - 9DBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0EB0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DC0 - 9DCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F8C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DD0 - 9DDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DE0 - 9DEF
	0xFFFF, 0xFFFF, 0x1DBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x2075, 0x19F3, 0x122C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9DF0 - 9DFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E00 - 9E0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1776, 0xFFFF, 0xFFFF, 0xFFFF, 0x11A8, 0xFFFF,   // 9E10 - 9E1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E20 - 9E2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E30 - 9E3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E40 - 9E4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E50 - 9E5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E60 - 9E6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x122D, 0xFFFF, 0xFFFF, 0xFFFF, 0x1F13, 0xFFFF, 0xFFFF, 0xFFFF, 0x1832, 0xFFFF, 0x1233,   // 9E70 - 9E7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9E80 - 9E8F
	0xFFFF, 0xFFFF, 0x1045, 0x1234, 0xFFFF, 0xFFFF, 0xFFFF, 0x11E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x153A, 0xFFFF, 0x12A6,   // 9E90 - 9E9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12F6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9EA0 - 9EAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F93, 0x1309, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x12B7, 0xFFFF, 0xFFFF, 0x206D, 0xFFFF,   // 9EB0 - 9EBF
	0xFFFF, 0xFFFF, 0xFFFF, 0x2020, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15A4, 0x11E5, 0xFFFF,   // 9EC0 - 9ECF
	0xFFFF, 0x207B, 0xFFFF, 0xFFFF, 0x0E47, 0xFFFF, 0xFFFF, 0xFFFF, 0x1363, 0xFFFF, 0xFFFF, 0x1120, 0x1DA7, 0xFFFF, 0x1B45, 0xFFFF,   // 9ED0 - 9EDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1110, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9EE0 - 9EEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1385, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9EF0 - 9EFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1894, 0x1433, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B7F, 0xFFFF,   // 9F00 - 9F0F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0ED7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F10 - 9F1F
	0x15A5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F20 - 9F2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x14EC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F30 - 9F3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1B96, 0x1AD1, 0xFFFF, 0xFFFF, 0x1AD2, 0xFFFF,   // 9F40 - 9F4F
	0xFFFF, 0xFFFF, 0x1DDD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1AF2,   // 9F50 - 9F5F
	0xFFFF, 0x1216, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x15E1, 0xFFFF, 0xFFFF, 0x1CB1, 0xFFFF, 0x17B3, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F60 - 9F6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x173F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F70 - 9F7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x1251, 0xFFFF, 0xFFFF,   // 9F80 - 9F8F
	0x13E8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0DE6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0F8D, 0xFFFF, 0xFFFF, 0xFFFF,   // 9F90 - 9F9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FA0 - 9FAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FB0 - 9FBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FC0 - 9FCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FD0 - 9FDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FE0 - 9FEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 9FF0 - 9FFF
	0x045B, 0x045C, 0xFFFF, 0xFFFF, 0x045D, 0xFFFF, 0xFFFF, 0x045E, 0x045F, 0x0460, 0x0461, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AC00 - AC0F
	0x0462, 0x0463, 0x0464, 0x0465, 0x0466, 0x0467, 0x0468, 0x0469, 0xFFFF, 0x046A, 0x046B, 0x046C, 0x046D, 0x046E, 0xFFFF, 0xFFFF,   // AC10 - AC1F
	0x046F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0470, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0471, 0x0472, 0xFFFF, 0x0473,   // AC20 - AC2F
	0x0474, 0x0475, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0476, 0x0477, 0xFFFF, 0xFFFF, 0x0478, 0xFFFF, 0xFFFF, 0xFFFF,   // AC30 - AC3F
	0x0479, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x047A, 0xFFFF, 0x047B, 0xFFFF, 0xFFFF,   // AC40 - AC4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x047C, 0xFFFF, 0xFFFF, 0xFFFF, 0x047D, 0xFFFF, 0xFFFF, 0xFFFF, 0x047E, 0xFFFF, 0xFFFF, 0xFFFF,   // AC50 - AC5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AC60 - AC6F
	0x047F, 0x0480, 0xFFFF, 0xFFFF, 0x0481, 0xFFFF, 0xFFFF, 0x0482, 0x0483, 0xFFFF, 0x0484, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AC70 - AC7F
	0x0485, 0x0486, 0xFFFF, 0x0487, 0x0488, 0x0489, 0x048A, 0xFFFF, 0xFFFF, 0x048B, 0x048C, 0x048D, 0x048E, 0xFFFF, 0xFFFF, 0xFFFF,   // AC80 - AC8F
	0x048F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0490, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0491, 0x0492, 0xFFFF, 0x0493,   // AC90 - AC9F
	0x0494, 0x0495, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0496, 0x0497, 0x0498, 0xFFFF, 0x0499, 0xFFFF, 0xFFFF, 0x049A,   // ACA0 - ACAF
	0x049B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x049C, 0x049D, 0xFFFF, 0x049E, 0x049F, 0x04A0, 0xFFFF, 0xFFFF,   // ACB0 - ACBF
	0xFFFF, 0x04A1, 0xFFFF, 0xFFFF, 0x04A2, 0xFFFF, 0xFFFF, 0xFFFF, 0x04A3, 0xFFFF, 0xFFFF, 0xFFFF, 0x04A4, 0xFFFF, 0xFFFF, 0xFFFF,   // ACC0 - ACCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04A5, 0xFFFF, 0x04A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // ACD0 - ACDF
	0x04A7, 0x04A8, 0xFFFF, 0xFFFF, 0x04A9, 0xFFFF, 0xFFFF, 0x04AA, 0x04AB, 0xFFFF, 0x04AC, 0xFFFF, 0x04AD, 0xFFFF, 0xFFFF, 0x04AE,   // ACE0 - ACEF
	0x04AF, 0x04B0, 0xFFFF, 0x04B1, 0xFFFF, 0x04B2, 0x04B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04B4, 0x04B5, 0xFFFF, 0xFFFF,   // ACF0 - ACFF
	0x04B6, 0xFFFF, 0xFFFF, 0xFFFF, 0x04B7, 0xFFFF, 0x04B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04B9, 0x04BA, 0xFFFF, 0x04BB,   // AD00 - AD0F
	0xFFFF, 0x04BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04BD, 0xFFFF, 0xFFFF, 0xFFFF, 0x04BE, 0xFFFF, 0xFFFF, 0xFFFF,   // AD10 - AD1F
	0x04BF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C0, 0xFFFF, 0xFFFF, 0x04C1, 0x04C2, 0xFFFF, 0xFFFF,   // AD20 - AD2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C3, 0x04C4, 0xFFFF, 0xFFFF, 0x04C5, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C6, 0xFFFF, 0xFFFF, 0xFFFF,   // AD30 - AD3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04C7, 0x04C8, 0xFFFF, 0x04C9, 0xFFFF, 0x04CA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AD40 - AD4F
	0x04CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x04CC, 0xFFFF, 0xFFFF, 0xFFFF, 0x04CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AD50 - AD5F
	0xFFFF, 0x04CE, 0xFFFF, 0x04CF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04D0, 0x04D1, 0xFFFF, 0xFFFF,   // AD60 - AD6F
	0x04D2, 0xFFFF, 0xFFFF, 0x04D3, 0x04D4, 0x04D5, 0x04D6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04D7, 0x04D8, 0x04D9, 0xFFFF, 0x04DA,   // AD70 - AD7F
	0xFFFF, 0x04DB, 0x04DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04DD, 0x04DE, 0xFFFF, 0xFFFF, 0x04DF, 0xFFFF, 0xFFFF, 0xFFFF,   // AD80 - AD8F
	0x04E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04E1, 0x04E2, 0xFFFF, 0xFFFF,   // AD90 - AD9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // ADA0 - ADAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // ADB0 - ADBF
	0x04E5, 0x04E6, 0xFFFF, 0xFFFF, 0x04E7, 0xFFFF, 0xFFFF, 0xFFFF, 0x04E8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // ADC0 - ADCF
	0x04E9, 0x04EA, 0xFFFF, 0x04EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04EC, 0xFFFF, 0xFFFF, 0xFFFF,   // ADD0 - ADDF
	0x04ED, 0xFFFF, 0xFFFF, 0xFFFF, 0x04EE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // ADE0 - ADEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04EF, 0x04F0, 0xFFFF, 0xFFFF, 0x04F1, 0xFFFF, 0xFFFF, 0x04F2,   // ADF0 - ADFF
	0x04F3, 0x04F4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04F5, 0x04F6, 0xFFFF, 0x04F7, 0xFFFF, 0x04F8, 0xFFFF, 0xFFFF,   // AE00 - AE0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x04F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AE10 - AE1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AE20 - AE2F
	0x04FA, 0x04FB, 0xFFFF, 0xFFFF, 0x04FC, 0xFFFF, 0xFFFF, 0x04FD, 0x04FE, 0xFFFF, 0x04FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AE30 - AE3F
	0x0500, 0x0501, 0xFFFF, 0x0502, 0xFFFF, 0x0503, 0x0504, 0xFFFF, 0xFFFF, 0xFFFF, 0x0505, 0xFFFF, 0x0506, 0x0507, 0x0508, 0xFFFF,   // AE40 - AE4F
	0x0509, 0xFFFF, 0xFFFF, 0xFFFF, 0x050A, 0xFFFF, 0x050B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x050C, 0x050D, 0xFFFF, 0x050E,   // AE50 - AE5F
	0x050F, 0x0510, 0xFFFF, 0xFFFF, 0xFFFF, 0x0511, 0xFFFF, 0xFFFF, 0x0512, 0x0513, 0xFFFF, 0xFFFF, 0x0514, 0xFFFF, 0xFFFF, 0xFFFF,   // AE60 - AE6F
	0x0515, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0516, 0x0517, 0xFFFF, 0x0518, 0x0519, 0x051A, 0xFFFF, 0xFFFF,   // AE70 - AE7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x051B, 0x051C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x051D, 0xFFFF, 0xFFFF, 0xFFFF,   // AE80 - AE8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AE90 - AE9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AEA0 - AEAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x051E, 0x051F, 0x0520, 0xFFFF,   // AEB0 - AEBF
	0x0521, 0xFFFF, 0xFFFF, 0xFFFF, 0x0522, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0523, 0x0524, 0xFFFF, 0x0525,   // AEC0 - AECF
	0x0526, 0x0527, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0528, 0x0529, 0xFFFF, 0xFFFF, 0x052A, 0xFFFF, 0xFFFF, 0xFFFF,   // AED0 - AEDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x052B, 0xFFFF, 0xFFFF, 0x052C, 0xFFFF, 0x052D, 0xFFFF, 0xFFFF,   // AEE0 - AEEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x052E, 0xFFFF, 0xFFFF, 0xFFFF, 0x052F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0530, 0xFFFF, 0xFFFF, 0xFFFF,   // AEF0 - AEFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0531, 0x0532, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0533, 0xFFFF, 0xFFFF,   // AF00 - AF0F
	0x0534, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AF10 - AF1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0535, 0x0536, 0xFFFF, 0xFFFF,   // AF20 - AF2F
	0x0537, 0xFFFF, 0x0538, 0xFFFF, 0x0539, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x053A, 0x053B, 0xFFFF, 0x053C,   // AF30 - AF3F
	0xFFFF, 0x053D, 0x053E, 0x053F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0540, 0x0541, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AF40 - AF4F
	0x0542, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0543, 0x0544, 0xFFFF, 0xFFFF,   // AF50 - AF5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0545, 0x0546, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AF60 - AF6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0547, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AF70 - AF7F
	0x0548, 0xFFFF, 0xFFFF, 0xFFFF, 0x0549, 0xFFFF, 0xFFFF, 0xFFFF, 0x054A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AF80 - AF8F
	0x054B, 0x054C, 0xFFFF, 0xFFFF, 0xFFFF, 0x054D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x054E, 0xFFFF, 0xFFFF, 0xFFFF,   // AF90 - AF9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AFA0 - AFAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x054F, 0x0550, 0xFFFF, 0xFFFF, 0x0551, 0xFFFF, 0xFFFF, 0xFFFF,   // AFB0 - AFBF
	0x0552, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0553, 0x0554, 0x0555, 0xFFFF, 0x0556, 0xFFFF, 0x0557, 0x0558, 0xFFFF,   // AFC0 - AFCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0559, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x055A, 0xFFFF, 0xFFFF, 0xFFFF,   // AFD0 - AFDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x055B, 0x055C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AFE0 - AFEF
	0x055D, 0x055E, 0xFFFF, 0xFFFF, 0x055F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0560, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // AFF0 - AFFF
	0x0561, 0x0562, 0xFFFF, 0xFFFF, 0x0563, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0564, 0xFFFF, 0xFFFF, 0xFFFF,   // B000 - B00F
	0x0565, 0xFFFF, 0xFFFF, 0xFFFF, 0x0566, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0567, 0x0568, 0xFFFF, 0xFFFF,   // B010 - B01F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0569, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B020 - B02F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B030 - B03F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x056A, 0x056B, 0xFFFF, 0xFFFF, 0x056C, 0xFFFF, 0x056D, 0xFFFF, 0x056E, 0xFFFF, 0x056F, 0xFFFF,   // B040 - B04F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0570, 0x0571, 0x0572, 0xFFFF, 0x0573, 0xFFFF, 0x0574, 0xFFFF, 0xFFFF, 0xFFFF, 0x0575, 0xFFFF, 0xFFFF,   // B050 - B05F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B060 - B06F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0576, 0x0577, 0xFFFF, 0xFFFF,   // B070 - B07F
	0x0578, 0xFFFF, 0xFFFF, 0xFFFF, 0x0579, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x057A, 0x057B, 0xFFFF, 0x057C,   // B080 - B08F
	0xFFFF, 0x057D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x057E, 0x057F, 0x0580, 0xFFFF, 0x0581, 0xFFFF, 0xFFFF, 0x0582,   // B090 - B09F
	0x0583, 0x0584, 0x0585, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0586, 0x0587, 0xFFFF, 0x0588, 0x0589, 0x058A, 0x058B, 0x058C,   // B0A0 - B0AF
	0xFFFF, 0x058D, 0xFFFF, 0x058E, 0x058F, 0x0590, 0xFFFF, 0xFFFF, 0x0591, 0xFFFF, 0xFFFF, 0xFFFF, 0x0592, 0xFFFF, 0xFFFF, 0xFFFF,   // B0B0 - B0BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0593, 0x0594, 0xFFFF, 0x0595, 0x0596, 0x0597, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B0C0 - B0CF
	0x0598, 0x0599, 0xFFFF, 0xFFFF, 0x059A, 0xFFFF, 0xFFFF, 0xFFFF, 0x059B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B0D0 - B0DF
	0x059C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x059D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B0E0 - B0EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B0F0 - B0FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x059E, 0x059F, 0xFFFF, 0x05A0, 0x05A1, 0xFFFF, 0xFFFF, 0xFFFF,   // B100 - B10F
	0x05A2, 0xFFFF, 0x05A3, 0x05A4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05A5, 0x05A6, 0xFFFF, 0x05A7, 0x05A8, 0x05A9, 0xFFFF, 0xFFFF,   // B110 - B11F
	0xFFFF, 0xFFFF, 0xFFFF, 0x05AA, 0x05AB, 0x05AC, 0xFFFF, 0xFFFF, 0x05AD, 0xFFFF, 0xFFFF, 0xFFFF, 0x05AE, 0xFFFF, 0xFFFF, 0xFFFF,   // B120 - B12F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05AF, 0x05B0, 0xFFFF, 0x05B1, 0x05B2, 0x05B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B130 - B13F
	0x05B4, 0x05B5, 0xFFFF, 0xFFFF, 0x05B6, 0xFFFF, 0xFFFF, 0xFFFF, 0x05B7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B140 - B14F
	0x05B8, 0x05B9, 0xFFFF, 0xFFFF, 0x05BA, 0x05BB, 0xFFFF, 0xFFFF, 0x05BC, 0xFFFF, 0xFFFF, 0xFFFF, 0x05BD, 0xFFFF, 0xFFFF, 0xFFFF,   // B150 - B15F
	0x05BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B160 - B16F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05BF, 0x05C0, 0xFFFF, 0xFFFF, 0x05C1, 0xFFFF, 0xFFFF, 0xFFFF,   // B170 - B17F
	0x05C2, 0xFFFF, 0x05C3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05C4, 0x05C5, 0xFFFF, 0x05C6, 0xFFFF, 0x05C7, 0xFFFF, 0xFFFF,   // B180 - B18F
	0xFFFF, 0xFFFF, 0x05C8, 0x05C9, 0x05CA, 0xFFFF, 0xFFFF, 0xFFFF, 0x05CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x05CC, 0xFFFF, 0xFFFF, 0xFFFF,   // B190 - B19F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B1A0 - B1AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B1B0 - B1BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05CE, 0xFFFF, 0xFFFF, 0xFFFF,   // B1C0 - B1CF
	0x05CF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05D0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05D1, 0x05D2, 0xFFFF, 0x05D3,   // B1D0 - B1DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05D4, 0x05D5, 0xFFFF, 0xFFFF, 0x05D6, 0xFFFF, 0xFFFF, 0xFFFF,   // B1E0 - B1EF
	0x05D7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05D8, 0xFFFF, 0x05D9, 0xFFFF, 0x05DA, 0xFFFF, 0xFFFF,   // B1F0 - B1FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05DB, 0x05DC, 0xFFFF, 0xFFFF, 0x05DD, 0xFFFF, 0xFFFF, 0x05DE, 0x05DF, 0xFFFF, 0xFFFF, 0xFFFF,   // B200 - B20F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05E0, 0x05E1, 0xFFFF, 0x05E2, 0xFFFF, 0x05E3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B210 - B21F
	0x05E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B220 - B22F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05E5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05E6, 0xFFFF, 0xFFFF, 0xFFFF,   // B230 - B23F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B240 - B24F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05E7, 0xFFFF, 0xFFFF, 0xFFFF, 0x05E8, 0xFFFF, 0xFFFF, 0xFFFF,   // B250 - B25F
	0x05E9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05EA, 0x05EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B260 - B26F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05EC, 0x05ED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05EE, 0xFFFF, 0xFFFF, 0xFFFF,   // B270 - B27F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x05EF, 0x05F0, 0xFFFF, 0xFFFF, 0xFFFF, 0x05F1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B280 - B28F
	0x05F2, 0x05F3, 0xFFFF, 0xFFFF, 0x05F4, 0xFFFF, 0xFFFF, 0xFFFF, 0x05F5, 0x05F6, 0x05F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B290 - B29F
	0x05F8, 0x05F9, 0xFFFF, 0x05FA, 0xFFFF, 0x05FB, 0x05FC, 0xFFFF, 0xFFFF, 0xFFFF, 0x05FD, 0xFFFF, 0x05FE, 0xFFFF, 0xFFFF, 0xFFFF,   // B2A0 - B2AF
	0x05FF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0600, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B2B0 - B2BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0601, 0x0602, 0xFFFF, 0xFFFF, 0x0603, 0xFFFF, 0xFFFF, 0xFFFF,   // B2C0 - B2CF
	0x0604, 0xFFFF, 0x0605, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0606, 0x0607, 0xFFFF, 0x0608, 0xFFFF, 0x0609, 0xFFFF, 0xFFFF,   // B2D0 - B2DF
	0xFFFF, 0xFFFF, 0x060A, 0xFFFF, 0x060B, 0x060C, 0x060D, 0xFFFF, 0x060E, 0xFFFF, 0xFFFF, 0x060F, 0x0610, 0x0611, 0x0612, 0x0613,   // B2E0 - B2EF
	0xFFFF, 0xFFFF, 0xFFFF, 0x0614, 0x0615, 0x0616, 0xFFFF, 0x0617, 0x0618, 0x0619, 0x061A, 0x061B, 0xFFFF, 0xFFFF, 0xFFFF, 0x061C,   // B2F0 - B2FF
	0x061D, 0x061E, 0xFFFF, 0xFFFF, 0x061F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0620, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B300 - B30F
	0x0621, 0x0622, 0xFFFF, 0x0623, 0x0624, 0x0625, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0626, 0xFFFF, 0xFFFF, 0xFFFF,   // B310 - B31F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B320 - B32F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B330 - B33F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B340 - B34F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0627, 0x0628, 0x0629, 0xFFFF, 0x062A, 0xFFFF, 0xFFFF, 0x062B, 0x062C, 0xFFFF, 0x062D, 0x062E,   // B350 - B35F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x062F, 0x0630, 0xFFFF, 0x0631, 0xFFFF, 0x0632, 0xFFFF, 0x0633, 0xFFFF, 0xFFFF, 0x0634, 0xFFFF,   // B360 - B36F
	0x0635, 0x0636, 0xFFFF, 0xFFFF, 0x0637, 0xFFFF, 0xFFFF, 0xFFFF, 0x0638, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B370 - B37F
	0x0639, 0x063A, 0xFFFF, 0x063B, 0x063C, 0x063D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x063E, 0xFFFF, 0xFFFF, 0xFFFF,   // B380 - B38F
	0x063F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0640, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B390 - B39F
	0x0641, 0x0642, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0643, 0xFFFF, 0xFFFF, 0xFFFF, 0x0644, 0xFFFF, 0xFFFF, 0xFFFF,   // B3A0 - B3AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B3B0 - B3BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0645, 0x0646, 0xFFFF, 0xFFFF, 0x0647, 0xFFFF, 0xFFFF, 0x0648, 0x0649, 0xFFFF, 0x064A, 0xFFFF,   // B3C0 - B3CF
	0x064B, 0xFFFF, 0xFFFF, 0xFFFF, 0x064C, 0x064D, 0xFFFF, 0x064E, 0xFFFF, 0x064F, 0xFFFF, 0x0650, 0xFFFF, 0x0651, 0xFFFF, 0xFFFF,   // B3D0 - B3DF
	0x0652, 0xFFFF, 0xFFFF, 0xFFFF, 0x0653, 0xFFFF, 0xFFFF, 0xFFFF, 0x0654, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B3E0 - B3EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0655, 0xFFFF, 0xFFFF, 0xFFFF,   // B3F0 - B3FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B400 - B40F
	0x0656, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0657, 0xFFFF, 0xFFFF, 0xFFFF, 0x0658, 0xFFFF, 0xFFFF, 0xFFFF,   // B410 - B41F
	0x0659, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x065A, 0x065B, 0xFFFF, 0x065C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B420 - B42F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x065D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B430 - B43F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B440 - B44F
	0x065E, 0x065F, 0xFFFF, 0xFFFF, 0x0660, 0xFFFF, 0xFFFF, 0xFFFF, 0x0661, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B450 - B45F
	0x0662, 0x0663, 0xFFFF, 0x0664, 0xFFFF, 0x0665, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0666, 0xFFFF, 0xFFFF, 0xFFFF,   // B460 - B46F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B470 - B47F
	0x0667, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0668, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B480 - B48F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0669, 0xFFFF, 0xFFFF,   // B490 - B49F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x066A, 0xFFFF, 0xFFFF, 0xFFFF, 0x066B, 0xFFFF, 0xFFFF, 0xFFFF, 0x066C, 0xFFFF, 0xFFFF, 0xFFFF,   // B4A0 - B4AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x066D, 0xFFFF, 0x066E, 0xFFFF, 0x066F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B4B0 - B4BF
	0x0670, 0xFFFF, 0xFFFF, 0xFFFF, 0x0671, 0xFFFF, 0xFFFF, 0xFFFF, 0x0672, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B4C0 - B4CF
	0x0673, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0674, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0675, 0x0676, 0xFFFF, 0xFFFF,   // B4D0 - B4DF
	0x0677, 0xFFFF, 0xFFFF, 0x0678, 0x0679, 0xFFFF, 0x067A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x067B, 0x067C, 0xFFFF, 0x067D,   // B4E0 - B4EF
	0xFFFF, 0x067E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x067F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B4F0 - B4FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B500 - B50F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0680, 0x0681, 0xFFFF, 0xFFFF, 0x0682, 0xFFFF, 0xFFFF, 0x0683, 0x0684, 0xFFFF, 0xFFFF, 0xFFFF,   // B510 - B51F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0685, 0x0686, 0xFFFF, 0x0687, 0x0688, 0x0689, 0x068A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B520 - B52F
	0x068B, 0x068C, 0xFFFF, 0xFFFF, 0x068D, 0xFFFF, 0xFFFF, 0xFFFF, 0x068E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B530 - B53F
	0x068F, 0x0690, 0xFFFF, 0x0691, 0x0692, 0x0693, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0694, 0x0695, 0x0696, 0xFFFF, 0xFFFF,   // B540 - B54F
	0x0697, 0xFFFF, 0xFFFF, 0xFFFF, 0x0698, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0699, 0x069A, 0xFFFF, 0x069B,   // B550 - B55F
	0x069C, 0x069D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B560 - B56F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B570 - B57F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B580 - B58F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B590 - B59F
	0x069E, 0x069F, 0xFFFF, 0xFFFF, 0x06A0, 0xFFFF, 0xFFFF, 0xFFFF, 0x06A1, 0xFFFF, 0x06A2, 0x06A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B5A0 - B5AF
	0x06A4, 0x06A5, 0xFFFF, 0x06A6, 0x06A7, 0x06A8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06A9, 0x06AA, 0x06AB, 0xFFFF, 0xFFFF,   // B5B0 - B5BF
	0x06AC, 0xFFFF, 0xFFFF, 0xFFFF, 0x06AD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06AE, 0x06AF, 0xFFFF, 0x06B0,   // B5C0 - B5CF
	0x06B1, 0x06B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06B3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B5D0 - B5DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06B4, 0xFFFF, 0xFFFF, 0xFFFF,   // B5E0 - B5EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B5F0 - B5FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B600 - B60F
	0x06B5, 0x06B6, 0xFFFF, 0xFFFF, 0x06B7, 0xFFFF, 0xFFFF, 0xFFFF, 0x06B8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B610 - B61F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06B9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06BA, 0xFFFF, 0xFFFF, 0xFFFF,   // B620 - B62F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06BB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B630 - B63F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B640 - B64F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B650 - B65F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06BD, 0xFFFF, 0xFFFF, 0xFFFF, 0x06BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B660 - B66F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B670 - B67F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B680 - B68F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06BF, 0x06C0, 0xFFFF, 0xFFFF,   // B690 - B69F
	0x06C1, 0xFFFF, 0xFFFF, 0xFFFF, 0x06C2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06C3, 0x06C4, 0xFFFF, 0xFFFF, 0xFFFF,   // B6A0 - B6AF
	0xFFFF, 0x06C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B6B0 - B6BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B6C0 - B6CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06C6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B6D0 - B6DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B6E0 - B6EF
	0x06C7, 0xFFFF, 0xFFFF, 0xFFFF, 0x06C8, 0xFFFF, 0xFFFF, 0xFFFF, 0x06C9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B6F0 - B6FF
	0x06CA, 0x06CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x06CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B700 - B70F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B710 - B71F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06CD, 0x06CE, 0xFFFF, 0xFFFF, 0x06CF, 0xFFFF, 0xFFFF, 0x06D0,   // B720 - B72F
	0x06D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06D2, 0x06D3, 0xFFFF, 0x06D4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B730 - B73F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06D5, 0xFFFF, 0xFFFF, 0xFFFF, 0x06D6, 0xFFFF, 0xFFFF, 0xFFFF, 0x06D7, 0xFFFF, 0xFFFF, 0xFFFF,   // B740 - B74F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06D8, 0x06D9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B750 - B75F
	0x06DA, 0xFFFF, 0xFFFF, 0xFFFF, 0x06DB, 0xFFFF, 0xFFFF, 0xFFFF, 0x06DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B760 - B76F
	0x06DD, 0x06DE, 0xFFFF, 0x06DF, 0xFFFF, 0x06E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06E1, 0x06E2, 0xFFFF, 0xFFFF,   // B770 - B77F
	0x06E3, 0xFFFF, 0xFFFF, 0xFFFF, 0x06E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06E5, 0x06E6, 0xFFFF, 0x06E7,   // B780 - B78F
	0x06E8, 0x06E9, 0x06EA, 0xFFFF, 0xFFFF, 0xFFFF, 0x06EB, 0x06EC, 0x06ED, 0x06EE, 0xFFFF, 0xFFFF, 0x06EF, 0xFFFF, 0xFFFF, 0xFFFF,   // B790 - B79F
	0x06F0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06F1, 0x06F2, 0xFFFF, 0x06F3, 0x06F4, 0x06F5, 0xFFFF, 0xFFFF,   // B7A0 - B7AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06F6, 0x06F7, 0xFFFF, 0xFFFF, 0x06F8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B7B0 - B7BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06F9, 0xFFFF, 0x06FA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B7C0 - B7CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B7D0 - B7DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06FB, 0x06FC, 0xFFFF, 0xFFFF,   // B7E0 - B7EF
	0x06FD, 0xFFFF, 0xFFFF, 0xFFFF, 0x06FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x06FF, 0x0700, 0xFFFF, 0x0701,   // B7F0 - B7FF
	0x0702, 0x0703, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0704, 0x0705, 0x0706, 0xFFFF, 0xFFFF, 0x0707, 0xFFFF, 0xFFFF, 0xFFFF,   // B800 - B80F
	0x0708, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0709, 0x070A, 0xFFFF, 0x070B, 0xFFFF, 0x070C, 0xFFFF, 0xFFFF,   // B810 - B81F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x070D, 0x070E, 0xFFFF, 0xFFFF, 0x070F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0710, 0xFFFF, 0xFFFF, 0xFFFF,   // B820 - B82F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0711, 0x0712, 0xFFFF, 0x0713, 0x0714, 0x0715, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B830 - B83F
	0x0716, 0xFFFF, 0xFFFF, 0xFFFF, 0x0717, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B840 - B84F
	0xFFFF, 0x0718, 0xFFFF, 0x0719, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x071A, 0x071B, 0xFFFF, 0xFFFF,   // B850 - B85F
	0x071C, 0xFFFF, 0xFFFF, 0xFFFF, 0x071D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x071E, 0x071F, 0xFFFF, 0x0720,   // B860 - B86F
	0xFFFF, 0x0721, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0722, 0xFFFF, 0xFFFF, 0xFFFF, 0x0723, 0xFFFF, 0xFFFF, 0xFFFF,   // B870 - B87F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0724, 0xFFFF, 0xFFFF,   // B880 - B88F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B890 - B89F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0725, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B8A0 - B8AF
	0x0726, 0xFFFF, 0xFFFF, 0xFFFF, 0x0727, 0xFFFF, 0xFFFF, 0xFFFF, 0x0728, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B8B0 - B8BF
	0x0729, 0x072A, 0xFFFF, 0x072B, 0xFFFF, 0x072C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x072D, 0xFFFF, 0xFFFF, 0xFFFF,   // B8C0 - B8CF
	0x072E, 0xFFFF, 0xFFFF, 0xFFFF, 0x072F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0730, 0xFFFF, 0x0731,   // B8D0 - B8DF
	0xFFFF, 0x0732, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0733, 0x0734, 0xFFFF, 0xFFFF, 0x0735, 0xFFFF, 0xFFFF, 0xFFFF,   // B8E0 - B8EF
	0x0736, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0737, 0x0738, 0xFFFF, 0x0739, 0xFFFF, 0x073A, 0xFFFF, 0xFFFF,   // B8F0 - B8FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x073B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B900 - B90F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x073C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B910 - B91F
	0x073D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B920 - B92F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x073E, 0x073F, 0xFFFF, 0xFFFF,   // B930 - B93F
	0x0740, 0xFFFF, 0xFFFF, 0xFFFF, 0x0741, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0742, 0xFFFF, 0xFFFF, 0x0743,   // B940 - B94F
	0xFFFF, 0x0744, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0745, 0x0746, 0xFFFF, 0xFFFF, 0x0747, 0xFFFF, 0xFFFF, 0xFFFF,   // B950 - B95F
	0x0748, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0749, 0x074A, 0xFFFF, 0x074B, 0xFFFF, 0x074C, 0xFFFF, 0xFFFF,   // B960 - B96F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x074D, 0x074E, 0xFFFF, 0xFFFF, 0x074F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0750, 0xFFFF, 0xFFFF, 0xFFFF,   // B970 - B97F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0751, 0x0752, 0xFFFF, 0x0753, 0xFFFF, 0x0754, 0x0755, 0xFFFF, 0xFFFF, 0x0756, 0x0757, 0xFFFF,   // B980 - B98F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B990 - B99F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0758, 0x0759, 0xFFFF, 0xFFFF,   // B9A0 - B9AF
	0x075A, 0xFFFF, 0xFFFF, 0xFFFF, 0x075B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x075C, 0x075D, 0xFFFF, 0x075E,   // B9B0 - B9BF
	0xFFFF, 0x075F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0760, 0x0761, 0xFFFF, 0xFFFF, 0x0762, 0xFFFF, 0x0763, 0x0764,   // B9C0 - B9CF
	0x0765, 0x0766, 0x0767, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0768, 0x0769, 0xFFFF, 0x076A, 0xFFFF, 0x076B, 0x076C, 0xFFFF,   // B9D0 - B9DF
	0xFFFF, 0x076D, 0xFFFF, 0x076E, 0x076F, 0x0770, 0xFFFF, 0xFFFF, 0x0771, 0xFFFF, 0xFFFF, 0xFFFF, 0x0772, 0xFFFF, 0xFFFF, 0xFFFF,   // B9E0 - B9EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0773, 0x0774, 0xFFFF, 0x0775, 0x0776, 0x0777, 0x0778, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B9F0 - B9FF
	0x0779, 0x077A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x077B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BA00 - BA0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x077C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BA10 - BA1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BA20 - BA2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x077D, 0x077E, 0xFFFF, 0xFFFF, 0x077F, 0xFFFF, 0xFFFF, 0xFFFF,   // BA30 - BA3F
	0x0780, 0xFFFF, 0x0781, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0782, 0x0783, 0xFFFF, 0x0784, 0xFFFF, 0x0785, 0x0786, 0xFFFF,   // BA40 - BA4F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0787, 0x0788, 0x0789, 0xFFFF, 0xFFFF, 0x078A, 0xFFFF, 0xFFFF, 0xFFFF, 0x078B, 0xFFFF, 0xFFFF, 0xFFFF,   // BA50 - BA5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x078C, 0x078D, 0xFFFF, 0x078E, 0x078F, 0x0790, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BA60 - BA6F
	0x0791, 0x0792, 0xFFFF, 0xFFFF, 0x0793, 0xFFFF, 0xFFFF, 0xFFFF, 0x0794, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BA70 - BA7F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0795, 0x0796, 0x0797, 0xFFFF, 0x0798, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0799, 0xFFFF, 0xFFFF, 0xFFFF,   // BA80 - BA8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BA90 - BA9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x079A, 0x079B, 0xFFFF, 0x079C, 0x079D, 0xFFFF, 0xFFFF, 0xFFFF,   // BAA0 - BAAF
	0x079E, 0xFFFF, 0x079F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A0, 0x07A1, 0xFFFF, 0x07A2, 0xFFFF, 0x07A3, 0xFFFF, 0xFFFF,   // BAB0 - BABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A4, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BAC0 - BACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A6, 0x07A7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BAD0 - BADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BAE0 - BAEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07A8, 0xFFFF, 0xFFFF, 0xFFFF,   // BAF0 - BAFF
	0x07A9, 0xFFFF, 0xFFFF, 0xFFFF, 0x07AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07AB, 0xFFFF, 0x07AC,   // BB00 - BB0F
	0xFFFF, 0x07AD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07AE, 0xFFFF, 0xFFFF, 0xFFFF, 0x07AF, 0xFFFF, 0xFFFF, 0xFFFF,   // BB10 - BB1F
	0x07B0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07B1, 0xFFFF, 0x07B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BB20 - BB2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07B3, 0x07B4, 0x07B5, 0xFFFF, 0x07B6, 0xFFFF, 0xFFFF, 0x07B7, 0x07B8, 0x07B9, 0x07BA, 0xFFFF,   // BB30 - BB3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07BB, 0x07BC, 0xFFFF, 0x07BD, 0xFFFF, 0x07BE, 0xFFFF, 0xFFFF, 0xFFFF, 0x07BF, 0xFFFF, 0x07C0,   // BB40 - BB4F
	0x07C1, 0xFFFF, 0xFFFF, 0xFFFF, 0x07C2, 0xFFFF, 0xFFFF, 0xFFFF, 0x07C3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BB50 - BB5F
	0xFFFF, 0x07C4, 0xFFFF, 0x07C5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07C6, 0xFFFF, 0xFFFF, 0xFFFF,   // BB60 - BB6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BB70 - BB7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07C7, 0xFFFF, 0xFFFF, 0xFFFF, 0x07C8, 0xFFFF, 0xFFFF, 0xFFFF,   // BB80 - BB8F
	0x07C9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BB90 - BB9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07CA, 0xFFFF, 0xFFFF, 0xFFFF, 0x07CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x07CC, 0xFFFF, 0xFFFF, 0xFFFF,   // BBA0 - BBAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07CD, 0xFFFF, 0xFFFF, 0x07CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BBB0 - BBBF
	0x07CF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07D0, 0xFFFF, 0xFFFF, 0xFFFF, 0x07D1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BBC0 - BBCF
	0x07D2, 0xFFFF, 0xFFFF, 0x07D3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BBD0 - BBDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BBE0 - BBEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07D4, 0x07D5, 0xFFFF, 0xFFFF, 0x07D6, 0xFFFF, 0xFFFF, 0x07D7,   // BBF0 - BBFF
	0x07D8, 0xFFFF, 0x07D9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07DA, 0x07DB, 0xFFFF, 0x07DC, 0x07DD, 0x07DE, 0xFFFF, 0x07DF,   // BC00 - BC0F
	0xFFFF, 0x07E0, 0xFFFF, 0xFFFF, 0x07E1, 0x07E2, 0x07E3, 0x07E4, 0x07E5, 0xFFFF, 0xFFFF, 0x07E6, 0x07E7, 0x07E8, 0x07E9, 0x07EA,   // BC10 - BC1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07EB, 0x07EC, 0xFFFF, 0x07ED, 0xFFFF, 0x07EE, 0xFFFF, 0xFFFF, 0xFFFF, 0x07EF, 0xFFFF, 0xFFFF,   // BC20 - BC2F
	0x07F0, 0x07F1, 0xFFFF, 0xFFFF, 0x07F2, 0xFFFF, 0xFFFF, 0xFFFF, 0x07F3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BC30 - BC3F
	0x07F4, 0x07F5, 0xFFFF, 0x07F6, 0x07F7, 0x07F8, 0xFFFF, 0xFFFF, 0xFFFF, 0x07F9, 0xFFFF, 0xFFFF, 0x07FA, 0x07FB, 0xFFFF, 0xFFFF,   // BC40 - BC4F
	0x07FC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07FD, 0xFFFF, 0xFFFF,   // BC50 - BC5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BC60 - BC6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BC70 - BC7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x07FE, 0x07FF, 0xFFFF, 0xFFFF, 0x0800, 0xFFFF, 0xFFFF, 0x0801, 0x0802, 0xFFFF, 0x0803, 0xFFFF,   // BC80 - BC8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0804, 0x0805, 0xFFFF, 0x0806, 0xFFFF, 0x0807, 0x0808, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BC90 - BC9F
	0x0809, 0x080A, 0xFFFF, 0xFFFF, 0x080B, 0xFFFF, 0xFFFF, 0x080C, 0x080D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BCA0 - BCAF
	0x080E, 0x080F, 0xFFFF, 0x0810, 0x0811, 0x0812, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0813, 0x0814, 0xFFFF, 0xFFFF,   // BCB0 - BCBF
	0x0815, 0xFFFF, 0xFFFF, 0xFFFF, 0x0816, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0817, 0xFFFF, 0x0818,   // BCC0 - BCCF
	0x0819, 0x081A, 0xFFFF, 0xFFFF, 0xFFFF, 0x081B, 0xFFFF, 0xFFFF, 0x081C, 0xFFFF, 0xFFFF, 0xFFFF, 0x081D, 0xFFFF, 0xFFFF, 0xFFFF,   // BCD0 - BCDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BCE0 - BCEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x081E, 0x081F, 0x0820, 0xFFFF, 0x0821, 0xFFFF, 0xFFFF, 0xFFFF, 0x0822, 0xFFFF, 0xFFFF, 0xFFFF,   // BCF0 - BCFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0823, 0x0824, 0xFFFF, 0x0825, 0xFFFF, 0x0826, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD00 - BD0F
	0x0827, 0xFFFF, 0xFFFF, 0xFFFF, 0x0828, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD10 - BD1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0829, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x082A, 0xFFFF, 0xFFFF, 0xFFFF,   // BD20 - BD2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD30 - BD3F
	0x082B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x082C, 0x082D, 0xFFFF, 0xFFFF, 0x082E, 0xFFFF, 0xFFFF, 0xFFFF,   // BD40 - BD4F
	0x082F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0830, 0x0831, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD50 - BD5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0832, 0xFFFF, 0xFFFF, 0xFFFF, 0x0833, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD60 - BD6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD70 - BD7F
	0x0834, 0x0835, 0xFFFF, 0xFFFF, 0x0836, 0xFFFF, 0xFFFF, 0x0837, 0x0838, 0x0839, 0x083A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BD80 - BD8F
	0x083B, 0x083C, 0xFFFF, 0x083D, 0xFFFF, 0x083E, 0xFFFF, 0xFFFF, 0xFFFF, 0x083F, 0x0840, 0xFFFF, 0x0841, 0xFFFF, 0xFFFF, 0xFFFF,   // BD90 - BD9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0842, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BDA0 - BDAF
	0x0843, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0844, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BDB0 - BDBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BDC0 - BDCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0845, 0x0846, 0xFFFF, 0xFFFF, 0x0847, 0xFFFF, 0xFFFF, 0xFFFF, 0x0848, 0xFFFF, 0xFFFF, 0xFFFF,   // BDD0 - BDDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0849, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BDE0 - BDEF
	0x084A, 0xFFFF, 0xFFFF, 0xFFFF, 0x084B, 0xFFFF, 0xFFFF, 0xFFFF, 0x084C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BDF0 - BDFF
	0x084D, 0xFFFF, 0xFFFF, 0x084E, 0xFFFF, 0x084F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0850, 0x0851, 0xFFFF, 0xFFFF,   // BE00 - BE0F
	0x0852, 0xFFFF, 0xFFFF, 0xFFFF, 0x0853, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0854, 0x0855, 0xFFFF, 0x0856,   // BE10 - BE1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BE20 - BE2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BE30 - BE3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0857, 0x0858, 0xFFFF, 0xFFFF, 0x0859, 0xFFFF, 0xFFFF, 0xFFFF, 0x085A, 0xFFFF, 0x085B, 0xFFFF,   // BE40 - BE4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x085C, 0x085D, 0xFFFF, 0x085E, 0xFFFF, 0x085F, 0x0860, 0x0861, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BE50 - BE5F
	0x0862, 0x0863, 0xFFFF, 0xFFFF, 0x0864, 0xFFFF, 0xFFFF, 0xFFFF, 0x0865, 0xFFFF, 0x0866, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BE60 - BE6F
	0x0867, 0x0868, 0xFFFF, 0x0869, 0x086A, 0x086B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x086C, 0x086D, 0x086E, 0xFFFF, 0xFFFF,   // BE70 - BE7F
	0x086F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0870, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0871, 0x0872, 0xFFFF, 0x0873,   // BE80 - BE8F
	0x0874, 0x0875, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0876, 0x0877, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BE90 - BE9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0878, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BEA0 - BEAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BEB0 - BEBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BEC0 - BECF
	0x0879, 0x087A, 0xFFFF, 0xFFFF, 0x087B, 0xFFFF, 0xFFFF, 0x087C, 0x087D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BED0 - BEDF
	0x087E, 0xFFFF, 0xFFFF, 0x087F, 0x0880, 0x0881, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0882, 0xFFFF, 0xFFFF, 0xFFFF,   // BEE0 - BEEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BEF0 - BEFF
	0xFFFF, 0x0883, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0884, 0x0885, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF00 - BF0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0886, 0x0887, 0xFFFF, 0x0888, 0x0889, 0x088A, 0xFFFF, 0xFFFF,   // BF10 - BF1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF20 - BF2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF30 - BF3F
	0x088B, 0x088C, 0xFFFF, 0xFFFF, 0x088D, 0xFFFF, 0xFFFF, 0xFFFF, 0x088E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF40 - BF4F
	0x088F, 0x0890, 0xFFFF, 0xFFFF, 0xFFFF, 0x0891, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF50 - BF5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF60 - BF6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF70 - BF7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF80 - BF8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0892, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BF90 - BF9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BFA0 - BFAF
	0x0893, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BFB0 - BFBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0894, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0895, 0x0896, 0xFFFF, 0xFFFF,   // BFC0 - BFCF
	0x0897, 0xFFFF, 0xFFFF, 0xFFFF, 0x0898, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0899, 0xFFFF, 0xFFFF, 0x089A,   // BFD0 - BFDF
	0xFFFF, 0x089B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BFE0 - BFEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // BFF0 - BFFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C000 - C00F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C010 - C01F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C020 - C02F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x089C, 0xFFFF, 0xFFFF, 0xFFFF,   // C030 - C03F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C040 - C04F
	0xFFFF, 0x089D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x089E, 0xFFFF, 0xFFFF, 0xFFFF, 0x089F, 0xFFFF, 0xFFFF, 0xFFFF,   // C050 - C05F
	0x08A0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08A1, 0x08A2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C060 - C06F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C070 - C07F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C080 - C08F
	0x08A3, 0x08A4, 0xFFFF, 0xFFFF, 0x08A5, 0xFFFF, 0xFFFF, 0xFFFF, 0x08A6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C090 - C09F
	0x08A7, 0x08A8, 0xFFFF, 0x08A9, 0xFFFF, 0x08AA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08AB, 0x08AC, 0xFFFF, 0x08AD,   // C0A0 - C0AF
	0x08AE, 0xFFFF, 0xFFFF, 0x08AF, 0x08B0, 0x08B1, 0x08B2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08B3, 0x08B4, 0xFFFF, 0x08B5,   // C0B0 - C0BF
	0x08B6, 0x08B7, 0xFFFF, 0xFFFF, 0xFFFF, 0x08B8, 0xFFFF, 0xFFFF, 0x08B9, 0x08BA, 0xFFFF, 0xFFFF, 0x08BB, 0xFFFF, 0xFFFF, 0xFFFF,   // C0C0 - C0CF
	0x08BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08BD, 0x08BE, 0xFFFF, 0x08BF, 0x08C0, 0x08C1, 0xFFFF, 0xFFFF,   // C0D0 - C0DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08C2, 0x08C3, 0xFFFF, 0xFFFF, 0x08C4, 0xFFFF, 0xFFFF, 0xFFFF, 0x08C5, 0xFFFF, 0xFFFF, 0xFFFF,   // C0E0 - C0EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08C6, 0x08C7, 0xFFFF, 0x08C8, 0xFFFF, 0x08C9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C0F0 - C0FF
	0x08CA, 0xFFFF, 0xFFFF, 0xFFFF, 0x08CB, 0xFFFF, 0xFFFF, 0xFFFF, 0x08CC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C100 - C10F
	0x08CD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08CE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08CF, 0x08D0, 0x08D1, 0x08D2,   // C110 - C11F
	0x08D3, 0xFFFF, 0xFFFF, 0x08D4, 0x08D5, 0xFFFF, 0x08D6, 0x08D7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08D8, 0x08D9, 0xFFFF, 0x08DA,   // C120 - C12F
	0x08DB, 0x08DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08DD, 0xFFFF, 0x08DE, 0x08DF, 0xFFFF, 0xFFFF, 0x08E0, 0xFFFF, 0xFFFF, 0xFFFF,   // C130 - C13F
	0x08E1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08E2, 0x08E3, 0xFFFF, 0x08E4, 0x08E5, 0x08E6, 0xFFFF, 0xFFFF,   // C140 - C14F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08E7, 0x08E8, 0xFFFF, 0xFFFF, 0x08E9, 0xFFFF, 0xFFFF, 0xFFFF, 0x08EA, 0xFFFF, 0xFFFF, 0xFFFF,   // C150 - C15F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08EB, 0x08EC, 0xFFFF, 0x08ED, 0x08EE, 0x08EF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C160 - C16F
	0x08F0, 0xFFFF, 0xFFFF, 0xFFFF, 0x08F1, 0xFFFF, 0xFFFF, 0xFFFF, 0x08F2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C170 - C17F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08F3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08F4, 0x08F5, 0x08F6, 0xFFFF,   // C180 - C18F
	0x08F7, 0xFFFF, 0xFFFF, 0xFFFF, 0x08F8, 0xFFFF, 0x08F9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x08FA, 0x08FB, 0xFFFF, 0x08FC,   // C190 - C19F
	0xFFFF, 0x08FD, 0xFFFF, 0xFFFF, 0xFFFF, 0x08FE, 0xFFFF, 0xFFFF, 0x08FF, 0x0900, 0xFFFF, 0xFFFF, 0x0901, 0xFFFF, 0xFFFF, 0xFFFF,   // C1A0 - C1AF
	0x0902, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0903, 0xFFFF, 0xFFFF,   // C1B0 - C1BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0904, 0xFFFF, 0xFFFF, 0xFFFF, 0x0905, 0xFFFF, 0xFFFF, 0xFFFF, 0x0906, 0xFFFF, 0xFFFF, 0xFFFF,   // C1C0 - C1CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0907, 0xFFFF, 0xFFFF, 0x0908, 0x0909, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C1D0 - C1DF
	0x090A, 0xFFFF, 0xFFFF, 0xFFFF, 0x090B, 0xFFFF, 0xFFFF, 0xFFFF, 0x090C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C1E0 - C1EF
	0x090D, 0x090E, 0xFFFF, 0x090F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0910, 0x0911, 0xFFFF, 0xFFFF,   // C1F0 - C1FF
	0x0912, 0xFFFF, 0xFFFF, 0xFFFF, 0x0913, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0914, 0x0915, 0xFFFF, 0x0916,   // C200 - C20F
	0xFFFF, 0x0917, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0918, 0x0919, 0xFFFF, 0xFFFF, 0x091A, 0xFFFF, 0xFFFF, 0x091B,   // C210 - C21F
	0x091C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x091D, 0x091E, 0xFFFF, 0x091F, 0xFFFF, 0x0920, 0xFFFF, 0x0921,   // C220 - C22F
	0xFFFF, 0x0922, 0x0923, 0xFFFF, 0x0924, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C230 - C23F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0925, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C240 - C24F
	0x0926, 0x0927, 0xFFFF, 0xFFFF, 0x0928, 0xFFFF, 0xFFFF, 0xFFFF, 0x0929, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C250 - C25F
	0x092A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x092B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x092C, 0x092D, 0xFFFF, 0xFFFF,   // C260 - C26F
	0x092E, 0xFFFF, 0xFFFF, 0xFFFF, 0x092F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0930, 0x0931, 0xFFFF, 0x0932,   // C270 - C27F
	0xFFFF, 0x0933, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0934, 0x0935, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C280 - C28F
	0x0936, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0937, 0xFFFF, 0xFFFF, 0x0938, 0xFFFF, 0x0939, 0xFFFF, 0xFFFF,   // C290 - C29F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x093A, 0x093B, 0xFFFF, 0xFFFF, 0x093C, 0xFFFF, 0xFFFF, 0xFFFF, 0x093D, 0x093E, 0xFFFF, 0xFFFF,   // C2A0 - C2AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x093F, 0x0940, 0xFFFF, 0x0941, 0xFFFF, 0x0942, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C2B0 - C2BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C2C0 - C2CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0943, 0x0944, 0xFFFF, 0xFFFF,   // C2D0 - C2DF
	0x0945, 0xFFFF, 0xFFFF, 0x0946, 0x0947, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0948, 0x0949, 0x094A, 0xFFFF, 0x094B,   // C2E0 - C2EF
	0xFFFF, 0x094C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x094D, 0xFFFF, 0x094E, 0x094F, 0xFFFF, 0x0950, 0x0951, 0xFFFF, 0xFFFF, 0xFFFF,   // C2F0 - C2FF
	0x0952, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0953, 0x0954, 0xFFFF, 0xFFFF, 0x0955, 0x0956, 0xFFFF, 0xFFFF,   // C300 - C30F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0957, 0x0958, 0x0959, 0xFFFF, 0xFFFF, 0x095A, 0xFFFF, 0xFFFF, 0xFFFF, 0x095B, 0xFFFF, 0xFFFF, 0xFFFF,   // C310 - C31F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x095C, 0x095D, 0xFFFF, 0xFFFF, 0x095E, 0x095F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C320 - C32F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C330 - C33F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0960, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C340 - C34F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C350 - C35F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0961, 0x0962, 0xFFFF, 0xFFFF, 0x0963, 0xFFFF, 0xFFFF, 0xFFFF,   // C360 - C36F
	0x0964, 0xFFFF, 0x0965, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0966, 0x0967, 0xFFFF, 0xFFFF, 0x0968, 0x0969, 0xFFFF, 0xFFFF,   // C370 - C37F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x096A, 0xFFFF, 0xFFFF, 0xFFFF, 0x096B, 0xFFFF, 0xFFFF, 0xFFFF, 0x096C, 0xFFFF, 0xFFFF, 0xFFFF,   // C380 - C38F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C390 - C39F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C3A0 - C3AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C3B0 - C3BF
	0x096D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C3C0 - C3CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x096E, 0x096F, 0xFFFF, 0xFFFF, 0x0970, 0xFFFF, 0xFFFF, 0x0971,   // C3D0 - C3DF
	0x0972, 0xFFFF, 0x0973, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0974, 0x0975, 0xFFFF, 0xFFFF, 0xFFFF, 0x0976, 0xFFFF, 0xFFFF,   // C3E0 - C3EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0977, 0x0978, 0xFFFF, 0xFFFF, 0x0979, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C3F0 - C3FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x097A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C400 - C40F
	0x097B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C410 - C41F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x097C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x097D, 0xFFFF, 0xFFFF, 0xFFFF,   // C420 - C42F
	0x097E, 0xFFFF, 0xFFFF, 0xFFFF, 0x097F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0980, 0x0981, 0xFFFF, 0xFFFF,   // C430 - C43F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0982, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C440 - C44F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C450 - C45F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0983, 0x0984, 0xFFFF, 0xFFFF, 0x0985, 0xFFFF, 0xFFFF, 0xFFFF, 0x0986, 0xFFFF, 0xFFFF, 0xFFFF,   // C460 - C46F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0987, 0x0988, 0xFFFF, 0xFFFF, 0xFFFF, 0x0989, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C470 - C47F
	0x098A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C480 - C48F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x098B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x098C, 0xFFFF, 0xFFFF, 0xFFFF,   // C490 - C49F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C4A0 - C4AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x098D, 0xFFFF, 0xFFFF, 0xFFFF, 0x098E, 0xFFFF, 0xFFFF, 0xFFFF,   // C4B0 - C4BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C4C0 - C4CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C4D0 - C4DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x098F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C4E0 - C4EF
	0x0990, 0x0991, 0xFFFF, 0xFFFF, 0x0992, 0xFFFF, 0xFFFF, 0xFFFF, 0x0993, 0xFFFF, 0x0994, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0995,   // C4F0 - C4FF
	0x0996, 0x0997, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0998, 0xFFFF, 0xFFFF, 0xFFFF,   // C500 - C50F
	0x0999, 0xFFFF, 0xFFFF, 0xFFFF, 0x099A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x099B, 0xFFFF, 0xFFFF, 0xFFFF,   // C510 - C51F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x099C, 0x099D, 0xFFFF, 0xFFFF, 0x099E, 0xFFFF, 0xFFFF, 0xFFFF,   // C520 - C52F
	0x099F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09A0, 0x09A1, 0xFFFF, 0x09A2, 0xFFFF, 0x09A3, 0xFFFF, 0xFFFF,   // C530 - C53F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09A4, 0x09A5, 0xFFFF, 0xFFFF, 0x09A6, 0x09A7, 0x09A8, 0xFFFF, 0x09A9, 0x09AA, 0x09AB, 0xFFFF,   // C540 - C54F
	0xFFFF, 0xFFFF, 0xFFFF, 0x09AC, 0x09AD, 0x09AE, 0xFFFF, 0x09AF, 0x09B0, 0x09B1, 0xFFFF, 0xFFFF, 0xFFFF, 0x09B2, 0x09B3, 0xFFFF,   // C550 - C55F
	0x09B4, 0x09B5, 0xFFFF, 0xFFFF, 0x09B6, 0xFFFF, 0xFFFF, 0xFFFF, 0x09B7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C560 - C56F
	0x09B8, 0x09B9, 0xFFFF, 0x09BA, 0x09BB, 0x09BC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09BD, 0x09BE, 0xFFFF, 0xFFFF,   // C570 - C57F
	0x09BF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09C0, 0xFFFF, 0xFFFF, 0x09C1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09C2, 0x09C3, 0xFFFF, 0x09C4,   // C580 - C58F
	0xFFFF, 0x09C5, 0xFFFF, 0xFFFF, 0xFFFF, 0x09C6, 0xFFFF, 0x09C7, 0x09C8, 0xFFFF, 0xFFFF, 0xFFFF, 0x09C9, 0xFFFF, 0xFFFF, 0xFFFF,   // C590 - C59F
	0x09CA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09CB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C5A0 - C5AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09CC, 0x09CD, 0xFFFF, 0xFFFF, 0x09CE, 0x09CF, 0xFFFF, 0x09D0, 0x09D1, 0x09D2, 0x09D3, 0xFFFF,   // C5B0 - C5BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09D4, 0x09D5, 0x09D6, 0x09D7, 0x09D8, 0x09D9, 0x09DA, 0xFFFF, 0x09DB, 0xFFFF, 0x09DC, 0xFFFF,   // C5C0 - C5CF
	0x09DD, 0x09DE, 0xFFFF, 0xFFFF, 0x09DF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09E0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C5D0 - C5DF
	0x09E1, 0x09E2, 0xFFFF, 0x09E3, 0xFFFF, 0x09E4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09E5, 0x09E6, 0x09E7, 0xFFFF,   // C5E0 - C5EF
	0x09E8, 0xFFFF, 0xFFFF, 0xFFFF, 0x09E9, 0xFFFF, 0x09EA, 0x09EB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09EC, 0x09ED, 0x09EE, 0x09EF,   // C5F0 - C5FF
	0x09F0, 0x09F1, 0xFFFF, 0xFFFF, 0xFFFF, 0x09F2, 0x09F3, 0x09F4, 0x09F5, 0xFFFF, 0xFFFF, 0xFFFF, 0x09F6, 0xFFFF, 0xFFFF, 0xFFFF,   // C600 - C60F
	0x09F7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09F8, 0x09F9, 0xFFFF, 0x09FA, 0x09FB, 0xFFFF, 0xFFFF, 0xFFFF,   // C610 - C61F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x09FC, 0x09FD, 0xFFFF, 0xFFFF, 0x09FE, 0xFFFF, 0xFFFF, 0xFFFF, 0x09FF, 0x0A00, 0x0A01, 0xFFFF,   // C620 - C62F
	0x0A02, 0xFFFF, 0xFFFF, 0x0A03, 0x0A04, 0x0A05, 0xFFFF, 0x0A06, 0xFFFF, 0x0A07, 0xFFFF, 0x0A08, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C630 - C63F
	0x0A09, 0x0A0A, 0xFFFF, 0xFFFF, 0x0A0B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A0C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C640 - C64F
	0x0A0D, 0x0A0E, 0xFFFF, 0x0A0F, 0x0A10, 0x0A11, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A12, 0x0A13, 0xFFFF, 0xFFFF,   // C650 - C65F
	0x0A14, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A15, 0xFFFF, 0xFFFF, 0x0A16,   // C660 - C66F
	0xFFFF, 0x0A17, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A18, 0x0A19, 0xFFFF, 0xFFFF, 0x0A1A, 0xFFFF, 0xFFFF, 0xFFFF,   // C670 - C67F
	0x0A1B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A1C, 0x0A1D, 0xFFFF, 0x0A1E, 0xFFFF, 0x0A1F, 0xFFFF, 0xFFFF,   // C680 - C68F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A20, 0x0A21, 0xFFFF, 0xFFFF, 0x0A22, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A23, 0xFFFF, 0xFFFF, 0xFFFF,   // C690 - C69F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A24, 0x0A25, 0xFFFF, 0x0A26, 0xFFFF, 0x0A27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C6A0 - C6AF
	0x0A28, 0x0A29, 0xFFFF, 0xFFFF, 0x0A2A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A2B, 0x0A2C, 0x0A2D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C6B0 - C6BF
	0x0A2E, 0x0A2F, 0xFFFF, 0x0A30, 0xFFFF, 0x0A31, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A32, 0x0A33, 0xFFFF, 0xFFFF,   // C6C0 - C6CF
	0x0A34, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A35, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A36, 0x0A37, 0xFFFF, 0xFFFF,   // C6D0 - C6DF
	0x0A38, 0x0A39, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A3A, 0x0A3B, 0xFFFF, 0xFFFF, 0x0A3C, 0xFFFF, 0xFFFF, 0xFFFF,   // C6E0 - C6EF
	0x0A3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A3E, 0x0A3F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A40, 0xFFFF, 0xFFFF,   // C6F0 - C6FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A41, 0x0A42, 0xFFFF, 0xFFFF, 0x0A43, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A44, 0xFFFF, 0xFFFF, 0xFFFF,   // C700 - C70F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A45, 0x0A46, 0xFFFF, 0x0A47, 0xFFFF, 0x0A48, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C710 - C71F
	0x0A49, 0x0A4A, 0xFFFF, 0xFFFF, 0x0A4B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A4C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C720 - C72F
	0x0A4D, 0x0A4E, 0xFFFF, 0x0A4F, 0xFFFF, 0x0A50, 0xFFFF, 0x0A51, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A52, 0x0A53, 0xFFFF, 0xFFFF,   // C730 - C73F
	0x0A54, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A55, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A56, 0xFFFF, 0x0A57, 0x0A58, 0xFFFF, 0x0A59,   // C740 - C74F
	0xFFFF, 0x0A5A, 0x0A5B, 0x0A5C, 0x0A5D, 0x0A5E, 0x0A5F, 0x0A60, 0x0A61, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A62, 0xFFFF, 0xFFFF, 0xFFFF,   // C750 - C75F
	0x0A63, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A64, 0xFFFF, 0xFFFF, 0x0A65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C760 - C76F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A66, 0x0A67, 0xFFFF, 0xFFFF, 0x0A68, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A69, 0x0A6A, 0x0A6B, 0xFFFF,   // C770 - C77F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0A6C, 0x0A6D, 0x0A6E, 0xFFFF, 0x0A6F, 0x0A70, 0x0A71, 0x0A72, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A73, 0xFFFF,   // C780 - C78F
	0x0A74, 0x0A75, 0xFFFF, 0xFFFF, 0x0A76, 0xFFFF, 0x0A77, 0x0A78, 0x0A79, 0xFFFF, 0x0A7A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C790 - C79F
	0x0A7B, 0x0A7C, 0xFFFF, 0x0A7D, 0x0A7E, 0x0A7F, 0x0A80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A81, 0x0A82, 0xFFFF, 0xFFFF,   // C7A0 - C7AF
	0x0A83, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A84, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A85, 0x0A86, 0xFFFF, 0x0A87,   // C7B0 - C7BF
	0x0A88, 0x0A89, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A8A, 0x0A8B, 0xFFFF, 0xFFFF, 0x0A8C, 0xFFFF, 0x0A8D, 0xFFFF,   // C7C0 - C7CF
	0x0A8E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A8F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A90, 0xFFFF, 0xFFFF,   // C7D0 - C7DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A91, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A92, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A93, 0xFFFF, 0xFFFF, 0xFFFF,   // C7E0 - C7EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C7F0 - C7FF
	0x0A94, 0x0A95, 0xFFFF, 0xFFFF, 0x0A96, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A97, 0xFFFF, 0x0A98, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C800 - C80F
	0x0A99, 0x0A9A, 0xFFFF, 0x0A9B, 0xFFFF, 0x0A9C, 0x0A9D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0A9E, 0x0A9F, 0xFFFF, 0xFFFF,   // C810 - C81F
	0x0AA0, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AA1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AA2, 0x0AA3, 0xFFFF, 0x0AA4,   // C820 - C82F
	0xFFFF, 0x0AA5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AA6, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AA7, 0xFFFF, 0xFFFF, 0xFFFF,   // C830 - C83F
	0x0AA8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AA9, 0x0AAA, 0xFFFF, 0xFFFF, 0x0AAB, 0x0AAC, 0xFFFF, 0xFFFF,   // C840 - C84F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AAD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C850 - C85F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C860 - C86F
	0x0AAE, 0x0AAF, 0xFFFF, 0xFFFF, 0x0AB0, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AB1, 0xFFFF, 0x0AB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C870 - C87F
	0x0AB3, 0x0AB4, 0xFFFF, 0x0AB5, 0xFFFF, 0x0AB6, 0x0AB7, 0x0AB8, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AB9, 0x0ABA, 0x0ABB, 0xFFFF, 0xFFFF,   // C880 - C88F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ABC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ABD, 0xFFFF, 0x0ABE,   // C890 - C89F
	0xFFFF, 0x0ABF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C8A0 - C8AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AC1, 0x0AC2, 0xFFFF, 0xFFFF,   // C8B0 - C8BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AC3, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AC4, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AC5, 0xFFFF, 0xFFFF, 0xFFFF,   // C8C0 - C8CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AC6, 0x0AC7, 0xFFFF, 0x0AC8, 0xFFFF, 0x0AC9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C8D0 - C8DF
	0x0ACA, 0x0ACB, 0xFFFF, 0xFFFF, 0x0ACC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C8E0 - C8EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ACD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ACE, 0x0ACF, 0xFFFF, 0xFFFF,   // C8F0 - C8FF
	0x0AD0, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AD1, 0x0AD2, 0x0AD3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AD4, 0x0AD5, 0xFFFF, 0x0AD6,   // C900 - C90F
	0xFFFF, 0x0AD7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AD8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C910 - C91F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AD9, 0xFFFF, 0xFFFF, 0xFFFF,   // C920 - C92F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ADA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C930 - C93F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C940 - C94F
	0x0ADB, 0x0ADC, 0xFFFF, 0xFFFF, 0x0ADD, 0xFFFF, 0xFFFF, 0xFFFF, 0x0ADE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C950 - C95F
	0x0ADF, 0x0AE0, 0xFFFF, 0x0AE1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AE2, 0xFFFF, 0xFFFF, 0xFFFF,   // C960 - C96F
	0x0AE3, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AE4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AE5, 0xFFFF, 0xFFFF, 0xFFFF,   // C970 - C97F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AE6, 0x0AE7, 0xFFFF, 0xFFFF, 0x0AE8, 0xFFFF, 0xFFFF, 0xFFFF,   // C980 - C98F
	0x0AE9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0AEA, 0x0AEB, 0xFFFF, 0x0AEC, 0xFFFF, 0x0AED, 0xFFFF, 0xFFFF,   // C990 - C99F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C9A0 - C9AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C9B0 - C9BF
	0x0AEE, 0x0AEF, 0xFFFF, 0xFFFF, 0x0AF0, 0xFFFF, 0xFFFF, 0x0AF1, 0x0AF2, 0xFFFF, 0x0AF3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C9C0 - C9CF
	0x0AF4, 0x0AF5, 0xFFFF, 0x0AF6, 0xFFFF, 0x0AF7, 0x0AF8, 0xFFFF, 0xFFFF, 0x0AF9, 0x0AFA, 0xFFFF, 0x0AFB, 0x0AFC, 0xFFFF, 0xFFFF,   // C9D0 - C9DF
	0x0AFD, 0xFFFF, 0x0AFE, 0xFFFF, 0x0AFF, 0xFFFF, 0xFFFF, 0x0B00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B01, 0x0B02, 0xFFFF, 0x0B03,   // C9E0 - C9EF
	0x0B04, 0x0B05, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B06, 0x0B07, 0xFFFF, 0xFFFF, 0x0B08, 0xFFFF, 0xFFFF, 0xFFFF,   // C9F0 - C9FF
	0x0B09, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B0A, 0x0B0B, 0xFFFF, 0x0B0C, 0x0B0D, 0x0B0E, 0xFFFF, 0xFFFF,   // CA00 - CA0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B0F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B10, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CA10 - CA1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B11, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CA20 - CA2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CA30 - CA3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B12, 0x0B13, 0xFFFF, 0xFFFF,   // CA40 - CA4F
	0x0B14, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B15, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B16, 0x0B17, 0xFFFF, 0x0B18,   // CA50 - CA5F
	0x0B19, 0x0B1A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B1B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CA60 - CA6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B1C, 0xFFFF, 0xFFFF,   // CA70 - CA7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B1D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CA80 - CA8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B1E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CA90 - CA9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CAA0 - CAAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B1F, 0x0B20, 0xFFFF, 0xFFFF,   // CAB0 - CABF
	0x0B21, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B22, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B23, 0x0B24, 0xFFFF, 0x0B25,   // CAC0 - CACF
	0xFFFF, 0x0B26, 0xFFFF, 0x0B27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B28, 0x0B29, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CAD0 - CADF
	0x0B2A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B2B, 0xFFFF, 0xFFFF, 0xFFFF,   // CAE0 - CAEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B2C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CAF0 - CAFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B2D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB00 - CB0F
	0x0B2E, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B2F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B30, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB10 - CB1F
	0x0B31, 0x0B32, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB20 - CB2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB30 - CB3F
	0xFFFF, 0x0B33, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B34, 0x0B35, 0xFFFF, 0xFFFF, 0x0B36, 0xFFFF, 0xFFFF, 0xFFFF,   // CB40 - CB4F
	0x0B37, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B38, 0x0B39, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B3A, 0xFFFF, 0xFFFF,   // CB50 - CB5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B3B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB60 - CB6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B3C, 0x0B3D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB70 - CB7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CB80 - CB8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B3E, 0xFFFF, 0xFFFF, 0xFFFF,   // CB90 - CB9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CBA0 - CBAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B3F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CBB0 - CBBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CBC0 - CBCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B40, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CBD0 - CBDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B41, 0xFFFF, 0xFFFF, 0x0B42, 0xFFFF, 0x0B43, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CBE0 - CBEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CBF0 - CBFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B44, 0x0B45, 0xFFFF, 0xFFFF,   // CC00 - CC0F
	0x0B46, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B47, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B48, 0x0B49, 0xFFFF, 0xFFFF,   // CC10 - CC1F
	0xFFFF, 0x0B4A, 0x0B4B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B4C, 0x0B4D, 0x0B4E, 0xFFFF, 0xFFFF, 0x0B4F, 0xFFFF, 0x0B50, 0xFFFF,   // CC20 - CC2F
	0x0B51, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B52, 0x0B53, 0xFFFF, 0x0B54, 0x0B55, 0x0B56, 0x0B57, 0xFFFF,   // CC30 - CC3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B58, 0x0B59, 0xFFFF, 0xFFFF, 0x0B5A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B5B, 0xFFFF, 0xFFFF, 0xFFFF,   // CC40 - CC4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B5C, 0x0B5D, 0xFFFF, 0x0B5E, 0x0B5F, 0x0B60, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CC50 - CC5F
	0x0B61, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B62, 0xFFFF, 0x0B63, 0xFFFF, 0x0B64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CC60 - CC6F
	0x0B65, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B66, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CC70 - CC7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CC80 - CC8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B67, 0x0B68, 0xFFFF, 0xFFFF, 0x0B69, 0xFFFF, 0xFFFF, 0xFFFF,   // CC90 - CC9F
	0x0B6A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B6B, 0x0B6C, 0xFFFF, 0x0B6D, 0x0B6E, 0x0B6F, 0xFFFF, 0xFFFF,   // CCA0 - CCAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B70, 0x0B71, 0xFFFF, 0xFFFF, 0x0B72, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B73, 0xFFFF, 0xFFFF, 0xFFFF,   // CCB0 - CCBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B74, 0x0B75, 0xFFFF, 0x0B76, 0xFFFF, 0x0B77, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CCC0 - CCCF
	0x0B78, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B79, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CCD0 - CCDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B7A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B7B, 0xFFFF, 0xFFFF, 0xFFFF,   // CCE0 - CCEF
	0x0B7C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CCF0 - CCFF
	0xFFFF, 0x0B7D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B7E, 0x0B7F, 0xFFFF, 0xFFFF, 0x0B80, 0xFFFF, 0xFFFF, 0xFFFF,   // CD00 - CD0F
	0x0B81, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B82, 0x0B83, 0xFFFF, 0x0B84, 0xFFFF, 0x0B85, 0xFFFF, 0xFFFF,   // CD10 - CD1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B86, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B87, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B88, 0xFFFF, 0xFFFF, 0xFFFF,   // CD20 - CD2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B89, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CD30 - CD3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CD40 - CD4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B8A, 0xFFFF, 0xFFFF, 0xFFFF,   // CD50 - CD5F
	0x0B8B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B8C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B8D, 0x0B8E, 0xFFFF, 0x0B8F,   // CD60 - CD6F
	0xFFFF, 0x0B90, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CD70 - CD7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B92, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CD80 - CD8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B93, 0x0B94, 0xFFFF, 0xFFFF, 0x0B95, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B96, 0xFFFF, 0xFFFF, 0xFFFF,   // CD90 - CD9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B97, 0x0B98, 0xFFFF, 0x0B99, 0xFFFF, 0x0B9A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CDA0 - CDAF
	0x0B9B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CDB0 - CDBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B9C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B9D, 0xFFFF, 0xFFFF, 0xFFFF,   // CDC0 - CDCF
	0x0B9E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CDD0 - CDDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0B9F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BA0, 0xFFFF, 0xFFFF, 0xFFFF,   // CDE0 - CDEF
	0x0BA1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BA2, 0x0BA3, 0xFFFF, 0x0BA4, 0xFFFF, 0x0BA5, 0xFFFF, 0xFFFF,   // CDF0 - CDFF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BA6, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BA7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BA8, 0xFFFF, 0xFFFF, 0xFFFF,   // CE00 - CE0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BA9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BAA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CE10 - CE1F
	0x0BAB, 0x0BAC, 0xFFFF, 0xFFFF, 0x0BAD, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BAE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CE20 - CE2F
	0x0BAF, 0x0BB0, 0xFFFF, 0x0BB1, 0xFFFF, 0x0BB2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CE30 - CE3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CE40 - CE4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BB3, 0x0BB4, 0xFFFF, 0xFFFF, 0x0BB5, 0xFFFF, 0xFFFF, 0x0BB6,   // CE50 - CE5F
	0x0BB7, 0x0BB8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BB9, 0x0BBA, 0xFFFF, 0x0BBB, 0xFFFF, 0x0BBC, 0xFFFF, 0xFFFF,   // CE60 - CE6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BBD, 0x0BBE, 0xFFFF, 0xFFFF, 0x0BBF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BC0, 0xFFFF, 0xFFFF, 0xFFFF,   // CE70 - CE7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BC1, 0x0BC2, 0xFFFF, 0x0BC3, 0xFFFF, 0x0BC4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CE80 - CE8F
	0x0BC5, 0x0BC6, 0xFFFF, 0xFFFF, 0x0BC7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BC8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CE90 - CE9F
	0x0BC9, 0x0BCA, 0xFFFF, 0x0BCB, 0x0BCC, 0x0BCD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BCE, 0x0BCF, 0xFFFF, 0xFFFF,   // CEA0 - CEAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CEB0 - CEBF
	0xFFFF, 0x0BD0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CEC0 - CECF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CED0 - CEDF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BD1, 0x0BD2, 0xFFFF, 0xFFFF, 0x0BD3, 0xFFFF, 0xFFFF, 0x0BD4, 0x0BD5, 0xFFFF, 0xFFFF, 0xFFFF,   // CEE0 - CEEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BD6, 0x0BD7, 0xFFFF, 0x0BD8, 0x0BD9, 0x0BDA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CEF0 - CEFF
	0x0BDB, 0x0BDC, 0xFFFF, 0xFFFF, 0x0BDD, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BDE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF00 - CF0F
	0x0BDF, 0x0BE0, 0xFFFF, 0x0BE1, 0xFFFF, 0x0BE2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BE3, 0xFFFF, 0xFFFF, 0xFFFF,   // CF10 - CF1F
	0x0BE4, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BE5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BE6, 0x0BE7, 0xFFFF, 0x0BE8,   // CF20 - CF2F
	0x0BE9, 0x0BEA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BEB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF30 - CF3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF40 - CF4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BEC, 0x0BED, 0xFFFF, 0xFFFF, 0x0BEE, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BEF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF50 - CF5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BF0, 0x0BF1, 0xFFFF, 0x0BF2, 0xFFFF, 0x0BF3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF60 - CF6F
	0x0BF4, 0x0BF5, 0xFFFF, 0xFFFF, 0x0BF6, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BF7, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF70 - CF7F
	0x0BF8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BF9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BFA, 0xFFFF, 0xFFFF, 0xFFFF,   // CF80 - CF8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CF90 - CF9F
	0xFFFF, 0x0BFB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BFC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CFA0 - CFAF
	0x0BFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CFB0 - CFBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0BFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CFC0 - CFCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CFD0 - CFDF
	0x0BFF, 0x0C00, 0xFFFF, 0xFFFF, 0x0C01, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C02, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // CFE0 - CFEF
	0x0C03, 0x0C04, 0xFFFF, 0x0C05, 0xFFFF, 0x0C06, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C07, 0xFFFF, 0xFFFF, 0xFFFF,   // CFF0 - CFFF
	0x0C08, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C09, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D000 - D00F
	0xFFFF, 0x0C0A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C0B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D010 - D01F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C0C, 0xFFFF, 0xFFFF,   // D020 - D02F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C0D, 0x0C0E, 0xFFFF, 0xFFFF, 0x0C0F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C10, 0xFFFF, 0xFFFF, 0xFFFF,   // D030 - D03F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C11, 0x0C12, 0xFFFF, 0x0C13, 0xFFFF, 0x0C14, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D040 - D04F
	0x0C15, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C16, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C17, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D050 - D05F
	0x0C18, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C19, 0x0C1A, 0xFFFF, 0xFFFF,   // D060 - D06F
	0x0C1B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C1C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C1D, 0x0C1E, 0xFFFF, 0xFFFF,   // D070 - D07F
	0xFFFF, 0x0C1F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D080 - D08F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D090 - D09F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C20, 0x0C21, 0xFFFF, 0xFFFF, 0x0C22, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C23, 0xFFFF, 0xFFFF, 0xFFFF,   // D0A0 - D0AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C24, 0x0C25, 0xFFFF, 0x0C26, 0xFFFF, 0x0C27, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D0B0 - D0BF
	0x0C28, 0x0C29, 0xFFFF, 0xFFFF, 0x0C2A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C2B, 0x0C2C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D0C0 - D0CF
	0x0C2D, 0x0C2E, 0xFFFF, 0x0C2F, 0x0C30, 0x0C31, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C32, 0x0C33, 0xFFFF, 0xFFFF,   // D0D0 - D0DF
	0x0C34, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C35, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C36, 0x0C37, 0xFFFF, 0x0C38,   // D0E0 - D0EF
	0x0C39, 0x0C3A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C3B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D0F0 - D0FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C3C, 0xFFFF, 0xFFFF,   // D100 - D10F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D110 - D11F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D120 - D12F
	0x0C3D, 0x0C3E, 0xFFFF, 0xFFFF, 0x0C3F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C40, 0xFFFF, 0x0C41, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D130 - D13F
	0x0C42, 0x0C43, 0xFFFF, 0x0C44, 0x0C45, 0x0C46, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C47, 0x0C48, 0xFFFF, 0xFFFF,   // D140 - D14F
	0x0C49, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C4A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C4B, 0x0C4C, 0xFFFF, 0x0C4D,   // D150 - D15F
	0xFFFF, 0x0C4E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C4F, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C50, 0xFFFF, 0xFFFF, 0xFFFF,   // D160 - D16F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C51, 0xFFFF, 0xFFFF, 0xFFFF,   // D170 - D17F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C52, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C53, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D180 - D18F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D190 - D19F
	0x0C54, 0x0C55, 0xFFFF, 0xFFFF, 0x0C56, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C57, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D1A0 - D1AF
	0x0C58, 0x0C59, 0xFFFF, 0x0C5A, 0xFFFF, 0x0C5B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C5C, 0xFFFF, 0x0C5D, 0xFFFF, 0xFFFF, 0xFFFF,   // D1B0 - D1BF
	0x0C5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D1C0 - D1CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C5F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D1D0 - D1DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D1E0 - D1EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C60, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C61, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D1F0 - D1FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C62, 0xFFFF, 0x0C63, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D200 - D20F
	0x0C64, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D210 - D21F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C65, 0x0C66, 0xFFFF, 0xFFFF,   // D220 - D22F
	0x0C67, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C68, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C69, 0x0C6A, 0xFFFF, 0x0C6B,   // D230 - D23F
	0xFFFF, 0x0C6C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C6D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D240 - D24F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C6E, 0xFFFF, 0xFFFF, 0xFFFF,   // D250 - D25F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C6F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D260 - D26F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D270 - D27F
	0x0C70, 0x0C71, 0xFFFF, 0xFFFF, 0x0C72, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C73, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D280 - D28F
	0x0C74, 0x0C75, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C76, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C77, 0xFFFF, 0xFFFF, 0xFFFF,   // D290 - D29F
	0x0C78, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C79, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C7A, 0xFFFF, 0xFFFF, 0xFFFF,   // D2A0 - D2AF
	0xFFFF, 0x0C7B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C7C, 0x0C7D, 0xFFFF, 0xFFFF, 0x0C7E, 0xFFFF, 0xFFFF, 0x0C7F,   // D2B0 - D2BF
	0x0C80, 0xFFFF, 0x0C81, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C82, 0x0C83, 0xFFFF, 0x0C84, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D2C0 - D2CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C85, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C86, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C87, 0xFFFF, 0xFFFF, 0xFFFF,   // D2D0 - D2DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C88, 0x0C89, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D2E0 - D2EF
	0x0C8A, 0x0C8B, 0xFFFF, 0xFFFF, 0x0C8C, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C8D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D2F0 - D2FF
	0x0C8E, 0x0C8F, 0xFFFF, 0x0C90, 0xFFFF, 0x0C91, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C92, 0x0C93, 0x0C94, 0xFFFF,   // D300 - D30F
	0x0C95, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C96, 0xFFFF, 0x0C97, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C98, 0x0C99, 0xFFFF, 0x0C9A,   // D310 - D31F
	0x0C9B, 0x0C9C, 0xFFFF, 0xFFFF, 0xFFFF, 0x0C9D, 0xFFFF, 0xFFFF, 0x0C9E, 0x0C9F, 0xFFFF, 0xFFFF, 0x0CA0, 0xFFFF, 0xFFFF, 0xFFFF,   // D320 - D32F
	0x0CA1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CA2, 0x0CA3, 0xFFFF, 0x0CA4, 0x0CA5, 0x0CA6, 0xFFFF, 0xFFFF,   // D330 - D33F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CA7, 0x0CA8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D340 - D34F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D350 - D35F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D360 - D36F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CA9, 0x0CAA, 0xFFFF, 0xFFFF,   // D370 - D37F
	0x0CAB, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CAC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CAD, 0x0CAE, 0xFFFF, 0x0CAF,   // D380 - D38F
	0x0CB0, 0x0CB1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CB2, 0x0CB3, 0xFFFF, 0xFFFF, 0x0CB4, 0xFFFF, 0xFFFF, 0xFFFF,   // D390 - D39F
	0x0CB5, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CB6, 0x0CB7, 0xFFFF, 0x0CB8, 0xFFFF, 0x0CB9, 0xFFFF, 0xFFFF,   // D3A0 - D3AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CBA, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CBB, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CBC, 0xFFFF, 0xFFFF, 0xFFFF,   // D3B0 - D3BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CBD, 0x0CBE, 0xFFFF, 0xFFFF, 0x0CBF, 0x0CC0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D3C0 - D3CF
	0x0CC1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CC2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D3D0 - D3DF
	0xFFFF, 0x0CC3, 0xFFFF, 0x0CC4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CC5, 0x0CC6, 0xFFFF, 0xFFFF,   // D3E0 - D3EF
	0x0CC7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CC8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CC9, 0x0CCA, 0xFFFF, 0x0CCB,   // D3F0 - D3FF
	0xFFFF, 0x0CCC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CCD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D400 - D40F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CCE, 0xFFFF, 0xFFFF,   // D410 - D41F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D420 - D42F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D430 - D43F
	0x0CCF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CD0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D440 - D44F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CD1, 0xFFFF, 0xFFFF, 0xFFFF,   // D450 - D45F
	0x0CD2, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CD3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CD4, 0xFFFF, 0x0CD5,   // D460 - D46F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CD6, 0x0CD7, 0xFFFF, 0xFFFF, 0x0CD8, 0xFFFF, 0xFFFF, 0x0CD9,   // D470 - D47F
	0x0CDA, 0xFFFF, 0x0CDB, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CDC, 0x0CDD, 0xFFFF, 0x0CDE, 0xFFFF, 0x0CDF, 0xFFFF, 0xFFFF,   // D480 - D48F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE0, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D490 - D49F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D4A0 - D4AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D4B0 - D4BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE2, 0xFFFF, 0xFFFF, 0xFFFF,   // D4C0 - D4CF
	0x0CE3, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE5, 0xFFFF, 0xFFFF, 0x0CE6,   // D4D0 - D4DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE7, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CE8, 0xFFFF, 0xFFFF, 0xFFFF,   // D4E0 - D4EF
	0x0CE9, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CEA, 0xFFFF, 0xFFFF, 0x0CEB, 0xFFFF, 0x0CEC, 0xFFFF, 0xFFFF,   // D4F0 - D4FF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CED, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CEE, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CEF, 0xFFFF, 0xFFFF, 0xFFFF,   // D500 - D50F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF0, 0x0CF1, 0xFFFF, 0x0CF2, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D510 - D51F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D520 - D52F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF3, 0x0CF4, 0xFFFF, 0xFFFF,   // D530 - D53F
	0x0CF5, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF6, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CF7, 0x0CF8, 0xFFFF, 0x0CF9,   // D540 - D54F
	0xFFFF, 0x0CFA, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CFB, 0x0CFC, 0xFFFF, 0xFFFF, 0x0CFD, 0xFFFF, 0xFFFF, 0xFFFF,   // D550 - D55F
	0x0CFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0CFF, 0xFFFF, 0xFFFF, 0x0D00, 0x0D01, 0xFFFF, 0x0D02, 0xFFFF, 0x0D03, 0xFFFF, 0xFFFF,   // D560 - D56F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D04, 0x0D05, 0xFFFF, 0xFFFF, 0x0D06, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D07, 0xFFFF, 0xFFFF, 0xFFFF,   // D570 - D57F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D08, 0x0D09, 0xFFFF, 0x0D0A, 0x0D0B, 0x0D0C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D580 - D58F
	0x0D0D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D590 - D59F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D0E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D5A0 - D5AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D5B0 - D5BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D0F, 0x0D10, 0xFFFF, 0xFFFF, 0x0D11, 0xFFFF, 0xFFFF, 0xFFFF,   // D5C0 - D5CF
	0x0D12, 0xFFFF, 0x0D13, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D14, 0x0D15, 0xFFFF, 0x0D16, 0xFFFF, 0x0D17, 0xFFFF, 0xFFFF,   // D5D0 - D5DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D18, 0x0D19, 0xFFFF, 0xFFFF, 0x0D1A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D1B, 0xFFFF, 0xFFFF, 0xFFFF,   // D5E0 - D5EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D1C, 0x0D1D, 0xFFFF, 0x0D1E, 0xFFFF, 0x0D1F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D5F0 - D5FF
	0x0D20, 0x0D21, 0xFFFF, 0xFFFF, 0x0D22, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D23, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D600 - D60F
	0x0D24, 0x0D25, 0xFFFF, 0x0D26, 0x0D27, 0x0D28, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D29, 0xFFFF, 0xFFFF, 0xFFFF,   // D610 - D61F
	0x0D2A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D2B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D2C, 0xFFFF, 0xFFFF,   // D620 - D62F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D2D, 0x0D2E, 0xFFFF, 0xFFFF, 0x0D2F, 0xFFFF, 0xFFFF, 0xFFFF,   // D630 - D63F
	0x0D30, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D31, 0xFFFF, 0xFFFF, 0x0D32, 0x0D33, 0xFFFF, 0x0D34, 0xFFFF, 0x0D35, 0xFFFF, 0xFFFF,   // D640 - D64F
	0xFFFF, 0x0D36, 0xFFFF, 0xFFFF, 0x0D37, 0x0D38, 0xFFFF, 0xFFFF, 0x0D39, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D3A, 0xFFFF, 0xFFFF, 0xFFFF,   // D650 - D65F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D3B, 0xFFFF, 0x0D3C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D660 - D66F
	0x0D3D, 0x0D3E, 0xFFFF, 0xFFFF, 0x0D3F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D670 - D67F
	0xFFFF, 0xFFFF, 0xFFFF, 0x0D40, 0xFFFF, 0x0D41, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D42, 0x0D43, 0xFFFF, 0xFFFF,   // D680 - D68F
	0x0D44, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D45, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D46, 0xFFFF, 0x0D47,   // D690 - D69F
	0xFFFF, 0x0D48, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D49, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D4A, 0xFFFF, 0xFFFF, 0xFFFF,   // D6A0 - D6AF
	0x0D4B, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D4C, 0xFFFF, 0x0D4D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D6B0 - D6BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D4E, 0x0D4F, 0xFFFF, 0xFFFF, 0x0D50, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D51, 0xFFFF, 0xFFFF, 0xFFFF,   // D6C0 - D6CF
	0xFFFF, 0x0D52, 0xFFFF, 0xFFFF, 0x0D53, 0xFFFF, 0xFFFF, 0x0D54, 0xFFFF, 0x0D55, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D6D0 - D6DF
	0x0D56, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D57, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D58, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D6E0 - D6EF
	0x0D59, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D5A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D5B, 0x0D5C, 0xFFFF, 0xFFFF,   // D6F0 - D6FF
	0x0D5D, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D5E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D700 - D70F
	0xFFFF, 0x0D5F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D60, 0x0D61, 0xFFFF, 0xFFFF, 0x0D62, 0xFFFF, 0xFFFF, 0xFFFF,   // D710 - D71F
	0x0D63, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D64, 0x0D65, 0xFFFF, 0x0D66, 0xFFFF, 0x0D67, 0xFFFF, 0xFFFF,   // D720 - D72F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D68, 0x0D69, 0xFFFF, 0xFFFF, 0x0D6A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D6B, 0xFFFF, 0xFFFF, 0xFFFF,   // D730 - D73F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D6C, 0xFFFF, 0xFFFF, 0x0D6D, 0xFFFF, 0x0D6E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D740 - D74F
	0x0D6F, 0x0D70, 0xFFFF, 0xFFFF, 0x0D71, 0xFFFF, 0x0D72, 0x0D73, 0x0D74, 0x0D75, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D750 - D75F
	0x0D76, 0x0D77, 0xFFFF, 0x0D78, 0xFFFF, 0x0D79, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D7A, 0xFFFF, 0xFFFF, 0x0D7B, 0xFFFF, 0xFFFF, 0xFFFF,   // D760 - D76F
	0x0D7C, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D7D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D7E, 0x0D7F, 0xFFFF, 0xFFFF,   // D770 - D77F
	0xFFFF, 0x0D80, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D81, 0x0D82, 0xFFFF, 0xFFFF, 0x0D83, 0xFFFF, 0xFFFF, 0xFFFF,   // D780 - D78F
	0x0D84, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0D85, 0x0D86, 0xFFFF, 0x0D87, 0xFFFF, 0x0D88, 0xFFFF, 0xFFFF,   // D790 - D79F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7A0 - D7AF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7B0 - D7BF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7C0 - D7CF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7D0 - D7DF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7E0 - D7EF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D7F0 - D7FF
	0x0E16, 0x0E1C, 0x0E2D, 0x0ED1, 0x0EEA, 0x0F0D, 0x0FB9, 0x0FBE, 0x0FD4, 0x0FEC, 0x0FF9, 0x104E, 0x104F, 0x1052, 0x1055, 0x1056,   // F900 - F90F
	0x1057, 0x1058, 0x1059, 0x105A, 0x105C, 0x105D, 0x105E, 0x105F, 0x1060, 0x1062, 0x1063, 0x1064, 0x1065, 0x1067, 0x1069, 0x106A,   // F910 - F91F
	0x106C, 0x1070, 0x1074, 0x1076, 0x1077, 0x1078, 0x107A, 0x107B, 0x107F, 0x1080, 0x1081, 0x1082, 0x1083, 0x1085, 0x108A, 0x1096,   // F920 - F92F
	0x109A, 0x109B, 0x109C, 0x109E, 0x109F, 0x10A0, 0x10A1, 0x10A2, 0x10A3, 0x10A5, 0x10A6, 0x10A7, 0x10A8, 0x10A9, 0x10AA, 0x10AB,   // F930 - F93F
	0x10AC, 0x10AD, 0x10AE, 0x10AF, 0x10B1, 0x10B2, 0x10B6, 0x10B7, 0x10B9, 0x10BA, 0x10BC, 0x10BD, 0x10BE, 0x10BF, 0x10C0, 0x10C1,   // F940 - F94F
	0x10C2, 0x10C3, 0x10C8, 0x10C9, 0x10CA, 0x10CB, 0x10CC, 0x10CD, 0x10CF, 0x10D0, 0x117A, 0x1190, 0x1197, 0x119D, 0x11A0, 0x1208,   // F950 - F95F
	0x121D, 0x1279, 0x1292, 0x13EB, 0x140A, 0x1429, 0x1487, 0x14B7, 0x14D6, 0x153C, 0x153E, 0x1551, 0x157F, 0x1586, 0x15ED, 0x1607,   // F960 - F96F
	0x1647, 0x170B, 0x1715, 0x171D, 0x1780, 0x1783, 0x1784, 0x178B, 0x178D, 0x178E, 0x1796, 0x17A0, 0x17A2, 0x17A4, 0x17A8, 0x17CC,   // F970 - F97F
	0x17CD, 0x17CE, 0x17D0, 0x17D1, 0x17D4, 0x17D7, 0x17DD, 0x17DF, 0x17E0, 0x17E1, 0x17E3, 0x17E7, 0x17E8, 0x17EC, 0x17F4, 0x17F6,   // F980 - F98F
	0x17F7, 0x17FA, 0x1802, 0x1806, 0x1809, 0x180C, 0x180F, 0x1811, 0x1814, 0x1815, 0x1816, 0x1818, 0x181A, 0x181B, 0x181C, 0x181F,   // F990 - F99F
	0x1821, 0x1822, 0x1825, 0x1826, 0x1827, 0x1829, 0x182F, 0x1834, 0x1837, 0x1838, 0x183A, 0x183B, 0x183E, 0x184D, 0x184F, 0x1854,   // F9A0 - F9AF
	0x1855, 0x1859, 0x185B, 0x185D, 0x185E, 0x1861, 0x186D, 0x1872, 0x1874, 0x1885, 0x18D3, 0x18D4, 0x18DC, 0x18DD, 0x18E3, 0x18E5,   // F9B0 - F9BF
	0x18E7, 0x18EA, 0x18F1, 0x18F6, 0x1916, 0x1941, 0x1969, 0x198D, 0x199C, 0x199F, 0x19A4, 0x19A6, 0x19AA, 0x19AD, 0x19AF, 0x19B0,   // F9C0 - F9CF
	0x19C0, 0x19C1, 0x19C3, 0x19C7, 0x19C8, 0x19CC, 0x19CD, 0x19D2, 0x19D5, 0x19D6, 0x19D7, 0x19D8, 0x19DE, 0x1A0A, 0x1A0B, 0x1A0E,   // F9D0 - F9DF
	0x1A13, 0x1A14, 0x1A15, 0x1A16, 0x1A19, 0x1A1C, 0x1A1E, 0x1A24, 0x1A25, 0x1A29, 0x1A2A, 0x1A2D, 0x1A2E, 0x1A39, 0x1A41, 0x1A42,   // F9E0 - F9EF
	0x1A45, 0x1A48, 0x1A4B, 0x1A4C, 0x1A5B, 0x1A5C, 0x1A5E, 0x1A63, 0x1A64, 0x1A65, 0x1AB0, 0x1AFB, 0x1C55, 0x1C92, 0x1CA7, 0x1CFB,   // F9F0 - F9FF
	0x1D42, 0x1E04, 0x1E06, 0x1E26, 0x1E36, 0x1E41, 0x1EA7, 0x1EBC, 0x1F29, 0x1F2A, 0x1F6E, 0x1FED, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA00 - FA0F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA10 - FA1F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA20 - FA2F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA30 - FA3F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA40 - FA4F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA50 - FA5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA60 - FA6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA70 - FA7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA80 - FA8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FA90 - FA9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAA0 - FAAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAB0 - FABF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAC0 - FACF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAD0 - FADF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAE0 - FAEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FAF0 - FAFF
	0xFFFF, 0x0124, 0x0125, 0x0126, 0x0127, 0x0128, 0x0129, 0x012A, 0x012B, 0x012C, 0x012D, 0x012E, 0x012F, 0x0130, 0x0131, 0x0132,   // FF00 - FF0F
	0x0133, 0x0134, 0x0135, 0x0136, 0x0137, 0x0138, 0x0139, 0x013A, 0x013B, 0x013C, 0x013D, 0x013E, 0x013F, 0x0140, 0x0141, 0x0142,   // FF10 - FF1F
	0x0143, 0x0144, 0x0145, 0x0146, 0x0147, 0x0148, 0x0149, 0x014A, 0x014B, 0x014C, 0x014D, 0x014E, 0x014F, 0x0150, 0x0151, 0x0152,   // FF20 - FF2F
	0x0153, 0x0154, 0x0155, 0x0156, 0x0157, 0x0158, 0x0159, 0x015A, 0x015B, 0x015C, 0x015D, 0x015E, 0x008C, 0x0160, 0x0161, 0x0162,   // FF30 - FF3F
	0x0163, 0x0164, 0x0165, 0x0166, 0x0167, 0x0168, 0x0169, 0x016A, 0x016B, 0x016C, 0x016D, 0x016E, 0x016F, 0x0170, 0x0171, 0x0172,   // FF40 - FF4F
	0x0173, 0x0174, 0x0175, 0x0176, 0x0177, 0x0178, 0x0179, 0x017A, 0x017B, 0x017C, 0x017D, 0x017E, 0x017F, 0x0180, 0x00E4, 0xFFFF,   // FF50 - FF5F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FF60 - FF6F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FF70 - FF7F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FF80 - FF8F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FF90 - FF9F
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FFA0 - FFAF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FFB0 - FFBF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FFC0 - FFCF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FFD0 - FFDF
	0x00AB, 0x00AC, 0x00DE, 0x0181, 0xFFFF, 0x00AD, 0x015F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FFE0 - FFEF
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // FFF0 - FFFF
};

sal_Int32 SAL_CALL Collator_ko_KR_charset::compareSubstring (
            const ::rtl::OUString& str1, sal_Int32 off1, sal_Int32 len1,
            const ::rtl::OUString& str2, sal_Int32 off2, sal_Int32 len2)
            throw (::com::sun::star::uno::RuntimeException) {
        return compare(str1, off1, len1, str2, off2, len2, index, weight);
}

sal_Int32 SAL_CALL Collator_ko_KR_charset::compareString (
            const ::rtl::OUString& str1,
            const ::rtl::OUString& str2)
            throw (::com::sun::star::uno::RuntimeException) {
        return compare(str1, 0, str1.getLength(), str2, 0, str2.getLength(), index, weight);
}

